/*
 * SubproblemHandler.h
 *
 *  Copyright (C) 2008-2012 Lars Otten
 *  This file is part of DAOOPT.
 *
 *  DAOOPT is free software: you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  DAOOPT is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with DAOOPT.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  Created on: Nov 12, 2008
 *      Author: Lars Otten <lotten@ics.uci.edu>
 */

#ifndef SUBPROBLEMHANDLER_H_
#define SUBPROBLEMHANDLER_H_

#include "SearchSpace.h"


#ifdef PARALLEL_DYNAMIC

//#include "pstream.h"

/* Instances of this class handle one specific subproblem
 * generated by the search  */
class SubproblemHandler {

protected:
  SearchSpaceMaster* m_spaceMaster;
  SearchNode* m_rootnode;

public:

  // takes the next subproblem, takes care of its processing
  // (in whatever way, possibly on another machine) and
  // feeds the result back into the search space
  virtual void operator() () = 0;

public:
  SubproblemHandler(SearchSpaceMaster* p, SearchNode* n);

};


/* Constructors */
inline SubproblemHandler::SubproblemHandler(SearchSpaceMaster* p, SearchNode* n) :
  m_spaceMaster(p), m_rootnode(n) {}

#endif /* PARALLEL_DYNAMIC */

#endif /* SUBPROBLEMHANDLER_H_ */
