#ifndef LOCIDATA_H
#define LOCIDATA_H

#define MAX_CLUSTER_NAME 250

typedef enum Bool {TRUE = 1, FALSE = 0} Bool;
typedef enum LocusType { NUMBERED_LOCUS  = 3, AFFECTED_LOCUS = 1, COMLEX_LOCUS = 4 } LocusType;
typedef enum InputFormat { GH = 1, SL = 2} InputFormat;

typedef struct LocusData{
	LocusType type;
	char locusName[MAX_CLUSTER_NAME]; 
	double femalePosition;     //in cM
	double malePosition;       // in cM
	int numOfAlleles;
	double *alleleFreq;  // size of array is numOfAlleles
	Bool printFlag;
}LocusDataStruct;

typedef struct DiseaseData1{
	int numOfLiabClasses;
	int *positions; //indexes, starting 0. Size numLoci
	double **femalePenetrances;
	double   **malePenetrances;
	double *freq;

}DiseaseDataStruct;


typedef struct ProgramData1{
	int programCode;
	int numberOfLoci;  //including disease
	int numberOfClusters;
	int riskLocus;
	int numberOfDiseaseLoci;
	Bool sexLinked;
	int sexDiff;
	int interference;
	Bool haldane;
	int inputFormat; 
	int numInformativeMarkers;
	double		geneticDist;
}ProgramDataStruct;

#endif
