#include "convertGHtoSL.h"


void updateSiblingFields(PedigreeDataStruct *pedigree);
void updateFirstChildField(PedigreeDataStruct *pedigree);
/******************************************************************************
*
*       Function        convertGHtoSL
*       Parameters		Pedigrees 
*       Output          none
*       Description		Updates SL fileds
*       Comments		none
*
******************************************************************************/
void convertGHtoSL(PedigreesStruct Pedigrees){
	int i;

	if (ProgramData.inputFormat == SL)
		return;
	for (i = 0; i < Pedigrees.numOfPedigrees; i++){
		updateSiblingFields(Pedigrees.pedigrees + i);
		updateFirstChildField(Pedigrees.pedigrees + i);
	}

}
/******************************************************************************
*
*       Function        updateSiblingFields
*       Parameters		pedigree (the struct which will hold the info about the
*					    current pedigree being updated), pedInd (the index of the 
*						pedigree now being updated).
*       Output          none
*       Description		updates the child-pointers of one pedigree from the 
*						pedigree file. 
*       Comments		
*
******************************************************************************/
void updateSiblingFields(PedigreeDataStruct *pedigree){

	int		personInd;
	PersonDataStruct	*currPerson, *pa, *ma;


	/* 1.	Iterate over the people in the pedigree. */

	for (personInd = 0; personInd < pedigree->numPeople; personInd++) {

		currPerson = &(pedigree->people)[personInd];
		currPerson->siblingFather = 0;
		currPerson->siblingMother = 0;
		/* 1.1.	If this person isn't a founder. */

		if (currPerson->father != 0) {	
			pa = &(pedigree->people)[currPerson->father - 1];
			
			if (pa->firstChild == -1) 
				pa->firstChild = currPerson->id;
			else{
				currPerson->siblingFather = pa->firstChild;
				pa->firstChild = currPerson->id;
				
			}
		}


		if (currPerson->mother != 0) {
			ma = &(pedigree->people)[currPerson->mother - 1];
			
			if (ma->firstChild == -1) 
				ma->firstChild = currPerson->id;
			else{
				currPerson->siblingMother = ma->firstChild;
				ma->firstChild = currPerson->id;
			}
		}
			
		
	}
}

/******************************************************************************
*
*       Function        updateFirstChildField
*       Parameters		ped (the struct which will hold the info about the
*					    current pedigree being updated), pedInd (the index of the 
*						pedigree now being updated).
*       Output          none
*       Description		updates the child-pointers of one pedigree from the 
*						pedigree file. 
*       Comments		none
*
******************************************************************************/
void updateFirstChildField(PedigreeDataStruct *pedigree){

	int		personInd;
	PersonDataStruct	*currPerson;


	/* 1.	Iterate over the people in the pedigree. */

	for (personInd = 0; personInd < pedigree->numPeople; personInd++) {

		currPerson = &(pedigree->people)[personInd];
		if (currPerson->firstChild == -1){
			currPerson->firstChild = 0;
		}
	}
}

