#include "freeMemory.h"

void freePedigreeData();
void freeLociData();
void freeDiseaseData();


void freeMainMemory(){
	free(OkMarkers);
	freePedigreeData();
	freeLociData();
	freeDiseaseData();
}

void freeLociData(){
	int i;
	LocusDataStruct *locusPtr;
	for (i =0, locusPtr = LociData; i < ProgramData.numberOfLoci - ProgramData.numberOfDiseaseLoci; i++, locusPtr++){
		free(locusPtr->alleleFreq);
	}
	free(LociData);	
	for (i =0, locusPtr = ClusterData; i < ProgramData.numberOfClusters; i++, locusPtr++){
		free(locusPtr->alleleFreq);
	}
	free(ClusterData);
}

void freeDiseaseData(){
	int i;
	for ( i = 0; i < DiseaseData.numOfLiabClasses; i++){
		free(DiseaseData.femalePenetrances[i]);
		if (ProgramData.sexLinked)
			free(DiseaseData.malePenetrances [i]);
	}
	free(DiseaseData.femalePenetrances);
	free(DiseaseData.freq);
	if (ProgramData.sexLinked)
		free(DiseaseData.malePenetrances);
	free(DiseaseData.positions);

}

void freePedigreeData(){
	int pedInd, pId;
	for (pedInd = 0; pedInd < Pedigrees.numOfPedigrees; pedInd++){
		for (pId = 0; pId < Pedigrees.pedigrees[pedInd].numPeople; pId++){
			free(Pedigrees.pedigrees[pedInd].people[pId].clustersAlleles);
			free(Pedigrees.pedigrees[pedInd].people[pId].markersAlleles);
		}
		free(Pedigrees.pedigrees[pedInd].people);
	}
	free(Pedigrees.pedigrees);
}
