#include "checkGenotypes.h"
#define SIGNIFICANT_DIGITS 7

double sl_main(int numMarkers,int* markersUsed, Bool diseaseUsed, int progCode,double specialThetas, PedigreeDataStruct *currPedigree);

/*******************************************/
// Kfir addition - 
// Auxiliary rounb up function
double fround(double n, unsigned int d)
{
  unsigned p;
  p = d - (unsigned)log10(n);
  return floor(n * pow(10., p) + .5) / pow(10., p);
}


/*******************************************/

void removeInfinity()
{
	int markInd[1];
	int i,pedInd;
	PedigreeDataStruct *currPedigree;
	FILE *output;
	double resNoLink,resLinkage;
	output = fopen(ERROR_FILE ,"a");
	//fprintf(output,"       ############################\n");
	//fprintf(output,"       # INFINITY_GENOTYPES_START #\n");
	//fprintf(output,"       ############################\n");

	printf("Checking consistency\n");
	for (i =0 ; i < ProgramData.numberOfLoci - ProgramData.numberOfDiseaseLoci; i++){
		if (!OkMarkers[i]){
			continue;
		}
		*markInd = i;
		printf("Marker %d: ", i + 1);
		for (pedInd = 0, currPedigree = Pedigrees.pedigrees; 
			pedInd < Pedigrees.numOfPedigrees; pedInd++, currPedigree++){
				printf("pedigree %d ", currPedigree->index);
				//resLinkage = sl_main(1,markInd,TRUE,CALCULATE_LIKELIHOOD,0.1,currPedigree);
				resNoLink = sl_main(1,markInd,TRUE,CALCULATE_LIKELIHOOD, 0.5,currPedigree);
				if (/*MIN_DBL == resLinkage||*/ MIN_DBL == resNoLink  
					/* || ((resLinkage - resNoLink) < -10)*/ ){
				OkMarkers[i] = FALSE;
				ProgramData.numInformativeMarkers--;
				//fprintf(output,"Droping marker #%d (%s) - too many errors\n",i, LociData[i].locusName);
				//fprintf(output,"%s - too many errors\n",LociData[i].locusName);
				printf("Droping marker #%d (%s) - too many errors\n",
					i + 1, LociData[i].locusName);
				break;
					}
			}
			printf("\n");
	}
	//fprintf(output,"        ##########################\n");
	//fprintf(output,"        # INFINITY_GENOTYPES_END #\n");
	//fprintf(output,"        ##########################\n\n");
	fclose(output);
}

void removeUnLikelyGenotypes( int typeOfGenoCheck ){
	int* markersUsed, *markerPtr;
	int i, numMarkersToUse, startNumInformMarkers, start, end, maxNumMarkers, complexCount;
	int countErrors;
	double lnlikeFullUnlinlked, lnlikeFullLinlked, lnlikeMissLinlked ,lnlikeMissUnlinlked;
	double rLinked, rUnlinked, rTotal;
	Bool restartFlag;
	PersonDataStruct *personPtr;
	PedigreeDataStruct *currPedigree;
	AlleleDataStruct alleles;
	int pedInd, personInd, markerInd,  locusInd;
	int complexity = 6;

	
	FILE *output;
	output = fopen(ERROR_FILE ,"a");
	//fprintf(output,"       ############################\n");
	//fprintf(output,"       # UNLIKELY_GENOTYPES_START #\n");
	//fprintf(output,"       ############################\n");
	myMalloc(markersUsed, (ProgramData.numInformativeMarkers*sizeof(int)));
	for (i =0 ,markerPtr = markersUsed; i < ProgramData.numberOfLoci - ProgramData.numberOfDiseaseLoci; i++){
		if (OkMarkers[i]){
			*markerPtr = i;
			markerPtr++;
		}
	}


	//1.0 iterate over families
	for (pedInd = 0, currPedigree = Pedigrees.pedigrees; 
		pedInd < Pedigrees.numOfPedigrees; pedInd++, currPedigree++){
			// find max markers
			maxNumMarkers = (10 <ProgramData.numInformativeMarkers)?10:ProgramData.numInformativeMarkers ;
			while(sl_main(maxNumMarkers,markersUsed,FALSE,FIND_ORDER_PROG,-1,currPedigree) > complexity ){
				maxNumMarkers--;
				if (maxNumMarkers <= 1){
					complexity++;
					maxNumMarkers = maxNumMarkers = (10 <ProgramData.numInformativeMarkers)?10:ProgramData.numInformativeMarkers ;
					if (complexity > 7)
					{	
						//fprintf(output,"        ##########################\n");
						//fprintf(output,"        # UNLIKELY_GENOTYPES_END #\n");
						//fprintf(output,"        ##########################\n\n");
						fclose(output);
						free(markersUsed);
						return;
					}
				}
			}

			restartFlag = FALSE;
			markerInd = 0;
			locusInd = markersUsed[0];
			//1.1 find l_full_linked = likelihood with original thetas
			// 2.0 iterate over markers
			while (markerInd < ProgramData.numInformativeMarkers){
			
		
				restartFlag = FALSE;
				locusInd = markersUsed[markerInd];
	
				printf("Checking genotype errors, marker #%d\nPerson: ",locusInd + 1);
				start = markerInd - maxNumMarkers/2;
				end = markerInd + maxNumMarkers/2;
				if (start <= 0){
					start = 0;
					end = maxNumMarkers - 1;
				}
				if (end >= ProgramData.numInformativeMarkers){
					// HERE IS THE BUG! start is reciving negative value!
					start = ProgramData.numInformativeMarkers - maxNumMarkers;
					/*  solution */
					if (start <= 0)	
					{					   
						start = 0;																
					}	
					end = ProgramData.numInformativeMarkers - 1;

				}
				/*	start = ((markerInd - NUMBER_OF_MARKERS_PER_CHECK)<0)?0:(markerInd - NUMBER_OF_MARKERS_PER_CHECK);
				end = ((markerInd + NUMBER_OF_MARKERS_PER_CHECK)>= ProgramData.numInformativeMarkers)?
				ProgramData.numInformativeMarkers - 1:markerInd + NUMBER_OF_MARKERS_PER_CHECK;
				*/
				countErrors = 0;
				complexCount = 0;
				markerPtr = markersUsed + start;
				numMarkersToUse = end - start + 1;
				lnlikeFullLinlked = sl_main(numMarkersToUse,markerPtr,FALSE,CALCULATE_LIKELIHOOD,-1,currPedigree);
				
				////////////////////////
				lnlikeFullLinlked = fround(lnlikeFullLinlked,SIGNIFICANT_DIGITS);
				////////////////////////

				//1.2 find l_full_unlinked = likelihood with theta = 0.5
				lnlikeFullUnlinlked = sl_main(numMarkersToUse,markerPtr,FALSE,CALCULATE_LIKELIHOOD,0.5,currPedigree);

				////////////////////////
				lnlikeFullUnlinlked = fround(lnlikeFullUnlinlked,SIGNIFICANT_DIGITS); 
				////////////////////////

				// 3.0 iterate over people
			 
					for (personInd =0, personPtr = Pedigrees.pedigrees[pedInd].people;
						personInd < Pedigrees.pedigrees[pedInd].numPeople; personInd++, personPtr++){			
							printf("%d ",personInd+1);
							if (personPtr->markersAlleles[locusInd].allele1 == 0)
								continue;
							// Save original values
							alleles.allele1 = personPtr->markersAlleles[locusInd].allele1;
							alleles.allele2 = personPtr->markersAlleles[locusInd].allele2;
							// Set values to zero
							personPtr->markersAlleles[locusInd].allele1 = 0;
							personPtr->markersAlleles[locusInd].allele2 = 0;
							//	 3.1 if person[marker] != unknown
							//		3.1.1 l_miss_linked = like G/g|theta
							lnlikeMissLinlked = sl_main(numMarkersToUse,markerPtr,FALSE,CALCULATE_LIKELIHOOD,-1,currPedigree);
							
							///////////////////////////
							lnlikeMissLinlked = fround(lnlikeMissLinlked,SIGNIFICANT_DIGITS);
							///////////////////////////
							
							//		3.1.2 l_miss_unlinked = like G/g|theta = 0.5
							lnlikeMissUnlinlked = sl_main(numMarkersToUse,markerPtr,FALSE,CALCULATE_LIKELIHOOD,0.5,currPedigree);
							 
							///////////////////////////
							lnlikeMissUnlinlked = fround(lnlikeMissUnlinlked,SIGNIFICANT_DIGITS);
							///////////////////////////

							//     3.1.3 r_linked = l_miss_linked - l_full_linked (the result is ln)
							if (lnlikeMissLinlked == -DBL_MAX || lnlikeFullLinlked == -DBL_MAX
								|| lnlikeMissUnlinlked == -DBL_MAX || lnlikeFullUnlinlked == -DBL_MAX ){
									maxNumMarkers--;
									if (maxNumMarkers <= 1){
										maxNumMarkers = 2;
										complexCount++;
										if (complexCount > ERRORS_PER_MARKER_TRESHOLD){
											//fprintf(output,"Marker #%d (%s) - too complex\n",locusInd, LociData[locusInd].locusName);
											fprintf(output,"%s - too complex\n",LociData[locusInd].locusName);
											printf("Marker #%d (%s) - too complex\n",
												locusInd + 1 , LociData[locusInd].locusName);
											break;
										}
										continue;
									}
									restartFlag = TRUE;
									break;
								}
								rLinked = lnlikeMissLinlked -lnlikeFullLinlked;

								///////////////////////////
								rLinked = fround(rLinked,SIGNIFICANT_DIGITS);
								///////////////////////////

								// Fix - due to double last digit noise
								if (rLinked <= NOISEBOUNDARY)
									rLinked = 0;
									
								//		3.1.4 r_unlinked = l_miss_unlinked - l_full_unlinked (the result is ln)
								rUnlinked = lnlikeMissUnlinlked -  lnlikeFullUnlinlked;
								
								///////////////////////////
								rUnlinked = fround(rUnlinked,SIGNIFICANT_DIGITS);
								///////////////////////////


								// Fix - due to double last digit noise
								if (rUnlinked <= NOISEBOUNDARY)
									rUnlinked = 0;
						
								//		3.1.5 r = r_linked - r_unlinked


								rTotal = rLinked - rUnlinked;
								///////////////////////////
								rTotal = fround(rTotal,SIGNIFICANT_DIGITS);
								///////////////////////////
								
								// Fix - due to double last digit noise
								if (rTotal <= NOISEBOUNDARY)
									rTotal = 0;

								//		if (r > treshold) set person[marker] =unknown
								if (rTotal > ERROR_TRESHOLD  ){
									countErrors++;
									lnlikeFullLinlked = lnlikeMissLinlked;
									//1.2 find l_full_unlinked = likelihood with theta = 0.5
									lnlikeFullUnlinlked = lnlikeMissUnlinlked;
									
									if (countErrors > typeOfGenoCheck)
									{
										fprintf(output,"%s - Dropping this marker due to unlikely genotype at Person #%d\n"
										,LociData[locusInd].locusName ,personPtr->id);
									}
									else 
									{
										fprintf(output,"%s - unlikely genotype at Person #%d \n"
										,LociData[locusInd].locusName ,personPtr->id);
									}
									//fprintf(output,"Person #%d marker #%d (%s) has unlikely genotype\n",
									//	personPtr->id, locusInd, LociData[locusInd].locusName);
									

								}else{ //restore original values
									personPtr->markersAlleles[locusInd].allele1 = alleles.allele1;
									personPtr->markersAlleles[locusInd].allele2 = alleles.allele2;
								}


						}
						printf("\n");
			

					
					if (countErrors > typeOfGenoCheck){
						OkMarkers[locusInd] = FALSE;
						ProgramData.numInformativeMarkers--;
						memmove(markersUsed + markerInd, markersUsed + markerInd +1,sizeof(int)*(ProgramData.numInformativeMarkers - markerInd));
						//fprintf(output,"Droping marker #%d (%s) - too many errors\n",
						//	locusInd, LociData[locusInd].locusName);
						//fprintf(output,"%s - too many errors\n", LociData[locusInd].locusName);
						printf("Droping marker #%d (%s) - too many errors\n",
							locusInd + 1, LociData[locusInd].locusName);
						markerInd--;
					}

					if (!restartFlag){
						markerInd++;
					}
			}
		
		} 
		//fprintf(output,"        ##########################\n");
		//fprintf(output,"        # UNLIKELY_GENOTYPES_END #\n");
		//fprintf(output,"        ##########################\n\n");
		fclose(output);
		free(markersUsed);
}
