#include "common.h"


/****************************************************
*       Function        printStdErr
*       Parameters		str - message
*       Output          none
*       Description		Print message to stderr
*       Comments		exits( no memory free)
/****************************************************/
void printStdErr(char *str){
	fprintf(stderr,"%s",str);
	exit(1);
}

/******************************************************************************
*
*       function        inputErr
*       parameters      message (the error message printed before exiting).
*       output          none
*       description     Prints an error message when there's an input error,
*						and exits.
*       comments		none
*
******************************************************************************/
void printStdErrWithParamNoExit(char *message, ...) 
{
	va_list		ap;


	/* 1.	Set a pointer to the beginning of the argument list. */

	va_start(ap, message);

	/* 2.	Print the requested string to stderr. */

	fprintf(stderr, "\nAn input error has been found:\n");
	vfprintf(stderr, message, ap);

	/* 4.	Reset the pointer to the beginning of the argument list. */

	va_end(ap);
}


void printStdErrWithParam(char *message, ...) {
	printStdErrWithParamNoExit(message);
	/* 5.	Exit. */
	exit(1);
}

void mallocErr(char *message){
	printStdErr("\nProblem with malloc, probably not enough space.\n"); \
printStdErrWithParam("Problem occurred when allocating %s.\n", message);
}
	

void printFile(char *filename){
	FILE *stream;
	char c;
	stream = fopen(filename,"r");
	while (fscanf(stream,"%c",&c) != EOF){
		printf("%c", c);
	}
	fclose(stream);
	printf("\n");
	return;
}
