/*************************************************************************************
 Common.c
 The file deals with common functions and definitions which are used all over the 
 project.
 *************************************************************************************/
#ifndef _PC_COMMON_H
#define _PC_COMMON_H

typedef enum {male, female} Gender;
typedef enum {unknown = 0, healthy = 1, affected = 2} AffStatus;
typedef enum {YES, NO} Result;
typedef enum {error7 = 7, error8 = 8, error9 = 9} ErrorNum;
typedef enum {SEXLINKED = 0 , AUTOSOMAL = 1} Format;

/* This values are to be changed by the user of the application */
#define CRITICAL_GENOTYPES_MAX_LEVEL 1

/* If this argument is set to 1, then the application will find 
   all possible results of uncorrect persons in family. (a long 
   running time). Of course, only at the minimum solving critical 
   genotypes level, and not above it.
   If it is set to 0, then the application will find the first 
   possible results of uncorrect persons in family. (a shorter 
   running time) */
#define CRITICAL_GENOTYPES_MULT_RESULTS 1


#define MAX_PEDIGREE_NAME_LEN 80
#define MAX_PERSON_ID_LEN   20
#define MAX_LENGTH 80
#define MAX_ERROR_ID_LEN 500
#define MAX_ALLELE_ID_LEN 5

#define MAX_NUM_STR_LEN 20

/* The strings that present an "unknown" character */
#define NO_PARENT_1 "0"
#define NO_PARENT_2 "?"
#define NO_PARENT_3 "-"

#define UNDEFINED_MARKER_IDX -1

/* returned values in many of the functions */
typedef enum {ckrOK = 1, ckrErr = 2, ckrMemErr = 3, ckrNonCriticErr = 4} ckrResult;

/* a macro that detects a memory error, and returns if it occures */
#define RETURN_MEM_ERROR(aRes) {if (ckrMemErr == aRes) return aRes;}

/* MyDecimalItoa is coded, because itoa is not a standart C 
   function (allthough atoi is..) */
void MyDecimalItoa(int aNum, char * aNumStr, int aStrLen);

#endif

