#include "pc_FreeMemory.h"

#include "pc_Error.h"
#include "pc_PedigreeList.h"


void pc_freeMarkerLLNode(MarkerLLNode *markerLLNode){
	MarkerLLNode *currentNode, *nextNode;
	currentNode = markerLLNode;
	while (currentNode != NULL){
		nextNode = currentNode->mNext;
		free(currentNode);
		currentNode = nextNode;
	}
}
void pc_freeAlleles(PedAlleles * aPedAlleles){
	AlleleLLNode *currentAlleleLLNode, *nextAlleleLLNode;
	AlleleLL *nextAlleleLL, *currentAlleleLL;
	if (aPedAlleles == NULL)
		return;
	currentAlleleLL = aPedAlleles->mAlleleLists;
	while  	(currentAlleleLL != NULL){
		nextAlleleLL = currentAlleleLL->mNext;
		currentAlleleLLNode = currentAlleleLL->mFirstLLNode;
		while (currentAlleleLLNode != NULL){
			nextAlleleLLNode = currentAlleleLLNode->mNext;
			free(currentAlleleLLNode);
			currentAlleleLLNode = nextAlleleLLNode;
		}
		free(currentAlleleLL);
		currentAlleleLL = nextAlleleLL;
	}
	free(aPedAlleles);
}

void pc_FreeNuclearFamily(NuclearFam * aFam){
	if (aFam == NULL)
		return;
	/*free(aFam->mFather);
	free(aFam->mMother);
	free(aFam->mNextFatherFam);
	free(aFam->mNextMotherFam);
	free(aFam->mChild);*/
	free(aFam);

}

void pc_freeMemory(PedigreeList pedigreeLL){
	int i;
	Pedigree *currentPed,*nextPed; 
	currentPed = pedigreeLL.mFirst;
	while (currentPed != NULL){
		FreeErrorLL(currentPed->mErrorLL1);
		free(currentPed->mErrorLL1);
		FreeErrorLL(currentPed->mErrorLL2);
		free(currentPed->mErrorLL2);
		pc_freeAlleles(currentPed->mPedAlleles);
		for (i =0; i < currentPed->mPersonCnt; i++){
			/*pc_FreeNuclearFamily(currentPed->mPersonArray[i]->mParentsFam);
			pc_FreeNuclearFamily(currentPed->mPersonArray[i]->mFoundedFam);*/
			free(currentPed->mPersonArray[i]->mMarkerArr);
			pc_freeMarkerLLNode(currentPed->mPersonArray[i]->mOptMarkerLL);
			free(currentPed->mPersonArray[i]);
		}
		free(currentPed->mPersonArray);
		// no recomendation are used, no need to free internal recomendations
		free(currentPed->mRecommendationLL);
		free(currentPed->mCriticalGenotypesLevel);
		nextPed = currentPed->mNext;
		free(currentPed);
		currentPed=nextPed;
	}

}
