/*************************************************************************************
 InputChecker.c
 This file contains the main function. It is the API of the application.
*************************************************************************************/

#include "pc_SimplifiedParser.h"
#include "pc_Level2Checker.h"
#include "pc_Level3Checker.h"
#include "pc_PedigreeList.h"
#include "pc_Error.h"
#include "pc_FreeMemory.h"

ErrorLL gProgErrorLL;
FILE * output;
int fileFormat;

int pc_main()
{
	ckrResult aRes;
	PedigreeList pedigreeLL;
	Pedigree * pedigree;
    FILE * output;
	int isErrorExist = 0 , isLevel1Error = 0;

	output = fopen(ERROR_FILE ,"w");
	//fprintf(output,"       ##########################\n");
	//fprintf(output,"       # MENDELIAN_ERRORS_START #\n");
	//fprintf(output,"       ##########################\n");
	
	/* initialization of empty list of errors and families*/
	InitErrorLL(&gProgErrorLL);
	InitPedigreeList(&pedigreeLL);
	
	/* Two input files are given by user : argv[1] - name of the data file 
	                                       argv[2] - name of the pedigree file 
										   argv[3] - file format*/
	

	aRes = ParseSimplifiedMultiPedigree(Pedigrees, /*fileFormat,*/ &pedigreeLL);
	
	if (ckrOK != aRes)
	{
		//fprintf(output,"        ########################\n");
		//fprintf(output,"        # MENDELIAN_ERRORS_END #\n");
		//fprintf(output,"        ########################\n\n");
		fclose(output);
		return 0;
	}
	
	/* go over all families*/
	pedigree = pedigreeLL.mFirst;
	
	while (NULL != pedigree)
	{
		/* level 1 */
		/* print the syntax errors of family 
		   isErrorExist - if there were errors in family
		*/
		isErrorExist = PrintPedigreeErrors(1, pedigree,output);	
		if (1 == isErrorExist)
		{
			pedigree = pedigree->mNext;
			isLevel1Error = 1;
			continue;
		}
		/* Anna - if level 1 errors - program should exit */
		if (isLevel1Error == 1){
			pedigree = pedigree->mNext;
			continue;
		}
		/* level 2 */
		aRes = Level2Errors(pedigree); /* checking level 2 errors*/
		PrintPedigreeErrors(2, pedigree,output);

		/*if (aRes == ckrOK)
		{
			// level 3  - recommendation, only within lang. algorithm
			if (pedigree->mFormat == AUTOSOMAL){
				Level3Errors(pedigree);
				PrintPedigreeErrors(3, pedigree,output);
				PrintPedigreeRecommendations(pedigree, output);
			}
		}
*/

	    pedigree = pedigree->mNext;
    
	}
	
	//fprintf(output,"       ########################\n");
	//fprintf(output,"       # MENDELIAN_ERRORS_END #\n");
	//fprintf(output,"       ########################\n\n");
	fclose(output);
	pc_freeMemory(pedigreeLL);
	if ( isLevel1Error == 1){
		return -1;
	}
	return 0;
}


