/*************************************************************************************
 Marker.h
 Marker is a struct which represents a marker. It holds the marker's 2 alleles.
*************************************************************************************/
#ifndef _PC_MARKER_H
#define _PC_MARKER_H

#include "pc_Common.h"


typedef struct _Marker
{
	int mAllele1;
	int mAllele2;
} Marker;


/* 
* Marker Linked-List Node
*/
typedef struct _MarkerLLNode
{
	Marker mMarker;
	struct _MarkerLLNode * mNext;
	int    mIsMarked;
	int	   mTmpIsMarked;
} MarkerLLNode;




MarkerLLNode * CreateMarkerLLNode(int aAllele1, int aAllele2);
Marker * CreateMarkerArray(int aSize);
void CopyMarkerMarkerLLN(Marker * aMarker, MarkerLLNode * aMarkerLLN);
void DeleteMarkerLL(MarkerLLNode ** aMarkerLL);
void AddMarkerToList(MarkerLLNode * aMarkerLLN, MarkerLLNode ** aMarkerLLLst);
ckrResult CreateAddMarker(int aAllele1, int aAllele2, MarkerLLNode ** aMarkerList);




#endif
