/*************************************************************************************
 NuclearFam.c
 NuclearFam is a struct which represenets a nuclear family. It holds data on the family
 and points to its members.
*************************************************************************************/
#include "pc_NuclearFam.h"
#include <stdlib.h>

/************************************************************************************
Function:CreateNuclearFam
This function creates a new struct of NuclearFam.
*************************************************************************************/
NuclearFam * CreateNuclearFam()
{
	NuclearFam * aFam;
	aFam = (NuclearFam *)malloc(sizeof(NuclearFam));
	if (aFam == NULL)
		return NULL;

	aFam->mChild = NULL;
	aFam->mFather = NULL;
	aFam->mMother = NULL;
	aFam->mNextFatherFam = NULL;
	aFam->mNextMotherFam = NULL;

	aFam->mIsChecked = 0;
	return aFam;
}

/************************************************************************************
Function:DeleteNuclearFam
This function deletes a struct of NuclearFam.
*************************************************************************************/
void DeleteNuclearFam(NuclearFam * aFam)
{
	if (aFam != NULL)
	{
		free(aFam);
	}
}
/*************************************************************************************/

