/*************************************************************************************
 PedAlleles.h
 This file deals with structures and functions, which "collect", at parsing time, all
 the alleles in the pedigree, for a certain marker.
 This is important for later stages of the application. (for Lange-Goradia algorithm)
*************************************************************************************/
#ifndef _PC_PED_ALLELES_
#define _PC_PED_ALLELES_

#include "pc_Common.h"

typedef struct _AlleleLLNode
{
	int mAllele;
	struct _AlleleLLNode * mNext;
} AlleleLLNode;


/* struct of alleles per marker*/
typedef struct _AlleleLL
{
	AlleleLLNode * mFirstLLNode;
	int			   mIndex;
	struct _AlleleLL *     mNext;
} AlleleLL;


/* struct that contains list of alleles per each marker*/
typedef struct _PedAlleles
{
	AlleleLL * mAlleleLists;
} PedAlleles;



Result IsAlleleIn(int aCheckedAllele,int aAllele1,int aAllele2);
AlleleLLNode * CreateAlleleLLNode(int aAlleleValue);

/* void InitPedAlleles(PedAlleles * aPedAlleles); */

PedAlleles * CreatePedAlleles();
ckrResult AddAlleleToPedAlleles(int aAlleleValue, PedAlleles * aPedAlleles, int aMarkerIdx);

ckrResult GetAlleleLLFromPedAlleles(AlleleLL ** aAlleleLL, PedAlleles * aPedAlleles, int aMarkerIdx);

#endif

