/*************************************************************************************
 PedigreeList.c
 PedigreeList is a struct which represenets a pedigree list. It is needed because in 
 the input file there could be several pedigrees.
*************************************************************************************/
#include "pc_PedigreeList.h"
#include <stdio.h>
#include <stdlib.h>


/*****************************************************************************************
Function:CreatePedigreeList 
This function allocates a struct of PedigreeList.
/****************************************************************************************/
PedigreeList * CreatePedigreeList()
{
	PedigreeList * aPedigreeList;

	aPedigreeList = (PedigreeList *)malloc(sizeof(PedigreeList));
	if (aPedigreeList == NULL)
	{
		return NULL;
	}

	InitPedigreeList(aPedigreeList);
	return aPedigreeList;
}

/*****************************************************************************************
Function:InitPedigreeList 
Sets the fields of PedigreeList
/****************************************************************************************/
void InitPedigreeList(PedigreeList * aPedigreeList)
{
	aPedigreeList->mFirst = NULL;
	aPedigreeList->mLast = NULL;
	aPedigreeList->mNumOfPedigrees = 0;
}


/*****************************************************************************************
Function:AddPedigree 
Adds a pedigree to the PedigreeList
/****************************************************************************************/
void AddPedigree(PedigreeList * aPedigreeList, Pedigree * aPedigree)
{
	aPedigreeList->mNumOfPedigrees++; /* update counter */

	/* list is empty */
	if (NULL == aPedigreeList->mFirst)
	{
		aPedigreeList->mFirst = aPedigree;
		aPedigreeList->mLast  = aPedigree;
		return;
	}
	/* list is not empty */
	aPedigreeList->mLast->mNext = aPedigree;
	aPedigreeList->mLast = aPedigree;	
}

