/*************************************************************************************
 Person.c
 Person is a struct which represenets a person in the pedigree. It holds any needed 
 information on the person and its markers.
*************************************************************************************/
#include "pc_Person.h"
#include <stdio.h>
#include <stdlib.h>


/*****************************************************************************************
Function:CreatePerson
The function creates a new Person structure and initializes its fields.
Input: void
Output: Person * - the new created person
******************************************************************************************/
Person * CreatePerson()
{
	Person * aPerson;
//	int i;

	aPerson = (Person *)malloc(sizeof(Person));
	if (aPerson == NULL)
		return NULL;

/* anna 20/6
	for (i=0; i<MAX_PERSON_ID_LEN; ++i)
	{
		aPerson->mID[i]       = '\0';
		aPerson->mFatherID[i] = '\0';
		aPerson->mMotherID[i] = '\0';
	}
*/
	aPerson->mGender     = male;

	aPerson->mAffStatus  = unknown;

	aPerson->mParentsFam = NULL;
	aPerson->mFoundedFam = NULL;
	aPerson->mSibling    = NULL;

	aPerson->mMarkerArr  = NULL;
	aPerson->mMarkersCnt = 0;

	aPerson->mNext	     = NULL;

	aPerson->mOptMarkerLL = NULL;
	
	aPerson->mProblem = 40;

	return aPerson;
}


/*****************************************************************************************
Function:DeletePerson
The function deletes the given person
Input: Person * aPerson - the person structure to delete
Output: void
******************************************************************************************/
void DeletePerson(Person * aPerson)
{
	if (aPerson != NULL)
	{
		free(aPerson);
	}
}


/*****************************************************************************************
Function:GetMarkers
The function returns the markers of the given person, in the given marker index
Input: Person * aPerson - the checked person
	   int aMarkerNum - the marker index
	   int  * allele1 - allele number 1 of this marker. Is filled by the function.
	   int * allele2  - allele number 2 of this marker. Is filled by the function.
Output: void
******************************************************************************************/
void GetMarkers(Person * aPerson,int  * allele1,int * allele2,int aMarkerNum)
{
    *allele1=aPerson->mMarkerArr[aMarkerNum].mAllele1;
    *allele2=aPerson->mMarkerArr[aMarkerNum].mAllele2;
}

