/*************************************************************************************
 Person.h
 Person is a struct which represenets a person in the pedigree. It holds any needed 
 information on the person and its markers.
*************************************************************************************/
#ifndef _PC_PERSON_H
#define _PC_PERSON_H

#include "pc_Common.h"
#include "pc_NuclearFam.h"
#include "pc_Marker.h"

typedef struct _Person
{
	char      mID[MAX_PERSON_ID_LEN]; /*name*/
	struct _NuclearFam * mParentsFam; /* pointer to family of his parents*/
	struct _NuclearFam * mFoundedFam; /* pointer to all families that he created*/
	struct _Person * mSibling;        /*pointer to his brother*/

	Gender    mGender;		
	AffStatus mAffStatus;
	Marker *  mMarkerArr;			/* a list of markers from input */
	int		  mMarkersCnt;			/* a number of markers*/


	Marker mMarkerBackupForUnknown;	/* ??? */
	int	   mIsUnknown;


	char mFatherID[MAX_PERSON_ID_LEN];	/* father name*/
	char mMotherID[MAX_PERSON_ID_LEN]; /* mather name*/
	struct _Person * mNext;            /* a pointer to next person in the parsing */

	MarkerLLNode * mOptMarkerLL;   /* list of all possible markers;
								    if person was typed then the values are equal to
									 mMarkerArr */
	char mProblem;

} Person;


void GetMarkers(Person * aPerson,int  * allele1,int * allele2,int aMarkerNum);


Person * CreatePerson();

#endif

