/*************************************************************************************
 Recommendation.h
 The file deals with recommendations functions. 
 A recommendation is a struct, which holds a string which is a recommendation to the 
 user of the application to turn a subset of people to "unknown" in a certain marker,
 in order to make the input pedigree be consistent. Meaning, a recommendation is 
 a "critical genotype" of the pedigree, on a certain marker.
*************************************************************************************/
#ifndef _PC_RECOMMENDATION_H
#define _PC_RECOMMENDATION_H

#include "pc_Common.h"
#include "pc_Pedigree.h"



typedef struct _Recommendation
{
	char * mRecommendationString;
	int    mRecommendationLen;
    struct _Recommendation * mNext;

} Recommendation;



typedef struct _RecommendationLL
{
    Recommendation * mFirst;
	Recommendation * mLast;
	int     numOfRecommendation;

} RecommendationLL;


RecommendationLL * CreateRecommendationLL();


#endif

