/*********************************************************************************/
/*  AlleleRecoding.h														     */
/*  Author:	Ma'ayan Fishelson													 */
/*********************************************************************************/
/*																			     */
/*  Comment: This file includes functions used for performing allele-recoding,   */
/*			 both for likelihood computations and for haplotyping.				 */
/*																			     */
/*********************************************************************************/


#ifndef _SL_ALLELE_RECODING_H_
#define _SL_ALLELE_RECODING_H_

#include <stdio.h>
#include <stdlib.h>
#include "sl_PedData.h"
#include "sl_Globals.h"


/*------------------------------*/
/*		FUNCTIONS				*/
/*------------------------------*/

void performAlleleRecoding();
void updatePersonTransmitted(person *currPerson);
void traverseUpTransmitted(person *currPerson);
void traverseDownTransmitted(person *currPerson);
void updateParentsTransmitted(person *pa, person *ma, person *ch);
void addTransmittedAlleles(halfLocusPerson *allelesCh, locusPerson *locusParent);


#endif /* _ALLELE_RECODING_H_ */

