/*****************************************************************************/
/*  Inference.h																 */
/*  Author: Ma'ayan Fishelson												 */
/*****************************************************************************/

#ifndef _SL_INFERENCE_H_
#define _SL_INFERENCE_H_


#include <stdio.h>
#include <stdlib.h>
#include "sl_BayesNet.h"
#include "sl_EliminationOrderStructures.h"
#include "sl_PedData.h"
#include "sl_SpecialMult.h"
#include "sl_Globals.h"
#include "sl_IterateAff.h"


/*------------------------------*/
/*		GLOBAL VARIABLES		*/
/*------------------------------*/

#if ELIMINATE_SELECTORS_TOGETHER
	boolean				eliminateSelectorsTogether;
#endif

/*------------------------------*/
/*		FUNCTIONS				*/
/*------------------------------*/

double envEvaluateLike(double *x, void* funcData);
double evaluateLike(double *x, int numTraitLoci, retValFuncType retFunc, 
					boolean printResults);
void findTraitLocPos(scanIntervalData *scanData, double x, int *newLocPos, 
					Probability *newTheta);
void moveTraitLoc(int numTraitLoci, int *oldLocPos, int *newLocPos, double *newThetas);
void calcLikelihood(product** prodArr, elimOrder *elimOrderArrs);
boolean calcLikelihoodPed(product *prod, int pedNum, elimOrderPed *elimOrderArr);
Probability inferProd(product *prod, elimOrderPed *elimOrd, 
					  float problemSize, float solved);
void zeroDataFreeMemory(product **prodArr);

boolean calcLikelihoodPedApproximate(product *prod, int pedNum, elimOrderPed *elimOrderArr);

#endif		/*	_INFERENCE_H_	*/

