/*********************************************************************************/
/*  ReadData.h																     */
/*  Author: Ma'ayan Fishelson													 */
/*********************************************************************************/
/*																				 */
/*  Comment: This file includes functions used for reading all the data from the */
/*			 input files and initializing the relevant data-structures.			 */
/*																				 */
/*********************************************************************************/

#ifndef _SL_READ_DATA_H_
#define _SL_READ_DATA_H_


#include <stdio.h>
#include <stdlib.h>
#include "sl_LociData.h"
#include "sl_PedData.h"


/*------------------------------*/
/*		GLOBAL VARIABLES		*/
/*------------------------------*/

FILE	*pedFile, *dataFile;		/* Pointers to the input files. */

/*------------------------------*/
/*		FUNCTIONS				*/
/*------------------------------*/

void init(int numMarkers,int* markersUsed, Bool diseaseUsed, int progCode, PedigreeDataStruct *currPedigree);
void openFiles(char *datafileName, char *pedfileName);
void closeFiles(char *datafileName, char *pedfileName);


#endif /* _READ_DATA_H_ */

