package Configuration;
use Exporter qw(import); 
use Environment;
our @EXPORT_OK = qw(%configfile); 
  
our $workDir 	= "\/scratch\/superlinksnp\/$Environment::WORK_DIR";
our $TASKS_DIR  = "$workDir\/tasks";
our $ERRORS_DIR = "$workDir\/errorLogs";
our $LOCKS_DIR 	= "$workDir\/locksOfSys";
# every script that can be call from hap should have its log file at $LOGS_DIR
our $LOGS_DIR 	= "$workDir\/logs";

our $SYSTEM_OUT_OF_RESOURCES_FILENAME_IND = "$ERRORS_DIR\/SYSTEM_OUT_OF_RESOURCES.indication";

$maxSleepTimeOfExpBackoff = 600; # In sec
  
our %configfile = ( 

	#############################################
	#	Parameters used by:						#
	#		AcceptSubmission.pl 				#
	#		Split.pm							#
	#############################################
	dataDir				=> "$workDir\/data",
	
	#############################################
	#	Parameters used by:						#
	#		AcceptSubmission.pl 				#
	#############################################
	mailDir						=> "$workDir\/mail",
	outputDir   				=> "$workDir\/output",
	runlogDir					=> "$workDir\/runlogs",
	taskDir						=> "$workDir\/tasks",
	systemErrorCode				=> '-1',
	jobsErrorLog				=> "$ERRORS_DIR\/jobsErrors.log",
	jobsErrorCode				=> '2',
	highLoadErrorCode			=> '10',
	
	#############################################
	#	Parameters used by:						#
	#       Split.pm 							#
    #		checkTasks.pl						#
	#############################################
	ssh_options		    	=> '-o CheckHostIP=no -o ConnectTimeout=60 -o StrictHostKeyChecking=no',
	ssh_remote			=> 'cbl-hap.cs.technion.ac.il',
	ssh_user			=> 'oren',
	remote_script			=> "'export PERLLIB=\/var\/www\/html\/oren\/$Environment::WEB_DIR\/cgi-bin; perl \/var\/www\/html\/oren\/$Environment::WEB_DIR\/cgi-bin\/reportResults.pl'", #"'. \$HOME/.bash_profile; perl \/var\/www\/html\/oren\/$Environment::WEB_DIR\/cgi-bin\/reportResults.pl'",
	remote_dir			    => "var\/www\/html\/oren\/$Environment::WEB_DIR\/Submissions",	
	web_main_dir            => "/var/www/html/oren/$Environment::WEB_DIR",
	errorOutboxReport		=> "$ERRORS_DIR\/errorOutboxReport.log",
	splitInnerSysError		=> "$ERRORS_DIR\/splitInnerSysError.log",
	
	binDir				=> "\/scratch\/superlinksnp\/$Environment::SRC_DIR\/perlbin",
		
	currentlyRunningDir 			=> "$workDir\/running",
	maxNumberOfParallelTasks		=> '25',
	maxNumberOfParallelLocalTasks	=> '2',
	counterOfTasksLock 				=> "$LOCKS_DIR\/counterOfTasksLock",
	counterOfTasksInSys 			=> "$LOCKS_DIR\/counterOfTasks",
	pidFileName						=> "PIDsToKillList.log",
	
	#############################################
	#	Parameters used by:						#
	#       Split.pm 							#
	#############################################
	splitRunLog				=> "$workDir\/runlogs\/splitSNPdistiller.pl.Report.log",
	SNPdistiller			=> "\/scratch\/superlinksnp\/trunk\/SNP.compileVersion\/snpDistiller",
	mode 					=>  "EliminatingAndCluster", # Default mode
	splitForCheckNum 		=>  '400',
	splitForClusterNum		=>  '400',
	programCode				=>  '8',
	cleaningParam			=>  '4', 	# parameter to snpdistiler - in order to perform only the cleaning.
	clusteringParam			=>  "5 5",  # parameter to snpdistiler - in order to perform only the clustering.
	clusteringRawParam		=>  "5 777",# parameter to snpdistiler - in order to perform only the clustering on raw files.
	partNum					=>  '0',  	# number of clustering parts	  

	#############################################
	#	Parameters used by:						#
	#       killProjByName.pl					#
	#############################################
	
	killAllFamilyScript => "killFamByPPid",
	
	#############################################
	#   Parameters used by						#
	#       Analysis dags						#
	#############################################
	SLoutputError		=> "SLerror_out.txt",
	SLerror				=> "SLerror.txt",
	HZToutputError		=> "HZTerror_out.txt",
	HZTerror			=> "HZTerror.txt",
	PainterOutputError  => "PainterError_out.txt",
	PainterError  		=> "PainterError.txt",
	JobTooHeavy 		=> '3',
	HighRemoveRate		=> '2',	
	RecheckNotEmpty		=> '3',
	
	################################################################
	# 		The definitions are taken from 
	#		/scratch/pedtool/Pedtool/bin/CONFIG.LOCAL.SH
	################################################################
	MAX_AVAILABLE_MEMORY 					=> '450',
	LOCAL_RUN_APPROX_COMPLEXITY_THRESHOLD 	=> '7', 
	MAX_CPU_LOAD_THRESHOLD 					=> '380',
	MAX_MONITOR_CPU_LOAD_THRESHOLD 			=> '800',
	APPROX_ESTIMATION_COMPLEXITY_THRESHOLD 	=> '20',
	LOW_PARALLELIZATION_THRESHOLD 			=>	'9',
	
	################################################################
	#		Semaphore definitions
	################################################################
	#dvir 2011/12/04 - no more use in semaphores
#	semKey 		=> $Environment::PROCESSES_SEMAPHORE_KEY,
#	semNum		=>	'8',
#	semNetKey 	=> $Environment::NETWORK_CONNECTIONS_SEMAPHORE_KEY,  # Network connections monitor
#	semNetNum	=>	'5',	
); 

	# Others
	# dvir : a marker line can be the 4 line in the dat file or higher line.
	# the template for the marker line doesn't have to contain # # for the name of the marker,
	# but we need there are many scripts that need the names of the markers (run_cleaning for example).
	$MARKER_LINE_TEMPLATE = '^3\s+\d+\s*';
	$MARKER_LINE_WITH_MARKER_NAME_TEMPLATE = $MARKER_LINE_TEMPLATE.'#.+#';
	# seperate template for grep, since that grep doesn't work with : +, \s \d
	$MARKER_LINE_TEMPLATE_FOR_GREP = '^3  *[0-9][0-9]*  *#..*#';
	
	# the second parameter should be $!
	$ERR_MSG_FAILED_OPENING_FILE = "Could not open file: %s, error: (%s)";
	$ERR_MSG_FAILED_LOCKING_FILE = "Could not lock file: %s, error: (%s)";
	
	$FAMILY_JOB_DIR_SUFFIX = '.familyJobDir';
	$JOB_DIR_SUFFIX = '.job';
	$DUPLICATE_DIR_SUFFIX = '.duplicate';

	
	$FAMILIES_NUMBERS_FILENAME = 'familiesNumbers.list';
	$PAINTER_PARAMETERS_FILENAME = 'painter_parameters.txt';
	$MADELINE_INPUT_FILENAME = 'madeline.input';
	$HAPLO_PAINTER_INPUT_FILENAME = 'haploPainter.input';
	$MADELINE_DIR = 'madeline';
	$HAPLO_PAINTER_DIR = 'haploPainter';
	$PAINTER_PROGRAM_MADELINE = 'madelineProgram';
	$PAINTER_PROGRAM_HAPLO_PAINTER = 'haploPainterProgram';
	$OUTPUT_FORMAT_PDF = 'pdf';
	$OUTPUT_FORMAT_PNG = 'png';
	
	$SIMPLE_SHORT_CONDOR_JOB = "$configfile{binDir}\/Tmpl\/SimpleShortLocalJob.sub";
	
	# this is in porpose on large caps to be emphasize in the file system,
	# when a programmer looks at the files manualy
	$JOB_SUCCEEDED_FILENAME = 'JOB_SUCCEEDED';
	$JOB_FAILED_FILENAME = 'JOB_FAILED';
	$JOB_FAILED_WITH_ACCEPTABLE_REASON_FILENAME = 'JOB_FAILED_WITH_ACCEPTABLE_REASON';
	# this file is used to mark that the task was killed
	$TASK_KILLED_FILENAME = 'TASK_KILLED.log';
	# this file is used to mark that a job in a task has stopped after a time period
	$JOB_STOPPED_FILENAME = 'JOB_STOPPPED';
	
	# dvir 2011/11 this file will indicate that the specific job or one of the job sub jobs was timed out.
	$JOB_TIMEOUT_FILENAME = 'JOB_TIMEOUT';
	
	$JOB_WITHOUT_STATUS_FILENAME = 'JOB_WITHOUT_STATUS';
	
	$ESTIMATION_JOB_DURATION_IN_SECONDS_FILENAME = 'estimationInSeconds.log';
	
	$TASK_MAIN_DAG_NAME = 'Global.dag';
	# the name of the dag that will be created when preforming multi window run
	$TASK_SECOND_DAG_FILENAME = 'Second.dag';
	$CONDOR_DAG_SUBMISSION_OF_MAIN_TASK_OUTPUT_FILENAME = 'CondorDagSubmissionOfMainTask.output';
	$CONDOR_DAG_SUBMISSION_OF_MAIN_TASK_ERROR_FILENAME = 'CondorDagSubmissionOfMainTask.error';
	$CONDOR_DAG_REMOVING_OF_MAIN_TASK_OUTPUT_FILENAME = 'CondorDagRemovingOfMainTask.output';
	$CONDOR_DAG_REMOVING_OF_MAIN_TASK_ERROR_FILENAME = 'CondorDagRemovingOfMainTask.error';
	
	# this file is in order that not both the killed process and the tasks will access
	# the counters of the num of submitted tasks & num of running tasks.
	# so that those counters won't be raised twice.
	$TASK_LOCK_FILENAME = 'TASK_LOCK';
	
	$EXCLUSIVE_LOCK = '2';
	$SHARED_LOCK = '1';
	$EXCLUSIVE_OR_FAILURE_LOCK = '6'; # won't wait for the lock if the lock is taken
	
	$TASKS_BY_STATUS_DIR = "$workDir\/tasksByStatus";
	# this folder will contain all the names of the tasks which the task's main dag is submitted now (=running now).
	$TASKS_BY_RUN_STATUS_DIR = "$TASKS_BY_STATUS_DIR\/running";
	# this folder will contain all the names of the tasks which the task's was submitted to the server from outside,
	# and the task hasn't started to run
	# for example: from c b l-h a p, and we need to start run the tasks
	$TASKS_BY_WAIT_TO_RUN_STATUS_DIR = "$TASKS_BY_STATUS_DIR\/waitingToRun";
	
	our $MAX_TASKS_IN_WAITING_TO_RUN_DIR = 27;
	
	# this lock, since the script run in crontab (once in _ minutes)
	# and we don't want that 2 scripts will run at the same time
	$CHECK_TASKS_SCRIPT_LOCK = "$LOCKS_DIR\/checkTasks.pl.lock";
	$ACCEPT_SUBMISSIONS_SCRIPT_LOCK = "$LOCKS_DIR\/AcceptSubmission.pl.lock";
	$TASK_HANDLER_SCRIPT_LOCK = "$LOCKS_DIR\/TaskHandler.pl.lock";
	$TASKS_WAITING_TO_RUN_LOCK = "$LOCKS_DIR\/tasksDir_WaitingToRun.lock";
	
	$ACCEPT_SUBMISSIONS_SCRIPT_LOG_FILENAME = "$LOGS_DIR\/AcceptSubmission.pl.log";
	$KILL_PROJECT_BY_NAME_SCRIPT_LOG_FILENAME = "$LOGS_DIR\/killProjByName.pl.log";
	
	# if we get an windowed analisys with 1000 windows (per family) than we won't create
	# 1000 jobs per family, because the overhead of the condor to maintain so many jobs
	# is huge, for example the DAG has to check too many jobs every preiod.
	# also, there is too many accesses to the file system of the server c b l - l i n k 0 1
	# to update the status of the jobs.
	# so we would like to create no more than $MAX_NUM_OF_JOBS_PER_FAMILY jobs
	# so this overhead will be little.
	# terminology: task may contain many jobs
	$MAX_NUM_OF_JOBS_PER_FAMILY = 40; # there be a case with 41 jobs.
	$OPTIMIZE_MIN_EXECUTION_TIME_OF_A_SINGLE_JOB_IN_MINUTES = 30;
	$OPTIMIZE_MIN_EXECUTION_TIME_OF_A_SINGLE_JOB_IN_SECONDS = $OPTIMIZE_MIN_EXECUTION_TIME_OF_A_SINGLE_JOB_IN_MINUTES * 60;
	$ESTIMATION_TIME_IN_MINUTES = 5; # 
	$ESTIMATION_TIME_IN_SECONDS = $ESTIMATION_TIME_IN_MINUTES * 60;
	
	# the seperator between dat files that are at the same multi dat file
	# and the seperator between ped files that are at the same multi ped file
	$MULTI_FILES_IN_SINGLE_FILE_SEPERATOR = "###multi end###\n";
	$MULTI_DAT_FILE_NAME = 'dat.multi';
	$MULTI_PED_FILE_NAME = 'ped.multi';
	$CURRENT_WINDOW_DAT_FILE_NAME = 'current_window.dat';
	$CURRENT_WINDOW_PED_FILE_NAME = 'current_window.ped';
	$MULTI_WINDOW_RUN_RETURN_VALUES_FILENAME = 'return_values.log';
	
	# this name will be the name of the ped at the current family job
	$PED_FILE_NAME = 'job.ped';
	
	$PED_WITH_NO_ALLELS_FILE_NAME = 'no_allels.ped';
	
	# how many fields are at the begining of each line before the allels of the person.
	# the fields at the begining are for the family num, person num, affection status...
	$NUM_OF_FIELDS_BEFORE_FIRST_ALLEL_AT_PED_FILE = 10;
	
	# not all superlink analyses can work on pedigree with family num such as 2 or higher
	# but the superlink analyses always works on family num 1, so we will change the family 
	# number to 1.
	$DEFAULT_FAMILY_NUMBER = 1;
	
	$ESTIMATION_DIR_NAME = 'estimation';
	
	$MULTI_WINDOW_TASK_INDICATION_FILENAME = 'MULTI_WINDOW_TASK';
	
	$HAPLOTYPING_ANALYSIS_FILENAME = 'HAPLOTYPING';
	
	$CONDOR_JOB_SUBMIT_DEFINITIONS_FILENAME = 'Analysis.sub';
	$CONDOR_ESTIMATION_JOB_SUBMIT_DEFINITIONS_FILENAME = 'estimation.sub';
	$CONDOR_JOB_SUBMIT_DEFENITIONS_TEMPLATE_FILENAME = "$configfile{binDir}\/Tmpl\/Analysis.sub.tmpl";
	$CONDOR_JOB_SUBMIT_DEFINITIONS_MULTI_WINDOW_PER_JOB_FILENAME = 'MultiWindowPerJob.sub';
	
	$HAPLOTYPE_LARS_PROGRAM_DIR = "$configfile{binDir}\/Haplotyping-Lars";
	#$STANDARD_OUTPUT_FILE_HAPLOTYPE_LARS = 'haplotypeLars.out';
	#$STANDARD_ERROR_FILE_HAPLOTYPE_LARS = 'haplotypeLars.err';
	$RESULT_FILE_HAPLOTYPE_LARS = 'haplotypes.txt';
	$RESULT_FILE_ASSIGNMENT_HAPLOTYPE_LARS = 'assignment.txt';
	# this file will contain the results of the haplotype lars for all the windows
	# at the current job
	# $MULTI_WINDOW_RESULT_FILE_HAPLOTYPE_LARS = 'haplotypes.txt.multi';	
	
	$ALLEL_VALUE_UNKNOWN = 0;
	$AFFECTION_STATUS_UNKNOWN = 0;
	$AFFECTION_STATUS_HEALTHY = 1;
	$AFFECTION_STATUS_AFFECTED = 2;

	$SEX_MALE = 1;
	$SEX_FEMALE = 2;
	
	# for the founders of the pedigree, we don't know their parents number
	# so at the father&mother cols, it is written : $UNKNOWN_PERSON_NUM
	$UNKNOWN_PERSON_NUM = 0;
	
	$PED_FILE_COL_INDEX_FAMILY = 0;
	$PED_FILE_COL_INDEX_ID = 1;
	$PED_FILE_COL_FATHER_ID = 2;
	$PED_FILE_COL_MOTHER_ID = 3;
	$PED_FILE_COL_SEX = 7;
	$PED_FILE_COL_INDEX_AFFECTION_STATUS = 9;
	$PED_FILE_COL_INDEX_FIRST_MARKER = $NUM_OF_FIELDS_BEFORE_FIRST_ALLEL_AT_PED_FILE;
	
	$MARKERS_NUMS_TO_NAMES_FILENAME = 'markersNumsToNames.map';
	
	# some analysis comes with a file of the names of the people of the pedigree
	# NOTE: this file is hidden, so you will need to make ls -a to see it.
	$PEOPLE_NAMES_FILE_NAME = ".pedigree_translate_1.txt";
	
	$FIRST_JOB_NUMBER = 1;
	
	$HAP_INDICATION_FILE_FOR_ANALYSIS_END = 'TASK_LOG.txt';

	$DRAWING_ANALYSIS_FILENAME = 'DRAWING'; # same principle as $HAPLOTYPING_ANALYSIS_FILENAME
	$SEGREGATION_ANALYSIS_FILENAME = 'SEGREGATION'; # same principle as $HAPLOTYPING_ANALYSIS_FILENAME
	$HMM_ANALYSIS_FILENAME = 'HMM'; # same principle as $HAPLOTYPING_ANALYSIS_FILENAME
	
	$MORGAN_LM_LINKAGE_EXE = 'lm_linkage.64bit.version3.0.3'; # the name of the exe file
	$MORGAN_GL_AUTO_ANALYSIS_FILENAME = 'MORGAN_GL_AUTO'; # same principle as $HAPLOTYPING_ANALYSIS_FILENAME
	$MORGAN_LM_MARKERS_ANALYSIS_FILENAME = 'MORGAN_LM_MARKERS'; # same principle as $HAPLOTYPING_ANALYSIS_FILENAME
	$MORGAN_LM_MARKERS_PROGRAM_DIR = "$configfile{binDir}\/morganbin";
	$MORGAN_LM_MARKERS_NUM_OF_SIMULTANEOUS_EXECUTEABLES_PER_FAMILY = 5;	
	$MORGAN_LM_MARKERS_STANDARD_OUTPUT_FILE = 'morgan-lm_markers.out';
	$MORGAN_LM_MARKERS_STANDARD_ERROR_FILE = 'morgan-lm_markers.err';
	our $MULTI_WINDOW_RUN_MORGAN_LM_MARKERS_OUTPUT_FILENAME = 'morgan-lm_markers.multi.out';
	our $MULTI_WINDOW_RUN_MORGAN_LM_MARKERS_ERROR_FILENAME = 'morgan-lm_markers.multi.err';

	$MORGAN_LM_MARKERS_PARAM_FILENAME = 'par.lmm';
	$MORGAN_LM_MARKERS_PARAM_WITH_NUM_OF_ITERATIONS_FILENAME = 'par.withNumOfIterations.lmm';
	
	$MORGAN_LM_MARKERS_SEPERATOR = 'MORGAN_LM_MARKERS_SEPERATOR Iterations:';
	
	$GL_AUTO_PARAM_FILENAME = 'par.glAuto';
	$GL_AUTO_PARAM_WITH_NUM_OF_ITERATIONS_FILENAME = 'par.withNumOfIterations.glAuto';
	$GL_AUTO_STANDARD_OUTPUT_FILE = 'gl_auto.out';
	$GL_AUTO_STANDARD_ERROR_FILE = 'gl_auto.err';
	our $GL_AUTO_MULTI_WIN_RES = 'gl_auto.multi.out';
	our $GL_AUTO_MULTI_WIN_ERR = 'gl_auto.multi.err';
	$GL_AUTO_SEPERATOR = 'GL_AUTO_ITERATION_SEPERATOR Iterations:';
	$GL_AUTO_SINGLE_RUNNING_OUTPUT_FILE = 'gl_auto_single_res.out';
	
	# 2011/07/28, error files to be reported to web server in case of user error or analysis failure.
	# the name of the report file name that the web server expect to get
	$REPORT_HTML_FILENAME = 'results.html';
	$RUN_REPORT_HTML_FOLDERNAME = 'runReportHtml';
	$REPORT_TEXT_FILENAME = "$RUN_REPORT_HTML_FOLDERNAME\/reportText.txt";
	$REPORT_HTML_TEMPLATE_FILENAME = "$configfile{binDir}\/Tmpl\/report\.html\.tmpl";	
	
	$LOD_SCORE_GRAPH_FILES_EXTENTION = 'png';
	
	our $ANALYSIS_PARAMETERS_MODEFILE_FILENAME = 'modefile.txt';
	
	our $CONDOR_BIN_DIR = '/shared/condor/current_version/bin/';
			
	our $INITIAL_PARTIAL_HTML_OUTPUT = 'initial.partial.html.out';
	our $FINAL_PARTIAL_HTML_OUTPUT = 'final.partial.html.out';
	our $PARTIAL_HTML_OUTPUT = 'partial.html.out';
	
	# dvir 2011/10/26
	our $SEGREGATION_EXECUTEABLE = "$configfile{binDir}\/Superlink\/SuperLink.linux";
	
	# dvir 2011/11/15
	our $WINDOW_END_TIME_FILENAME = "window_end_time.txt";
	
	# dvir 2011/11/16
	our $HMM_DAT_FILENAME = 'datafile.dat';
	our $HMM_PED_FILENAME = 'pedfile.dat';
	
	# a message fragment when the condor revokes the job cause the job run too much time (timeout)
	# example for that message: 
	# The job attribute PeriodicRemove expression '(RemoteWallClockTime - CumulativeSuspensionTime > 8)' evaluated to TRUE
	our $TIMEOUT_MESSAGE_FRAGMENT_AT_JOB_LOG_FILE = 'The job attribute PeriodicRemove expression';
1;
