package DrawingGeneral;

use strict;

use General;
use Configuration;

# dvir 19/12/2010
# returns the output filename of the pedigree of the haploPainter
# this isn't a method ! shouldn't be call like $class -> getPainterProgramOutputFileName
# it should be called like this &Drawing::getPainterProgramOutputFileName
#	parameters : 
#		$outputFormat - should  be $Configuration::OUTPUT_FORMAT_PDF
#								or $Configuration::OUTPUT_FORMAT_PNG
#		$painterProgram - should  be $Configuration::PAINTER_PROGRAM_MADELINE
# 								  or $Configuration::PAINTER_PROGRAM_HAPLO_PAINTER

#		$familyNumber - the num of the family
sub getPainterProgramOutputFileName($ $ $) {
	my $outputFormat = $_[0];
	my $painterProgram = $_[1];
	my $familyNumber = $_[2];
		
	if ($outputFormat ne $Configuration::OUTPUT_FORMAT_PDF &&
		$outputFormat ne $Configuration::OUTPUT_FORMAT_PNG) {
	    &General::reportOnErrorReleaseSemaphoresAndDie('Drawing.pm',`pwd`,"getPainterProgramOutputFileName: wrong outputFormat: $outputFormat");
	}
	
	my $outputFileName;	
	if ($painterProgram eq $Configuration::PAINTER_PROGRAM_MADELINE) {
		if ($outputFormat eq $Configuration::OUTPUT_FORMAT_PDF) {
			$outputFileName = "pedigree.$familyNumber.$outputFormat";
		}
		else {
			$outputFileName = "pedigree.${familyNumber}-0.$outputFormat";
		}
	}
	elsif ($painterProgram eq $Configuration::PAINTER_PROGRAM_HAPLO_PAINTER) {
		$outputFileName = "painter_out_$familyNumber.$outputFormat";
	}
	else {
		&General::reportOnErrorReleaseSemaphoresAndDie('Drawing.pm',`pwd`,"getPainterProgramOutputFileName: wrong painterProgram: $painterProgram");
	}
	
	return $outputFileName;
}

1;