package HMM_Html;

use strict;
use ProcessingBackend;
use Cwd;
use General;
use DatPedHandler;
use Plotter;

# executeable output files
our $OUTPUT_FILE_HMM_LOD               = 'results.txt';
our $OUTPUT_FILE_HMM_HAPLOTYPE         = 'haplotypes.txt';
our $OUTPUT_FILE_HMM_COLORED_HAPLOTYPE = 'colouredHaplotypes.txt';

our @HMM_EXECUTEABLE_OUTPUT_FILES = (
	$OUTPUT_FILE_HMM_LOD,
	$OUTPUT_FILE_HMM_HAPLOTYPE,
	$OUTPUT_FILE_HMM_COLORED_HAPLOTYPE);
	
	
# those files will be copied to the web server
my $HTML_OUTPUT_FILENAME = $ProcessingBackend::OUTPUT_FILE;
our @RESULTS_FILE_LIST = (
	$HTML_OUTPUT_FILENAME,
	$ProcessingBackend::OUTPUT_NAVIGATION_FILE,
	$ProcessingBackend::OUTPUT_RESULTS_FILE,
	'formatted_outputHaplo.html',
	$ProcessingBackend::COLLECT_DATA_FILE
);
	
# dvir 2011/11/17: all the section bellow was copied from PostHMM.pl except some few changes

sub loadResults( $ );
sub printColoredNumber( $ );


my @markersNames = ();
my @entriesNum = (); 		#One for each marker in markersNames

my @distEntries = ();	
my @LNEntries = ();	#One for each dist in distEntries
my @LODEntries = ();	#One for each dist in distEntries
my @NPLSPAIRSEntries = ();	#One for each dist in distEntries
my @NPLSALLEntries = ();	#One for each dist in distEntries

my @LNEntriesTotal = ();	#One for each dist in distEntries
my @LODEntriesTotal = ();	#One for each dist in distEntries
my @NPLSPAIRSEntriesTotal = ();	#One for each dist in distEntries
my @NPLSALLEntriesTotal = ();	#One for each dist in distEntries
my ($clustered,@linesMap,$fam,$NPLSALLEntriesTotal,$bedFlag,$result);
my ($haploOutput,$fullAddress,$multiTableOutputMain,$pedInd,@lineData,);
my (@lines,$i);
my ($j,$name,@positions);
my ($LOD_TABLE_IS_EMPTY_IND,$LODdata,$clusterCount,$clusterIndex,$code,$codeIndex,$color,$colorCol1_1,$colorCol1_2,$colorCol2_1,$colorCol2_2,$countPeople,$currCluster,$currVal,$firstPosContainsName,$id,$k,$line,$lineRes,$mapIndex,$mapVal,$markerName,$nameID,$nameIndex,$nameLen,$nextId,$noEntry,$peopleNum,$personID,$personIndex,$personName,$prevCluster,$prevMapIndex,$projName,$rangeIndex,$sepPeople,$skipSearch,$skipSecondary,$startAt,$startPos,$width,$wordIndex,%familyUnFinishedOutputMessage,%lineValues,%namedPeople,@codeLine,@codeLineTmp,@currColor_1,@currColor_2,@datLines,@data,@innerMarkersNames,@mapLine,@mapLineTmp,@markerData,@markersArray,@nameParts,@people,@peopleData,@peopleNames,@realVals,@splitData,@tmp,@vals);
my $projectTaskDir;
my %variables;
my (@successfulFamiliesArr,$maxLOD,$maxLN);
my (@markersArrayBackup,@chromNameData,@multiTableOutput,$resFile,@haploData);

# this method is called when cwd is the workDir
sub createHtmlPages( $ \@ \%) {
	my $htmlFailureText = $_[0];
	my $successfulFamiliesArrRef = $_[1];
	my $projectTaskDir2 = $_[2];
	my $variablesHashRef = $_[3];
	
	%variables = %$variablesHashRef;
	$projectTaskDir = $projectTaskDir2;
	
	@successfulFamiliesArr = @$successfulFamiliesArrRef;

	%familyUnFinishedOutputMessage = ();

	$maxLN = -1;
	$maxLOD = -1;

	$firstPosContainsName = 0;

	$LOD_TABLE_IS_EMPTY_IND = 3;	


	$variables{ webDir } = $variables{ newDir };
	$variables{ newDir } = $projectTaskDir;

	if ( defined($variables{ from }) && ( $variables{ from } !~ /Unknown/ ) ) {$startAt = $variables{ from };}
	else {$startAt = 1;}
	@markersArray  = sort {$a <=> $b} @{$variables { usedMarkersId }};
	@markersArrayBackup = @markersArray;

	$projName = $variables{ PROJ };
	@chromNameData = split /chrom_/, $projName;
	@positions = &ProcessingBackend::getBEDPositions( \%variables );
	if ($#positions > -1) {
		&ProcessingBackend::createBEDfile($chromNameData[1]+0, $positions[0], $positions[1]);
	}

	##################################
	$clustered = 0;
	if (-e "$projectTaskDir\/mapfile.dat") {
		open MAP, "$projectTaskDir\/mapfile.dat";
		@linesMap = <MAP>;
		close MAP;
		
		my $line = shift @linesMap;
		while (($#linesMap > -1) && ($line !~ /\[VALUE MAPPING\]/)) {$line = shift @linesMap;}
		if (defined($line) && ($line =~ /\[VALUE MAPPING\]/)) {$clustered = 1;}
	}

	open HAPLO_OUT, ">formatted_outputHaplo.html";
	print HAPLO_OUT "<html> 
				 <body bgcolor=\"#F0FFFF\">
				 <center>
					<p><h1><u><b> Results of Haplotyping for project $variables{ PROJ }  </b></u></h1></p>
					</center>";

	@multiTableOutput = ();

	#Omer - this hash is used for graph plotting
	my %aggregateLodPerFamilyHash = ();

	my $totalArraysInitialized = 0;
	foreach $fam (@$successfulFamiliesArrRef){
		$fam =~ s/\s+//sig;
		my $currFamilyRunDir = &General::getFamilyRunDir($fam);
		my $lodResultFile = "$currFamilyRunDir\/results.txt";
		my $haplotypeResultFile = "$currFamilyRunDir\/haplotypes.txt";
		unless (-e $lodResultFile) {
			`touch TASK_FAILED.txt`;
			exit(-1);
		}

		#Init global arrays
		@markersNames = ();
		@entriesNum = ();
		
		@distEntries = ();
		@LNEntries = ();
		@LODEntries = ();
		@NPLSPAIRSEntries = ();
		@NPLSALLEntries = ();	
		
		#Load the HMM computation results
		my $indIsResultsEmpty = &loadResults($lodResultFile);
		
		#If the HMM failed for this family, print message and continue to the next family
		if ($indIsResultsEmpty == $LOD_TABLE_IS_EMPTY_IND) {
			$multiTableOutput[$fam - 1] = "<p>The calculation of the LOD scores for pedigree ".($fam - 1)." has exceeded the time limit of the task.</p>";
			print HAPLO_OUT "<p>The calculation of the haplotypes for pedigree ".($fam - 1)." has exceeded the time limit of the task.</p>";
			next;
		}
		
		#Initialize the total arrays to zeros if needed
		unless ($totalArraysInitialized) {
			for $i (0..$#LNEntries) {
				$LNEntriesTotal[$i] = 0;
				$LODEntriesTotal[$i] = 0;
				$NPLSPAIRSEntriesTotal[$i] = 0;
				$NPLSALLEntriesTotal = 0;			
			}	
			$totalArraysInitialized = 1;
		}
		
		#Update the families hash array
		@{$aggregateLodPerFamilyHash{$fam}} = ();
		
		#Update the total arrays and the family hash array
		for $i (0..$#LNEntries) {
			$LNEntriesTotal[$i] += $LNEntries[$i];
			$LODEntriesTotal[$i] += $LODEntries[$i];
			$NPLSPAIRSEntriesTotal[$i] += $NPLSPAIRSEntries[$i];
			$NPLSALLEntriesTotal[$i] += $NPLSALLEntries[$i];
			push (@{$aggregateLodPerFamilyHash{$fam}}, $LODEntries[$i]);
		}	
		
		$bedFlag = "NO_BED";
		if ($#successfulFamiliesArr == 0) {$bedFlag = "BED";}
		@markersArray = @markersArrayBackup;
		$multiTableOutput[$fam - 1] = &createResultTable($bedFlag);
		
		# dvir 2010/10/25
		# adding a message to mention that the rest of the LOD table had not been calculated due to time limit
		if (defined $familyUnFinishedOutputMessage{$fam - 1}) {
			$multiTableOutput[$fam - 1].= $familyUnFinishedOutputMessage{$fam - 1};
		}

		if ($clustered == 1) {
			$result = &openClusters($haplotypeResultFile, @linesMap);
			$haplotypeResultFile = $haplotypeResultFile."cluster_open";
			open HAPLO, ">$haplotypeResultFile";
			print HAPLO "$result";
			close HAPLO;
		}

		##################################

		$haploOutput = &createHaploResult($haplotypeResultFile, $fam);
		print HAPLO_OUT "\n<font size=4><div align=center><center><b>Haplotypes for family $fam</b></font>\n";
		print HAPLO_OUT "$haploOutput";
		print HAPLO_OUT "</br>";	
	}
	close HAPLO_OUT;

	#Omer 3/9/2011 - create all graphs using the Plotter
	&Plotter::plotLodGraphs(\@distEntries, \@LODEntriesTotal, \%aggregateLodPerFamilyHash);

	#Create combined LOD table for all families
	if ($#successfulFamiliesArr > 0) {
		@LNEntries = @LNEntriesTotal;
		@LODEntries = @LODEntriesTotal;
		@NPLSPAIRSEntries = @NPLSPAIRSEntriesTotal;
		@NPLSALLEntries = @NPLSALLEntriesTotal;

		@markersArray = @markersArrayBackup;
		$multiTableOutputMain = &createResultTable("BED");
	}


	open(OUT, "> formatted_output.html") || die "<p>cannot open formatted_output.html</p>";
	print OUT '<html>
				<head>
				<script type="text/javascript">
					function hideOrShow(id) {
						if (document.getElementById(id).style.display==\'none\') {
							document.getElementById(id).style.display=\'\';
							document.getElementById(\'label_\'+id).innerHTML = \'Hide LOD table\';
						}
						else {
							document.getElementById(id).style.display=\'none\';
							document.getElementById(\'label_\'+id).innerHTML  = \'Show LOD table\';
						}				
					}
				</script>
				</head>'.
				'<body bgcolor="#F0FFFF">
				<center> ';
	print (OUT "<p><h1><u><b>  Results of SingleLocus MultiPoint Analysis for Project $variables{ PROJ } </b></u></h1></p></center>");
	print OUT $htmlFailureText;
	print OUT "<a name=\"Graph\"></a>\n";

	######## Genome browser link ######
	$fullAddress = $ProcessingBackend::HTTP_HOST;
	if ( $variables{ webDir } =~ /^.*var\/www\/html\/(.*)$/ ) {$fullAddress = $ProcessingBackend::HTTP_HOST.$1;}
	if (exists $variables { positions } && $variables { positions } ne '') {
		@positions = @{$variables { positions }}; 
		if ($#positions > -1) {print OUT "<a href=\"http://genome.ucsc.edu/cgi-bin/hgTracks?clade=mammal&org=Human&db=hg18&pix=800&hgt.customText=$fullAddress\/$ProcessingBackend::BED_OUTPUT_FILE\" target=\"_blank\">View in genome browser</a>";}
		else {print OUT "<font color=\"#999999\"><u>View in genome browser</u></font>&nbsp;(No data. Available for snp input only)";}
	}
	unless (-e "collect_data.txt") {`touch "collect_data.txt"`;} # in order that the send files to hap will succeed

	###################################

	#Add main graph to HTML file
	if (scalar(@successfulFamiliesArr) > 1 && (-e "LODgraph.pedfile_main.png" )){
		print OUT "<center>All analyzed pedigrees combined</center><br>\n";
		print OUT "<center><img src=\"LODgraph.pedfile_main.png\" /></center>\n";
		print OUT "<a id=\"label_pedigrees_combined\" href=\"javascript:void(0);\" onclick=\"hideOrShow('pedigrees_combined');\">Hide LOD table</a>";
		print OUT "<div id=\"pedigrees_combined\" style=\"display=\'\';\">$multiTableOutputMain</br></div>";
	}

	#Add each family graph to the HTML file
	$pedInd  = 1;
	if (scalar(@successfulFamiliesArr) > 1) {	
		while( -e "LODgraph.pedfile_$pedInd.png" ){		
			print OUT "</br></br><center>Pedigree ".$pedInd."</center><br>\n";
			print OUT "<center><img src=\"LODgraph.pedfile_$pedInd.png\" /></center>\n";
				print OUT "<a id=\"label_pedigree_$pedInd\" href=\"javascript:void(0);\" onclick=\"hideOrShow('pedigree_$pedInd');\">Hide LOD table</a>";
				print OUT "<div id=\"pedigree_$pedInd\" style=\"display=\'\';\">$multiTableOutput[$pedInd-1]</br></div>";
			$pedInd++;
		}
	}
	else {
		print OUT "<center>Pedigree 1</center><br>\n".
				  "<center><img src=\"LODgraph.pedfile_1.png\" /></center><br><br>\n".
				  "$multiTableOutput[0]</br>";
	}
	print OUT "<br>\n"; 
	close OUT;
	&makeOuputFrameset();
}

################################################################
# 				loadResults
#	Loads the HMM multipoint results into the arrays above
#
#	Parameters:
#				$_[0] - the HMM result file
#	Returns:
#					NOTHING
################################################################
sub loadResults( $ ) {
	my $resFile = $_[0];
	
	open RES, "$resFile";
	@lines = <RES>;
	close RES;
	
	$i = 0;
	
	while ((defined($lines[ $i ])) && ( $lines[ $i ] !~ /Trait/ )) {		#format is "  Marker | Trait Position (cM) |   LN(LIKE)  | LOD_SCORE
																		# 			   Name  |  (from marker #x)   |             |
		$i++;
	}
	
	if (!defined($lines[ $i ])) {
		`touch TASK_FAILED.txt`;
		exit(-1);
	}
	
	# dvir. no lod score data.
	#-------------------------------------------------------------------------------------------
	#  Marker | Trait Position (cM) |   LN(LIKE)  | LOD_SCORE   |	NPL         |	NPL         
	#   Name  |  (from marker #1)   |             |             |	SPAIRS      |	SALL        
	#-------------------------------------------------------------------------------------------
	#Stopped after reaching timeout at 8.38367 minutes
	#Completed number of loci: 0
	if ($lines[ $i + 3 ] =~ /^Stopped/) {return $LOD_TABLE_IS_EMPTY_IND;}
	
	@lineData = split /\s+/, $lines[ $i + 3];
	if ( $lineData[1] =~ /^[+-]?\d+\.?\d*$/ ) {
		push(@markersNames, "");
		$i += 2;
	}
	else {
		$name = $lineData[1];
		for $j (2.. $#lineData) {$name = $name." ".$lineData[$j];}
		push(@markersNames, $name);
		$firstPosContainsName = 1;
		$i += 3;
	}
	
	while ( $lineData[0] !~ /------------------/) {
		$i++;
		$entriesNum[$#markersNames] = 0;

		@lineData = split /\s+/, $lines[ $i ];
		while ( defined($lineData[1]) && ( $lineData[1] =~ /^[+-]?\d+\.?\d*$/ ) ) {
			push(@distEntries,$lineData[1]);
			push(@LNEntries,$lineData[2]);
			push(@LODEntries,$lineData[3]);
			push(@NPLSPAIRSEntries,$lineData[4]);
			push(@NPLSALLEntries,$lineData[5]);
			$i++;
			$entriesNum[$#markersNames] += 1;
			
			# dvir. no all lod score rows exists at the table
			if ($lines[ $i ]=~/^Stopped/) {
				$familyUnFinishedOutputMessage{$fam - 1} = "<p>The calculation of the LOD for the rest of the markers has exceeded the time limit of the task.</p>";
				return;
			}
			@lineData = split /\s+/, $lines[ $i ];
		}
		#@lineData = split /\s+/, $lines[ $i ];
		if ($lineData[0] =~ /------------------/) {
			last;
		}
		$name = $lineData[1];
		for $j (2.. $#lineData) {$name = $name." ".$lineData[$j];}
		push(@markersNames, $name);
	}
	
	@lineData = split /\s+/ , $lines[ $i + 1 ];
	$maxLN = $lineData[2];
	$maxLOD = $lineData[3];
}

################################################################
# 				createResultTable
#
#	Parameters:
#				$_[0] - indication if a BED file should be created
#				uses the global arrays.
#				assuming they were initiated
#	Returns:
#				Table output string (as a part of html page)
################################################################
sub createResultTable () {
	my $tableOutput = "<table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\" id=\"AutoNumber1\">
	<tr>
	<td width=\"24%\" colspan=\"3\" align=\"center\"><b>Marker information</b></td>
	<td width=\"8%\" rowspan=\"2\" align=\"center\"><b>LN</b></td>
	<td width=\"8%\" rowspan=\"2\" align=\"center\"><b>LOD</b></td>
	<td width=\"8%\" rowspan=\"2\" align=\"center\"><b>NPL SPAIRS</b></td>
	<td width=\"8%\" rowspan=\"2\" align=\"center\"><b>NPL SALL</b></td>
	</tr>
	<tr>
	<td width=\"8%\" align=\"center\"><b><font color=\"#0000FF\">Marker id</font></b></td>
	<td width=\"8%\" align=\"center\"><b><font color=\"#0000FF\">Marker name</font></b></td>
	<td width=\"8%\" align=\"center\"><b><font color=\"#0000FF\">Distance</font></b></td>
	</tr>";

	$i = 0;
	$nextId = 1;
	for $j (0 .. $#markersNames) {
		for $k (1 .. $entriesNum[ $j ]) {
			$name = "&nbsp;";
			$id = "&nbsp;";
			if (( $k == 1 ) && (length $markersNames[ $j ] > 0)) {
				$id = $nextId;
				if ($startAt > 1) {$id = $startAt + $id - 1;}
				$nextId++;
				$name = $markersNames[ $j ];
				
				if ($variables{ numMarkers } > $#markersArray + 1) {$id = shift @markersArray;}
				
				if (! -z "mapfile.dat") {$id = "c".$id;}
			}
			$tableOutput = $tableOutput."<tr>
			<td width=\"8%\" align=\"center\"><b><font color=\"#0000FF\">".$id."</font></b></td>
			<td width=\"8%\" align=\"center\"><b><font color=\"#0000FF\">".$name."</font></b></td>
			<td width=\"8%\" align=\"center\"><b><font color=\"#0000FF\">".$distEntries[ $i ]."</font></b></td>
			<td width=\"8%\" align=\"center\"><b>".$LNEntries[ $i ]."</b></td>
			<td width=\"8%\" align=\"center\"><b>".&ProcessingBackend::printColoredNumber($LODEntries[ $i ])."</b></td>
			<td width=\"8%\" align=\"center\"><b>".$NPLSPAIRSEntries[ $i ]."</b></td>
			<td width=\"8%\" align=\"center\"><b>".$NPLSALLEntries[ $i ]."</b></td>
			</tr>";
			
			open TEST, "> /tmp/bla.txt";
			print TEST "$tableOutput";
			close TEST;
			
			if ($_[0] !~ /NO/) {
				if ($name =~ /&nbsp;/ ) {&ProcessingBackend::addMarkerData("","", $distEntries[ $i ], $LODEntries[ $i ]);}
				else {&ProcessingBackend::addMarkerData($id, $name, $distEntries[ $i ], $LODEntries[ $i ]);}
			}
			
			$projName = $variables{ PROJ };
			@chromNameData = split /chrom_/, $projName;
			if (exists $variables { positions } && $variables { positions } ne '') {
				@positions = @{$variables { positions }};
				
				if (($_[0] !~ /NO/) && ($#positions > -1) && ($name !~ /&nbsp;/)) {
					$LODdata = $LODEntries[ $i ];
					if ($LODdata =~ /^[+-]?\d+\.?\d*$/){
						@innerMarkersNames = split /\([0-9]+\)[ ]*/, $name;
						$markerName = $innerMarkersNames[0];
						@markerData = grep(/$markerName :/, @positions);
						@splitData = split / : /, $markerData[0];
						$startPos = $splitData[1];
						&ProcessingBackend::addMarkerLODscore("$ProcessingBackend::RUN_DIR\/$ProcessingBackend::BED_OUTPUT_FILE", $chromNameData[1]+0, $startPos, $LODdata);
					}
				}	
			}
			$i++;
		}
	}
	$tableOutput = $tableOutput."</table>";

	return $tableOutput;
}


################################################################
# 				createHaploResult
#
#	Parameters:
#				$_[0] - the haplotypes file name
#				$_[1] - the current family number
#				uses the global arrays.
#				assuming they were initiated
#	Returns:
#				text for haplotyping table in formatted_outputHaplo.html
################################################################
sub createHaploResult () {

	my $haploFile = $_[0];
	my $pedNum = $_[1];
	
	if (! -e "$haploFile") {
		return;
	}
	
	open HAPLORES, "$haploFile";
	@haploData = <HAPLORES>;
	close HAPLORES;
	
	# loadNames
	my @arr = ();
	if (-e "$projectTaskDir\/pedigree_translate_1.txt") {
		open T, "$projectTaskDir\/pedigree_translate_1.txt";
		@arr = <T>;
		close(T);
	}

	%namedPeople = ();
	foreach my $line (@arr) {
		my @val = split(/\s+/,$line);
		$namedPeople{ $val[0].".".$val[1] } = $val[2];
	}

	my $tableOutput = "<table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\" id=\"AutoNumber1\">";
	@people = split /\s+/ , $haploData[0];
	$tableOutput = $tableOutput."<tr>
				<td width=\"10%\" align=\"center\"><b>&nbsp;</b></td>";

	$width = 90/($#people);

	for $i (1 .. $#people - 1) {
		$personName = &getRealPersonName( $people[$i], $pedNum );
		$tableOutput = $tableOutput."<td width=\"".$width."%\" colspan=\"2\" align=\"center\"><b>$personName</b></td>
									<td width=\"0.1%\" align=\"center\"><b>&nbsp;</b></td>";
	}
	$personName = &getRealPersonName( $people[$#people], $pedNum );
	$tableOutput = $tableOutput."<td width=\"".$width."%\" colspan=\"2\" align=\"center\"><b>$personName</b></td></tr>";

	$colorCol1_1 = "#FFFACD";
	$colorCol1_2 = "#F0FFF0";
	$colorCol2_1 = "#E6E6FA";
	$colorCol2_2 = "#FFE4C4";

	@currColor_1 = ();
	@currColor_2 = ();
	for $i (1 .. 2*$#people) {
		push(@currColor_1, $colorCol1_1);
		push(@currColor_2, $colorCol2_1);
	}

	for $i (2 .. $#haploData) {
		if ($haploData[$i] =~ /NUMBER OF RECOMBINATIONS/ ) {
			last;
		}
		if ($i % 2 == 0) {	# values line
			@data = split /\s+/, $haploData[$i];
			if (! defined($data[0]) ) {
				next;
			}
			
			$name = $data[0];
			$k = 1;
			while (defined($data[$k]) && ($data[$k] !~ /^[+-]?\d+\.?\d*$/)){
				$name = $name." ".$data[$k];
				$k++;
			}
			$tableOutput = $tableOutput."<tr>
				<td width=\"10%\" align=\"center\"><b>$name</b></td>";
			
			$countPeople = 0;
			for $j ($k .. $#data) {
				if ($data[$j] !~ /\|/) {
					if ( $data[$j-1] =~ /\|/) {
						$color = $currColor_2[$countPeople];
						$countPeople++;
					}
					else {
						$color = $currColor_1[$countPeople];
					}
					
					$tableOutput = $tableOutput."<td width=\"".($width/2)."%\" align=\"center\" bgcolor=\"".$color."\">$data[$j]</td>";
					
					if (($data[$j-1] =~ /\|/ ) && ($j != $#data)) {
						$tableOutput = $tableOutput."<td width=\"0.1%\" align=\"center\"><b>&nbsp;</b></td>";
					}
				}
			}
			$tableOutput = $tableOutput."</tr>";
		}
		else {
			$sepPeople = $haploData[$i];
			$sepPeople =~ s/\t\t/#/g;
			@peopleData = split /#/, $sepPeople;
			$countPeople = -1;
			for $j (0 .. $#peopleData){
				if ( $peopleData[$j] =~ /\|/ ){
					$countPeople++;
					if ( $peopleData[$j] =~ /\X\s+\|/ ){
						if ( $currColor_1[$countPeople] eq $colorCol1_1 ) {
							$currColor_1[$countPeople] = $colorCol1_2;
						}
						else {
							$currColor_1[$countPeople] = $colorCol1_1;
						}
					}
					if ( $peopleData[$j] =~ /\|\s+\X/ ){
						if ( $currColor_2[$countPeople] eq $colorCol2_1 ) {
							$currColor_2[$countPeople] = $colorCol2_2;
						}
						else {
							$currColor_2[$countPeople] = $colorCol2_1;
						}
					}
				}
			}
		}
			
	}
	$tableOutput = $tableOutput."</table>";
	return $tableOutput;
}

sub makeOuputFrameset(  ){
	
	system("mv $ProcessingBackend::OUTPUT_FILE $ProcessingBackend::OUTPUT_RESULTS_FILE");
	
	open( OUTPUT_FILE,">$ProcessingBackend::OUTPUT_FILE");
	print OUTPUT_FILE "<html>\n";
	print OUTPUT_FILE "<frameset cols=\"20%, 80%\">\n";
	print OUTPUT_FILE "\t<frame src=\"$ProcessingBackend::OUTPUT_NAVIGATION_FILE\" name=\"menu\">\n";
	print OUTPUT_FILE "\t<frame src=\"$ProcessingBackend::OUTPUT_RESULTS_FILE\" name=\"main\">\n";
	print OUTPUT_FILE "\t<noframes>\n";
	print OUTPUT_FILE "\t\tyou do not support the use of frames. please press the following link to see the results<br>\n";
	print OUTPUT_FILE "\t\t<a href=\"$ProcessingBackend::OUTPUT_RESULTS_FILE\">Results</a>\n";
	print OUTPUT_FILE "\t</noframes>\n";
	print OUTPUT_FILE "</frameset>\n";
	print OUTPUT_FILE "</html>\n";
	close(OUTPUT_FILE);
	
	open( NAV_FILE,">$ProcessingBackend::OUTPUT_NAVIGATION_FILE");
	print NAV_FILE "<table border=\"1\" cellpadding=\"2\" cellspacing=\"2\" width=\"100%\" id=\"AutoNumber1\"><tr align=\"center\"><td>";
	print NAV_FILE "<a STYLE=\"text-decoration:none\" href=\"$ProcessingBackend::OUTPUT_RESULTS_FILE\" target =\"main\">MultiPoint Results</a><br>\n";
	print NAV_FILE "</td></tr><tr align=\"center\"><td>";
	print NAV_FILE "<a STYLE=\"text-decoration:none\" href=\"formatted_outputHaplo.html\" target =\"main\">Haplotyping Results</a><br>\n";
	print NAV_FILE "</td></tr></table>";
	close(NAV_FILE);
}

sub getRealPersonName( $ ) {
	my $name = $_[0];
	my $pedNum = $_[1];
	
	@nameParts = split /person/, $name;
	$personID = $nameParts[1];
	chomp($personID);
	if (defined($namedPeople{$pedNum.".".$personID})) {
		$name = $namedPeople{$pedNum.".".$personID}."(".$personID.")";
	}
	
	return $name;
}

sub openClusters( $ ) {
	my @linesMap = @_;
	my $hapFile = $_[0];
	if (! -e $hapFile) {return;}
	
	open HAPLORES, $hapFile;
	@haploData = <HAPLORES>;
	close HAPLORES;

	my $result = $haploData[0].$haploData[1];
	
	@peopleNames = split /\s+/ , $haploData[0];
	$peopleNum = $#peopleNames;
	
	shift @haploData;
	shift @haploData;
	
	while ($#haploData > -1) {
		$line = shift @haploData;
		if ($line !~ /rs/ ) {
			$result = $result.$line;
		}
		else {
			%lineValues = &openClusterLineValues($line, @linesMap);
			
			my @lineData = split /\t/ , $line;
			$nameLen = length $lineData[0];
			
			my $emptyLine = "";
			for (1..$nameLen) {
				$emptyLine = $emptyLine." ";
			}
			$emptyLine = $emptyLine."\t";
			for (1..$peopleNum) {
				$emptyLine = $emptyLine."\t".""."\t|\t".""."\t";
			}
			$emptyLine = $emptyLine."\n";
			
			my @names = split /\s+/, $lineData[0];
			# remove the marker number
			for $nameIndex (0..$#names) {
				@tmp = split /\(/, $names[$nameIndex];
				$names[ $nameIndex ] = $tmp[0];
			}
			
			if ($#names == 0) {
				$lineData[0] = $names[0];
				for ((length $names[0]) .. $nameLen) {
					$lineData[0] = $lineData[0]." ";
				}
								
				$lineRes = join "\t" , @lineData;
				$result = $result.$lineRes;
			}
			else {
				for $nameIndex (0..$#names) {
					if (length $names[$nameIndex] <= 0) {
						next;
					}
					$result = $result.$names[$nameIndex];
					# add spaces to get the length of the original name length
					for ((length $names[$nameIndex]) .. $nameLen) {
						$result = $result." ";
					}
					$result = $result."\t";
					
					$personIndex = 0;
					for (1..$peopleNum) {
						$result = $result."\t".@{$lineValues{$personIndex}}[$nameIndex]."\t|\t".@{$lineValues{$personIndex+1}}[$nameIndex]."\t";
						$personIndex = $personIndex + 2;
					}
					
					if ($nameIndex < $#names) {
						$result = $result."\n".$emptyLine;
					}
					else {
						$result = $result."\n";
					}
				}
			}
		}
	}
	
	return $result;
}

sub openClusterLineValues( $ $ ){
	my $clusterLine = shift @_;
	my @linesMap = @_;
	
	my @words = split /\t/ , $clusterLine;
	
	$nameID = &getClusterNum($words[0], "datafiles\/datafile.dat");
	
	my $result = "";
	my %clusterValues = ();
	
	$rangeIndex = -1;
	$clusterIndex = 0;
	for $wordIndex (1 .. $#words) {
		if ( $words[ $wordIndex ] !~ /^[+-]?\d+\.?\d*$/) {
			next;
		}
		$rangeIndex++;
		$mapIndex = 0;
		$skipSecondary = 0;
		$skipSearch = 0;
		@realVals = ();
		if ($nameID > 0) {
			$prevCluster = $nameID - 1;
			if ($prevCluster >= 1){
				while ($linesMap[ $mapIndex ] !~ /Mapping of cluster $prevCluster is finished/ ) {
					$mapIndex++;
					if (! defined($linesMap[ $mapIndex ]) ) {
						%variables = %{&ProcessingBackend::makeInputError("Cluster number $nameID doesn't exist! ", \%variables )};
						exit $ProcessingBackend::ERROR if ( $ProcessingBackend::NO !~ $variables{ errorExist } );
					}
				}
				$currCluster = $nameID;
				while (($linesMap[ $mapIndex + 1 ] !~ /result allele:/) && ($linesMap[ $mapIndex + 1 ] !~ /Clustering markers:/) && 
						($linesMap[ $mapIndex ] !~ /Mapping of cluster $currCluster is finished/)){
					$mapIndex++;
				}
			}
		}
		$codeIndex = $mapIndex;
		$mapVal = $words [ $wordIndex ] - 1; 
		$currVal = $nameID;
		while (($linesMap[ $codeIndex ] !~ /is $mapVal/) && ($linesMap[ $codeIndex ] !~ /Mapping of cluster $currVal is finished/)){ 
			$codeIndex++;
		}
		if ($linesMap[ $codeIndex ] =~ /Mapping of cluster $currVal is finished/) { # there was no "is $mapVal" line 
			if ($linesMap[ $codeIndex - 1 ] =~ /mapCode /) { #There were secondary mappings but the current value wasn't there - it wasn't in the original data
				while ($linesMap[ $mapIndex + 1 ] !~ /result allele:/) { 
					$mapIndex++;
				}
				@mapLineTmp = split /result allele:/, $linesMap[ $mapIndex + 1 ];
				@mapLine = split /: / , $mapLineTmp[0];
				@vals = split /\s+/  ,&General::trim($mapLine[1]);
				
				foreach $k (0 .. $#vals) {
					$realVals[ $k ] = "0";
				}
				$skipSearch = 1;
			}
			else { #There were no secondary mappings
				$code = $mapVal + 1;
				$skipSecondary = 1;
			}
		}
		if (($skipSecondary == 0) && ($skipSearch == 0)) {
			@codeLineTmp = split /mapCode /, $linesMap[ $codeIndex ];
			@codeLine = split / is /, $codeLineTmp[1];
			$code = $codeLine[0];
		}
		
		if ($skipSearch == 0) {
			$prevMapIndex = $mapIndex;
			while (($linesMap[ $mapIndex ] !~ /result allele: $code/) && ($linesMap[ $mapIndex ] !~ /Mapping of cluster $currVal is finished/)){
				$mapIndex++;
			}
			
			if ($linesMap[ $mapIndex ] =~ /Mapping of cluster $currVal is finished/) {
				$noEntry = 0;
				if ($linesMap[ $prevMapIndex + 1 ] =~ /Clustering markers:/) {
					if ($linesMap[ $prevMapIndex + 2 ] =~ /Mapping of cluster/) { # no entries for this cluster at all
						$realVals[0] = $words [ $wordIndex ]; # leave the values as it was
						$noEntry = 1;
					}
					else {
						@mapLineTmp = split /result allele:/, $linesMap[ $prevMapIndex + 2 ];
					}
				}
				else {
					@mapLineTmp = split /result allele:/, $linesMap[ $prevMapIndex + 1 ];
				}
				if ($noEntry == 0) {
					@mapLine = split /: / , $mapLineTmp[0];
					@vals = split /\s+/  ,&General::trim($mapLine[1]);
					
					foreach $k (0 .. $#vals) {
						$realVals[ $k ] = "0";
					}
				}
			}
			else {				
				@mapLineTmp = split /result allele:/, $linesMap[ $mapIndex ];
				@mapLine = split /: / , $mapLineTmp[0];
				
				@realVals = split /\s+/  ,&General::trim($mapLine[1]);
			}	
		}	
		@{$clusterValues{$clusterIndex}} = @realVals;
		$clusterIndex++;
		#@{$clusterValues[ $wordIndex - 1]} = @realVals;
	}

	return %clusterValues;
}

sub getClusterNum( $ $ ) {
	my $clusterName = $_[0];
	my $datFile = $_[1];
	
	open DAT, "<$datFile";
	@datLines = <DAT>;
	close DAT;
	
	$clusterCount = 0;
	my @nameData = split /\(/ , $clusterName;
	
	while ($#datLines > -1) {
		my $line = shift @datLines;
		if ($line =~ /rs/) {
			$clusterCount++;
		}
		if ($line =~ /$nameData[0]/) {
			return $clusterCount;
		}
	}

	#The name was not found
	return -1;
}
1;