#!/usr/bin/perl -w
use Cwd;
use DAGSplit;
use Configuration qw(%configfile);

#######
#
#start
########
my $SNPdistiller  			=$configfile{SNPdistiller};
my $clusteringParamToDistiler 		=$configfile{clusteringParam};
my $binDir 					= $configfile{binDir};

my $configDir = $binDir;

$workDir = $ARGV[0];
chdir($workDir);

$projName = $ARGV[1];
$chromName = $ARGV[2];

%variables = %{ &DAGSplit::initVariablesFromFile("variables.txt","currentChromosom.txt",$projName, $chromName) };

$mode = "EliminatingOnly";
if (exists $variables{ 'modeOfRun' } ) {$mode = $variables{ modeOfRun };}

my $datfileName = $variables{ Datfile };
$datfileName =~ s/\.dat//;	
 # First creating the workDir of the current task 
$cleaningWorkDir = "$workDir\/cleaning";
$workDir = "$workDir\/multiPedClustering";

&DAGSplit::splitLog("try to create $workDir");
if( -d $workDir ){&DAGSplit::splitLog("$workDir already exist, content will be overriden.");}
else{
	system("mkdir $workDir");
	( -d $workDir ) or &DAGSplit::logInnerSysError("mkdir $workDir failed");
}

if ( $mode eq "ClusteringOnly" )
{
	#If there was no cleaning we are working on input files and should check them
	&DAGSplit::getFiles( "badFile.log","$workDir\/$variables{ Datfile }","$workDir\/$variables{ Pedfile }" );
	$inDatafile = "$workDir\/$variables{ Datfile }";
	$inPedfile = "$workDir\/$variables{ Pedfile }";
}
else {
	$inDatafile = "$cleaningWorkDir\/resultFileTotal.".$datfileName.".dat";
	$inPedfile = "$cleaningWorkDir\/resultFileTotal.".$datfileName.".ped";
}

$maxLen = 0;
$maxPed = 0;
@families = `awk ' { print \$1 } ' $inPedfile |sort | uniq`;
foreach $fam (@families){
	$fam =~ s/\s+//sig;
	
	system("grep ^$fam $inPedfile > $workDir\/input_$fam.ped");
	$currLines = `cat $workDir\/input_$fam.ped | wc -l`;
	if ($currLines > $maxLen) {
		$maxLen = $currLines;
		$maxPed = $fam;
	}
}
	
system("cp $workDir\/input_$maxPed.ped $workDir\/pedfile.dat");
system("cp $inDatafile $workDir\/datafile.dat");
system("echo $maxPed > $workDir\/usedPed.txt");
	
	
	
	
	
	
	
