#!/usr/bin/perl -w
use FindBin ();
use lib "$FindBin::Bin";
use Configuration qw(%configfile); 
use POSIX qw(strftime); # in order to track time

#general parameters
$taskDir 	= $configfile{taskDir}; 
$runlogDir 	= 	$configfile{runlogDir};
$dataDir 	= 	$configfile{dataDir};
$mailDir 	= 	$configfile{mailDir};
$outputDir 	= 	$configfile{outputDir};

$cleanWorkspaceLogFile = "$runlogDir\/cleanWorkspaceLogFile.log";   

open CLEAN_LOG, ">$cleanWorkspaceLogFile";
my $now_string = strftime "%a %b %e %H:%M:%S %Y", localtime;
print CLEAN_LOG "Cleaning of workspace called at $now_string\n";

chdir($taskDir);
system("rm -rf `find * ! -name . -prune -mtime +30 | awk -F \" \" \'{print \$1}\'`");
print CLEAN_LOG "Cleaning of $taskDir complete\n";

chdir($runlogDir);
system("rm -rf `find * ! -name . -prune -mtime +30 | awk -F \" \" \'{print \$1}\'`");
print CLEAN_LOG "Cleaning of $runlogDir complete\n";

chdir($dataDir);
system("rm -rf `find * ! -name . -prune -mtime +30 | awk -F \" \" \'{print \$1}\'`");
print CLEAN_LOG "Cleaning of $dataDir complete\n";

chdir($mailDir);
system("rm -rf `find * ! -name . -prune -mtime +30 | awk -F \" \" \'{print \$1}\'`");
print CLEAN_LOG "Cleaning of $mailDir complete\n";

chdir($outputDir);
system("rm -rf `find * ! -name . -prune -mtime +30 | awk -F \" \" \'{print \$1}\'`");
print CLEAN_LOG "Cleaning of $outputDir complete\n";

close CLEAN_LOG;

exit(0);