#!/usr/bin/perl -w
use ProcessingBackend;
use strict;
use Configuration;
use DatPedHandler;
use DrawingGeneral;

# dvir333 use CGI qw(:standard);
# When writing files, several options can be set... here we just set one
# Limit upload size to avoid using too much memory
# dvir333 $cgi_lib'maxdata = 500000;

my $MADELINE_PROGRAM = "\/usr\/local\/bin\/madeline2";
my $INKSCAPE_PROGRAM = "\/usr\/local\/bin\/inkscape";

umask 0;

&ProcessingBackend::setLogFiles( ".\/" );
	
&ProcessingBackend::debug_print("DRAWING ALL FAMILIES");
&executeCommand("$MADELINE_PROGRAM $Configuration::MADELINE_INPUT_FILENAME > madeline_program.out 2>> madeline_program.error");

my @familiesNumbers;
&DatPedHandler::getFamiliesNumbersArrByFamiliesNumbersFile(\@familiesNumbers);
	
# passing over all the families, and painting acording to the svg file
foreach my $currFamilyNum (@familiesNumbers) {
	&ProcessingBackend::debug_print("DRAW $currFamilyNum");
	
	# in case that there is only one ped, than the output file name of the madeline ends with "___ped.xml"
	my $currFamilyMadelineOutputFileName;
	if (scalar(@familiesNumbers) == 1) {
		$currFamilyMadelineOutputFileName = "F${currFamilyNum}ped.xml";
	}
	else {
		$currFamilyMadelineOutputFileName = "F${currFamilyNum}.xml";
	}

	my $svgFile = $currFamilyMadelineOutputFileName;
	$svgFile =~ s/xml/svg/;

	&executeCommand("mv $currFamilyMadelineOutputFileName $svgFile 2>> madeline_move.error");

	my $pdfOutputFileName = &DrawingGeneral::getPainterProgramOutputFileName($Configuration::OUTPUT_FORMAT_PDF, $Configuration::PAINTER_PROGRAM_MADELINE, $currFamilyNum);
	my $pngOutputFileName = &DrawingGeneral::getPainterProgramOutputFileName($Configuration::OUTPUT_FORMAT_PNG, $Configuration::PAINTER_PROGRAM_MADELINE, $currFamilyNum);
	
	# dvir: converting the svg format to png & pdf format
	&executeCommand("$INKSCAPE_PROGRAM -z --export-pdf=$pdfOutputFileName $svgFile 2>> inkscape_program1.error");
	&executeCommand("$INKSCAPE_PROGRAM -z --export-png=$pngOutputFileName $svgFile 2>> inkscape_program2.error");
	&ProcessingBackend::debug_print("After DRAW $currFamilyNum");
}
	
&ProcessingBackend::debug_print("AFTER DRAWING ALL FAMILIES");

###################
sub executeCommand{
	&ProcessingBackend::debug_print($_[0]);
	system($_[0]);
}