#!/usr/bin/perl -w
# dvir 2010/12
use Configuration qw(%configfile);
use strict;
use DatPedHandler;
use DrawingGeneral;
	
my @familiesNumbers;
&DatPedHandler::getFamiliesNumbersArrByFamiliesNumbersFile(\@familiesNumbers);
	
# passing over all the families, and painting acording to the svg file
foreach my $currFamilyNum (@familiesNumbers) {

	my $pdfOutputFileName = &DrawingGeneral::getPainterProgramOutputFileName($Configuration::OUTPUT_FORMAT_PDF, $Configuration::PAINTER_PROGRAM_HAPLO_PAINTER, $currFamilyNum);
	my $pngOutputFileName = &DrawingGeneral::getPainterProgramOutputFileName($Configuration::OUTPUT_FORMAT_PNG, $Configuration::PAINTER_PROGRAM_HAPLO_PAINTER, $currFamilyNum);
	
	&runHaploPainter($currFamilyNum, $pdfOutputFileName, $Configuration::OUTPUT_FORMAT_PDF);
	&runHaploPainter($currFamilyNum, $pngOutputFileName, $Configuration::OUTPUT_FORMAT_PNG);	
}

sub runHaploPainter($ $ $) {
	my $currFamilyNum = $_[0];
	my $outputFile = $_[1];
	my $outputFormat = $_[2];

	system("HaploPainter.pl -b -pedfile $Configuration::HAPLO_PAINTER_INPUT_FILENAME -family $currFamilyNum -outfile $outputFile -outformat $outputFormat -orientation landscape >> HaploPainter_program.out 2>> $configfile{PainterOutputError}");
	my $returnVal = $? >> 8;
	if ($returnVal != 0) {
		open ERR, ">>$configfile{PainterError}";
		print ERR "Painter failed with error $returnVal while producing the png for pedigree $currFamilyNum.\n";
		close ERR;
	}	
}