#!/usr/bin/perl
#
# Andrew Isbell; November 2, 2010
#
# Place it in the same directory as fnA.ped and fnB.dat and run it. It will output pedfile.dat and datafile.dat in Linkage format.
#
# Please send questions and comments to aisbell@uci.edu

# Dvir : 2011/05/25
# I have change it to a package


package superlink2lnkg;

our $FILES_PREFIX = 'lnkg_';
use strict;

# Dvir : 2011/05/25
# in the new Dat file, there is no comments such as : " << bla bla"
# in the new Ped file, columns 5,6,7 are removed
# will return the new names of the dat&ped
sub convertSuperlink2lnkg($ $) {
	my $datFileName = $_[0];
	my $pedFileName = $_[1];
	
	my $datFileNameInLnkgFormat = $FILES_PREFIX.$datFileName;
	my $pedFileNameInLnkgFormat = $FILES_PREFIX.$pedFileName;
	
	#The following converts the Data File
	open (NEWDAT, ">$datFileNameInLnkgFormat");
	open (OLDDAT, $datFileName);

	 while (my $currLine = <OLDDAT>) {
		chomp $currLine;

		$currLine =~ s/<<.*//;
		print NEWDAT "$currLine\n";
	 }
	
	close (OLDDAT); 
	close (NEWDAT); 

	##

	#The following converts the Pedigree File
	open (NEWPED, ">$pedFileNameInLnkgFormat");
	open (OLDPED, $pedFileName);
	while (<OLDPED>) {
		chomp;

		$_ =~ s/<<.*//;
		$_ =~ s/(^\S*\s*\S*\s*\S*\s*\S*\s*)(\S*\s*\S*\s*\S*)(\s*\S*\s*)(\S*)(.*)/$1$3$5/;
		print NEWPED "$_\n";
	}
	close (OLDPED); 
	close (NEWPED); 
	
	return ($datFileNameInLnkgFormat, $pedFileNameInLnkgFormat);
}

1;