#!/bin/bash
basepath=`dirname $0`
. ${basepath}/JobUtils.sh
RedirOutToTaskLog

#this script is responsible for deciding if to allow execution of a job in the system

# we have to write the result of execution to ${ACCEPT_RESULT_FILE} since 
# All following scripts are waiting for this file to be created to start execution

UpdateTaskState $ACCEPT_STATE 
#decide if we can continue - only if no proc with TASKID smaller than ours have caught the lock

Log "Running load estimation script $LOAD_ESTIMATION_SCRIPT"

#[ -x ${BIN}/${LOAD_ESTIMATION_SCRIPT} ] || {
#	DieNoLogin "Load estimate script ${BIN}/${LOAD_ESTIMATION_SCRIPT} is not runnable or not available";
#}
#eval "${BIN}/${LOAD_ESTIMATION_SCRIPT}" || { Log "Load too high" ; 
#											 UpdateTaskState ${ACCEPT_STATE}.${FAILED} ; 
#											 echo ${LOAD_TOO_HIGH} > ${ACCEPT_RESULT_FILE}; 
#											 exit $LOAD_TOO_HIGH;
#											}

Log "Submission allowed" 

# Update user regarding the place of the execution
CountJobsAndTasksBeforeMe $TASKID
let taskNumber="$tasks"+"1"

echo "${CONDOR_GW_USER}@${CONDOR_GW} ${BIN}/RemoveTask.sh" > ${CONDOR_GW_HOST_FILE}
UpdateFileForUser ${CONDOR_GW_HOST_FILE}
[ -e ${RESTART_JOB} ] || ReportUpdateToUser "Update Project $TASK_PROJECT_NAME has entered the queue. Your place in queue is: $taskNumber"

#&& {
#	ReportUpdateToUser "Update Project $TASK_PROJECT_NAME has been moved to background execution due to the high load it has been creating on the system. Background execution permits a job to consume more resources for a longer period of time. Your place in the queue is: $taskNumber";
#}

UpdateTaskState "$ACCEPT_STATE TOTAL_QUEUE=${taskNumber}"

${BIN}/CreateUtilizationStat.sh $LOG_DIR/CONDOR_Q >> ${LOG_DIR}/Utilization.log
tail -1 ${LOG_DIR}/Utilization.log >> $PUBLISH_RUN_STAT_LOCATION

UpdateTaskState ${ACCEPT_STATE}.${DONE}
ReportWebUpdateToUser

### We will generate all possible DAGs here.

k=0


Log "Starting DAGs generation"

RunCommand "${BIN}/CreateInitDags.sh" ||  Die "Failed to create init DAGs for restart"; 

# we have to output to ACCEPT_RESULT_FILE here since next stages are awaiting for the results
# this is an ugly workaround for DAGman not being able to handle READY parents to DONE children
echo 0 > ${ACCEPT_RESULT_FILE}
exit 0

