#!/bin/bash

# Script constants
SCRIPT_NAME=$(basename $0)
#set -x
# Exit codes
USAGE_EXIT=1
INVALID_INPUT=2
# End of exit codes

declare -r INVALID_INPUT
declare -r USAGE_EXIT
declare -r SCRIPT_NAME
# End of script constants

# Includes
. "${PEDTOOL_ROOT}/BoincNodeConstants.sh"
# End of includes

# Script variables
directory="."
dataped=""
datafile=""
pedfile="0"
location=""
monitoring_id=""
set_id=""
# End of script variables

# Auxiliary functions

# Print the help screen
# End of auxiliary functions
# Parsing the input
# End of parsing the input

sumOnly=1

[ -z "$1" ] && { echo "$0 <taskid> [-only-summary] "; exit; }
[ -z "$2" ] && { sumOnly=0; }

TASKID=$1;
[ -e /p/$TASKID ] || { echo "$TASKID does not exist" ; exit 0; }

workunitids=( `execute_ssh_frontend << EOF
    . \$HOME/.bash_profile; \
     mysql ${MYSQL_FLAGS} -e \
	"select  ${MONITORING_ID_TABLE}.id, ${MONITORING_SET_TABLE}.id, directory \
	from ${MONITORING_ID_TABLE}, ${MONITORING_SET_TABLE} where  ${MONITORING_ID_TABLE}.status not like 'Finished' \
	and ${MONITORING_ID_TABLE}.set_id = ${MONITORING_SET_TABLE}.id and ${MONITORING_SET_TABLE}.task_id = $TASKID ;" 
EOF`)


let totalLeft=${#workunitids[*]}/3

[ $totalLeft -eq 0 ] && { echo "None left"; exit; }


echo "--------------------------------"
echo "Total left unfinished:  $totalLeft"
echo "--------------------------------"

[ $sumOnly -eq 1 ] && exit


count=0;
while [ $totalLeft -ne 0 ]; do

	monitoring_id=${workunitids[$count]}
	let count++
	set_id=${workunitids[$count]}
	let count++
	location=${workunitids[$count]}
	let count++
	let totalLeft--

	find_debug_info $monitoring_id $set_id $location

done

let totalLeft=$count/3


exit 0
