#!/bin/bash
base=`dirname $0`
. $base/CONFIG.SH

. $base/BoincNodeConstants.sh

set -x

#mv -f $CONDOR_Q_OUTPUT $CONDOR_Q_OUTPUT.old
q_failed=""
$CONDOR_Q_EXEC $CONDOR_GW_USER  -format "ClusterId=%d " ClusterId -format "JobStatus=%d " JobStatus -format "PedtoolID=%s " PedtoolID -format "ImageSize=%d " ImageSize -format "NumJobMatches=%d " NumJobMatches -format "JobCurrentStartDate=%f " JobCurrentStartDate -format "Universe=%d\n" JobUniverse > ${CONDOR_Q_OUTPUT}.tmp
ret=$?
[ $ret -eq 0 ] && mv -f ${CONDOR_Q_OUTPUT}.tmp ${CONDOR_Q_OUTPUT}
rm -f ${CONDOR_Q_OUTPUT}.tmp


# now also grab the boinc stuff

res=`execute_ssh_frontend << EOF
    . \$HOME/.bash_profile; \
     mysql ${MYSQL_FLAGS} -b -e \
	"select count( distinct host.external_ip_addr),workunit.task_id from host,result,workunit where host.id=result.hostid and result.workunitid = workunit.id and result.server_state=4 group by workunit.task_id;" 
EOF`

ret=$?
echo $res | xargs -n2  > ${BOINC_Q_OUTPUT}.tmp

[ $ret -eq 0 ] && mv ${BOINC_Q_OUTPUT}.tmp  ${BOINC_Q_OUTPUT}
rm -f ${BOINC_Q_OUTPUT}.tmp

