#!/bin/bash
base=`dirname $0`
. $base/CONFIG.SH
shift 
alldirs=$*
stat=$CONDOR_Q_OUTPUT

set -x
# this command goes over all ACTIVE condor jobs and puts the statistics into the right directory
cd $WORK_DIR

for i in $alldirs; do
	echo 0 > $i/$CUR_NUM_RUNNING_JOBS
done
grep PedtoolID $stat | awk '{ split($2,status,/=/); split($3,id,/=/); if (status[2]==2) print id[2]}' | sort |
	uniq -c | awk "{ print \$1 > \$2\"/$CUR_NUM_RUNNING_JOBS\"}" 

if [ -s $BOINC_Q_OUTPUT ]; then
	all_changed_dirs=$(cat $BOINC_Q_OUTPUT |  awk "{ print \$1 > \$2\"/$CUR_NUM_RUNNING_JOBS.boinc\"; print \$2; }")
	for i in ${all_changed_dirs[*]}; do
		total_condor=`cat $i/$CUR_NUM_RUNNING_JOBS`;
		total_boinc=`cat $i/$CUR_NUM_RUNNING_JOBS.boinc`;
		let total=$total_condor+$total_boinc
		echo $total>$i/$CUR_NUM_RUNNING_JOBS;
	done

fi
	


for i in $alldirs; do
	[ -e $i/$CUR_NUM_RUNNING_JOBS ] || continue
	current=`cat $i/$CUR_NUM_RUNNING_JOBS`
	[ -z "$current" ] && current=0
	[ -e $i/MAX_NUM_OF_RUNNING_JOBS ] || echo $current > $i/MAX_NUM_OF_RUNNING_JOBS
	max=`cat $i/MAX_NUM_OF_RUNNING_JOBS`
	[ -z "$max" ] && max=0
	[ $current -gt $max ] && echo $current > $i/MAX_NUM_OF_RUNNING_JOBS
	echo "$current / $max " > $i/$RESOURCE_USAGE_STAT_FILE
done

