#!/bin/bash
basepath=`dirname $0`
. ${basepath}/JobUtils.sh


#CURRENT_STATE_MARKER='<b>&#8226;'
CURRENT_STATE_MARKER='<b>&gt;&gt;&gt;&gt;&gt;&gt;'

statefile=${TASK_STATE_FILE}
[ -e $statefile ] || exit

TASK_COMPLETE=`grep ${PEDTOOL_STATE}.${DONE} $statefile`
[ ! -z "$TASK_COMPLETE" ] && {
	echo "<br>Task complete."
	[ -e MAX_NUM_OF_RUNNING_JOBS ] && echo " Used up to `cat MAX_NUM_OF_RUNNING_JOBS` computers";
	total_time=(`grep TOTAL_TIME $statefile | cut -d"=" -f2`)
	[ ! -z "${total_time[*]}" ] && {
		count=0
		for i in ${total_time[*]}; do
			let count+="$i"
		done
		echo "<br>Total time in the system - $count seconds";
	}
	exit 0;
}
	
[ ! -z "$TASK_TYPE" -a "$TASK_TYPE" != "LINKAGE" ] && {
	echo  "<br> Task is being executed on one computer <br>";
	exit;
}

ACCEPT=`grep ${ACCEPT_STATE}.${DONE} $statefile`
[ -z "$ACCEPT" ] && {
	echo "<br> Pending execution. "
	place=`grep '${ACCEPT_STATE} TOTAL_QUEUE' $statefile | tail -1 | cut -d"=" -f2`
	[ -z "$place" ] || echo "Place in queue - $place"
	exit 0
}

COMPLEXITY=`grep ${FIRST_ESTIMATE_STATE}.${DONE} $statefile`
output_str="Stage 1 - Complexity estimation: "
current_state=""
if [ ! -z "$COMPLEXITY" ]; then 
	number=`grep TOTAL_COMPLEXITY $statefile | tail -1 | cut -d"=" -f2`
	if [ ! -z "$number" ]; then
		output_str="$output_str `${BIN}/TranslateComplexity.sh $FRONTEND_COMPLEXITY_CONVERSION_TABLE $number`"
	else
		output_str="$output_str Complete"
	fi
	echo "<br> $output_str"
else
	current_state="COMPLEXITY"
	echo "<br>${CURRENT_STATE_MARKER} $output_str Calculating </b>"
fi

SIMPLEJOB=`grep ${SIMPLEJOBRUN} $statefile`
PARJOB=`grep ${PARALLEL_STATE}.${DONE} $statefile`
output_str="Stage 2 - Parallelization: "
if [ ! -z "$PARJOB" ]; then
	number=`grep TOTAL_JOBS $statefile | tail -1 | cut -d"=" -f2`
	if [ ! -z "$number" ]; then
		output_str="$output_str Created $number small pieces for parallel run"
	else
		output_str="$output_str Complete"
	fi
	echo "<br>$output_str"
else
	[ -z "$current_state" ] && {
		[ -z "${SIMPLEJOB}" ] && {
			    current_state="PARJOB";
				echo "<br>${CURRENT_STATE_MARKER} $output_str Calculating... </b>";
				} || echo "<br> $output_str Skipped </b>"	
	} || echo "<br> $output_str Not started"
fi 
PARALLEL=`grep ${PARALLEL_COMP_STATE} $statefile`
output_str="Stage 3 - Linkage computation: "
if [ ! -z "$PARALLEL" ]; then
	if [ -e ${TOTAL_JOBS_FILE} -a -e ${TOTAL_DONE_JOBS_FILE} -a -e ${TOTAL_DONE_JOBS_FILE} ]; then
		total_jobs=`cat ${TOTAL_JOBS_FILE}`
 		total_done=`cat ${TOTAL_DONE_JOBS_FILE}`
		percent=`echo | awk "{ print 100*($total_done/$total_jobs) }"`
		output_str="<br>${CURRENT_STATE_MARKER} $output_str Completed $percent percents of the task." 
		[  -e CUR_NUM_OF_RUNNING_JOBS ] && output_str="$output_str Currently using `cat CUR_NUM_OF_RUNNING_JOBS` computers"
		output_str="$output_str </b>"
	else
		output_str="<br>${CURRENT_STATE_MARKER} $output_str Calculating... </b>"
	fi
	echo "$output_str"
else
	[ -z "$current_state" ] && 	echo "<br>${CURRENT_STATE_MARKER} $output_str Calculating... </b>" || echo "<br> $output_str Not started"
fi
