#!/bin/bash
base=`dirname $0`
. $base/CONFIG.SH
. $base/Utils.sh

exit 0
q_file=$1
[ $q_file ] || { echo "Missing parameter - condor_q filename"; exit -1; }

[ -e $q_file ] || { echo "No $q_file found"; exit; }
[ -s $q_file ] || exit

#grep PedtoolID $q_file | awk '{ match($0,/ClusterId=([[:digit:]]+)/,clusterId); match($0,/JobStatus=([[:digit:]]+)/,status);match($0,/PedtoolID=([[:digit:]]+)/,pid); print clusterId[1] " " status[1] " " pid[1]}'

ids=(`grep PedtoolID $q_file | awk '{ match($0,/JobStatus=([[:digit:]]+)/,status);match($0,/PedtoolID=([[:digit:]]+)/,pid); print status[1] " " pid[1]}' | sort -k2 -n | awk '{ if ($2!=old) { if (old!=0) print old " " count_idle " " count_run ;old=$2;count_idle=0;count_run=0;} if ($1==2) {count_run++} else {count_idle++} }END{ print old " " count_idle " " count_run }'`)

[ -z "${ids[*]}" ] && exit 
total=${#ids[*]}
let last_row="${total}/3-1"
# nothing to do with single row
[ $last_row -eq 0 ] && exit
Log "Detected potential jobs for rescheduling: ${ids[*]}"
 
idle_row=0
run_row=$last_row
condor_rm_array=""
while [ $idle_row -lt $run_row ]; do
	let p_idle="$idle_row*3+1"
	let p_run="$run_row*3+2"
	idle=${ids[$p_idle]}
	run=${ids[$p_run]}
	if [ $idle -eq 0 ]; then
		let idle_row++
		continue
	fi
	if [ $run -eq 0 ]; then
		let run_row--
		continue
	fi
	# if there are more running than idle
	let p_idle_cluster="$p_idle-1"
	let p_run_cluster="$p_run-2"
	idle_cluster=${ids[$p_idle_cluster]}
	run_cluster=${ids[$p_run_cluster]}

 	if [ $run -ge $idle ]; then
	 	let run-="$idle"
		condor_rm_array="$run_cluster $idle $condor_rm_array"
		ids[$p_run]=$run
		let idle_row++
		continue
	fi

 	if [ $run -lt $idle ]; then
	 	let idle-="$run"
		condor_rm_array="$run_cluster $run $condor_rm_array"
		ids[$p_idle]=$idle
		let run_row--
		continue
	fi
done
[ -z "$condor_rm_array" ] && exit
# group same PedtoolIDs
array=(`echo $condor_rm_array | xargs -n2 | sort -k1 -n | awk '{ if (old!=$1){ print old " " count; old=$1; count=$2; } else { count+=$2; } }END{print old " " count}'`)
#now if this array is not 0 we should go to each PID and output the clusters to remove
Log "Found jobs for rescheduling: ${array[*]}"
counter=0
while [ $counter -lt ${#array[*]} ]; do
	clusters=`grep PedtoolID=${array[$counter]} $q_file | grep JobStatus=2 | awk '{ match($0,/ClusterId=([[:digit:]]+)/,clusterId); print clusterId[1] }'`
	tmp_counter=0
	let counter++
	for i in $clusters; do
		[ $tmp_counter -ge ${array[$counter]} ] && break
		echo $i
		let tmp_counter++
	done
	let counter++
done
