#!/bin/bash
basepath=`dirname $0`
. ${basepath}/CONFIG.SH
. ${basepath}/Utils.sh
RedirOutToGlobalLog
CurrentLoad=0
execdirs=`find $WORK_DIR -type d -maxdepth 1 -mindepth 1`
[ -z "$execdirs" ] && { echo "Detected 0"; exit 0; }
for i in $execdirs; do
	id=`basename $i`
	[ -e ${DONE_DIR}/$id ] && continue
	if IsNumber $id; then
# we are supposed to do many clever things here, but for now:
		[ ! -r $i/${TOTAL_JOBS_FILE} ] && continue
		jobs=`cat $i/${TOTAL_JOBS_FILE}`
		[ -z "$jobs" ] && continue
		let CurrentLoad+="$jobs"

		[ ! -r $i/${TOTAL_DONE_JOBS_FILE} ] && continue
		jobs=`cat $i/${TOTAL_DONE_JOBS_FILE}`
		[ -z "$jobs" ] && continue
		let CurrentLoad-="$jobs"
	fi
done

Log "Detected current amount of condor jobs: ${CurrentLoad}"
echo "Detected current amount of condor jobs: ${CurrentLoad}" 

[ $CurrentLoad -ge ${MAX_ALLOWED_JOBS_IN_QUEUE} ]  && {
	Log "Current load is higher than ${MAX_ALLOWED_JOBS_IN_QUEUE}, the system is too busy";
	exit ${LOAD_TOO_HIGH};
}

CountTasks
taskNumber=$?
[ $taskNumber -gt $MAX_ALLOWED_TASKS_IN_QUEUE ] && {
	Log "Too many tasks in queue, the system is too busy"
	exit ${LOAD_TOO_HIGH};
}

exit ${SUCCESS}

