#!/bin/bash
basepath=`dirname $0`
. ${basepath}/JobUtils.sh
mylock=/tmp/GATHER_ALL_RESULTS.${TASKID}
#set -x
clean(){
	rm -f $mylock
}

#exit 1
# lock
counter=0
while [ -e ${mylock} -a $counter -lt 1000 ]; do
	let counter++
	sleep 5
done
# this script gathers all results

alldirs=`FindAllDataDirs`
alldirs="$alldirs `FindAllSimpleReadyDirs`"

[ -z "${alldirs}" -a ! -e ${TASK_COMPLETE_FILE} ] && exit 0


type=""

[ -z "$1" ] || type=$1;

collect_all="./$FRONTEND_POST_SCRIPT"
collect_single="${BIN}/$COLLECT_SINGLE_POINT"

[ -x ${collect_all} ] || { 
	clean;
	DieNoLogin "$collect_all is not executable"
}


for i in $alldirs; do 
	[ -e $i/GATHERED_RESULTS -a ! -e ${i}/${OUTLIERS_SUBMITTED} ] && continue;

	if [ -z "$type" ]; then
		cd $i > /dev/null;
		[ -s $TOTAL_JOBS_FILE ] || DieNoLogin "Expected to find $TOTAL_JOBS_FILE in $i"

		num_of_jobs=`cat $TOTAL_JOBS_FILE`
		[ -z "$num_of_jobs" ] && DieNoLogin "Expected to find something in $TOTAL_JOBS_FILE in $i"
	
		$collect_single
		
		result=""
		[ -e $BOINC_RESULT_FILE_NAME ] && result=`cat $BOINC_RESULT_FILE_NAME `
# convert to lg10 
		[ -z "$result" ] || {

			[ $result != "-Infinity" ] && { 
				result=` echo $result/l\(10\) | bc -l`
				[ -z "$result" ] && DieNoLogin "Failed to translate the result into lg10" ;
  			}
			echo $result > $FRONTEND_RESULTS_FILE || DieNoLogin "Failed to write $FRONTEND_RESULTS_FILE"
			[ "$result" = "0" ] && touch $FRONTEND_ERROR_FILE && rm $FRONTEND_RESULTS_FILE
			touch GATHERED_RESULTS;	
		}	 
		cd - > /dev/null;
	fi
done

${collect_all} . > /dev/null || {
	clean;
	exit -1;
}
	

clean
exit 0

