#!/bin/bash
basepath=`dirname $0`
basepath=`dirname $basepath`
. ${basepath}/CONFIG.SH ${basepath}
. ${basepath}/Utils.sh

RedirOutToGlobalLog

# this is initial file for HAPLOTYPING analysis

Log "Initalizing Haplotyping task"

[ $# -ne 2 ] && DieNoLogin "Wrong parameters: <job working dir> <TaskID>"

WorkDir=$1
TaskID=$2

cd $WorkDir || DieNoLogin "Could not chdir to $WorkDir"

[ -e $JOB_DETAILS_FILE ] || DieNoLogin "Failed to load $JOB_DETAILS_FILE - probably wrong invocation sequence"

source ${WorkDir}/$JOB_DETAILS_FILE

# get our type:
myname=`dirname $0`
TASK_TYPE=`basename $myname`

#create GlobalDag

cwd=`pwd`
sed_cwd=`pwd | sed 's/\//\\\\\\//g'`
sed_execdir=`echo $BIN | sed 's/\//\\\\\\//g'`

cat ${SUBFILES}/${TASK_TYPE}/GlobalDag.dag.tmpl | sed "s/_PEDTOOL_EXECDIR_/${sed_execdir}/" | sed "s/_PEDTOOL_TASKID_/$TaskID/" > GlobalDag.dag

# in case we are restarting - use JOB entry from the exiting dag, since some jobs maybe already DONE
MergeRescueDag "GlobalDag.dag"

#copy Accept.sub
ln -fs ${SUBFILES}/Accept.sub . || DieNoLogin "Problem while creating Accept.sub"

#copy TaskMonitor.sub
ln -fs ${SUBFILES}/TaskMonitor.sub . || DieNoLogin "Problem while creating TaskMonitor.sub"

# copy Haplo.sub
ln -fs ${SUBFILES}/${TASK_TYPE}/Haplo.sub . || DieNoLogin "Problem while creating Haplo.sub"

CondorSubmitDag GlobalDag.dag || DieNoLogin "Problem creating GlobalDag.dag"

# rm GlobalDag log since in case it existed, since it would confuse PreAccept handler
rm -f GlobalDag.dag.dagman.log

# mark that there is only a single job here
echo 1 > ${TOTAL_JOBS_FILE}

