#!/bin/bash
basepath=`dirname $0`
basepath=`dirname $basepath`
. ${basepath}/JobUtils.sh ${basepath}

RedirOutToTaskLog

[ -z "$1" ] && Die "Wrong parameters - return status"

[ $1 -eq 0 ] && {

	[ -e haplotypes.txt ] || Die "No haplotypes.txt file found -> failure"
	
	Log "Haplotyping condor task complete sucessfully";

	output_file=`basename ${TASK_OUTPUT_FILE}`
	cp haplotypes.txt $output_file

	##### HERE WE INVOKE ALL PERL SCRIPTS
	############################
	# we update all result files here as well
	#############################

	touch ${TASK_COMPLETE_FILE};
	echo 1 > ${TOTAL_DONE_JOBS_FILE}
	Log "Haplotyping task completed successfully"
	exit 0;
}

# we are here in case of problem - report error
# do we have an input problem?
if [ -s Haplo_error.dat -o -s Haplo_output.dat ]; then
	cat Haplo_error.dat > $SUPERLINK_INPUT_ERROR_FILE
#	cat Haplo_error.dat Haplo_output.dat > $SUPERLINK_INPUT_ERROR_FILE
	Log "Probably INPUT ERROR in haplotyping"
 	echo ${SUPERLINK_INPUT_ERROR} > ${UBNORMAL_TERMINATION_FILE}
	exit ${SUPERLINK_INPUT_ERROR}
fi

# We don't know what the problem is
Die "Failure of Haplotyping - don't know the reason"
