#!/bin/bash 
# this script is invoked in the working dir. It invokes the parallelization stuff CORRECTLY
basepath=`dirname $0`
. ${basepath}/JobUtils.sh
RedirOutToTaskLog

mydie(){
	Error "$1"
	exit -1
}


# first, let's understand if we need to do it at all, since the complexity of the task
# might be too small

[ -e "datafile.dat" ] || mydie "Failed to find datafile.dat"

numMarkers=`cat datafile.dat | head -1 | awk '{ print $1; }'`
[ -z "$numMarkers" ] && numMarkers=1;

let numMarkers--

[ $numMarkers -gt $MAX_NUM_MARKERS ] && {
	echo $numMarkers >> $NUM_OF_DATAFILES_FILE
	echo 1 >> $NUM_OF_PEDFILES_FILE
	exit 0;
}

RunCommand ./$FRONTEND_PRE_SCRIPT . || mydie "Failed to run $FRONTEND_PRE_SCRIPT intial parallelization, $command_output"


sleep 5
# this is a sanity check that Results will be gathered

alldirs=(`FindAllDataDirs`)
[ -z  $alldirs ] && mydie "Initial parallelization resulted in 0 data-parallel jobs. This is wrong"

num_pedfiles=(`ls datafile_1_0`)

[ -z "${num_pedfiles[*]}" ] && mydie "Initial parallelization resulted in 0 pedfiles jobs. This is wrong"


let num_datafiles="${#alldirs[*]}"/"${#num_pedfiles[*]}"

echo ${num_datafiles} > ${NUM_OF_DATAFILES_FILE}
echo ${#num_pedfiles[*]} > ${NUM_OF_PEDFILES_FILE}





