#!/bin/bash
basepath=`dirname $0`
basepath=`dirname $basepath`
. ${basepath}/JobUtils.sh ${basepath}

RedirOutToTaskLog

[ -z "$1" ] && Die "Wrong parameters - return status"

[ $1 -eq 0 ] && {

	[ -s SerialSL_output.dat ] || Die "file SerialSL_output.dat is not found or empty -> failure"
	
	Log "Serial invocation of Superlink: condor task: complete sucessfully";

	output_file=`basename ${TASK_OUTPUT_FILE}`
	cp SerialSL_output.dat $output_file

	##### HERE WE INVOKE ALL PERL SCRIPTS
	############################
	# we update all result files here as well
	#############################
	unix2dos $output_file
	touch ${TASK_COMPLETE_FILE};
	echo 1 > ${TOTAL_DONE_JOBS_FILE}
	Log "LINKAGE_SERIAL task completed successfully"
	exit 0;
}

# we are here in case of problem - report error
# do we have an input problem?
if [ -s SerialSL_output.dat -o -s SerialSL_error.dat ]; then
	cat  SerialSL_error.dat > $SUPERLINK_INPUT_ERROR_FILE
	Log "Probably INPUT ERROR in Superlink"
 	echo ${SUPERLINK_INPUT_ERROR} > ${UBNORMAL_TERMINATION_FILE}
	exit ${SUPERLINK_INPUT_ERROR}
fi

# We don't know what the problem is
Die "Failure of LINKAGE_SERIAL - don't know the reason"
