#!/bin/bash
basepath=`dirname $0`
. ${basepath}/JobUtils.sh
RedirOutToTaskLog

[ -z "$2" ] && Die "required parameter: retval stage_code"
Log " $2 Completed with the return value $1"
ret_val=$1
stage=$2
[ $ret_val -ne 0 ] && {
	UpdateTaskState "$stage.$FAILED DAG";
	Die "$stage failed due to DAG failure";
}

# we invoke to decide what to do with the task
${BIN}/DecideTaskComplexity.sh || ret_val=$?

[ -r ${SECOND_ESTIMATE_RESULT_FILE} ] && ret_val=`cat ${SECOND_ESTIMATE_RESULT_FILE}`
[ $ret_val -ne 0 ] && echo $ret_val > ${SECOND_ESTIMATE_RESULT_FILE}

Log "Real return value is $ret_val"
case "$ret_val" in
	$JOB_TOO_HEAVY)
		UpdateTaskState "$stage.$FAILED JOB_TOO_HEAVY"
		exit $JOB_TOO_HEAVY
	;;
	$BACKFILL_JOB)
		UpdateTaskState "$stage.$DONE BACKFILL_JOB"
# we are going to move this job to backfill, since it's too heavy for frontfill
		Log "Passing over to Backfill"
		exit 0
	;;
	$SUCCESS)
		Log "Second complexity estimation successfull"
		exit 0
	;;
	*)
		UpdateTaskState "$stage.$FAILED $ret_val"
		Die "Failed to perform second stage of complexity estimation."
	;;
esac
