#!/bin/bash
basepath=`dirname $0`
. ${basepath}/JobUtils.sh
RedirOutToTaskLog

[ -z "$1" ] && Die "required parameter: retval"
ret_val=$1
Log "FirstEstimate.dag completed with the return value $1"


[ -e ${FIRST_ESTIMATE_RESULT_FILE} ] && ret_val=`cat ${FIRST_ESTIMATE_RESULT_FILE}`

[ ${ret_val} -ne 0 ] && echo ${ret_val} > ${FIRST_ESTIMATE_RESULT_FILE}

case "$ret_val" in
	$TASK_SPECIFIC_POINT_ERROR )
		exit $TASK_SPECIFIC_POINT_ERROR
	;;
	$JOB_TOO_HEAVY )
		exit $JOB_TOO_HEAVY
	;;
	${JOB_TOO_SIMPLE} )
		Log "We are done already now!"
		UpdateTaskState "$FIRST_ESTIMATE_STATE"."DONE"
		touch ${TASK_COMPLETE_FILE}
		# important! GATHER_RESULT won't work without TASK_COMPLETE!!
		 DeleteDataDirCache
		 ${BIN}/${GATHER_RESULT_SCRIPT}  ||  Die "Failed to run ${GATHER_RESULT_SCRIPT} "
		 
		exit ${JOB_TOO_SIMPLE}
	;;
	$SUCCESS )
		Log "Initial complexity estimation successfull"
		UpdateTaskState "$FIRST_ESTIMATE_STATE"."DONE"
		ReportWebUpdateToUser
		exit $SUCCESS
	;;
	$SUPERLINK_INPUT_ERROR )
		exit $SUPERLINK_INPUT_ERROR
	;;
	$TOO_MANY_POINTS )
		exit $TOO_MANY_POINTS
	;;
	* )
		UpdateTaskState "$FIRST_ESTIMATE_STATE.$FAILED $ret_val"
		TaskDie "Failed to perform inital complexity estimation."
	;;
esac

[ -e ${FIRST_ESTIMATE_DECISION_FILE} ] || DieNoLogin "Cannot find ${FIRST_ESTIMATE_DECISION_FILE} - something wrong here"
des=`cat ${FIRST_ESTIMATE_DECISION_FILE}`
Log "Here is the decision of ${FIRST_ESTIMATE_DECISION_FILE} -> $des"
exit $SUCCESS
