#!/bin/bash
basepath=`dirname $0`
. ${basepath}/JobUtils.sh
RedirOutToTaskLog

[ -z "$1" ] && Die "wrong args: return status"

Log "LanderGreen returned $1"

[ $1 -eq 0 ] && {
	Log "Lander Green run successfull"
	output=`basename ${TASK_OUTPUT_FILE}`
	[ -e results.txt ] || {
		UpdateTaskState "$SIMPLEJOBRUN $LANDER_GREEN.${FAILED}"
		Die "Problem - results.txt file could not be found, though job finished successfully";
	}
	
	${BIN}/LG2Html.sh results.txt $output || DieNoLogin "Failed to create final result"
 
	UpdateTaskState "$SIMPLEJOBRUN $LANDER_GREEN.${DONE}";
	touch $TASK_COMPLETE_FILE
	exit 0;
}

# if something went wrong
# this means that LG cannot be complete -> normal run should be engaged
[ $1 -eq 2 ] && {
	Log "LG could not complete - too hard => starting normal run"
	UpdateTaskState "$SIMPLEJOBRUN $LANDER_GREEN.${DONE}";
	rm -f ${LANDER_GREEN_RUN_FILE}
	exit 0;
}

# if previous run failed because it was aborted => it should be rerun
[ $1 -eq  $CONDOR_RM ] && {
	Log "LG took more than 30 sec - reruning it as vanilla"
	UpdateTaskState "$SIMPLEJOBRUN $LANDER_GREEN.VANILLA ";
	exit 1;
}


[ $1 -eq 1 ] &&
	{ 
		if [ -s LanderGreen_error.dat ]; then
			cat LanderGreen_error.dat > $SUPERLINK_INPUT_ERROR_FILE
		else
		 	echo "Input error has been found. Please recheck your data" > $SUPERLINK_INPUT_ERROR_FILE
		fi;
	echo "$SUPERLINK_INPUT_ERROR" > ${LANDER_GREEN_RUN_FILE}
	Log "Failed to run Superlink - error `cat $SUPERLINK_INPUT_ERROR_FILE`";
	UpdateTaskState "$SIMPLEJOBRUN $LANDER_GREEN.INPUTERROR";
	exit $SUPERLINK_INPUT_ERROR;
}

DieNoLogin "Bug detected -> return status undefined"
 

