#!/bin/bash

# For debugging purposes only
set -x

# Script constants
DIRECTORY_NAME=$(dirname $0)
SCRIPT_NAME=$(basename $0)

declare -r SCRIPT_NAME
declare -r DIRECTORY_NAME
# End of script constants

# Includes
. "${PEDTOOL_ROOT}/JobUtils.sh"
# End of includes

# Processing input arguments
pruning_output_file=$1
range_start=$2
range_end=$3
# End of processing input arguments

Log "Starting ${SCRIPT_NAME} from ${range_start} to ${range_end} in ${pruning_output_file}"

if [[ ! ( -s "${pruning_output_file}" ) ]]
then
	Log "Pruning output file ${pruning_output_file} not found, recreating the entire range"

	for range_index in $(seq ${range_start} ${range_end})
	do
		echo "valid=> ${range_index}" >> "${pruning_output_file}"
	done
fi

Log "Ending ${SCRIPT_NAME}"

exit 0
