#!/bin/bash
basepath=`dirname $0`
. ${basepath}/JobUtils.sh
RedirOutToTaskLog


# this script will run after SimpleJobRun.sh to enforce correct termination detection

[ -z "$1" ] && Die "Missing parameter - return value"

res=$1
### we retry to run the same locally to since there's probably problem with TAR
if [ $res -eq 1 ]; then
	Log "SimpleJobRun.sh failed to run on this computer, let's try locally"
	${BIN}/SimpleJobRun.sh ${BIN} scheduler || {
		echo $? > ${UBNORMAL_TERMINATION_FILE}
		UpdateTaskState "SIMPLEJOBRUN.${FAILED}.TWICE";
		Die "Failed to run SimpleJobRun even from the post script...";
	}
	res=0;
fi

[ $res -ne 0 ] && { 
	Log "SimpleJobRun.sh ubnormal termination"
	UpdateTaskState "SIMPLEJOBRUN.${FAILED}"
	echo $res > ${UBNORMAL_TERMINATION_FILE}
	exit $res;
}

error=0;
if [ -e SIMPLE_JOB_RUN_RESULTS.tar ]; then
	tar xf SIMPLE_JOB_RUN_RESULTS.tar || {
		Log "SimpleJobRun.sh completed normally, but cannot extract the TAR archive"
		error=1;
	}
fi
## we are ready to create the output
DeleteDataDirCache
${BIN}/${GATHER_RESULT_SCRIPT} || {
	Log "Gather results script failed -> we can't create any output.";
	error=1;
}
        
[ $error -ne 0 ] && { UpdateTaskState "SIMPLEJOBRUN.${FAILED}";
			 echo -1 > ${UBNORMAL_TERMINATION_FILE}
			 exit -1;	
}

UpdateTaskState "SIMPLEJOBRUN.${DONE}"
Log "Simple single-job run terminated successfully"
touch ${TASK_COMPLETE_FILE}
exit 0
