#!/bin/bash
basepath=`dirname $0`
. ${basepath}/JobUtils.sh
RedirOutToTaskLog


WaitForAccept || { Log "Accept returned failure -> can't continue";
                 echo ${retval} > ${FIRST_ESTIMATE_RESULT_FILE};
                 exit ${retval};
}

Log "prepairing LG run"
UpdateTaskState "$SIMPLEJOBRUN $LANDER_GREEN"

universe=Vanilla;
periodic_remove=False;

if [ -e $LANDER_GREEN_RUN_FILE ]; then
	# this is our second run via Lander Green
	err=`cat $LANDER_GREEN_RUN_FILE`;
	[ "$err" = "$SUPERLINK_INPUT_ERROR" ] && exit $SUPERLINK_INPUT_ERROR;
	Log "Reruning LG"
else
# check if we can run locally
	EvalCPULoad
	[ $CPU_local_load -le 60 ] && { 
		universe=Local;
		periodic_remove='\(\(JobStatus==2\) \&\& \(CurrentTime-JobCurrentStartDate\)\>1500\)';
	}
fi
	
echo 0 > $LANDER_GREEN_RUN_FILE

cat ${SUBFILES}/LanderGreen.sub.tmpl | sed "s/_PEDTOOL_PERIODIC_REMOVE_/$periodic_remove/" | sed "s/_PEDTOOL_UNIVERSE_/$universe/" > LanderGreen.sub


	



