#!/bin/bash
basepath=`dirname $0`
. ${basepath}/JobUtils.sh
RedirOutToTaskLog

# this script is used to detect if we are going to run Single instance of Slink locally/single condor job, or fully blown Condor DAG

[ -e ${FIRST_ESTIMATE_DECISION_FILE} ] || DieNoLogin "Expecting ${FIRST_ESTIMATE_DECISION_FILE} to be available by now"
res=`cat ${FIRST_ESTIMATE_DECISION_FILE}`

[ -z "$res" ] && DieNoLogin "Failed to read ${FIRST_ESTIMATE_DECISION_FILE} correctly - no good"

[ $res -ne ${CONDOR_SINGLE_RUN} -a $res -ne ${LOCAL_SINGLE_RUN} ] && {
	Log "Detected that job is going to be parallelized, exiting with status $res";
	exit $res;
}
UpdateTaskState "SIMPLEJOBRUN"

# now we just add two lines to the submission file

universe="vanilla"
[ $res -eq ${CONDOR_SINGLE_RUN} ] && {
# if we are going to run Condor job - let's make sure it will work
#	eval "${BIN}/${LOAD_ESTIMATION_SCRIPT}" || { Log "Load too high, can't continue" ; 
#											 echo ${LOAD_TOO_HIGH} > ${SIMPLE_JOB_RUN_RESULT_FILE}; 
#											 exit $LOAD_TOO_HIGH;
#											};
#
	universe="vanilla";
} 

#[ $res -eq ${LOCAL_SINGLE_RUN} ] && {
#	universe="scheduler"
#	EvalCPULoad
#	local_load=$CPU_local_load
#	Log "CPU load is ${local_load} out of 100"
#	[ $local_load -gt ${MAX_CPU_LOAD_THRESHOLD} ] && universe="vanilla";
#}
Log "decided to run in $universe universe"
if [ $universe = "vanilla" ]; then 
	UpdateTaskState "SIMPLEJOBRUN CondorJob" 
	tar cf job_archive.tar datafile* pedfile* || {
		Error "Failed to create job_archive.tar.gz archive, falling back to local execution"
		UpdateTaskState "SIMPLEJOBRUN CondorJob->LocalJob"	
		universe="Scheduler";
	}
else
	touch job_archive.tar
	UpdateTaskState "SIMPLEJOBRUN LocalJob"
fi

echo "Universe=$universe" >> SimpleJobRun.sub
echo "Priority=$TASK_PRIO_IN_CONDOR" >>  SimpleJobRun.sub
echo "Queue" >> SimpleJobRun.sub
Log "Complete preparation to run SimpleJobRun.sub"
exit 0
