#!/bin/bash 
basepath=`dirname $0`
. ${basepath}/CONFIG.SH
. ${basepath}/Utils.sh

RedirOutToGlobalLog

[ -z "$1" ] && Die "Missing parameter: <task UID>"

taskdir=${WORK_DIR}/$1
[ -e ${WORK_DIR}/$1 ] || Die "No task with UID $1 found"

cluster_uid_file=${taskdir}/${GLOBALDAG_CLUSTERID_FILE}

[ -e ${cluster_uid_file} ] || Die "Was not able to remove the job from Condor since the cluster id file was not found"

cluster_id=`cat ${cluster_uid_file}`

[ -z "${cluster_id}" ] && Die "Was not able to remove the job from Condor since cluster id file was empty"

OK="NO"
counter=0
max_remove_attempts=10
while [ ! -z "$OK" ]; do
	condor_rm $cluster_id && OK="" || {
		let counter++;
		[ ${max_remove_attempts} -lt ${counter} ] && break ;
		sleep $counter;
	}
done

[ -z "${OK}" ] && { echo "Removal successfull"; exit 0; }

echo "Failed to remove task due to problem in Condor"
exit 1;


