#!/bin/bash

# Script constants
set -x
DIRECTORY_NAME=$(dirname $0)

declare -r DIRECTORY_NAME
# End of script constants

# Includes
# For $WORK_DIR $BOINC_PARAMETERS_FILE_NAME
. "$DIRECTORY_NAME/CONFIG.SH"
# For $MYSQL_FLAGS
. "$DIRECTORY_NAME/BoincNodeConstants.sh"
# End of includes

# Auxiliary functions
function remove_reserved_symbols()
{
	echo $1 | tr '/' ','
}
# End of auxiliary functions

cd "$WORK_DIR"

declare -a all_tasks=( $(find . -mindepth 1 -maxdepth 1 -type d) )

for task in ${all_tasks[@]}
do
	# Accomplished tasks do not need to be reported
	[ -f ../done/$task ] && continue

	# BOINC node has not started yet
	[ ! -f "$task/$BOINC_PARAMETERS_FILE_NAME" ] && continue

	cd $task
	task_directory=$(pwd)
	decorated_task_directory=$(remove_reserved_symbols $task_directory)
	clients_on_task=$( mysql $MYSQL_FLAGS -e "select count(*) from result, workunit where result.workunitid = workunit.id and \
											  workunit.name like 'Point-${decorated_task_directory}%'" )
	#echo $clients_on_task > $BOINC_RUNNING_CLIENTS
	echo $clients_on_task > $CUR_NUM_RUNNING_JOBS
	cd ..
done
