#!/bin/bash
base=`dirname $0`
. $base/CONFIG.SH
. $base/Utils.sh

[ -z "$1" ] && Die "Missing parameter: <condor_q_file> <list of dirs to check>"

q_out=$1
shift
for i in $*; do
	[ -e $WORK_DIR/$i/$GLOBALDAG_CLUSTERID_FILE ] || { echo "Failed to find CLUSTER_ID file - skip $i"; continue; }
	cluster_id=`cat $WORK_DIR/$i/$GLOBALDAG_CLUSTERID_FILE`
	[ -z "$cluster_id" ] && { echo "Could not detect cluster id of DAG"; continue; }
	res=`grep ClusterId=$cluster_id $q_out`
	if [ -z "$res" ]; then
		[ -e $WORK_DIR/$i/DEAD_CLUSTER ] && { Log "$i - Suspected dead DAGman"; echo "$i - Suspected dead DAGman"; }
		touch $WORK_DIR/$i/DEAD_CLUSTER
	else
		rm -f $WORK_DIR/$i/DEAD_CLUSTER
	fi
done
