#!/bin/bash
basepath=`dirname $0`
. ${basepath}/JobUtils.sh
RedirOutToTaskLog
# this script optimizes SecondEstimate to run as a scheduler universe job

[ -z "$*" ] && Die "Missing parameters or error: no file with data directory specified"
file_with_dir=$1
[ -s $file_with_dir ] || Die "Cannot find file with all working directories"
shift
SL_params=$*


SUPERLINK="${BIN}/Superlink/Superlink_Vanilla"
for i in `cat $file_with_dir`; do
	Log "Running local Second estimate in $i"
	cd $i || Die "Cannot cd to $i"
	${SUPERLINK} $SL_params > SecondE_local.out 2>&1 || Die "failed to Run first run of superlink"
	cd -
done


