#!/bin/bash
where=`dirname $0`
cd $where
die(){
	echo $1
	exit -1
}
echo "Enter the specification of your platform (as it appears in condor_status)"
select arch in "X86_64" "INTEL" "ppc64";do
[ -z "$arch" ] && { echo "wrong input"; exit -1;}
	break
done

#echo "Enter the specification of your OS (as it appears in condor_status)"
#select os in "LINUX" ;do
#[ -z "$os" ] && { echo "wrong input"; exit -1;}
#	break
#done
os=LINUX

cd ../src || die "can't find src dir"
make || die "Make failed - can't continue"

cd ../bin/Superlink || die "can't find Superlink directory"

rm -f Superlink_Vanilla 
ln -sf Superlink_Vanilla.${arch}.${os}  Superlink_Vanilla || die "Failed to create softlink to Superlink_Vanilla in bin/Superlink directory - can't continue"
rm -f Superlink_1.5_Vanilla
ln -sf Superlink_1.5_Vanilla.${arch}.${os} Superlink_1.5_Vanilla || die "Failed to create softlink to Superlink_1.5_Vanilla in bin/Superlink - can't continue"
rm -f 'Superlink_Vanilla.$$(Arch).$$(OpSys)'
ln -sf Superlink_Vanilla.${arch}.${os} 'Superlink_Vanilla.$$(Arch).$$(OpSys)'

rm -f 'Superlink_1.5_Vanilla.$$(Arch).$$(OpSys)' 
ln -fs Superlink_1.5_Vanilla.${arch}.${os} 'Superlink_1.5_Vanilla.$$(Arch).$$(OpSys)'
ln -s Superlink_Vanilla.ppc64.LINUX Superlink_Vanilla.PPC64.LINUX
ln -s Superlink_1.5_Vanilla.ppc64.LINUX Superlink_1.5_Vanilla.PPC64.LINUX

ln -sf Superlink_Vanilla.X86_64.LINUX Superlink_Vanilla.x86_64.LINUX
ln -sf Superlink_1.5_Vanilla.X86_64.LINUX Superlink_1.5_Vanilla.x86_64.LINUX
ln -sf Superlink_Vanilla.INTEL.WINNT51 Superlink_Vanilla.INTEL.WINNT50
echo "Setup complete"
