#!/bin/bash

[ -z "$2" ] && { echo "Missing argument: <complexity table> <complexity> <format> [-h (hours)| -w (words)]" ;exit; }
complexity_table=$1
shift
complexity=$1
format="-w"
[ -z "$2" ] || format="$2" 

readComplexityTable(){
	result=`grep -w $1 $complexity_table | cut -f2 -d" "`
	[ -z "$result" ] && result="Hard"
}

case "$format" in
	-h)
	[ $complexity -le 9 ] && result="0.5"
	[ $complexity -gt 9 ] && result="0.5"
	[ $complexity -gt 10 ] && result="1"
	[ $complexity -gt 11 ] && result="4"
	[ $complexity -gt 12 ] && result="6 and more"
	;;
	*)
		if [ -e $complexity_table ]; then
			 readComplexityTable $complexity;
		else
			[ $complexity -lt 10 ] &&  result="Simple"
			[ $complexity -ge 10 ] &&  result="Simple/Average"
			[ $complexity -ge 12 ] &&  result="Average/Hard"
			[ $complexity -gt 12 ] &&  result="Hard"
		fi
	;;
esac
echo $result
	



