FindAllSimpleReadyDirs(){
	[ -e READY_DIRS.txt ] && cat READY_DIRS.txt
}

FindAllDataDirs(){
  [ -e NO_DIRS_TO_COMPUTE.txt ] && return
  find_all_dir_lock="find_all_dir_lock"
  
  local c=0
  while ! ${BIN}/lockfile $find_all_dir_lock; do
		sleep 3
		let c++
		[ $c -gt 1000 ] && rm -f DATADIRS_CACHE.txt && break
  done
#set -x
	# first time invoked -> let's find things
	[ ! -e DO_NOT_COMPUTE_CACHE.txt -a ! -e DATADIRS_CACHE.txt ] && find  -maxdepth 2 -mindepth 2 -type d  -name 'pedfile*' > DATADIRS_CACHE.txt
	# simple case -> we have the cache and it is valid
	[ ! -e DO_NOT_COMPUTE_CACHE.txt -a -e DATADIRS_CACHE.txt ] && {
		cat DATADIRS_CACHE.txt;
		[ -s DATADIRS_CACHE.txt -a ! -e NO_DIRS_TO_COMPUTE.txt ] || rm -f DATADIRS_CACHE.txt
		rm $find_all_dir_lock
		return;
	}
	
	local pid=$$
	local tmp=""
	# we have invalidated cache
	
	if [ -e DO_NOT_COMPUTE_CACHE.txt -a -e DATADIRS_CACHE.txt ]; then
		rm -f DATADIRS_CACHE.txt.$pid
		touch DATADIRS_CACHE.txt.$pid
		for tmp in `cat DATADIRS_CACHE.txt`; do
			grep -w $tmp DO_NOT_COMPUTE_CACHE.txt > /dev/null || echo $tmp >> DATADIRS_CACHE.txt.$pid
		done
	fi
    touch DATADIRS_CACHE.txt.$pid
    mv -f DATADIRS_CACHE.txt.$pid DATADIRS_CACHE.txt	
	rm -f DO_NOT_COMPUTE_CACHE.txt
	[ ! -s DATADIRS_CACHE.txt ] && touch NO_DIRS_TO_COMPUTE.txt
	cat DATADIRS_CACHE.txt
	tmp=0
	rm -f $find_all_dir_lock
}

InvalidateDataDirCache(){
	echo $1 >> ${WORK_DIR}/${TASKID}/DO_NOT_COMPUTE_CACHE.txt
}
AddAlreadyDoneDir(){
	echo $1 >>  ${WORK_DIR}/${TASKID}/READY_DIRS.txt
}

DeleteDataDirCache(){
	rm -f DATADIRS_CACHE.txt
}
CheckTypeSupported(){
	[ -x ${BIN}/${TASK_TYPE}/InitSubmissionDir.sh ] && return 0
	return 1
}
CreateMailForAdmin(){
	host=`hostname`
	mail_string="$host: $1"

	mkdir -p ${MAIL_DIR}/ADMIN
	
	touch ${MAIL_DIR}/ADMIN/mail	
	status_file=${MAIL_DIR}/ADMIN/mail
# we creat a snapshot here
	echo "----------------------TASK ${TASKID}-------------" >> $status_file
	echo "$1" >> ${MAIL_DIR}/ADMIN/mail	
	echo "--SYSTEM SNAPSHOT" >> $status_file
	pwd >> $status_file	
	df >> $status_file
	uptime >> $status_file
	echo "--Last lines of the LOG" >> $status_file
	tail ${GLOBAL_LOG} >> $status_file
	
}

CreateNoLogin(){
	CreateMailForAdmin "CREATING NO LOGIN!"
	touch $QUEUE_DIR/NO_LOGIN
}


TestNoLogin(){
	[ -r $QUEUE_DIR/NO_LOGIN ]
}


RemoveNoLogin(){
	rm -f $QUEUE_DIR/NO_LOGIN > /dev/null 2>&1
}

Error() {
	echo "ERROR: `date` TASKID=$TASKID $0 $1 " >> ${GLOBAL_LOG}
#	echo "ERROR: `date` TASKID=$TASKID $0 $1 " >> ${LOG_DIR}/Error.txt
	[ -z "$TASKID" -o -z "$ENABLE_TASK_LOG" ] || echo "ERROR: `date` $0 $1" >> $TASK_LOG_FILE
}

Die(){
	echo "$1"
	Error "$1"
	[ -z "$TASKID" ] || echo -1 > ${UBNORMAL_TERMINATION_FILE}
	exit -1
}


Warn(){
	echo "WARNING: `date` TASKID=$TASKID $0 $1" >> ${GLOBAL_LOG}
	[ -z "$TASKID" -o -z "$ENABLE_TASK_LOG" ]  || echo "WARNING: `date` $0 $1" >> $TASK_LOG_FILE
}

Log(){
	echo "LOG: `date` TASKID=$TASKID $0 $1" >> ${GLOBAL_LOG}
	[ -z "$TASKID" -o -z "$ENABLE_TASK_LOG" ] || echo "LOG: `date`  $0 $1" >> $TASK_LOG_FILE
}

CleanJobSubmitDetails(){
	unset TASK_EMAIL
	unset TASK_PROJECT_NAME
	unset TASK_OUTPUT_FILE
	unset TASK_PROGRAM_CODE
	unset TASK_MULTIPOINT
	unset TASK_PORTAL_RUNDIR
	unset TASK_PORTAL_HOST
	unset TASK_SPECIFIC_POINT
	unset TASK_BEST_EFFORT
	unset TASK_TYPE
	unset TASK_TWO_LOCI
}
CheckJobSubmitDetails(){
	ch_q=""
	[ -z "$TASK_EMAIL" ] && { Error "TASK_EMAIL not defined"; ch_q=1; }
	[ -z "$TASK_PROJECT_NAME" ] && { Error "TASK_PROJECT_NAME not defined"; ch_q=1; }
	[ -z "$TASK_OUTPUT_FILE" ] && { Error "TASK_OUTPUT_FILE not defined"; ch_q=1; }
	[ -z "$TASK_PORTAL_RUNDIR" ] && { Error "TASK_PORTAL_RUNDIR not defined"; ch_q=1; }
	[ -z "$TASK_PORTAL_HOST" ] && { Error "TASK_PORTAL_HOST not defined"; ch_q=1; }

	[ -z "$ch_q" ]
}


ReportWebUpdateToUser(){
	ReportString=$1 
	[ -z "$1" ] && ReportString=`$BIN/CreateStatusUpdate.sh`
	
# lock on this dir, since it maybe removed by remote notification handler when all its data is sent	
	mkdir -p ${MAIL_DIR}/${TASKID}/lock || DieNoLogin "Was unable to create user mail dir:  ${MAIL_DIR}/${UserMail}"

	maildir=${MAIL_DIR}/${TASKID}/
	mypid=$$
	q=0
cat > ${MAIL_DIR}/${TASKID}/${JOB_DETAILS_FILE}.tmp <<EOF
TASK_PORTAL_RUNDIR=${TASK_PORTAL_RUNDIR}
TASK_PORTAL_HOST=${TASK_PORTAL_HOST}
EOF
mv ${MAIL_DIR}/${TASKID}/${JOB_DETAILS_FILE}.tmp ${MAIL_DIR}/${TASKID}/${JOB_DETAILS_FILE}
	mailfile=${maildir}/status
# rotate the file
	echo "$ReportString" >> ${mailfile}.tmp
	mv -f ${mailfile}.tmp ${mailfile} > /dev/null

# release the lock
	rmdir  ${MAIL_DIR}/${TASKID}/lock
}

CreateMailForUser(){
	UserMail="$1"
	UserProject="$2"
	ReportString="$3"
	ReportTemplate="$4"
	
# lock on this dir, since it maybe removed by remote notification handler when all its data is sent	
	mkdir -p ${MAIL_DIR}/${TASKID}/lock || DieNoLogin "Was unable to create user mail dir:  ${MAIL_DIR}/${UserMail}"

	maildir=${MAIL_DIR}/${TASKID}/
	mypid=$$
	q=0
cat > ${MAIL_DIR}/${TASKID}/${JOB_DETAILS_FILE}.tmp <<EOF
TASK_PORTAL_RUNDIR=${TASK_PORTAL_RUNDIR}
TASK_PORTAL_HOST=${TASK_PORTAL_HOST}
EOF
    mv ${MAIL_DIR}/${TASKID}/${JOB_DETAILS_FILE}.tmp  ${MAIL_DIR}/${TASKID}/${JOB_DETAILS_FILE}
	 

	mailfile=${maildir}/mail
	cat  ${ReportTemplate}.pre > $mailfile.tmp 
	echo "$ReportString" >> $mailfile.tmp
	cat ${ReportTemplate}.post >> $mailfile.tmp


# this tells that this is the last REPORT for the project -> after sending mail dir can be deleted
	if [ "$REPORT_RESULT" = "${ReportTemplate}" ]; then
		rm ${mailfile}
		mv -f ${mailfile}.tmp ${MAIL_DIR}/${TASKID}/SUCCESS;
		sleep 1; 
		touch  ${MAIL_DIR}/${TASKID}/LAST; 
	else
		mv -f ${mailfile}.tmp ${mailfile} > /dev/null
	fi
# release the lock
	# 
	rmdir  ${MAIL_DIR}/${TASKID}/lock
}

UpdateFileForUser(){
	ResultFile=$1
	mkdir -p ${MAIL_DIR}/${TASKID}/lock || DieNoLogin "Was unable to create user mail dir:  ${MAIL_DIR}/${UserMail}"
	
	maildir=${MAIL_DIR}/${TASKID}/
	mypid=$$
	q=0
cat > ${MAIL_DIR}/${TASKID}/${JOB_DETAILS_FILE}.tmp <<EOF
TASK_PORTAL_RUNDIR=${TASK_PORTAL_RUNDIR}
TASK_PORTAL_HOST=${TASK_PORTAL_HOST}
EOF
    mv ${MAIL_DIR}/${TASKID}/${JOB_DETAILS_FILE}.tmp  ${MAIL_DIR}/${TASKID}/${JOB_DETAILS_FILE}
	
	if [ -e ${ResultFile} ]; then
		if [ "${ResultFile}" == "$FRONTEND_ARCHIVE_FILE" ]; then
			tar -z -x -C  ${MAIL_DIR}/${TASKID} -f ${ResultFile}
		else
			cp ${ResultFile} ${MAIL_DIR}/${TASKID}
		fi
	fi
	rmdir  ${MAIL_DIR}/${TASKID}/lock
}


#
ReportErrorToUser(){
	Msg="$1"
	CheckJobSubmitDetails && 
		{ 
			Error "Reporting error to user ${TASK_EMAIL}: $0 $1";
		    CreateMailForUser "$TASK_EMAIL" "$TASK_PROJECT_NAME" "$1" "$REPORT_ERROR";
		} || Error "Was unable to report to user the following error due to insufficient data in $JOB_DETAILS_FILE : $0 $1"
		
		 		
}

ReportUpdateToUser(){
	Msg="$1"
	CheckJobSubmitDetails && 
		{ 
			Log "Reporting update to user ${TASK_EMAIL}: $0 $1";
		    CreateMailForUser "$TASK_EMAIL" "$TASK_PROJECT_NAME" "$1" "$REPORT_UPDATE";
		} || Error "Was unable to report to user the following update due to insufficient data in $JOB_DETAILS_FILE: $0 $1"
		
		 		
}

ReportFinalResultToUser() {
	link_to_results=$1
	CheckJobSubmitDetails && 
		{ 
			Log "Reporting final result to user ${TASK_EMAIL}: $link_to_results";
		    CreateMailForUser "$TASK_EMAIL" "$TASK_PROJECT_NAME" "$link_to_results" "$REPORT_RESULT";
		} || Error "Was unable to report to user due to insufficient data in $JOB_DETAILS_FILE : $0 $link_to_results"
}



TaskDie(){
	Error "$1"
	ReportWebUpdateToUser "$1"
	[ -z "$TASKID" ] || echo -1 > ${UBNORMAL_TERMINATION_FILE}
	exit -1 
}

IsNumber(){
	tmp=`echo $1 | awk '{ k=match($0,/^[[:digit:]]+$/); if (k!=0) print $0 " "  k }'`
	[ ! -z "$tmp" ]
}


UpdateTaskState(){
	[ -z "$TASKID" ] && return
	[ -e $TASK_STATE_FILE ] || touch $TASK_STATE_FILE > /dev/null 2>&1
	echo $1 >> $TASK_STATE_FILE
}


RunCommand(){
	local zzz=0
	for zzz in `seq 0 10`; do
		cmd="$*"
		command_output=`${cmd} 2>&1`
		ret=$?
		[ $ret -eq 0 ] || Log "Command $cmd returned non zero value $ret with the output: $command_output"
		[ $ret -eq 0 ] && break;
		sleep 10
	done
	[ $ret -eq 0 ]
}

RedirOutToTaskLog(){
	[ -z "$FD_3_OPEN" ] || return
	FD_3_OPEN="true"
	exec 3>> ${TASK_LOG_FILE}
	exec 1>&3
	exec 2>&3 
}


RedirOutToGlobalLog(){
	[ -z "$FD_4_OPEN" ] || return
	FD_4_OPEN="true"
	exec 4>> ${GLOBAL_LOG}
	exec 1>&4
	exec 2>&4 
}


EndRedirectOutput(){
	exec 3>&-
	exec 4>&-
}

createDir(){
# if something with this filename exists and is a dir - leave as is. Otherwise rm and create new
	problem=""
	[ -e $1 -a -d $1 ] || {
		rm -f $1 > /dev/null 2>&1;
		mkdir -p $1 || problem="cannot create dir $1"
	}

	chmod 755 $1 > /dev/null 2>&1;

	[ -x $1 -a -r $1 -a -w $1 ] ||
		problem="The directory $1 cannot be read"
	
	[ -z "$problem" ]

}

DieNoLogin(){
	CreateNoLogin
	ReportUpdateToUser "Failure The system is experiencing major failure. The error has been reported to the administrator"
	ReportWebUpdateToUser "The system is experiencing major failure. Please try again later."
	Error "CRITICAL, creating NO_LOGIN $1"
	CreateMailForAdmin  "CRITICAL, creating NO_LOGIN $1"
	[ -z "$TASKID" ] || { echo -1 > ${UBNORMAL_TERMINATION_FILE}; UpdateTaskState ${FAILED}; }
	exit -1
}

CountTasks(){
	total=0
	tasks=(`find ${QUEUE_DIR} -type d -maxdepth 1 -mindepth 1`)
	[ -z "${tasks}" ] || { 
		for u in ${tasks[*]}; do
			[ -e ${u}/ERROR ] ||  let total++
		done;
	}
	tasks=(`find ${WORK_DIR} -type d -maxdepth 1 -mindepth 1`)
	work_tasks="${tasks[*]}"
	[ -z "${work_tasks}" ] || { 
		for u in ${tasks[*]}; do
			id=`basename $u`
			[ -e ${DONE_DIR}/$id ] ||  let total++
		done;
	}
	
	return $total
}

WaitForAccept(){
	# The following is a workaround for DAGman which cannot handle DONE children for READY parent
	# we enforce dependencies manually here
	Log "Waiting for results of ACCEPT stage"
	while [ ! -e ${ACCEPT_RESULT_FILE} -a ! -e ${UBNORMAL_TERMINATION_FILE} ]; do
		sleep 1;
	done
	[ -e ${ACCEPT_RESULT_FILE} ] && retval=`cat ${ACCEPT_RESULT_FILE}`
	[ -e ${UBNORMAL_TERMINATION_FILE} ] && retval=`cat ${UBNORMAL_TERMINATION_FILE}`

	# file can be empty since the program didn't flush out. the result. Let's wait a bit
	[ -z "$retval" ] && { 
		sleep 3; 
		retval=`cat ${ACCEPT_RESULT_FILE}`; 
		[ -z "$retval" ] && { Log "${ACCEPT_RESULT_FILE} exists but empty"; retval=-1; };
	}

	[ $retval -eq 0 ] 
}

MergeRescueDag(){
	dagname=$1
	[ -e ${dagname}.rescue ] && { 
		grep -i ^JOB ${dagname}.rescue > ${dagname}.tmp ; 
		grep -i -v ^JOB ${dagname} >> ${dagname}.tmp; 
		mv -f ${dagname}.tmp ${dagname}; 
		rm -f ${dagname}.rescue;
	}
}

LogReject(){
	[ -z "$TASKID" ] && toprint="++++" || toprint=${TASKID}
	echo "REJECT| `date`| $toprint $1" >> ${REJECT_LOG}
}

LogSubmit(){
	echo "SUBMIT| `date`| $1" >> ${SUBMISSION_LOG}
}

EvalCPULoad(){

	local_load=`/usr/bin/uptime | /usr/bin/awk '{p=match($0,/average: ([[:digit:]]+.[[:digit:]]+)[[:punct:]][[:space:]]+([[:digit:]]+.[[:digit:]]+)/,k); if (p>0) print k[2]*100}'`
	[ -z "$local_load" ] && {
		local_load=400
		Error "Failed to estimate local load, eassuming $local_load";
	}
	CPU_local_load=$local_load
}

GetPedigreeNumberFromPath(){
	pedNum=`echo $1 | awk   '{match($0, /datafile_[[:digit:]]+_[[:digit:]]+\/pedfile_([[:digit:]]+)/,k); print k[1]}'`
}

GetDatapointNumberFromPath(){
	datapointNum=` echo $1 | awk   '{match($0, /datafile_([[:digit:]]+_[[:digit:]]+)\/pedfile_[[:digit:]]+/,k); print k[1]}'`
}

ReportTooHeavy(){
	local stage_report_file=$1
	local task_state=$2
	shift
	shift
	local heavy_tasks="$*"
	Log "Too heavy task -> exiting"
	echo ${heavy_tasks} | xargs -n2 > ${TOO_HEAVY_JOBS_FILE};
	UpdateTaskState "${task_state} TOO_HEAVY_TASKS=${heavy_tasks}"
	echo $JOB_TOO_HEAVY > ${stage_report_file}
	exit $JOB_TOO_HEAVY;
	
}

HandleTooHeavyJobs(){
	local stage_report_file=$1
	local task_state=$2
	shift
	shift
	local heavy_tasks="$*"

	Log "Found too heavy tasks";

# we are here only if we are running BEST_EFFORT/Single point execution, 
# let's check that there is at least something to compute:

	tmp_alldirs=`FindAllDataDirs`

	# if  we are running regular execution:
	if [ -z "$TASK_BEST_EFFORT" -a -z "$TASK_SPECIFIC_POINT" ]; then
		ReportTooHeavy $stage_report_file $task_state $heavy_tasks
	fi
	
	# Unless we are running TASK_SPECIFIC_POINT, bail out if UNLINKED is the only left, 
	# or something other than UNLINKED left
	if [ -z "$TASK_SPECIFIC_POINT" ]; then	
		# let's check that not only teta=0 left
		# check number of pedigrees
		num_of_peds=`ls $UNLINKED_DATAFILE | wc -l`
		for i in `seq 0 $num_of_peds`; do
			teta0=""
			all_points=""
			not_teta0=""
			# check if there is teta=0.5 for this pedigree
			all_points=`echo $tmp_alldirs | xargs -n1 | grep -w pedfile_$i`
			# no points left at all
			[ -z "$all_points" ] && continue
			teta0=`echo $all_points | xargs -n1 | grep -w $UNLINKED_DATAFILE`
			not_teta0=`echo $all_points | xargs -n1 | grep -v -w $UNLINKED_DATAFILE`
			# if no teta0 left -> mark all dirs 
			[ -z "$teta0" -a ! -e $UNLINKED_DATAFILE/pedfile_$i/${TASK_COMPLETE_FILE} ] && {
				for dirs in $not_teta0; do
					MarkDoNotCompute $dirs
				done
				continue;
			}
		
			[ -z "$not_teta0" ] && MarkDoNotCompute ./$UNLINKED_DATAFILE/pedfile_$i
		done
		tmp_alldirs=`FindAllDataDirs`
	fi
	
	if [ -z "$tmp_alldirs" ]; then
		ReportTooHeavy $stage_report_file $task_state $heavy_tasks
	fi 
	
	UpdateTaskState "${task_state} DATAPOINTS_LEFT=$tmp_alldirs"
	
	if [ ! -z "$TASK_BEST_EFFORT" ]; then
		Log "Detected BEST_EFFORT run"
	fi

	if [ ! -z "$TASK_SPECIFIC_POINT" ]; then
		Log "Detected Single Point run "
#		TaskIsOk=""
#		for task in $alldirs; do
#			GetPedigreeNumberFromPath $task
#			pedNum=$?
#			GetDatapointNumberFromPath $task
#			dataNum=$?
#			[ $pedNum -eq $TASK_SPECIFIC_PED -a $dataNum -eq $TASK_SPECIFIC_POINT ] && TaskIsOk="true" 
#		done
#	
#		[ -z "$TaskIsOk" ] && { 
#			# the point requested is too complex itself
#			Log "The point for computation is too heavy. Exiting"
#			UpdateTaskState "${FIRST_ESTIMATE_STATE} TOO_HEAVY_TASKS=datafile${dataNum}/pedfile${pedNum}"
#			echo $JOB_TOO_HEAVY > ${FIRST_ESTIMATE_RESULT_FILE}
#			exit $JOB_TOO_HEAVY;
#		}
	fi
	[ ! -e TOO_HEAVY_REPORTED ]&&{

		ReportUpdateToUser "Update Some requested positions cannot be calculated due to high complexity. The rest will be processed as usual.";
		touch TOO_HEAVY_REPORTED;
	}
	return 0

}
FindRealPath(){
      local task=$1
        cd $1 > /dev/null
        local cwd=`pwd`
        local cwd1=`basename $cwd`
        local cwd2=`dirname $cwd`
        local cwd3=`basename $cwd2`
        local fn="./${cwd3}/${cwd1}"
        cd - > /dev/null
	echo $fn;
}

AddExcludedNumJobs(){
	local numJobs=$1 
    local task=$2
    local taskdir=""
# this will always be in the top dir
	[ -e $task/../../Details.txt ] && taskdir="$task/../../"
	[ -e $task/Details.txt ] && taskdir=$task

	[ -z "$taskdir" ] && return

	local old=0;
	pid=$$
# update will be done ONLY if there are already relevant TOTAL_JOBS stuff, otherwise its irrelevant
	[ -s $taskdir/$TOTAL_JOBS_FILE -a -s $taskdir/$TOTAL_DONE_JOBS_FILE ] || return
	[ -e $taskdir/$EXCLUDED_NUM_JOBS_FILE ] && {
		mv $taskdir/$EXCLUDED_NUM_JOBS_FILE $taskdir/$EXCLUDED_NUM_JOBS_FILE.$pid
		old=`cat $taskdir/$EXCLUDED_NUM_JOBS_FILE.$pid`;
	}
    [ -z "$old" ] && old=0

	let old="$old"+"$numJobs"
	
    echo $old > $taskdir/$EXCLUDED_NUM_JOBS_FILE.$pid
	mv $taskdir/$EXCLUDED_NUM_JOBS_FILE.$pid $taskdir/$EXCLUDED_NUM_JOBS_FILE
}
MarkAlreadyDone(){
	local task=$1
	touch $task/${DO_NOT_COMPUTE_FILE}
	echo 1 > $task/$TOTAL_JOBS_FILE
	touch $task/${TASK_COMPLETE_FILE}
	AddExcludedNumJobs 1 "$task"
	InvalidateDataDirCache  `FindRealPath $1`
	AddAlreadyDoneDir `FindRealPath $1`
}
MarkDoNotCompute(){
	local task=$1
	touch $task/${DO_NOT_COMPUTE_FILE}
	[ -e $task/$TOTAL_JOBS_FILE ] && m_excluded=`cat  $task/$TOTAL_JOBS_FILE`
	[ ! -z "$m_excluded" ] && AddExcludedNumJobs $m_excluded "$task"
	echo 0 > $task/$TOTAL_JOBS_FILE
	touch $task/$FRONTEND_SKIPPED_FILE
	InvalidateDataDirCache `FindRealPath $1`
}
OverrideTotalJobs(){
	[ -e $EXCLUDED_NUM_JOBS_FILE ] && rm -f $EXCLUDED_NUM_JOBS_FILE
	echo $1 > $TOTAL_JOBS_FILE
}

MarkError(){
	local task=$1
	touch $task/${FRONTEND_ERROR_FILE}
	[ -e $task/GATHERED_RESULTS ] && rm -f $task/GATHERED_RESULTS
	[ -e $task/$BOINC_RESULT_FILE_NAME ] && rm -f $task/$BOINC_RESULT_FILE_NAME
	[ -e $task/$FRONTEND_RESULTS_FILE ] && rm -f $task/$FRONTEND_RESULTS_FILE
	[ -e $task/$TOTAL_JOBS_FILE ] && cat $task/$TOTAL_JOBS_FILE > $task/$TOTAL_DONE_JOBS_FILE
    [ -e $task/$TOTAL_JOBS_FILE ] && m_excluded=`cat  $task/$TOTAL_JOBS_FILE`
    [ ! -z "$m_excluded" ] && AddExcludedNumJobs $m_excluded
	InvalidateDataDirCache `FindRealPath $1`
}
ValidateLockfile(){
      lockfile=$1
      ${BIN}/lockfile $1 && return 1
      temp=`stat -c %X $lockfile`
      [ -z "$temp" ] && return 1
      let lockfile_time="`date +%s`-$temp"
      [ $lockfile_time -lt ${LOCKFILE_TIMEOUT} ] && { return 0; }

      # critical section of short lock
      ${BIN}/lockfile ${lockfile}_temp || return 0
      rm ${lockfile}
      ${BIN}/lockfile ${lockfile}
      rm ${lockfile}_temp
      return 1
}

CountJobsAndTasksBeforeMe(){
	myid=$1
	all_tasks=(`find ${WORK_DIR} -type d -maxdepth 1 -mindepth 1`)
        work_tasks="${all_tasks[*]}" 
	jobs=0
	tasks=0
	[ -z "${work_tasks}" ] && return
        for u in ${all_tasks[*]}; do
               id=`basename $u`
                        [ -e ${DONE_DIR}/$id ] && continue
			[ $id -ge $myid ] && continue
			
			# attempt not to count backfills
#			[ -e ${WORK_DIR}/$id/${TOTAL_COMPLEXITY_FILE} ] && {
#				cmplx=`cat ${WORK_DIR}/$id/${TOTAL_COMPLEXITY_FILE}`
#				[ $cmplx -ge ${BACKFILL_THRESHOLD} ] && continue;
#			
#			}

			
			if [ -e ${WORK_DIR}/$id/${TOTAL_JOBS_FILE} -a -e ${WORK_DIR}/$id/${TOTAL_DONE_JOBS_FILE} ]; then
				local total=`cat ${WORK_DIR}/$id/${TOTAL_JOBS_FILE}`;
				local done=`cat ${WORK_DIR}/$id/${TOTAL_DONE_JOBS_FILE}`;
				let jobs="${jobs}+${total}-${done}";
			else
				cnt=0;
				# let's wait ~50 sec till this file is created, at least by FirstEstimate
				while [ ! -e ${WORK_DIR}/$id/${TOTAL_COMPLEXITY_FILE} ]; do
					sleep 10
					let cnt++
					[ $cnt -ge 2 ] && break
				done
				tmp_jobs=0;
				if [ -e ${WORK_DIR}/$id/${TOTAL_COMPLEXITY_FILE} ]; then
					cmplx=`cat ${WORK_DIR}/$id/${TOTAL_COMPLEXITY_FILE}`
					tmp_jobs=0
					[ $cmplx -ge 10 ] && tmp_jobs=10
					[ $cmplx -ge 11 ] && tmp_jobs=80
					[ $cmplx -ge 12 ] && tmp_jobs=200
					[ $cmplx -ge 13 ] && tmp_jobs=900
				fi
				let jobs="${jobs}+${tmp_jobs}"
			fi
			let tasks++
     done
	
}

ParseComplexityEstimateFile(){
	t=(`/usr/bin/awk '{ if ($0~/TABLESUM/) { match($0,/TABLESUM ([[:digit:]]+)/,ts); } if ($0~/COMPLEXITY/) { match($0,/COMPLEXITY ([[:digit:]]+)/,c); }}END{ print ts[1]" "c[1]; }' $1`)
	task_ts=${t[0]}
	task_complexity=${t[1]}
}

GreaterThen(){
	return `echo "$1 <= $2" | bc -l`
}

LessThen(){
	return `echo "$1 >= $2" | bc -l`
}
CondorSubmitDag(){
	RunCommand "condor_submit_dag -f -oldrescue 1 -config $BIN/DAGMAN_CONFIG -maxjobs 1000 -autorescue 0 -no_recurse -no_submit $1" 
}
