#################################
######internal stuff#############
#################################
#setting environment

export PATH=${CONDOR_HOME}/bin:${CONDOR_HOME}/sbin:/bin:/sbin:/usr/bin:${PATH}
#[ -z "$CONDOR_CONFIG" ] && echo "ERROR: CONDOR_CONFIG is not set"

unalias ls > /dev/null 2>&1



# this variable is important, since it should be the upper bound on all periodic tasks
# we choose it so: currently tasks exit at most after 10 min
# if we detect something like that -> the lock will be removed
LOCKFILE_TIMEOUT=3600

MAX_CONDOR_PRIO=20
THETTA_HALF_PRIO=10
REGULAR_PRIO=0

PAR_DAG_PREFIX="ParallelJ"
SINGLE_PAR_SUB_PREFIX="Parallel_single_"

DECIDE_PRIO_SCRIPT="DecidePrio.sh"
LOAD_ESTIMATION_SCRIPT="EstimateLoad.sh"

SPLIT_DISTRIBUTION_BIN="find_assignment"

INITIAL_PARALLELIZATION_SCRIPT="InitParallelize.sh"
GATHER_RESULT_SCRIPT="GatherAllResults.sh"
COLLECT_SINGLE_POINT="GatherSinglePointResults.sh"


# ASSUMPTIONS OF FRONTEND SCRIPTS
###############################################3
FRONTEND_COMPLEXITY_FILE="complexity"
FRONTEND_RESULTS_FILE="result_condor"
FRONTEND_SKIPPED_FILE="skipped"
FRONTEND_ERROR_FILE="error"

FRONTEND_PRE_SCRIPT="Pre.pl"
FRONTEND_POST_SCRIPT="Post.pl"

FRONTEND_ARCHIVE_FILE="formatted_output.tar.gz"


FRONTEND_COMPLEXITY_CONVERSION_TABLE="Texts/ComplexityConversionTable.txt"
##############################################

UNLINKED_DATAFILE="datafile_1_0"

GROUPPED_JOB_DIR_PREFIX="groupped"
GROUPPED_JOB_DAG_NODE_FILE="DagNode.txt"


TOTAL_COMPUTATION_TIME_FILE="TOTAL_COMPUTATION_TIME.txt"

COMPLEXITY_TABLE_FILE="NumOfJobs.txt"
TOO_HEAVY_JOBS_FILE="TooHeavyJobs.txt"
TASK_COMPLEXITY_MAP_FILE="TaskComplexityMap.txt"
PRIORITY_FILE="CondorPrio.txt"
DEPTH_FILE="Depth.txt"
TOTAL_JOBS_FILE="TotalJobs.txt"
# The constant is used in two contexts: in task directory it means the number of accomplished jobs in
# all the subdirectories; in datafile/pedfile subdirectory it means the number of accomplished jobs in it.
# It is possible to follow the progress status of all the directories by means of these files
TOTAL_DONE_JOBS_FILE="TotalDoneJobs.txt"

CUR_NUM_RUNNING_JOBS="CUR_NUM_OF_RUNNING_JOBS"

#TASK status file
TASK_STATE_FILE="TASK_STATE.txt"

#TASK log file
TASK_LOG_FILE="TASK_LOG.txt"


# this file is used to transfer the decision which direction to take - either regular
# parallel job with second stage, or simple single job/condor single job
FIRST_ESTIMATE_DECISION_FILE="FIRST_ESTIMATE_DECISION.txt"
# here are the possible values for decisions
FULL_PARALLEL_RUN=100
CONDOR_SINGLE_RUN=101
LOCAL_SINGLE_RUN=102
########################################################

SPLIT_RESULT_FILE="SPLIT_RESULT.txt"

ACCEPT_RESULT_FILE="ACCEPT_RESULT.txt"
FIRST_ESTIMATE_RESULT_FILE="FIRST_ESTIMATE_RESULT.txt"
SECOND_ESTIMATE_RESULT_FILE="SECOND_ESTIMATE_RESULT.txt"
SIMPLE_JOB_RUN_RESULT_FILE="SIMPLE_JOB_RUN_RESULT.txt"
PARALLEL_RESULT_FILE="PARALLEL_RESULT.txt"
TASK_COMPLETE_FILE="TASK_COMPLETE.txt"
LANDER_GREEN_RUN_FILE="LANDER_GREEN_RUN.txt"
UBNORMAL_TERMINATION_FILE="UBNORMAL_TERMINATION.txt"

# the order is important in the following variable
# the order is the order of checking the files by Monitoring
STATE_FILES=(${ACCEPT_RESULT_FILE} ${LANDER_GREEN_RUN_FILE} ${FIRST_ESTIMATE_RESULT_FILE} ${SECOND_ESTIMATE_RESULT_FILE} ${PARALLEL_RESULT_FILE}  ${SIMPLE_JOB_RUN_RESULT_FILE} ${TASK_COMPLETE_FILE} ${UBNORMAL_TERMINATION_FILE} ESTIMATION_NODE_RESULT.txt )

JOB_SUBMIT_DAG="PedtoolSubmit.dag"

# this lock is required to allow estimation of complexity 
# one after one if the tasks were submitted simulateneously
# It is removed when the amount of jobs for the given task
# has been estimated

SUPERLINK_INPUT_ERROR_FILE="$FRONTEND_ERROR_FILE"

JOB_COMPLEXITY_ESTIMATE_LOCK="COMPLEXITY.LOCK"

# used to mark data directories which will not be computed
DO_NOT_COMPUTE_FILE="DO_NOT_COMPUTE"
#

TIMEOUT_MARKER_FILE="TASK_TIMEOUT"

JOB_DETAILS_FILE="Details.txt"

JOB_UID_FILE="JOBUID.txt"

LAST_HANLED_JOB_MARKER=LastHandledJob.txt

TOTAL_COMPLEXITY_FILE="TOTAL_COMPLEXITY"

GLOBALDAG_CLUSTERID_FILE="GLOBAL.DAG.CLUSTERID"
EXCLUDED_NUM_JOBS_FILE="ExcludedNumJobs.txt"

NUM_OF_DATAFILES_FILE="numOfDatafiles.dat"
NUM_OF_PEDFILES_FILE="numOfPedfiles.dat"

# here is the format of JOB_DETAILS_FILE
# TASK_EMAIL
# TASK_PROJECT_NAME
# TASK_OUTPUT_FILE
# TASK_PROGRAM_CODE
# TASK_MULTIPOINT = [MULTIPOINT_RUN=1 | TWOPOINT_RUN=0]
# TASK_PORTAL_RUNDIR
# TASK_PORTAL_HOST
# TASK_RESULTS_HTML
#----optional-----
# TASK_SPECIFIC_POINT
# TASK_SPECIFIC_PED
# TASK_BEST_EFFORT

MULTIPOINT_RUN=1
TWOPOINT_RUN=0

#DAG return values:
TOO_MANY_POINTS="18"
SUPERLINK_INPUT_ERROR="50"
TASK_SPECIFIC_POINT_ERROR="51"
SUCCESS="0"
LOAD_TOO_HIGH="10"
JOB_TOO_HEAVY="11"
BACKFILL_JOB="12"
GENERIC_ERROR="-1"
CONDOR_RM="-1002"
NO_LOGIN_DETECTED=13
TIMEOUT_ERROR=15
JOB_TOO_SIMPLE="16"
MIGRATION_REQUEST="17"

#TASK status state
ACCEPT_STATE="ACCEPT"
INIT_PARALLEL_STATE="PAR_INIT"
FIRST_ESTIMATE_STATE="FIRSTESTIMATE"
SECOND_ESTIMATE_STATE="SECONDESTIMATE"
POST_ESTIMATION_STATE="POSTESTIMATION"
POST_ESTIMATION_RESULT_FILE="POST_ESTIMATION_RESULT.txt"
PARALLEL_ORDERING_STATE="PAR_ORDERING"
PARALLEL_STATE="PARALLEL"
ESTIMATE_STATE="RUNTIME_ESTIMAE"
PARALLEL_COMP_STATE="PARALLEL_COMPUTATION"
PEDTOOL_STATE="PEDTOOL"
SIMPLEJOBRUN="SIMPLEJOBRUN"
LANDER_GREEN="LANDER_GREEN"
DONE="DONE"
FAILED="FAILED"

# result of ${GATHER_RESULT_SCRIPT} script

GATHER_RESULT_OUTPUT=index1.html


# marker for backfill jobs/ those to be restart
RESTART_JOB=RESTART

# file which is looked up by Remove script at the portal which contains the name where the job is running
CONDOR_GW_HOST_FILE="CONDOR_GW_HOST_FILE.txt"

# prefix for output of Superlink Single isntance
# example: output.0 output.1
OUTPUT_PREFIX=output

# CONDOR_Q numeric task status:
CONDOR_IDLE=1
CONDOR_RUNNING=2

###
# Work around for DAGman bugs -> to hand dagman job retries:
DEAD_DAGMAN_FILE=DEAD_DAGMAN.txt
#how many times to retry dagman failures
MAX_DEAD_DAGMAN_RETRIES=10

# TASK configuration file for CHECKPOINT, which is 
# created to save vital parameters and to redefine them
# at the remote computer in case of checkpoint-restart
CHECKPOINT_CONFIG_FILE="CHECKPOINT_CONFIG"

# FILE transferred from the portal to be included in the results
ADDITIONAL_INPUT_FILE="simpInput.txt"

#Accept submission lock
ACCEPT_SUBMISSION_LOCK=/tmp/Accept_lock_PedTool_${CONDOR_GW_USER}_${CONDOR_GW}

# File which if exists forces the task to migrate
MIGRATION_MARKER_FILE=MIGRATE_MARKER.txt

# FILE with statistics of a peer. The actual file name
# is formed by PEER_ACOUNT_$PEER_HOST_PERF_FILE_SUFFIX
PEER_HOST_PERF_FILE_SUFFIX=performance.txt

# My own performance file - indication for other pools about my load
SELF_PERF_FILE=SELF_PERFORMANCE.txt

# file with estimation of the amount of resources I have - for my own calculations
SELF_RESOURCES_FILE=SELF_RESOURCES.txt

#condor_status command
CONDOR_STATUS_EXEC=condor_status

#Supported plarforms as appear in condor_status output
SUPPORTED_PLATFORMS=( "INTEL/LINUX" "X86_64/LINUX" "ppc64/LINUX" "INTEL/WINNT51" "INTEL/WINNT50" )

#condor_config_val command
CONDOR_CONFIG_VAL_EXEC=condor_config_val

#FLOCK_TO variable
FLOCK_TO_VAR=FLOCK_TO

#collector list variable
COLLECTOR_VAR=COLLECTOR_HOST

#CONDOR q output file
CONDOR_Q_OUTPUT=${LOG_DIR}/CONDOR_Q
BOINC_Q_OUTPUT=${LOG_DIR}/BOINC_Q

# The product of markers number and peds number above this value will not be served by the program
MARKERS_PEDS_MAXIMUM=1000

#NAME of the marker which marks that the job will be part of a group and BOINC should not be invoked for this job
GROUPPED_JOB_MARKER=GROUPPED_JOB
###################################################################################
#                              BOINC-specific definitions
###################################################################################
#
# The name of the BOINC node input file
BOINC_PARAMETERS_FILE_NAME=boinc_node_parameters.txt
#
# The name of the result file in each datafile*/pedtool* subdirectory
BOINC_RESULT_FILE_NAME=boinc_results.txt
#
# For tracking down the progress of the directory. Designates the completion of the entire task for the sake of 
# external monitoring
BOINC_TASK_COMPLETE=boinc_task_complete.txt
#
# The file is created and maintained by the crontab job for the sake of external monitoring
#BOINC_RUNNING_CLIENTS=boinc_running_clients.txt
#
# The file contains the name of the BOINC front-end, which should proceed the Pedtool requests.
# The file is created in a task directory by the complexity-based scheduler
BOINC_SERVER_NAME=boinc_server_name.txt
#
# The file contains the classads, according to which the duplication and scheduling of the task will be performed
BOINC_CLASSADS=boinc_classads.txt
#
# Each set contains this file with all the results, calculated so far
BOINC_SET_OUTPUT_FILE_NAME=output
#
#
# Defines the name of the file, where the default lower watermark for gradual submission can be overridden
BOINC_SUBMISSION_LOWER_WATERMARK=boinc_submission_lower_watermark.txt
#
# Defines where the gradual submission state is stored
BOINC_SUBMISSION_STATE_FILE=boinc_submission_state.txt
#
#
# Boinc node checkpoint marker
BOINC_CHECKPOINT="BOINC_CHECKPOINT_MARKER"
#
#
# Unsetting this parameter or leaving blank forces estimation routine not to delete temporary results
#ESTIMATION_REMOVE_TEMPORARY_RESULTS=1
#
# Estimation exit codes
ESTIMATION_INVALID_DEPTH=1
ESTIMATION_EXECUTABLE_FAILURE_EXIT_CODE=2
# End of estimation exit codes
#
# The name of the estimation node input file
ESTIMATION_PARAMETERS_FILE_NAME=estimation_node_parameters.txt
#
# State of the estimation node that is being saved between successive invocations 
ESTIMATION_STATE_FILE=estimation_state.txt
#
# The name of pruning nodes input file
PRUNING_PARAMETERS_FILE_NAME=pruning_node_parameters.txt
#
# Due to regenerations of the BOINC node, the ${TOTAL_JOBS_FILE} in each datafile/pedfile directory might be rewritten with the number of jobs, left
# to calculate, hence the below file will contain the overall number that has to be accomplished as far as the tool for gathering results is concerned 
GATHER_TOTAL_JOBS_FILE="GatherTotalJobs.txt"
#
# The tool calculates the final ln-likelihood and various statistics of the obtained results
GATHER_RESULTS_TOOL_NAME=gather_single_point_results

DISALLOW_GRID_SUBMISSIONS_MARKER="NO_GRID_SUBMISSIONS_ALLOWED"
#
# Validation tool for several important attributes of classads
CLASSAD_VALIDATION_TOOL=validate_classad

#string for infinity result returned by GatherSingleResult

INFINITY_STRING="-Infinity"

###################################################################################
#                           End of BOINC-specific definitions
###################################################################################
