/* $Id: EliminationOrderMF.h,v 1.2 2008/08/03 08:15:46 superlink Exp $ */
/*****************************************************************************/
/*  EliminationOrderMF.h													 */
/*  Author: Ma'ayan Fishelson												 */
/*****************************************************************************/

#ifndef _ELIMINATION_ORDER_MF_H_
#define _ELIMINATION_ORDER_MF_H_

#include "Auxiliary.h"
#include "EliminationOrder.h"


/*------------------------------*/
/*		FUNCTIONS				*/
/*------------------------------*/

void MinFillSearch(elimOrderProduct *elimProd, elimOrderPed *elimOrd,
				   pedigree *currPed, graph *G, int numLoci, int firstElimInd,
				   double *tableSizes, long *elimVarsSegArr, long *numVarsSegArr,
				   costFunc cFunc, double bestTableSize);

boolean MinFillSearchG(elimOrderProduct *elimProd, elimOrderPed *elimOrd, 
					graph *G, int firstElimInd, vertexInPool **bestVertex, 
					vertexInPool **worstVertex, double *tableSizes, costFunc cFunc, double bestTableSize);
vertex* getNextVertex(struct graph *G, int *numVertices, boolean *isBreakVar, 
					  vertexInPool **bestVertexPtr, vertexInPool **worstVertexPtr, 
					  costFunc cFunc);
vertex* getBreakVertex(graph *G, int *numVertices);


void MinFillSearchLG(elimOrderProduct *elimProd, elimOrderPed *elimOrd,
					 pedigree *currPed, graph *G, int numLoci, 
					 int firstElimInd, vertexInPool **bestVertex,
					 vertexInPool **worstVertex, double *tableSizes, 
					 long *elimVarsSegArr, long *numVarsSegArr, costFunc cFunc);
void minFillSearchInSegs(elimOrderProduct *elimProd, elimOrderPed *elimOrd, 
						 graph *G, long maxSegSize, int numSegs, int firstElimInd, 
						 vertexInPool **bestVertex, vertexInPool **worstVertex,
						 double *tableSizes, long *elimVarsSegArr, 
						 long *numVarsSegArr, costFunc cFunc);
long minFillLGPart(vertex **elimVertexArr, long numVerticesInArr, 
				   long elimOrdInd, elimOrderPed *elimOrd, 
				   elimOrderProduct *elimProd, vertexInPool **bestVertex, 
				   vertexInPool **worstVertex, double *tableSizes, graph *G, 
				   costFunc cFunc);
vertex* getNextVertexPart(vertex **elimVertexArr, long numVerticesInArr, 
						  vertex ***nextElimVertex, struct graph *G, 
						  int *numVertices, boolean *isBreakVar, 
						  vertexInPool **bestVertexPtr, 
						  vertexInPool **worstVertexPtr, costFunc cFunc);

vertex* getBreakVertexPart(vertex **elimVertexArr, long numVerticesInArr,
						   int *numVertices);


double calcWMinFillCostJoint(struct graph *G, vertex **vertexArr, int numVertices);
double calcMinFillCostJoint(struct graph *G, vertex **vertexArr, int numVertices);



#endif		/*	_ELIMINATION_ORDER_MF_H_	*/
