/* $Id: IO.h,v 1.2 2008/08/03 08:15:46 superlink Exp $ */
#ifndef _IO_H_
#define _IO_H_
#define INIT_BOINC() 
#define END_BOINC(status) 

#ifdef BOINCIO

#include "boinc_api.h"		
#include "filesys.h"		
#ifdef _WIN32
  #include "boinc_win.h"
	#define dup2 _dup2
#endif
static FILE *file_open_aux(const char *filename, const char *mode)
{
		char resolved_name[512];

	    int rc = boinc_resolve_filename(filename, resolved_name, sizeof(resolved_name));
	    if (rc)
   		{
	    	// fprintf(stderr, "APP: cannot resolve output file name.\n");
	      	// exit(boinc_finish(rc));
		return fopen(filename,mode);
	    }
        return boinc_fopen(resolved_name, mode);
}

	#undef INIT_BOINC
	#undef END_BOINC
	#include <stdio.h>

	extern FILE*	OUTFILE;
	#ifdef _WIN32 
		#define OUTFILE_FD OUTFILE->_file
	#else 
		#define OUTFILE_FD OUTFILE->_fileno
	#endif
	
	#define fopen(filename, mode) file_open_aux(filename, mode)
	
	#define INIT_BOINC() \
		   	int rc = boinc_init();\
		    if (rc)\
		    {\
		      fprintf(stderr, "APP: boinc_init() failed.\n");\
		      exit(rc);\
		    }\
			OUTFILE=fopen("out","a"); \
			if (OUTFILE==NULL){\
				fprintf(stderr,"Cannot open file out for writing\n");\
				exit(-1);\
	  		};\
			dup2 (OUTFILE_FD, 1);
		
	#undef stdout
	#define stdout OUTFILE

	#define END_BOINC(status) \
		fflush(OUTFILE); \
	  	fclose(OUTFILE); \
		boinc_finish(status);
#endif // BOINCIO

#endif //_IO_H_
