/* $Id: costFunctions.c,v 1.2 2008/08/03 08:15:47 superlink Exp $ */
#include "costFunctions.h"

static double basic_min_fill_cost(Graph gr, int vertex_lbl, int alg_opt);

double gr_cost(Graph gr, int vertex_lbl){
	return gr->list[vertex_lbl].edgesNum;
}


double wgr_cost(Graph gr, int vertex_lbl){
	return neighborhood_weight(gr, vertex_lbl);
}

double min_fill_cost(Graph gr, int vertex_lbl){
	return basic_min_fill_cost(gr, vertex_lbl, 0);
}

double wmin_fill_cost(Graph gr, int vertex_lbl){
	return basic_min_fill_cost(gr, vertex_lbl, 1);
}

static double basic_min_fill_cost(Graph gr, int vertex_lbl, int alg_opt){
	double miss = 0.0;
	Edge e1 = gr->list[vertex_lbl].neighbors, e2;
	if(gr->list[vertex_lbl].edgesNum <= 1){
		return 0.0;
	}
	else{
		while(e1->next != NULL){
			e2 = e1;
			while(e2->next != NULL){
				e2 = e2->next;
				if(ifConnected(gr, e1->neighbor, e2->neighbor) == FALSE){
					miss +=  alg_opt ? gr->list[e1->neighbor].weight * gr->list[e2->neighbor].weight : 1.0;
				}
			}
			e1 = e1->next;
		}	
	}
	return miss;
}
