/* $Id: elim_auxiliary.c,v 1.2 2008/08/03 08:15:47 superlink Exp $ */
#include <stdio.h>
#include <stdlib.h>
#include "elim_auxiliary.h"

void error_elim(int exit_number){
	switch(exit_number){
	case 1:
		fprintf(stderr, "Failed to allocate memory.\n");
		break;
	case 2:
		fprintf(stderr, "Failed to open file.\n");
		break;
	case 3:
		fprintf(stderr, "Wrong ordering file.\n");
		break;
	case 4:
		fprintf(stderr, "Wrong input parameters.\n");
		fprintf(stderr, "For finding elimination order\n:");
		fprintf(stderr, "graph_file out_file order_alg{MF | SG | WMF | WSG} order_type{ALL_CLQ | LIM_CLQ | MAX_CLQ} [it it_num | time sec_num | it it_num time sec_num]\n\n");
		fprintf(stderr, "Or for estimation of the existing order:\n");
		fprintf(stderr, "estim_order graph_file out_file order_type{ALL_CLQ | LIM_CLQ | MAX_CLQ}\n");
		break;
	case 5:
		fprintf(stderr, "The program does not handle graphs with more than 10,000 vertices.\n");
		break;
	default:
		fprintf(stderr, "Fatal ERROR.\n");
		break;

	}
	fprintf(stderr, "The program has been terminated.\n");
	exit(exit_number);
}

void copy_file(char *to, char *from){
	int c;
	FILE *fin, *fout;
	
	if( (fin = fopen(from, "r")) == NULL) error_elim(2);
	if( (fout = fopen(to, "w")) == NULL)  error_elim(2);
	
	while((c = fgetc(fin)) != EOF){
		fputc(c, fout);
	}
	fclose(fin);
	fclose(fout);
}
