/* $Id: set.c,v 1.2 2008/08/03 08:15:47 superlink Exp $ */
#include <stdio.h>
#include <stdlib.h>
#include "set.h"

Set createEmptySet(){
	Set s;
	if( (s = (Set)malloc(sizeof(struct Set_str))) == NULL) error_elim(1);
	s->size = 0;
	return s;
}


boolean ifIsIn(Set s, int el){
	int i;
	for(i = 0; i < s->size; i++){
		if(s->elem[i] == el){
			return TRUE;
		}
	}	
	return FALSE;
}

Result addElem(Set s, int el){
	if(ifIsIn(s, el) == FALSE){
		if(s->size == MAX_SET_SIZE) error_elim(5);
		s->elem[s->size++] = el;
		return SUCCESS;
	}
	else{
		return FAILURE;
	}
}

Result removeElem(Set s, int el){
	int i, j;
	if(ifIsIn(s, el) == FALSE){
		return FAILURE;
	}
	else{
		for(i = 0; i < s->size; i++){
			if(s->elem[i] == el){
				break;
			}
		}
		for(j = i; j < s->size; j++){
			s->elem[j] = s->elem[j + 1];
		}
		s->size--;
		return SUCCESS;
	}
}

Result removeTail(Set s){
	if(s->size){
		s->size--;
		return SUCCESS;
	}
	return FAILURE;
}


boolean ifInclude(Set s1, Set s2){
	int i;
	if(s1->size > s2->size){
		return FALSE;
	}
	for(i = 0; i < s1->size; i++){
		if(ifIsIn(s2, s1->elem[i]) == FALSE){
			return FALSE;
		}
	}
	return TRUE;
}

void copySet(Set s1, Set s2){
	int i;
	for(i = 0; i < s2->size; i++){
		s1->elem[i] = s2->elem[i];
	}
	s1->size = s2->size;
}

void destroySet(Set s){
	if(s != NULL){
		free(s);
	}
}

