/* $Id: sumMaxCliques.c,v 1.2 2008/08/03 08:15:47 superlink Exp $ */
#include <stdio.h>
#include <string.h>
#include "elim_auxiliary.h"
#include "sumMaxCliques.h"
#include "elimination.h"
#include "set.h"

#define MAXLINE 1000

double calcNotMaxCliquesCost(int gr_size){
	FILE *fin;
	char line[MAXLINE], vertices[MAXLINE], *token;
	Set *s;
	int i, j ,set_num, old_set_num;
	double  clique_weight[MAX_VERTICES_NUM], weight = 0;
	fin = fopen(CLIQUE_FILE, "r");
	set_num = old_set_num = gr_size;
	if((s = (Set *)calloc(set_num, sizeof(Set))) == NULL) error_elim(1);
	for(i = 0; i < set_num; i++){
		s[i] = createEmptySet();
	}
	i = 0;
	while(fgets(line, MAXLINE, fin)){
		strcpy(vertices, strtok(line, ":"));
		clique_weight[i] = atof(strtok(NULL, ":"));
		token = strtok(vertices, ",");
		while(token != NULL){
			addElem(s[i], atoi(token));
			token = strtok(NULL, ",");
		}
		i++;
	}
	set_num = i;
	for(i = 0; i < set_num; i++){
		for(j = 0; j < i; j++){
			if(ifInclude(s[i], s[j]) == TRUE){
				weight += clique_weight[i];
				break;
			}
		}
		j = 0;
	}
	for(i = 0; i < old_set_num; i++){
		destroySet(s[i]);
	}
	free(s);
	fclose(fin);
	remove(CLIQUE_FILE);
	return weight;
}

void print_clique(Graph gr, int vrt_lbl){
	FILE *fout;
	Edge it = gr->list[vrt_lbl].neighbors;
	fout = fopen(CLIQUE_FILE, "a");
	fprintf(fout, "%d", vrt_lbl + 1);
	while(it != NULL){
		fprintf(fout, ",%d", it->neighbor + 1);
		it = it->next;
	}
	fprintf(fout, ":%.0lf\n", neighborhood_weight(gr, vrt_lbl));
	fclose(fout);
}
