/* $Id: PedInfo.h,v 1.2 2008/08/03 08:15:47 superlink Exp $ */
#if !defined(_PEDINFO_H)
#define _PEDINFO_H

#include<stdio.h>
#include<stdlib.h>
#include <iostream>
#include <vector>
using namespace std;
#include <string.h>
#include "InferEng_Settings.h"


class PedInfo 
{

public:
	PedInfo(string name);
	PedInfo(int ind, int loc, char type, char side);
	virtual ~PedInfo();

	inline int				getIndividual()		{return individual;}
	inline int				getLocus()			{return locus;}
	inline pedType			getType()			{return type;}
	inline pedSide			getSide()			{return side;}

	//void		printInfo(ofstream outFile);
	

protected:
	int			individual;
	int			locus;
	pedType		type;
	pedSide		side;
};

//*********************************************************************************88
// Implementation


PedInfo::PedInfo(string name) {
	
	char* rest = (char*)name.c_str();
	
	char* tok = strtok(rest, "_");
	string type = tok;

	int ind = atoi(strtok(NULL, "_"));
	int loc = atoi(strtok(NULL, "_"));

	this->individual = ind;
	this->locus = loc;

	char c1 = type[0];
	char c2 = type[1];
//	this->type = (pedType)type;
	//this->side = (pedSide)side;
	switch (c2) {
		case 's': this->type = _selector;break;
		case 'l': this->type = _locus;break;
		case 'e': this->type = _genotype;break;
		case 'h': this->type = _phenotype;break;
	}

	if (c1 == 'm') {
		this->side = _maternal;
	}
	else if ((c1 == 'p') && (c2 != 'h')) {
		this->side = _paternal;
	}
	else {
		this->side = _none;
	}
}

PedInfo::PedInfo(int ind, int loc, char type, char side) {

	this->individual = ind;
	this->locus = loc;
	this->type = (pedType)type;
	this->side = (pedSide)side;
}

PedInfo::~PedInfo() {

	
}

/*
void PedInfo::printInfo(ofstream outFile) {

	outFile << this->individual << " " << this->locus << " ";
	outFile << this->type << " " << this->side;
}
*/



#endif // !defined(_PEDINFO_H)



