/* $Id: Inference.h,v 1.2 2008/08/03 08:15:46 superlink Exp $ */
/*****************************************************************************/
/*  Inference.h																 */
/*  Author: Ma'ayan Fishelson												 */
/*****************************************************************************/

#ifndef _INFERENCE_H_
#define _INFERENCE_H_


#include <stdio.h>
#include <stdlib.h>
#include "BayesNet.h"
#include "EliminationOrderStructures.h"
#include "PedData.h"
#include "SpecialMult.h"
#include "Globals.h"
#include "IterateAff.h"


/*------------------------------*/
/*		GLOBAL VARIABLES		*/
/*------------------------------*/

#if ELIMINATE_SELECTORS_TOGETHER
	boolean				eliminateSelectorsTogether;
#endif

/*------------------------------*/
/*		FUNCTIONS				*/
/*------------------------------*/

double envEvaluateLike(double *x, void* funcData);
double evaluateLike(double *x, int numTraitLoci, retValFuncType retFunc, 
					boolean printResults);
void findTraitLocPos(scanIntervalData *scanData, double x, int *newLocPos, 
					Probability *newTheta);
void moveTraitLoc(int numTraitLoci, int *oldLocPos, int *newLocPos, double *newThetas);
void calcLikelihood(product** prodArr, elimOrder *elimOrderArrs);
boolean calcLikelihoodPed(product *prod, int pedNum, elimOrderPed *elimOrderArr);
Probability inferProd(product *prod, elimOrderPed *elimOrd, 
					  float problemSize, float solved);
void zeroDataFreeMemory(product **prodArr);

boolean calcLikelihoodPedApproximate(product *prod, int pedNum, elimOrderPed *elimOrderArr);

#endif		/*	_INFERENCE_H_	*/

