/* $Id: IterateAff.h,v 1.2 2008/08/03 08:15:46 superlink Exp $ */
/*****************************************************************************/
/*  IterateAff.h															 */
/*  Author: Anna Reitman							                         */
/*****************************************************************************/

#ifndef _ITERATE_AFF_H_
#define _ITERATE_AFF_H_

#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <limits.h>
#include <math.h>
#include "LociData.h"
#include "PedData.h"
#include "MapFunction.h"
#include "PSGraph.h"
#include "Optimize.h"

/*------------------------------*/
/*		DEFINITIONS				*/
/*------------------------------*/

#define		TO_LEFT				-1
#define		TO_RIGHT			1
#define		IN_PLACE			0

/* The size of the step, in cM, taken when executing a grid search for the maximum. */
#define		STEP_SIZE			1

/* The minimum number of steps taken when executing a grid search for the maximum. */
#define		MIN_NO_STEPS		2

/* The minimum step size, in cM, taken in the binary search for the maximum. */
#define		MIN_STEP_SIZE		5

/*------------------------------*/
/*		GLOBAL VARIABLES		*/
/*------------------------------*/

/* An array that stores the initial recombination values specified in the input. */
thetaCompTheta *thetaMarkers; 

/* The index of the current iteration. */
int currIter;

/*------------------------------*/
/*		FUNCTIONS				*/
/*------------------------------*/

int initPositionData();			
int initPositionDataLocus(int ind, int numIntervalsMap);
void findRequestedPosStepIter(sGHDataLocus *sGHDataLocusPtr, scanIntervalData *scanDataPtr);
void findRequestedPosNumIter(sGHDataLocus *sGHDataLocusPtr, scanIntervalData *scanDataPtr);
void moveLocus(int oldLocusIndMap, int newLocusIndMap);
void moveLoci(int oldLocusIndMap1, int *newLocusIndMap1, double theta1, 
			  int oldLocusIndMap2, int *newLocusIndMap2, double theta2);
void changeThetas(int locusInd,double rec);
void changeThetas2Loci(int locusInd1, double rec1, int locusInd2, double rec2,boolean unlinked);
void print_SuperGH_Results_OneLocus();
void print_SuperGH_Results_TwoLoci();
void freeSuperGHDS();
double computeMarkerDistance(int marker1, int marker2, thetaCompTheta* map );

#endif /* _ITERATE_AFF_H_ */

