/* $Id: Optimize.h,v 1.2 2008/08/03 08:15:46 superlink Exp $ */
/*****************************************************************************/
/*  Optimize.h															     */
/*  Author: Ma'ayan Fishelson												 */
/*****************************************************************************/
/*																			 */
/*  Comment: This file includes functions used for finding the value of a	 */
/*			 function which produces the maximum.					         */
/*																			 */
/*****************************************************************************/

#ifndef _OPTIMIZE_H_
#define _OPTIMIZE_H_

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "PedData.h"
#include "Globals.h"
#include "IterateAff.h"
#include "Inference.h"

/*------------------------------------------*/
/*		DATA-STRUCTURES	& DEFINITIONS		*/
/*------------------------------------------*/

#define		R		0.61803399		/* The golden ratio. */
#define		C		0.38196601		/* (1.0 - R)		 */
#define		TOL		1.0e-3

#define	shift2(a,b,c)	\
	(a) = (b); \
	(b) = (c); 

#define	shift3(a,b,c,d)	\
	(a) = (b); \
	(b) = (c); \
	(c) = (d);

#define		MIN_NUM_STEPS_INTERVAL		2

typedef struct resEntry {
	double		funcVal;
	double		x;
} resEntry;


/*------------------------------*/
/*		FUNCTIONS				*/
/*------------------------------*/

double findMaxInScanInterval(funcType func, void *funcData, double *xMax);
void iterateTraitScanInterval(funcType func, scanIntervalData *scanData, 
							  void *funcData, double stepSize, double *ax, 
							  double *bx, double *cx);
int calcNumSteps(double	dist, double stepSize, double *stepSizeArrPtr);
double golden(funcType func, double ax, double bx, double cx, double tol, 
			  void *funcData, double *xmax);


#endif		/*	_OPTIMIZE_H_	*/

