/* $Id: VariableElimination.h,v 1.2 2008/08/03 08:15:46 superlink Exp $ */
/*********************************************************************************/
/*  VariableElimination.h													     */
/*  Author: Ma'ayan Fishelson													 */
/*********************************************************************************/
/*																				 */
/*  Comment: This file includes functions used for performing variable 			 */
/*			 elimination.														 */
/*																				 */
/*********************************************************************************/

#ifndef _VARIABLE_ELIMINATION_H_
#define _VARIABLE_ELIMINATION_H_

#include <stdio.h>
#include <stdlib.h>
#include <float.h>
#include "LociData.h"
#include "Product.h"
#include "Probability.h"

/*------------------------------*/
/*		FUNCTIONS				*/
/*------------------------------*/

variable* getEliminateVar(elimOrderPed *elimOrd, boolean *isBreakVar);
boolean eliminateVar(product *prod, variable *elimVar, Probability *tempRes, 
					 boolean *isZeroLike);

#if UNITE_VARS
	boolean eliminateVarsJoint(product *prod, variable *elimVar, Probability *tempRes, 
							boolean *isZeroLike);
#endif

boolean sumVar(product *prod, variable *elimVar, Probability *tempRes, 
			   boolean *isZeroLike);

#endif /* _VARIABLE_ELIMINATION_H_ */

