/* $Id: XMLhelpFunction.c,v 1.2 2008/08/03 08:15:46 superlink Exp $ */
#include "XMLhelpFunction.h"
#include "Product.h"
#include "XMLFormat.h"
#include "Auxiliary.h"


/******************************************************************************
*
*       function        connectFuncToNode
*       parameters      funcPtr function to update
*						curNode child node
*       output          none
*       description     Update name of the child of the function
*       comments		none
*
******************************************************************************/
void connectFuncToNode(function *funcPtr, node *curNode){
	   funcPtr->owner = curNode->varInProd;
	   funcPtr->ownerName = curNode -> name;
}


/******************************************************************************
*
*       function        addOneToIndex
*       parameters      array - representation of the current number
*						size - current size
*						funcPtr - function to add to the array
*						curNode child node
*       output          none
*       description     Increment the number that represented by array by 1.
*						Each cell in array represents value.Each cell represented 
*						in x-base,where x number of values that this cell can have ;
*       comments		none
*
******************************************************************************/
void addOneToIndex(int* array,int size,function* funPtr){
	int j;
	j=size-1;
	while(j>=0){
		array[j]=(array[j]+1)%funPtr->variables[j]->numValues;
		if (array[j]!=0)
			break;
		j--;
	}
}

/******************************************************************************
*
*       function        findPosition
*       parameters      name - name of the nod
*						xPos - where to save the postion on x axis
*						yPos - where to save the postion on y axis
*						maxPeople - the number of people in the net
*						START - first y postion that empty
*       output          none
*       description     finds location of the node in the graphical representation
*       comments		the multfactor node is 0,0
*
******************************************************************************/
void findPosition(char *name, int *xPos, int *yPos, int maxPeople, int START){
	int id,locus,xStep=40;
	
	char *token;
	char type[5],str[25];

	/* If i const node */
	if(strcmp(name,MULTFACTOR) == 0){
		*xPos = 0; *yPos = 0;
		return;
	}
	/* Find type of node */
	strcpy(str,name);
	token = strtok( str,"_");
    strcpy(type,token);
	token = strtok( NULL, "_" );
    id=atoi(token); 
	token = strtok( NULL, "_" );
	locus=atoi(token);
	
	/* According to node type find its location */
	*yPos=START+locus*40;
	if (strcmp(type,"ps")==0)
		*xPos=0+id*xStep;
    else if (strcmp(type,"pl")==0)
		*xPos=(maxPeople+1)*xStep+id*xStep;
	else if (strcmp(type,"ph")==0)
		*xPos=(maxPeople+2)*xStep*2+id*xStep;
	else if (strcmp(type,"ge")==0)
		*xPos=(maxPeople+3)*xStep*3+id*xStep;
	else if (strcmp(type,"ml")==0)
		*xPos=(maxPeople+4)*xStep*4+id*xStep;
	else if (strcmp(type,"ms")==0)
		*xPos=(maxPeople+5)*xStep*5+id*xStep;
	else {
		printf("error");
	}
}

/******************************************************************************
*
*       function        addOneToIndex
*       parameters      prod - product to add function
*       output          none
*       description     Adds new function to the product,
*						which value is probability of eliminated nodes till now
*       comments		the name of the node is MULTFACTOR
*
******************************************************************************/
void addConstantToProd(product *prod){
	Probability *problist;
	function *func;
	myMalloc(problist, (1 * sizeof(Probability)));
	problist[0] = 1;
	func = insertFunctionToProduct(prod,1,problist,0,FALSE,0,NULL,FALSE,0);
	func->logMultFactor = totalRes.currRes->lnLike;
	func->owner = NULL;
	myMalloc(func->ownerName,(30*sizeof(char)));
	strcpy(func->ownerName,MULTFACTOR);
}
