/* $Id: MapWithPositiveRange.h,v 1.2 2008/08/03 08:15:48 superlink Exp $ */
/************************************************************************************/
//	MapWithPositiveRange.h:
//	Implementation of MapWithPositiveRange: map with predefined positive range of keys (positive integers)
//	The values are also positive integers
//	Written by Anisenia Andrei on 16/07/2008
/************************************************************************************/

#ifndef MAP_WITH_POSITIVE_RANGE_H
#define MAP_WITH_POSITIVE_RANGE_H

#include "../sl_Auxilary.h"


typedef struct MapWithPositiveRange_t MapWithPositiveRange;

//	Creation of the map:
//	If range less or equal 0 => return NULL 
MapWithPositiveRange* createMapWithPositiveRange(int range);

//	Setting the new value in the map: 
//	if mapWithPositiveRange is NULL or key is out of range or value is negative => do nothing
void setValue(MapWithPositiveRange* mapWithPositiveRange, int key, int value);

//	Getting value from the map:
//	if mapWithPositiveRange is NULL or key wasn't stored in the map (or out of range) => return -1
int getValue(MapWithPositiveRange* mapWithPositiveRange, int key);


void deleteMapWithPositiveRange(MapWithPositiveRange* mapWithPositiveRange);



#endif


