/* $Id: desiase.c,v 1.2 2008/08/03 08:15:47 superlink Exp $ */
 /****************************************************************************/
/*  desiase.c											   					*/
/*  Calculating desiase probability - currently Unused										*/
/*  Author: Anna Tzemach													*/
/****************************************************************************/

#include "gdata.h"
#include "fdata.h"
#include "desiase.h"
#include "allocfile.h"
#include <stdlib.h>
#include "stdio.h"
#include "sl_Auxilary.h"
#include <memory.h>
int *AlleleGraphDes;
int curGenotype;
int inhVector;
void mapFounders(int curVector);
void connectCompDes();
void insertDes(int founder1,int nonfounder,int founder2);
int findDAllele(int index, int sl_sex); 
double penetranceProb(int status,int pen,int  curLocus, Gender sex);



//	Doesn't work for the imprinting case
double desiaseProb(int curLocus, int curVector){
  	int i;
	double prob;
	double sum=0.0;
	#if DEBUG_MEMORY == 1
#ifdef WIN32
	_ASSERT(_CrtCheckMemory());
#endif
#endif
	AlleleGraphDes=(int*)malloc(PedigreeData.PedigreeSize*2*sizeof(int));
	for(curGenotype = 0; curGenotype < (1<<(PedigreeData.NumFoundersAlleles)); curGenotype++){
		prob=1.0;
		memset(AlleleGraphDes,'\0',PedigreeData.PedigreeSize*2*sizeof(int));
		mapFounders(curVector);
		for(i = 0; i<PedigreeData.PedigreeSize; ++i){
			if (PedigreeGraph[i].informative == false)
				continue;
			if (PedigreeGraph[i].myLocus[curLocus].allele1==0)
					continue;
			if (PedigreeGraph[i].myLocus[curLocus].allele1==1) /* healty */
				prob=prob*(1-penetranceProb(AlleleGraphDes[2*i]+AlleleGraphDes[2*i+1],
					PedigreeGraph[i].myLocus[curLocus].allele2,  curLocus, PedigreeGraph[i].sex));
			else 
				if (PedigreeGraph[i].myLocus[curLocus].allele1==2) /* sl_affected */
				prob=prob*
				(penetranceProb( AlleleGraphDes[2*i]+AlleleGraphDes[2*i+1],
						PedigreeGraph[i].myLocus[curLocus].allele2,  curLocus, PedigreeGraph[i].sex));
				else
				{ printf("ERROR: can't understand person status");
			exit(1);}
		}

		for (i=0;i<PedigreeData.NumOfFounders;i++){
			if (ProgramSpecificData.sexLinked && PedigreeGraph[PedigreeData.Founders[i]].sex == Male){
				prob*=lociDataArray[curLocus].frequencies[ AlleleGraphDes[2*PedigreeData.Founders[i]+1]-1];
			}else{
				prob*=(lociDataArray[curLocus].frequencies[ AlleleGraphDes[2*PedigreeData.Founders[i]]-1]*
					lociDataArray[curLocus].frequencies[ AlleleGraphDes[2*PedigreeData.Founders[i]+1]-1]);
			}}
		sum+=prob;
			
	}
	free(AlleleGraphDes);
//	printf("desease is %lf\n",sum);
	return sum;
	#if DEBUG_MEMORY == 1
#ifdef WIN32
	_ASSERT(_CrtCheckMemory());
#endif
#endif

}
/* return penetrance probability                      */
double penetranceProb(int status,int pen, int curLocus, Gender sex)
{
	if (ProgramSpecificData.sexLinked && sex == Male){
		if (status==1) /*both healthy*/
			return lociDataArray[curLocus].malePenatrences[0][pen-1];
		if (status==2) /*one healthy one sl_affected*/
			return lociDataArray[curLocus].malePenatrences[1][pen-1];
		else
			printf("ERROR: can't figure male penetrance");
			exit(1);
	}

	if (status==2) /*both healthy*/
		return lociDataArray[curLocus].penetrances[0][pen-1];

	if (status==3) /*one healthy one sl_affected*/
		return lociDataArray[curLocus].penetrances[1][pen-1];
	if (status==4)
		return lociDataArray[curLocus].penetrances[3][pen-1];
	printf("ERROR: can't figure penetrance");
	exit(1);

}

/* Accuring to genotype and inheretence vector decides */
/* which sl_loci sl_affected and which not                   */
void mapFounders(int curVector){
	int i, tmp;
	tmp=curGenotype;
	// map founders bits
	for (i=0;i< PedigreeData.NumOfFounders;i++){
		if (!(ProgramSpecificData.sexLinked && PedigreeGraph[PedigreeData.Founders[i]].sex ==Male)){
			AlleleGraphDes[2*PedigreeData.Founders[i]]=(tmp%2)+1;
			tmp/=2;
		}
		AlleleGraphDes[2*PedigreeData.Founders[i]+1]=(tmp%2)+1;
		tmp/=2;
	}

	//map nonfounder bits
	for (i = 0; i < 2*PedigreeData.NumOfNonFounders; i++){
		if (ProgramSpecificData.sexLinked && PedigreeGraph[PedigreeData.NonFounders[i/2]].sex ==Male && i%2 == 0)
			continue;
		AlleleGraphDes[2*PedigreeData.NonFounders[i/2]+i%2]= 
			AlleleGraphDes[2*PedigreeData.Founders[(getAllele(allelesInhObj, curVector, i))/2]
			+(getAllele(allelesInhObj, curVector, i))%2];
	}
}
