/* $Id: fdata.h,v 1.2 2008/08/03 08:15:47 superlink Exp $ */
/*************************************************************************/
/* gdata.c												     			 */
/* Local definitions													 */
/* Author: Anna Tzemach 												 */	
/*************************************************************************/
#ifndef FDATA_H
#define FDATA_H

#include "gdata.h"
#include "AllelesInheritance/AllelesInheritance.h"

void removeDouble();



//int *Mask;           /* data for meioses 0 is msb */
int *MaskLSB;        /* data for meioses 0 is lsb */

//	constant defining which implementation of the alleles inheritance module to use:
//	0 - use AlleleInh matrix implementation (with size = 2n*2^(2n-f) and O(1) worst case)
//	1 - use AllelesInheritance structure		(with size = 4n+f	and O(2n-f) worst case)
//	also, if 0 is set, then the FoundersChildren array is filled within "initAlleles()" function,
//	and   if 1 is set, then the FoundersChildren array is filled using "initFoundersChildren()" function
#define ALLELES_INH_USE 1

int **AlleleInh;
AllelesInheritance* allelesInhObj;

  
//double* sl_Probability;
void  PrepareMatrix(int startLocus, int endLocus);
void deleteProbabilityLocusForWindow(int startLocus, int endLocus);
double ComputeComp(int,int );
void Intersection();
double numeratedProb(int curLocus);




MATRIX ProbabilityLocus;  /*  sl_Probability(for each inheretance vector) for each numerated Locus */
VECTOR StandartTeta;
VECTOR ProbabilityDesiase;  /*  sl_Probability(for each inheretance vector) for dasease Locus */
double SumDesiase;


typedef struct Neighbours_t 
{
	int id;  // edge to vertex (founder)     
	int allele1; // first possible allele
	int allele2; // second possible allele

}Neighbours;

//FoundersGraph size is [numFounders][numNeigbours]
Neighbours **FoundersGraph;
/* For each founder, how many neigbours does it have */
int *NumFounderNeighbours;

/* Possible assignements for founders meioses */
typedef struct Assign{
	int A;
	int B;
	int currentValue; // if sl_vertex is in use which value eas asihnmet to it  
	Bool inUse;       // if we inserted already sl_vertex to componenet
	Bool if_visitedA;
	Bool if_visitedB;
	Bool if_visited;
}Assign;

Assign *Alleles; /* vector (size=founders meioses ) of possible assignments */





#endif

