/* $Id: multMatrix.c,v 1.2 2008/08/03 08:15:48 superlink Exp $ */
/****************************************************************************/
/*  multMatrix.c											   				*/		
/*  Multiplying matrixes (fast way where possible)							*/
/*  Author: Anna Tzemach													*/
/****************************************************************************/
#include "likehood.h"
#include "gdata.h"
#include "fdata.h"
#include <math.h>
#include <memory.h>
#include <time.h>
#include "allocfile.h"
#include <stdlib.h>
#include <stdio.h>



/******************************************************************************
*
*       Function        calculateElement
*       Parameters		j - Hamming distanse beetwen alfa and beta 
*       Output          none
*       Description		W[k,beta,j] = W[k-1,beta,j] + W[k-1,beta+c[k-1],NumOfMeioses-(k-1)-j]
*       Comments		none
*
******************************************************************************/
/*double calculateElement(int k,int beta,int j)
{    
	if (beta<0 || j<0 || k<0 || j>PedigreeData.SpeedUpNumOfMeioses)
		exit(1);
	if (!k)
		return Vector[beta]* CurrentMatrix[j]; // alfa,beta 
	return calculateElement(k-1,beta,j) + 
		calculateElement(k-1,(beta+c[k-1])%PedigreeData.Possibilities , (PedigreeData.SpeedUpNumOfMeioses-(k-1)-j));
}
*/
/******************************************************************************
*
*       Function        calculateElement
*       Parameters		matrix -  v[beta]=W[n.beta,0]
*       Output          none
*       Description		Vector * CurrentMatrix 
*       Comments		Multiplication of vector with matrix requeres 
*						(n+1)*2^n multiplications ,(n+1)(n+2)2^n-2 additions
*
*
******************************************************************************/
/*void MultRegularMatrix(VECTOR matrix)    {
	
	int beta;
	if (PedigreeData.Possibilities==1){
		matrix[0]=Vector[0];;
		return;
	}
	for (beta = 0; beta < PedigreeData.Possibilities; beta++){
		matrix[beta]=calculateElement(PedigreeData.SpeedUpNumOfMeioses-1,beta,0) 
			+ calculateElement(PedigreeData.SpeedUpNumOfMeioses-1,(beta+c[PedigreeData.SpeedUpNumOfMeioses-1])%PedigreeData.Possibilities,1);
		printf("matrix[%d]=%lf\n",beta,matrix[beta]);
	}
	
}
*/

/******************************************************************************
*
*       Function        MultDiagonalMatrix
*       Parameters		src1 - vector
*						src2 - diagonal matrix
*						dest - result vector
*       Output          none
*       Description		src1*src2 = desy
*       Comments		Multilication of vector with diagonal matrix 
*						requeres only 2^n multiplications
*
******************************************************************************/
void   MultDiagonalMatrix(VECTOR src,VECTOR src2, VECTOR dest){
	VECTOR destEnd;

	#if (PRINT_VECTORS_MULT_TIME == 1)
		fprintf(vectorsMultFile, "Start writing = %lf\t\t", ((double)clock())/(double)CLOCKS_PER_SEC);	
	#endif

	//double sum=0;
	for (destEnd = dest + PedigreeData.Possibilities ;dest < destEnd; 
			dest++, src++, src2++){
	//	dest[i]=src[i]*src2[i];
	*dest = *src * *src2;
	//	sum+=dest[i];
	}
	
	#if (PRINT_VECTORS_MULT_TIME == 1)
		fprintf(vectorsMultFile, "End writing = %lf\n", ((double)clock())/(double)CLOCKS_PER_SEC);	
	#endif
}


/******************************************************************************
*
*       Function        copyVector
*       Parameters		src - vector
*						target - result vector
*       Output          none
*       Description		copy one vector to another
*       Comments		none
*
******************************************************************************/
void copyVector(VECTOR src,VECTOR target){
	/*int i;
	double sum=0;
	for (i=0;i<Possibilities;++i){
		target[i]=src[i];
		sum+=target[i];
	}
	return sum;*/
	memcpy(target,src,sizeof(double)*PedigreeData.Possibilities);
}

/******************************************************************************
*
*       Function        copyVector
*       Parameters		vec1 - hor. vector
*						vec2 - ver. vector
*       Output          result of multiplication
*       Description		Mult two vectors (1 x NumOfMeioses ) by (NumOfMeioses x 1 )
*       Comments		none
*
*****************************************************************************/
double VecMultVec(VECTOR vec1,VECTOR vec2){
	int i;
	double sum = 0.0;

	#if (PRINT_VECTORS_MULT_TIME == 1)
		fprintf(vectorsMultFile, "Start writing = %lf\t\t", ((double)clock())/(double)CLOCKS_PER_SEC);	
	#endif

	//		printf("Final vector\n");
	for (i=0;i<PedigreeData.Possibilities;++i){
		sum+=(*vec1++ * *vec2++);
		//	printf(" %e",vec1[i]*vec2[i]);
	}
	
	#if (PRINT_VECTORS_MULT_TIME == 1)
		fprintf(vectorsMultFile, "End writing = %lf\n", ((double)clock())/(double)CLOCKS_PER_SEC);	
	#endif

	return sum;
}


/*
*
* result - vector  to store a result, shold be already allocated
* input - input vector
* theta - recombination value
* size - size of both vectors - input and result
*
*//*
void Yate(double *result,double *input,double theta,int size){
	int i,j,numIter;
	double *tmp,*result2;
	numIter=(int)ceil(log(size)/log(2.0));
	tmp=allocDoubleArray(Possibilities*2); 
	result2 = allocDoubleArray(Possibilities*2);
	memcpy(tmp,input, sizeof(double)*Possibilities);
	for (i=0;i<numIter;i++){
		for (j=0;j<size;j+=2){
			if (SpeedUp && ((j&FoundersBitOneMask) != FoundersBitOneMask) && (((j+1)&FoundersBitOneMask) != FoundersBitOneMask))
				continue;
			if (!SpeedUp || (j&FoundersBitOneMask) == FoundersBitOneMask) 
				result[RegularToSpeedArray[j]] = tmp[RegularToSpeedArray[j/2]]*(1-theta)+tmp[RegularToSpeedArray[j/2+size/2]]*theta;
			if (!SpeedUp || ((j+1)&FoundersBitOneMask) == FoundersBitOneMask)
				result[RegularToSpeedArray[j+1]] = tmp[RegularToSpeedArray[j/2]]*(theta)+tmp[RegularToSpeedArray[j/2+size/2]]*(1-theta);
		}
	}
		  
				
		memcpy(tmp,result, sizeof(double)*Possibilities);
	}
	free(tmp);   
}
*/


/*
void Yate(double *result,double *input,double theta,int size)
{
	int i,j,numIter;
	double *tmp;
	numIter=(int)ceil(log(Possibilities)/log(2.0));
	tmp=(double*)malloc(sizeof(double)*Possibilities);
	memcpy(tmp,input, sizeof(double)*Possibilities);
	for (i=0;i<numIter;i++){
		for (j=0;j<Possibilities;j+=2){
			result[j]=tmp[j/2]*(1-theta)+tmp[j/2+Possibilities/2]*theta;
			result[j+1]=tmp[j/2]*(theta)+tmp[j/2+Possibilities/2]*(1-theta);
		}
		memcpy(tmp,result, sizeof(double)*Possibilities);
	}
	free(tmp);
	
	
}
*/
