/* $Id: queue.c,v 1.2 2008/08/03 08:15:48 superlink Exp $ */
#include "queue.h"


Queue* CreateQueue(void* something)
{
	Queue* queuePtr;
	QueueNode* tmp;

	sl_myMalloc(queuePtr,sizeof(Queue));
	sl_myMalloc(tmp,sizeof(QueueNode));
	tmp->something = something;
	tmp->next = NULL;
	tmp->prev = NULL;
	queuePtr->curr = NULL;
	queuePtr->first = tmp;
	queuePtr->last = tmp;
	queuePtr->size = 1;

	return queuePtr;
}


void InsertToTail(Queue* queue, void* something)
{
	QueueNode* tmp;
	
	sl_myMalloc(tmp,sizeof(QueueNode));
	tmp->something = something;
	tmp->next = NULL;
	tmp->prev = queue->last;
	queue->last->next = tmp;
	queue->last = tmp;
	(queue->size)++;
}


void* getCurr(Queue* queue)
{
	if (queue->curr != NULL)
	{
		return queue->curr->something;
	}
	return NULL;
}


void* getLast(Queue* queue)
{
	if (queue->last != NULL)
	{
		return queue->last->something;
	}
	return NULL;
}


void* getFirst(Queue* queue)
{
	if (queue->first != NULL)
	{
		return queue->first->something;
	}
	return NULL;
}

void increaseCurr(Queue* queue)
{
	if (queue->curr == NULL)
	{
		queue->curr = queue->first;
	}
	else
	{
		queue->curr = queue->curr->next;
	}
}


void decreaseCurr(Queue* queue)
{
	if (queue->curr == NULL)
	{
		queue->curr = queue->last;
	}
	else
	{
		queue->curr = queue->curr->prev;
	}
}



void destroyQueue(Queue* queue)
{
	QueueNode* tmp;
	
	if (queue == NULL)
	{
		return;
	}
	queue->curr = NULL;
	queue->last = NULL;
	while(queue->first != NULL)
	{
		tmp = queue->first;
		queue->first = queue->first->next;
		free(tmp);
	}
	free(queue);
}



void restartCurr(Queue* queue)
{
	queue->curr = NULL;
	increaseCurr(queue);
}


void removeFirst(Queue* queue)
{
	QueueNode* tmp;

	if (queue->first != NULL)
	{
		if (queue->first == queue->last)
		{
			free(queue->first);
			queue->first = NULL;
			queue->last = NULL;
			queue->curr = NULL;
		}
		else
		{
			tmp = queue->first->next;
			tmp->prev = NULL;
			if (queue->curr == queue->first)
			{
				queue->curr = tmp;
			}
			free(queue->first);
			queue->first = tmp;
		}
		(queue->size)--;
	}
}



Bool isEmpty(Queue* queue)
{
	if (queue->first == NULL)
	{
		return true;
	}
	else
	{
		return false;
	}
}


int getSize(Queue* queue)
{
	if (queue != NULL)
	{
		return queue->size;
	}
	else
	{
		return -1;
	}
}


void removeCurr(Queue* queue)
{
	QueueNode* tmp;

	if (queue->curr != NULL)
	{
		tmp = queue->curr;
		(queue->size)--;
		if (queue->size == 0)
		{
			queue->curr = queue->first = queue->last = NULL;
			free(tmp);
			return;
		}

		queue->curr = tmp->prev;
		if (tmp == queue->first)
		{
			queue->first = queue->first->next;
			queue->first->prev = NULL;
			free(tmp);
			return;
		}
		if (tmp == queue->last)
		{
			queue->last = queue->curr;
			queue->last->next = NULL;
			free(tmp);
			return;
		}

		queue->curr->next = tmp->next;
		tmp->next->prev = queue->curr;
		free(tmp);
	}
}


