/* $Id: queue.h,v 1.2 2008/08/03 08:15:48 superlink Exp $ */
/*******************************************************************************/
/************** queue.h							********************************/
/************** created by Anisenia Andrei		********************************/
/************** is used in haplotypingAlleles.c	********************************/
/************** by treatComponent()				********************************/
/*******************************************************************************/

#ifndef QUEUE_H
#define QUEUE_H


#include "gdata.h"
#include "sl_Auxilary.h"


typedef struct queue_node
{
	void* something;
	struct queue_node* next;
	struct queue_node* prev;
}QueueNode;

typedef struct queue_t
{
	int size;
	QueueNode* first;
	QueueNode* last;
	QueueNode* curr;
}Queue;



Queue* CreateQueue(void* something);
void InsertToTail(Queue* queue, void* something);
void* getCurr(Queue* queue);
void* getLast(Queue* queue);
void* getFirst(Queue* queue);
void increaseCurr(Queue* queue);
void restartCurr(Queue* queue);
void decreaseCurr(Queue* queue);
void destroyQueue(Queue* queue);
void removeFirst(Queue* queue);
Bool isEmpty(Queue* queue);
int getSize(Queue* queue);
void removeCurr(Queue* queue);



#endif

