/* $Id: sl_Auxilary.h,v 1.2 2008/08/03 08:15:48 superlink Exp $ */
/*****************************************************************************/
/*  Auxilary.h																 */
/*  Author: Ma'ayan Fishelson												 */
/*****************************************************************************/

#ifndef _SL_AUXILARY_H_
#define _SL_AUXILARY_H_



#include <stdio.h>
#include <stdlib.h>
#include "sl_Settings.h"
#include "../Auxiliary.h"
#include <stdarg.h>

#ifdef WIN32
	#include <crtdbg.h>
	#include <Assert.h>
#endif


/*------------------------------*/
/*		DATA-TYPES	    		*/
/*------------------------------*/

/*
typedef char	boolean;
#define	FALSE	0
#define TRUE	1


typedef char	interval;
#define LEFT	0
#define MIDDLE	1
#define	RIGHT	2
*/ 
typedef double sl_Probability;

/*------------------------------*/
/*		FUNCTIONS				*/
/*------------------------------*/


void sl_mallocErr(char *message);
void sl_reallocErr(char *message);
void sl_inputErr(char *message, ...);
void sl_inputWarning(char * message);
int sl_P_eof(FILE *f);
void sl_swap(int *val1, int *val2);


/*void sl_myMalloc(void* pointer, size_t size) */

#define sl_myMalloc(pointer, size) \
	pointer = NULL; \
	pointer = malloc(size); \
	if (pointer == NULL) \
		sl_mallocErr("pointer");

#if DOUBLE_SIZE
#define myBigMalloc(pointer, num, size) \

      if ((double)num*size > INT_MAX ){\
            sl_myMalloc(pointer, 2*sizeof(void*));\
            sl_myMalloc(pointer[0],MAX_INT);\
            sl_myMalloc(pointer[1], ((int)((double)num*size - MAX_INT)*size);\
      }\
      else{\
            sl_myMalloc(pointer, sizeof(void*));\
            sl_myMalloc(pointer[0], malloc(size*num)); \
      }
#else
#define myBigMalloc(pointer, num, size) \
	sl_myMalloc(pointer, (num*size)) 
#endif

#if DOUBLE_SIZE
#define myGetIndexInt(index) \
		(num*sizeof(int) > INT_MAX )?((int)((double)num*sizeof(int) - MAX_INT)):index
#else
#define myGetIndexInt(index) \
		index
#endif

#if DOUBLE_SIZE
#define myGetIndexDouble(index) \
	(num*sizeof(double) > INT_MAX )?((int)((double)num*sizeof(double) - MAX_INT)):index
#else
#define myGetIndexDouble(index) \
		index
#endif

/*void sl_myCalloc(void* pointer, size_t size) */
#define sl_myCalloc(pointer,num, size) \
	pointer = NULL; \
	pointer = calloc(num,size); \
	if (pointer == NULL) \
		sl_mallocErr("pointer");

/*void sl_myRealloc(void* pointer, size_t size) */

#define sl_myRealloc(pointer, size) \
	pointer = realloc(pointer, size); \
	if (pointer == NULL) \
		sl_reallocErr("pointer");



#endif /* _AUXILARY_H_ */
