#!/usr/bin/perl -w

package AutoConfiguration; 
use Exporter qw(import); 
use Fcntl ':flock'; # import LOCK_* constants
use POSIX qw(strftime); # in order to track the locks time
use Cwd;
use FindBin();
use lib "$FindBin::Bin";
use Tie::File;
our @EXPORT_OK = qw(%configfile); 
  
our %configfile = ( 
	MaxVar 				=> 	'0.67',   	#automatic experiments will run on areas with LOD score higher than MaxVar*(maximal LOD score)
	MinVar 				=> 	'1.01',   	#minimal expected growth from the previous max LOD score in order to continue to a larger window. 
	MinAreaSize			=>  '5',  		#the minimal size of a high LOD score area to be considered for further analysis (in cM)
	LowRate				=>	'0.33',		#the percentage of markers allowed to have a LOD score lower than MaxVar*(maximal LOD score) in the suspect area
	MaxLowArea			=>	'1',		#the maximal size of a low LOD score area allowed in a continuous high LOD score area (in cM)
	MaxThresh			=>	'2',		#the lowest maximal LOD score for further analysis
	HardPointsThresh	=>	'0.4', 		#the percentage of complex points in the area which cause the area to be too complex for further window expansion
);
	