#!/usr/bin/perl -w
use Processing;
use AutoConfiguration qw(%configfile);
use submissionConfig;
use Fcntl ':flock'; # import LOCK_* constants
use Configuration;

$config = new submissionConfig;

$binDir = "$config->{'FULL_DIR'}\/cgi-bin";

$projectName = $ARGV[0];
$projectsDir = $ARGV[1];
$max = $ARGV[2];
$fatherMax = $ARGV[3];
$ancestorDir = $ARGV[4];

$maxVar = $configfile{MaxVar};
$maxLowArea = $configfile{MaxLowArea};
$minAreaSize = $configfile{MinAreaSize};
$lowRate = $configfile{LowRate};
$minVar = $configfile{MinVar};
$maxThresh = $configfile{MaxThresh};

open SUB_INFO, "$config->{'FULL_DIR'}\/Submissions\/$ancestorDir\/submissionInformation";
@subData = <SUB_INFO>;
close SUB_INFO;
for $sub (@subData) {
	@paramData = split /\s+/, $sub;
	if ($sub =~ /MaxVar/) {$maxVar = $paramData[1];}			
	if ($sub =~ /MaxLowArea/) {$maxLowArea = $paramData[1];}
	if ($sub =~ /MinAreaSize/) {$minAreaSize = $paramData[1];}
	if ($sub =~ /LowRate/) {$lowRate = $paramData[1];}
	if ($sub =~ /MinVar/) {$minVar = $paramData[1];}
	if ($sub =~ /MaxVar/) {$maxVar = $paramData[1];}
	if ($sub =~ /MaxThresh/) {$maxThresh = $paramData[1];}	
}
	

$mask = "$projectsDir\/*.$projectName.*/$Processing::COLLECT_DATA_FILE";
@inputFiles = <$mask*>;

$suspectAreasFile = "suspect_areas.txt";

$clustered = 0;

for $file (@inputFiles) {
	$sortedData = $file;
	$sortedData =~ s/$Processing::COLLECT_DATA_FILE/sort_tmp.txt/g;
	
	$outputAreas = $file;
	$outputAreas =~ s/$Processing::COLLECT_DATA_FILE/$suspectAreasFile/g;
	
	$highPoints = $file;
	$highPoints =~ s/$Processing::COLLECT_DATA_FILE/high_points.txt/g;
	
	$tempFile = $file;
	$tempFile =~ s/$Processing::COLLECT_DATA_FILE/temp.txt/g;
	
	$dataFile = $file;
	$fileContent = `cat $file`;
	
	if ($fileContent =~ /^c/) {$clustered = 1;}
	
	$fileContent =~ s/c//g;
	
	open TEMP, ">$tempFile";
	print TEMP "$fileContent";
	close TEMP;
	
	$haploOutFile = $file;
	$haploOutFile =~ s/$Processing::COLLECT_DATA_FILE/formatted_outputHaplo.html/g;
	
	if (! -e "$haploOutFile") { #If the experiment wasn't HMM - otherwise we might have middle points without marker numbers and we can't sort
		system("sort -n $tempFile | uniq > $sortedData");
		if ((-e $sortedData) && (! -z $sortedData)) {
			if ($clustered == 1) { #put the "c" headers back to the sorted file
				open SORTED, "$sortedData";
				@sortedData = <SORTED>;
				close SORTED;
				
				open SORTED, ">$sortedData";
				for $s (0..$#sortedData) {print SORTED "c".$sortedData[$s];}				
				close SORTED;
			}
			$dataFile = $sortedData;
		}
	}
	
	open INPUT, "$dataFile";
	@inputData = <INPUT>;
	close INPUT;
	
	$threshold = $max*$maxVar;
	$i = 0;
	$lastLine = 0;
	
	system("awk -F '\\t' '{if ((\$4 > $threshold) && (\$4 > $maxThresh) && (\$1 != \"\")) print \$0}' $dataFile > $highPoints");
		
	while ($i <= $#inputData) {
		@lineData = split /\t/ , $inputData[$i];
		$lastLine++;
		if ($lineData[0] ne "") {
			$lastID = $lineData[0];
			$lastID =~ s/c//g;
		}
		
		if (($lineData[0] ne "") && ($lineData[3] > $threshold)) {
			$areaMax = $lineData[3];
			$distStart = $lineData[2];
			$idStart = $lineData[0];
			$dist = 0;
			$distLastHigh = $dist;
			$lowCount = 0;
			$markersCount = 1;
			$lastHigh = $lineData[0];
			$lastHigh =~ s/c//g;
			$lastHighLine = $i;
			$currLowSeqDist = 0;
			$currLowStart = -1;
			if ($i == $#inputData) {last;}			
			$j = $i + 1;
			@lineData = split /\t/ , $inputData[$j];
			$lastLine++;
			if ($lineData[0] ne "") {
				$lastID = $lineData[0];
				$lastID =~ s/c//g;
			}
			while ($currLowSeqDist < $maxLowArea) {
				$dist = $lineData[2] - $distStart;
				$markersCount++;
				if ($lineData[3] < $threshold) {
					$lowCount++;
					if ($currLowStart == -1) {
						$currLowStart = &getID($lineData[0], $lastID);
						$currLowStartDist = $lineData[2];
						$currLowSeqDist = 0;
					}
					else {$currLowSeqDist = $lineData[2] - $currLowStartDist;}					
				}
				else {
					$lastHigh = &getID($lineData[0], $lastID);
					$distLastHigh = $dist;
					$lastHighLine = $j;
					if ($areaMax < $lineData[3]) {$areaMax = $lineData[3];}					
					$currLowSeqDist = 0;
					$currLowStart = -1;
					
					$lastMarkersCount = $markersCount;
					$lastLowCount = $lowCount;
					
				}
				$j++;
				if ($j > $#inputData) {last;}
				@lineData = split /\t/ , $inputData[$j];
				$lastLine++;
				if ($lineData[0] ne "") {$lastID = $lineData[0];}
			}
			
			if ($distLastHigh >= $minAreaSize) {
				if ($lastLowCount < $lastMarkersCount * $lowRate) {
					if ($idStart =~ /c/) {$lastHigh = "c".$lastHigh;}
					
					open AREAS, ">>$outputAreas";
					print AREAS "$idStart\t$lastHigh\t$distLastHigh\t$areaMax\n";
					close AREAS;
					&invokeNewExp($file, $idStart, $lastHigh, $areaMax, $sortedData, 0);
					
					$i = $lastHighLine + 1;
				}
				else {$i++;}
			}
			else {$i++;}							
		}
		else {$i++;}
	}
	
	if ($inputData[0] =~ /c/) {&testHighPoints($highPoints, $outputAreas, 1, "");}		
	
	else {
		# Check if a snp file exists in the user experiments folder	
		@temp = split(/\//, $file);
		pop @temp;
		pop @temp;
		$projectOutDir = join("/", @temp);

		open SUB_INFO, "$projectOutDir\/submissionInformation";
		@subData = <SUB_INFO>;
		close SUB_INFO;
		
		@temp = split(/\//, $subData[1]);
		pop @temp; pop @temp;
		$userProjectsDir = join("/", @temp);

		@testSnpExistance = `ls $config->{'FULL_DIR'}\/$userProjectsDir\/raw\/*filtered*.snp`;
		if ($#testSnpExistance > -1) {
			&testHighPoints($highPoints, $outputAreas, 0, "$config->{'FULL_DIR'}\/$userProjectsDir\/raw");
		}
	}
}

sub getID( $ $ ) {
	my $currID = $_[0];
	my $lastID = $_[1];
	
	if ($currID =~ /c/) {
		@IDdata = split /c/, $currID;
		return $IDdata[1];
	}
	
	if ($currID eq "") {
		if ($lastID =~ /c/) {
			@IDdata = split /c/, $lastID;
			return $IDdata[1];
		}
		return $lastID;
	}
	
	return $currID;
}

sub invokeNewExp ( $ $ $ $ ) {
	$file = $_[0];
	$idStart = $_[1];
	$idEnd = $_[2];
	$areaMax = $_[3];
	$sortedData = $_[4];
	$openClusters = $_[5];
	
	$clustered = 0;
	$program = "MultiPointAnalysis";
	
	if ($idStart =~ /c/ ) {
		$summary = "<h3> Suspect area: from cluster $idStart to cluster $idEnd </h3>";
		$idStart =~ s/c//g;
		$idEnd =~ s/c//g;
		$clustered = 1;
	}
	else {$summary = "<h3> Suspect area: from marker $idStart to marker $idEnd </h3>";}
	
	@temp = split(/\//, $file);
	pop @temp;
	$projectDir = join("/", @temp);
	
	&Processing::setLogFiles( "$projectDir\/" );
	my %variables = %{ &Processing::initVariablesFromPrePoint( $projectDir ) };
	
	if ($openClusters == 1) {
		$summary = $summary."This area was chosen for further analysis without clustering because it formed a high LOD score clusters area in previous analyses.</br>";
	}
	else {	
		if ($idStart =~ /rs/) {
			$summary = $summary."This area was chosen for further analysis by enlarging the suspect area with additional markers from the SNP file.</br>";
		}
		else {
			$summary = $summary."This area was chosen for further analysis because it contained a significantly long area with high LOD score</br>";
		}
	}
	if (($areaMax < $fatherMax*$minVar) && ($areaMax < $maxThresh))  {
		$summary = $summary."No further analyses were performed because the last analysis LOD score was lower than the previous scores for that area.\n";
		$program = "NONE";
	}
	
	if (($variables{ program } !~ /HMM/) && ($idStart !~ /rs/)) {
		# Check the current experiment complexity
		$countHardPoints = 0;
		for $i ($idStart .. $idEnd) {
			$id = $i;
			if ($clustered == 1) {$id = "c".$i;}
			@idLines = `grep $id $sortedData`;			
			@currentLineData = split /\t/ , $idLines[0];			
			if ($currentLineData[4] =~ /Hard/) {$countHardPoints++;}
		}
		
		if ($countHardPoints >= $configfile{HardPointsThresh} * ($idEnd - $idStart + 1)) {
			&Processing::debug_print( "The complexity of the current experiment was considered to be hard - we shouldn't try expanding the window any further" );
			if (defined($variables{ jump }) && ($summary !~ /chosen for further/)) {
				$summary = $summary."This area was analyzed via increasing windows from TwoPoint analysis to MultiPoint analysis with a window of $variables{ jump }.</br>";
			}
			$summary = $summary."No further analyses were performed because the complexity of the last experiment was considered to be hard.</br>";
				
			$program = "Haplotyping";
		}
	}
	
	if ($variables{ program } =~ /HMM/ ) {
		&Processing::debug_print( "The father experiment was invoked via HMM - it used all the markers for the analysis without windows - no expansion possible" );
		$summary = $summary."This area was analyzed via HMM MultiPoint analysis, meaning it used all the markers for the analysis without windows and no further analyses of the area were needed.</br>";
		if ($idStart !~ /rs/) {
			$program = "Haplotyping";
			#$window = $variables{ to } - $variables{ from } + 1 + 2; # we add 2 because haplotyping will reduce 2
			$window = 5;
		}
	}
	else {
		if ($variables{ program } =~ /TwoPoint/) {$window = 3;}		
		else {
			if ( defined($variables{ jump }) && ( $variables{ jump } !~ /Unknown/ ) ) {
				
				if (($summary !~ /analyzed via increasing/) && ($summary !~ /chosen for further/)) {
					$summary = $summary."This area was analyzed via increasing windows from TwoPoint analysis to MultiPoint analysis with a window of $variables{ jump }.</br>";
				}
				
				#Check whether there was any skipped data
				open DATA, "$file";
				@data = <DATA>;
				close DATA;
				
				if ($#data + 1 < $variables{ to } - $variables{ from } + 1) {
					&Processing::debug_print( "There was skipped data - no conclusions can be made");
					$summary = $summary."No further analyses were performed because the complexity of the last experiment was considered to be hard. As you can see it has some skipped points due to their computation complexity.</br>";
					$program = "Haplotyping";
				}
							
				if ( int(($idStart - $variables{ from })/$variables{ jump }) == int(($idEnd - $variables{ from })/$variables{ jump }) ) {
					&Processing::debug_print( "The area was fully covered by the previous window");
					$summary = $summary."No further analyses were performed because the last experiment had the suspect area covered by one continuous window.</br>";
					$program = "Haplotyping";
				}
				
				$window = $variables{ jump } + 1;
				if ($variables{ to } - $variables{ from } + 1 < $window) {
					$window = $variables{ to } - $variables{ from } + 1;
				}
			}
			else {
				&Processing::debug_print( "The father experiment was invoked on a list - we can't expand it...");
				$summary = $summary."No further analyses were performed because the last experiment was invoked on a list of specific markers/clusters.</br>";
				$program = "Haplotyping";
			}
		}
	}
	
	if (($program eq "MultiPointAnalysis") && ($idStart !~ /rs/ )) {
		#Add edges to the suspect area to get a better LOD curve
		@markersArray  = sort {$a <=> $b} @{$variables { usedMarkersId }};
		$firstInFile = $markersArray[0];
		$lastInFile = $markersArray[$#markersArray];
		if ($openClusters == 1) {		
			$id = "c".$markersArray[0];
			@idLines = `grep $id $sortedData`;
			
			@currentLineData = split /\t/ , $idLines[0];
			
			@namesTmp1 = split /\(/, $currentLineData[1];
			@namesTmp2 = split /\)/, $namesTmp1[1];
			
			$firstInFile = $namesTmp2[0];
			
			$id = "c".$markersArray[$#markersArray];
			@idLines = `grep $id $sortedData`;
			
			@currentLineData = split /\t/ , $idLines[0];
			
			@namesTmp1 = split /\(/, $currentLineData[1];
			@namesTmp2 = split /\)/, $namesTmp1[$#namesTmp1];
			
			$lastInFile = $namesTmp2[0];		
		}
		
		if ($idStart - 2 >= $firstInFile) {$idStart = $idStart - 2;}		
		elsif ($idStart - 1 >= $firstInFile) {$idStart = $idStart - 1;}			
		
		
		if ($idEnd + 2 <= $lastInFile) {$idEnd = $idEnd + 2;}		
		elsif ($idEnd + 1 <= $lastInFile) {$idEnd = $idEnd + 1;}
	}	
	
	if ($clustered == 1) {
		$idStart = "c".$idStart;
		$idEnd = "c".$idEnd;
	}
	
	if ($program eq "Haplotyping") {
		$window--;
		if ($window > 3) {$window--;}		
		$summary = $summary."A Haplotyping analysis was invoked on the area with a window of $window.</br>";
	}
		
	if ($idStart =~ /rs/) {$window = 3;}	#We will start from a small window in the enlarged are
	
	# Add chromosome indication to the experiment name if possible
	if ($variables{ PROJ } =~ /(chrom_\d+)/) {
		$chromNum = $1;
		$summary =~ s/Suspect area: from/Suspect area: on $chromNum from/g;
		$expName = $program."_".$chromNum."_".$idStart."_".$idEnd."_win".$window;
	}
	else {$expName = $program."_".$idStart."_".$idEnd."_win".$window;}
	
	# Check if this experiment exists in the user experiments folder	
	@temp = split(/\//, $file);
	pop @temp;
	pop @temp;
	$projectOutDir = join("/", @temp);
	
	open SUB_INFO, "$projectOutDir\/submissionInformation";
	@subData = <SUB_INFO>;
	close SUB_INFO;
	
	@temp = split(/\//, $subData[1]);
	chomp($subData[1]);
	$prevExp = pop @temp;
	$userProjectsDir = join("/", @temp);
	pop @temp;
	$webProjectName = pop @temp;
	
	# Try to find a name that doesn't exist
	$tempExpName = $expName;
	$i = 1;
	while (-d "$config->{'FULL_DIR'}\/$userProjectsDir\/$tempExpName") {
		$tempExpName = $expName."_V".$i;
		$i++;
	}
	$expName = $tempExpName;
	
	# Get MOI
	@penetrances  = @{$variables { penetrances }};
	if (($penetrances[0] == 0) && ($penetrances[1] == 0)) {$MOI = "Rec_".$penetrances[2];}	
	else {$MOI = "Dom_".$penetrances[1]."_".$penetrances[2];}
	
	$filesHead = $variables{ PROJ };
	if ( ($openClusters == 0) && (defined( $variables{ method })) ) {
		$filesHead = $variables{ method }."@".$variables{ PROJ };
	}
	
	#If we should open clusters then the parent project is the root project - before clusters were made
	$parentProject = $projectName;
	if ($openClusters == 1) {
		$parentProject = $variables{ root };
		$filesHead = $variables{ rootName };
	}
	
	if (($summary =~ /(N|n)o further/) || (($summary =~ /chosen for further/) && ($summary !~ /long area with high LOD score/)) || ($ancestorDir eq $projectName)) {
		open SUB_INFO, "$config->{'FULL_DIR'}\/Submissions\/$ancestorDir\/submissionInformation";
		@subData = <SUB_INFO>;
		close SUB_INFO;
	
		@temp = split(/\//, $subData[1]);
		chomp($subData[1]);
		
		$expLink = "<a href=\"$Configuration::HOME_WEB_DIR/projects.php?proj=$webProjectName&exp=$prevExp\" target=\"_blank\">$prevExp</a>";	
		if ($summary =~ /(N|n)o further/ ) {
			$summary = $summary."<b>This area is recommended for further analysis</b>";
			$summary =~ s/Suspect area/Suspect area according to $expLink/g;
		}
		else {$summary =~ s/Suspect area/Initially suspected area according to $expLink/g;}
		
		open SUMMARY, ">>$config->{'FULL_DIR'}\/$subData[1]\/autorunSummary.html";
		flock (SUMMARY, EX_LOCK);
		print SUMMARY "$summary";			
		close SUMMARY;
	}
	
	my $invokeCommand = "export PERLLIB=$binDir; perl $binDir\/runNewExperiment.pl -tool ".$program;
	$invokeCommand = $invokeCommand." -sourceTask ".$parentProject." -parent ".$projectName;
	$invokeCommand = $invokeCommand." -expName ".$expName;
	if ($idStart !~ /rs/ ) {$invokeCommand = $invokeCommand." -files ".$filesHead;}	
	else {$invokeCommand = $invokeCommand." -enlarge -clean Weak";}
	
	$invokeCommand = $invokeCommand." -freq ".$variables{ mutantFreq }." -MOI ".$MOI;
	$invokeCommand = $invokeCommand." -from ".$idStart." -to ".$idEnd." -window ".$window." -max ".$areaMax;
	$invokeCommand = $invokeCommand." -automate true";
	&Processing::debug_print( "$invokeCommand" );
	system($invokeCommand);
}

#Try to open clusters and search in their area for suspect areas
sub testHighPoints ( $ $ $ ) {
	
	$highPoints = $_[0];
	$outputAreas = $_[1];
	$clusteredData = $_[2];
	$currentProjectDir = $_[3]; #only for non-clustered data
	
	open HIGH, "$highPoints";
	@highData = <HIGH>;
	close HIGH;
	
	open AREAS, "$outputAreas";
	@areasData = <AREAS>;
	close AREAS;
	
	@highPoints = ();
	
	for $i (0..$#highData) {
		@lineData = split /\t/ , $highData[$i];
		if ($lineData[0] ne "") {
			$id = $lineData[0];
			$id =~ s/c//g;
		}
		
		$inArea = 0;
		for $j (0..$#areasData) {
			@areaLineData = split /\t/ , $areasData[$j];
			$areaStart = $areaLineData[0];
			$areaStart =~ s/c//g;
			$areaEnd = $areaLineData[1];
			$areaEnd =~ s/c//g;
			if (($areaStart <= $id) && ($areaEnd >= $id)) {$inArea = 1;}
		}
		
		if ($inArea == 0) {push(@highPoints, $highData[$i]);}		
	}
	
	if ($#highPoints > -1) {
		$startPoint = shift @highPoints;
		@startLineData = split /\t/ , $startPoint;
		if ($startLineData[0] ne "") {
			$startPointId = $startLineData[0];
			$startPointId =~ s/c//g;
		}
		
		$startPointId = $startLineData[0];
		$startPointNames = $startLineData[1];
		$prevPointNames = $startLineData[1];
		$prevPointId = $startLineData[0];
		$nextPointNames = $startLineData[1];
		$nextPointId = $startLineData[0];
		
		while ($#highPoints > -1) {
			$nextPoint = shift @highPoints;
			@nextLineData = split /\t/ , $nextPoint;
			if ($nextLineData[0] ne "") {
				$nextPointId = $nextLineData[0];
				$nextPointId =~ s/c//g;
			}
			$nextPointNames = $nextLineData[1];
			$nextPointId = $nextLineData[0];
			
			if ($nextPointId - $startPointId >= 5) {	
				if ($clusteredData == 1) {
					@namesTmp1 = split /\(/, $startPointNames;
					@namesTmp2 = split /\)/, $namesTmp1[1];
					
					@namesTmp1 = split /\(/, $prevPointNames;
					@namesTmp3 = split /\)/, $namesTmp1[$#namesTmp1];
					
					if ($namesTmp2[0] != $namesTmp3[0]) {
						&invokeNewExp($file, $namesTmp2[0], $namesTmp3[0], $lineData[3], $sortedData, 1);
					}
				}
				else {
					if ($startPointNames ne $prevPointNames) {
						@finalSnp = `ls $currentProjectDir\/*final*.snp`;
						$firstMarker = `grep $startPointNames -n $finalSnp[0] | awk -F":" '{print $1}'`;
						$lastMarker = `grep $prevPointNames -n $finalSnp[0] | awk -F":" '{print $1}'`;
						if (($lastMarker - $firstMarker + 1) > ($prevPointId - $startPointId + 1)) {
							&invokeNewExp($file, $startPointNames, $prevPointNames, $lineData[3], $sortedData, 0);
						}
					}
				}
				
				$startPoint = $nextPoint;
				$startPointId = $nextLineData[0];
				$startPointNames = $nextLineData[1];
			}
			else {
				$prevPointNames = $nextLineData[1];
				$prevPointId = $nextLineData[0];
			}
		}
		
		if ($clusteredData == 1) {
			@namesTmp1 = split /\(/, $startPointNames;
			@namesTmp2 = split /\)/, $namesTmp1[1];

			@namesTmp1 = split /\(/, $nextPointNames;
			@namesTmp3 = split /\)/, $namesTmp1[$#namesTmp1];

		
			if ($namesTmp2[0] != $namesTmp3[0]) {
				&invokeNewExp($file, $namesTmp2[0], $namesTmp3[0], $lineData[3], $sortedData, 1);
			}
		}
		else {
			if ($startPointNames ne $nextPointNames) {
				@finalSnp = `ls $currentProjectDir\/*final*.snp`;
				$firstMarker = `grep $startPointNames -n $finalSnp[0] | awk -F":" '{print $1}'`;
				$lastMarker = `grep $nextPointNames -n $finalSnp[0] | awk -F":" '{print $1}'`;
				if (($lastMarker - $firstMarker + 1) > ($nextPointId - $startPointId + 1)) {
					&invokeNewExp($file, $startPointNames, $nextPointNames, $lineData[3], $sortedData, 0);
				}
			}
		}
	}
}



	
	
	