#!/usr/bin/env perl

use MIME::QuotedPrint;
use MIME::Base64;
use Mail::Sendmail;
use submissionConfig; 


$workdir='PEDTOOL_FULL_DIR';
$user_email = 'PEDTOOL_USER_MAIL';
$project_name = 'PEDTOOL_PROJECT_NAME';
$server_results_dir = 'PEDTOOL_SERVER_DIR';
$server_output_file = 'PEDTOOL_SERVER_OUTPUT_FILE';
$server_status_file = 'PEDTOOL_SERVER_STATUS_FILE';
$server_name='PEDTOOL_PORTAL';
$smtp_server = 'PEDTOOL_SMTP_SERVER';
$from = 'PEDTOOL_EMAIL';

@tmp = split(/\@/, $user_email);
$user_name = $tmp[0];
chdir ("$workdir");
if ($#ARGV!=0){
	die "Missing parameter: type: 0-first mail,1-update (read from input),2-final with attachment";
}
sub CreateMailWithAttachment{
	my $file=$_[0];
	my $message=$_[1];
	my $subject=$_[2];
	#get the message from input

	%mail = ( To => $user_email,
        	  From => $from,
	          subject => $subject,
		  Smtp => "$smtp_server" );

	$boundary = "====" . time() . "====";
	$mail{'content-type'} = "multipart/mixed; boundary=\"$boundary\"";

	$message = encode_qp($message);
# attach the results file	
	open (F, $file) or die "Cannot read $file: $!";
	binmode F; undef $/;
	$mail{body} = encode_base64(<F>);
	close F;

	$boundary = '--'.$boundary;

$mail{body} = <<END_OF_BODY;
$boundary
Content-Type: text/plain; charset="ISO-8859-8"
Content-Transfer-Encoding: quoted-printable

$message
$boundary
Content-Type: application/octet-stream; name= \"$file\"
Content-Transfer-Encoding: base64
Content-Disposition: attachment; filename= \"$file\"

$mail{body}
$boundary--
END_OF_BODY
}

sub CreateMail{
	my ($message,$subject)=@_;
	 %mail = ( To => $user_email,
                  From => $from,
                  subject => $subject,
                  message => $message,
                  Smtp => "$smtp_server" );
	
}
sub SendFinalResults{
	#get the message from input
	$input="";
	$msg="";
	while($input=<STDIN>){
		$msg.=$input;
	}
	$message="Run $project_name has been successfully executed using Condor High Throughput System in the $msg\n\nLink to your summary results:\nhttp://$server_name/$server_results_dir/$server_output_file\n\n\n";
	
	&CreateMailWithAttachment($server_output_file,$message,"Project $project_name - Complete");
}


sub SendFirstMail{
	$message="run $project_name has been submitted to Condor's pool of computers.\n\n\nYou can check the progress of your computation using the following link: http://$server_name/$server_results_dir/$server_status_file\n";

	&CreateMail($message, "Report on project $project_name");
}
sub SendUpdate(){
	#get the message from input
	$input="";
	while($input=<STDIN>){
		$msg.=$input;
	}
	@res=split ' ',$msg;
	$subj=$res[0];
	shift @res;
	$msg=join ' ',@res;
	$msg.="\n\nYou can find additional information and results at\nhttp://$server_name/$server_results_dir/$server_status_file \n";
	
	&CreateMail($msg, "Project $project_name - $subj");
}


if ($ARGV[0]=="0"){
	&SendFirstMail();
}elsif ($ARGV[0]=="1"){
	&SendUpdate();
}elsif ($ARGV[0]=="2"){
	&SendFinalResults();
}else{
	die "Wrong parameter: can be [0,1,2]";
}

sendmail(%mail) || do { print "Error: $Mail::Sendmail::error\n"; exit -1; }
