#!/usr/bin/perl -w

# call to this script:
# perl prepareTask.pl [-dir <dir name>] [-mail <user email>]  [-flag <flag name1> [<flag name2>...]]    // depricated[-varFile <variables file>]
# -dir is the directory where the files to send are. (if not specified, the first parameter will be taken as the dir)
# -flag creates a file with a given <flag name> in the submission folder, for future need. leave empty for no flagging.
# -mail where to send e-mails for updates and errors.
#depricated   -varFile is the "more variables" file for clustering and filtering. this should be omitted if there's no such file.

use FindBin ();
use lib "$FindBin::Bin";
use submissionConfig;
use CGI ':standard';
use SharedConsts;

$config = new submissionConfig;

$mail = $SharedConsts::PROGRAMMERS_EMAIL_ADDRESS;

if ( $#ARGV == -1) {
	print "Script parameters error.";
	exit -1;
}
else {
	$dir = $ARGV[0];	# the directory where the ped and pairs are, default $ARGV[0] if not specified by -dir
	@flag = ('');
	
	for $i (0..$#ARGV){
		if ($ARGV[$i] eq "-dir"){
			$dir = $ARGV[$i+1];
		}
				
		if ($ARGV[$i] eq "-flag"){
			my $j = $i + 1;
			do {
				$flag[$j - $i - 1] = $ARGV[$j];
				$j = $j + 1;
			} while ( ($j <= $#ARGV) and (!($ARGV[$j] =~ /^-.*/)) );
		}
		
		if ($ARGV[$i] eq "-mail"){
			$mail = $ARGV[$i+1];
		}
	}
}

@array = ('a'..'z',0..9);
srand;

do {
	$runName = "";
	for (1..10) {
		$runName = $runName . $array[int(rand(36))];
	}
} while (-d "$config->{'FULL_DIR'}/Submissions/$runName");

system("mkdir $config->{'FULL_DIR'}/Submissions/$runName");
system("chmod 777 $config->{'FULL_DIR'}/Submissions/$runName");
system("echo $runName > $config->{'FULL_DIR'}/$dir/.processID.txt");

$workDir = "/Submissions/$runName";
$fullWorkDir = $config->{'FULL_DIR'} . $workDir;
$results = "results.html";
$mailSender = "$config->{'FULL_DIR'}/Submissions/$runName" . "/mail_sender.pl";

@dirSplit = split(/\//, $dir);		# get project name for the mails to the user
$projectName = $dirSplit[3];

open (MAIL_TEMPLATE , "$config->{'FULL_DIR'}/cgi-bin/mail_sender.pl");
@template = <MAIL_TEMPLATE>;
close (MAIL_TEMPLATE);

open (MAIL , ">$mailSender");
for $i (0..$#template) {
	my $line = $template[$i];
	if( $i >= 8 && $i <= 16) {
		$line =~ s/PEDTOOL_SERVER_DIR/$workDir/g;
		$line =~ s/PEDTOOL_PORTAL/$config->{'HTML_ROOT'}/g;
		$line =~ s/PEDTOOL_USER_MAIL/$mail/g;
		$line =~ s/PEDTOOL_PROJECT_NAME/$projectName/g;
		$line =~ s/PEDTOOL_SMTP_SERVER/$config->{'SMTP_SERVER'}/g;
		$line =~ s/PEDTOOL_SERVER_OUTPUT_FILE/$results/g;
		$line =~ s/PEDTOOL_SERVER_STATUS_FILE/$results/g;
		$line =~ s/PEDTOOL_FULL_DIR/$fullWorkDir/g;
		$line =~ s/PEDTOOL_EMAIL/$config->{'PORTAL_EMAIL'}/g;
	}
	print MAIL $line;
}
close (MAIL);

#system ("cat mail_sender.pl | sed \"s/PEDTOOL_SERVER_DIR/$workDir/\" | sed \"s/PEDTOOL_PORTAL/$config->{'HTML_ROOT'}/\" | sed \"s/PEDTOOL_USER_MAIL/$mail/\" | sed \"s/PEDTOOL_PROJECT_NAME/$runName/\" | sed \"s/PEDTOOL_SMTP_SERVER/$config->{'SMTP_SERVER'}/\" | sed \"s/PEDTOOL_SERVER_OUTPUT_FILE/$results/\" | sed \"s/PEDTOOL_SERVER_STATUS_FILE/$results/\" | sed \"s/PEDTOOL_FULL_DIR/$fullWorkDir/\" | sed \"s/PEDTOOL_EMAIL/$config->{'PORTAL_EMAIL'}/\" > $mailSender");
system("chmod +x $mailSender");


open(TARLIST,">$config->{'FULL_DIR'}/Submissions/$runName/tarList.txt");
open(DETAILS,">$config->{'FULL_DIR'}/Submissions/$runName/details.txt");

opendir(DIR,"$config->{'FULL_DIR'}/$dir");
foreach $file (readdir(DIR)) {
	if ($file =~ /^(.*)\.ped$/) {
		my $datFile = $1 . ".dat";
		my $pedFile = $file;								# similar to $1 . ".ped"
		if(-e "$config->{'FULL_DIR'}/$dir/$datFile") {
			print TARLIST "$datFile\n";
			print TARLIST "$file\n";
			print DETAILS "$datFile\n";
			print DETAILS "$pedFile\n";
			if(-e "$config->{'FULL_DIR'}/$dir/.$datFile.raw") {
				print TARLIST ".$datFile.raw\n";
			}
		}
	}
}
if (-e "$config->{'FULL_DIR'}/$dir/moreVariables.txt"){
	&setAnalysisParamsFromFile("$config->{'FULL_DIR'}/$dir/moreVariables.txt");
	print TARLIST "moreVariables.txt\n";
}
close(DIR);

#Omer 31/7/2011 - copy the file $SharedConsts::MORGAN_MORE_PARAMS_FILENAME if it exists
if (-e "$config->{'FULL_DIR'}/$dir/$SharedConsts::MORGAN_MORE_PARAMS_FILENAME"){
    system("cp $config->{'FULL_DIR'}/$dir/$SharedConsts::MORGAN_MORE_PARAMS_FILENAME $config->{'FULL_DIR'}/Submissions/$runName/$SharedConsts::MORGAN_MORE_PARAMS_FILENAME");    
}
	
close(DETAILS);
close(TARLIST);

if (!($flag[0] eq '')){
	for $i (0..$#flag) {
		open(FLAG,">$config->{'FULL_DIR'}/Submissions/$runName/".$flag[$i]);
		print FLAG "marked";
		close(FLAG);
	}
}

#### DEBUG - if needed logging of the send command ###
#open(LOG,">$config->{'FULL_DIR'}/Submissions/$runName/logSubmit");
#print LOG "cat $config->{'FULL_DIR'}/Submissions/$runName/Submission.tar.gz | $config->{'SSHCMD'} $config->{'REMOTE_USER'}" . "@" . "$config->{'GW'} $config->{'REMOTE_SUBMIT_SCRIPT'} $runName";
#close(LOG);
###################################

######## just for now ##########
#$mail = 'mail@mail.com';
$dir = $dir;
#$sexLinked = 0;
&initParamsFromDatInDir( $dir );
#$healthy = 0.99;
#$sick = 0.01;
#$HH = 0;
#$HD = 0;
#$DD = 0.99;
$maleH = 0;
$maleD = 1;
#########################


open(INF,">$config->{'FULL_DIR'}/Submissions/$runName/submissionInformation");
print INF "$mail\n";
print INF "$dir\n";
print INF "$sexLinked\n";
print INF "$healthy\n";
print INF "$sick\n";
print INF "$HH\n";
print INF "$HD\n";
print INF "$DD\n";
print INF "$maleH\n";
print INF "$maleD\n";
# automate values
if (defined($MaxVar)) {print INF "MaxVar $MaxVar\n";}
if (defined($MinVar)) {print INF "MinVar $MinVar\n";}
if (defined($MinAreaSize)) {print INF "MinAreaSize $MinAreaSize\n";}
if (defined($LowRate)) {print INF "LowRate $LowRate\n";}
if (defined($MaxLowArea)) {print INF "MaxLowArea $MaxLowArea\n";}
if (defined($MaxThresh)) {print INF "MaxThresh $MaxThresh\n";}

#segregation values
if (defined($segType)) {print INF "SegregationType $segType\n";}

# analysis values
if (defined($AnalysisType)) {print INF "Analysis $AnalysisType\n";}
if (defined($MarkersList)) {print INF "MarkersList $MarkersList\n";}
if (defined($FromMarker)) {print INF "FromMarker $FromMarker\n";}
if (defined($ToMarker)) {print INF "ToMarker $ToMarker\n";}
if (defined($WindowSize)) {print INF "WindowSize $WindowSize\n";}

#Omer 28/7/2011 - Morgan related fields
if (defined($MaxJobsPerTask)) {print INF "MaxJobsPerTask $MaxJobsPerTask\n";}
if (defined($MaxTimePerJob)) {print INF "MaxTimePerJob $MaxTimePerJob\n";}
if (defined($MinTimePerJob)) {print INF "MinTimePerJob $MinTimePerJob\n";}
if (defined($MinNumOfIterations)) {print INF "MinNumOfIterations $MinNumOfIterations\n";}
if (defined($MaxNumOfIterations)) {print INF "MaxNumOfIterations $MaxNumOfIterations\n";}
if (defined($NumDupsPerJob)) {print INF "NumDupsPerJob $NumDupsPerJob\n";}
if (defined($WindowTime)) {print INF "WindowTime $WindowTime\n";}
if (defined($BurnInPercentage)) {print INF "BurnInPercentage $BurnInPercentage\n";}
if (defined($SeqImpRealizationsPercentage)) {print INF "SeqImpRealizationsPercentage $SeqImpRealizationsPercentage\n";}
if (defined($ExperimentsWaiting)) {print INF "ExperimentsWaiting $ExperimentsWaiting\n";}


close (INF);

submissionConfig::Log($runName, "Task prepared successfully.", $config->{'GLOBAL_LOG'});

system ("echo $runName");

# initiates $sexLinked, $healthy, $sick, $HH, $HD, $DD, from the first dat file in a given $directory
sub initParamsFromDatInDir( $ ){
	my $dir = $_[0];
	opendir(DIR,"$config->{'FULL_DIR'}/$dir");
	foreach $file (readdir(DIR)) {
		if ($file =~ /^(.*)\.dat$/) {
			open(DAT,"<$config->{'FULL_DIR'}/$dir/$file");
			my $line = "";
			$line = <DAT>;
			chomp($line);
			@line = split(/[ \t]/,$line);
			$sexLinked = $line[2];
			for $i (1..4){
				$line = <DAT>;
			}
			chomp($line);
			@line = split(/[ \t]/,$line);
			$healthy = $line[0];
			$sick = $line[1];
			$line = <DAT>;
			$line = <DAT>;
			chomp($line);
			@line = split(/[ \t]/,$line);
			$HH = $line[0];
			$HD = $line[1];
			$DD = $line[2];
			last;
		}
	}
}

sub setAnalysisParamsFromFile( $ ){
	my $paramsFile = $_[0];
	
	open(INF,$paramsFile);
	@inf = <INF>;
	close(INF);

	for $line (@inf) {
		chomp($line);
		@line = split(/[ \t]/, $line);		
		if ($line[0] eq "Analysis") {$AnalysisType = $line[1];}		
		if ($line[0] eq "FromMarker") {$FromMarker = $line[1];}		
		if ($line[0] eq "ToMarker") {$ToMarker = $line[1];}		
		if ($line[0] eq "WindowSize") {$WindowSize = $line[1];}
		if ($line[0] eq "MarkersList") {$MarkersList = $line[1];}
		if ($line[0] eq "MaxVar") {$MaxVar = $line[1];}
		if ($line[0] eq "MinVar") {$MinVar = $line[1];}
		if ($line[0] eq "MinAreaSize") {$MinAreaSize = $line[1];}		
		if ($line[0] eq "LowRate") {$LowRate = $line[1];}
		if ($line[0] eq "MaxLowArea") {$MaxLowArea = $line[1];}
		if ($line[0] eq "MaxThresh") {$MaxThresh = $line[1];}

		#Omer 28/7/2011 - Morgan related flags
		if ($line[0] eq "MaxJobsPerTask") {$MaxJobsPerTask = $line[1];}
		if ($line[0] eq "MaxTimePerJob") {$MaxTimePerJob = $line[1];}
		if ($line[0] eq "MinTimePerJob") {$MinTimePerJob = $line[1];}
		if ($line[0] eq "MinNumOfIterations") {$MinNumOfIterations = $line[1];}
		if ($line[0] eq "MaxNumOfIterations") {$MaxNumOfIterations = $line[1];}		
		if ($line[0] eq "NumDupsPerJob") {$NumDupsPerJob = $line[1];}
		if ($line[0] eq "WindowTime") {$WindowTime = $line[1];}
		if ($line[0] eq "BurnInPercentage") {$BurnInPercentage = $line[1];}
		if ($line[0] eq "SeqImpRealizationsPercentage") {$SeqImpRealizationsPercentage = $line[1];}        
        if ($line[0] eq "ExperimentsWaiting") {$ExperimentsWaiting = $line[1];}	
		if ($line[0] eq "SegregationType") {$segType = $line[1];}
	}
}