#!/usr/bin/perl -w

use FindBin ();
use lib "$FindBin::Bin";
use submissionConfig;
#use resultsPage;
use File::Copy;
use SharedConsts;

use constant EX_LOCK => 2;

sub getDirOfRunName( $ );
sub updatePercents( $ $ $ $ );
sub getQueueForTask( $ );
sub reportTaskError( $ $ $ $ );
sub updateTask( $ $ $ $ $ );
sub finishTask( $ $ );
sub wakeTask( $ $ );
sub getWaitingExperiments( $ );
sub getScriptForTask( $ );
sub extractFilesFromTar( $ $ $ $ $ );


#$resPage = new resultsPage;
$config = new submissionConfig;
$cgibinDir = $config->{'FULL_DIR'}."/cgi-bin";

$mode = $ARGV[0];
$runName = $ARGV[1];
$tarName = $ARGV[2];

$msg = 0;
$flag = 0;
$projName = 0;
$chr = 0;
$parameter = 0;
$percent = 0;
$logFile = 0;

for $i (0..$#ARGV) {
		if ($ARGV[$i] eq "-msg") {$msg = $ARGV[$i+1];}
		elsif ($ARGV[$i] eq "-ef") {$flag = $ARGV[$i+1];}
		elsif ($ARGV[$i] eq "-errorFlag") {$flag = $ARGV[$i+1];}			# same as -ef
		elsif ($ARGV[$i] eq "-ef") {$flag = $ARGV[$i+1];}
		elsif ($ARGV[$i] eq "-sl") {$projName = $ARGV[$i+1];}
		elsif ($ARGV[$i] eq "-tar") {$tarName = $ARGV[$i+1];}
		elsif ($ARGV[$i] eq "-log") {$logFile = $ARGV[$i+1];}		
		elsif ($ARGV[$i] eq "-r") {$runName = $ARGV[$i+1];}
		elsif ($ARGV[$i] eq "-chr") {$chr = $ARGV[$i+1];}
		elsif ($ARGV[$i] eq "-parameter") {$parameter = $ARGV[$i+1];}
		elsif ($ARGV[$i] eq "-percent") {$percent = $ARGV[$i+1];}		
}

$lock = "$config->{'QUEUE_LOCK'}";

if($mode eq "update") {
	updateTask($runName, $chr, $parameter, $percent, $logFile);
	exit 0;
}

if($mode eq "error") {
	reportTaskError($runName, $chr, $parameter, $msg);

	### send mail to administrators (frontend / backend / superlink) ###
	$ret1 = system ("echo \"error encountered on task: $runName, on chromosome: $chr, during: $parameter, with message: $msg\" | $config->{'FULL_DIR'}/cgi-bin/admin_mail_sender.pl $SharedConsts::PROGRAMMERS_EMAIL_ADDRESS $config->{'SMTP_SERVER'}");
	# Dvir 12/05/2011, since I am both  WEB_ADMIN_MAIL & DISTILLER_ADMIN_MAIL so there is no need to send 2 mails to me.
	#$ret1 = system ("echo \"error encountered on task: $runName, on chromosome: $chr, during: $parameter, with message: $msg\" | $config->{'FULL_DIR'}/cgi-bin/admin_mail_sender.pl $config->{'WEB_ADMIN_MAIL'} $config->{'SMTP_SERVER'}");	
	#$ret2 = system ("echo \"error encountered on task: $runName, on chromosome: $chr, during: $parameter, with message: $msg\" | $config->{'FULL_DIR'}/cgi-bin/admin_mail_sender.pl $config->{'DISTILLER_ADMIN_MAIL'} $config->{'SMTP_SERVER'}");	
	#$ret3 = system ("echo \"error encountered on task: $runName, on chromosome: $chr, during: $parameter, with message: $msg\" | $config->{'FULL_DIR'}/cgi-bin/admin_mail_sender.pl $config->{'SUPERLINK_ADMIN_MAIL'} $config->{'SMTP_SERVER'}");
	
	if ($ret1 != 0){
		print "Error occurred while sending mail to admins.";
		exit -1;
	}
	else{print "Mail (about system error) sent successfully.\n";}
	
	$mailSender = "$config->{'FULL_DIR'}/Submissions/$runName" . "/mail_sender.pl";
	system ("echo \"Failure. There was an error while running $chr.\nSystem administrators were notified.\nPlease contact the system adminitrator for more information.\" | $mailSender 1"); 
	exit 0;
}

if($mode eq "SLnotify") {
	# missing projName.
	if (!($projName)){				#do nothing
		exit -1;
	}
	
	# in case of finish with no errors - errorFlag / ef = 0
	if ($flag eq "0") {
		@project = split(/\./, $projName);
		$chrom = $project[1];
		$runName = $project[2];
		
		#lock ?
		my $dir = "$config->{'FULL_DIR'}/".getDirOfRunName($runName);
		if (!(-d "$dir")) { return -1; }
		open(RESULTS_LOCK, "> $config->{'FULL_DIR'}/" . $dir . "/.resultsLock");
		flock (RESULTS_LOCK, EX_LOCK);
		open(RESULTS, "< $dir/.results");
		@allResults = <RESULTS>;
		close(RESULTS);
		
		if (!(-d $dir."/Results")){
			mkdir $dir."/Results";
		}
		
		for $i (1..$#allResults) {
			@nameLink = split(/[ ]/, $allResults[$i]);
			if ($#nameLink != 1) { next; }
			$name = $nameLink[0];
			#$link = $nameLink[1];
			$taskDir = "$config->{'FULL_DIR'}/Submissions/$runName/$projName";
			if (-d $taskDir){
				my $resultsDir = $dir."/Results/".$name;
				mkdir $resultsDir;
				system("cp $taskDir/*.html $resultsDir/");
				system("cp $taskDir/custom_tracks.txt $resultsDir/");
				system("cp $taskDir/*.png $resultsDir/");
				
				$nameLink[1] = getDirOfRunName($runName)."/Results/".$name;
				$allResults[$i] = $name." ".$nameLink[1]."\n";
				#mark task as finished
			}
		}
		
		open(RESULTS, "> $dir/.results");
		print RESULTS @allResults;
		close(RESULTS);
		
		#check if all  tasks are marked as finished, if so, run postGlobal
		close(RESULTS_LOCK);
	}
	
	# in case error is in Superlink, and it requires a re-run.
	if ($flag eq "1") {									# rerun
		@project = split(/\./, $projName);
		$chrom = $project[2];
		$runName = $project[3];
		
		open(LOCK, ">".$lock);
		flock (LOCK, EX_LOCK);							# wait until lock is free (blocking)
		
		print LOCK "Locked by reportResults.\n";		# just to indicate locked
		
		#opendir(DIR, $newDir);
		#foreach $pedFile (readdir(DIR)) {
		#	if ($pedFile =~ /^(.*)\.ped$/) {
				open(LOG_FILE, ">>"."$config->{'FULL_DIR'}/Submissions/$runName/SLnotify.log");		# writing to logfile
				flock (LOG_FILE, EX_LOCK);															# wait until lock is free (blocking)
				print LOG_FILE "Error while running $chr on Superlink, sending job back to queue to re-run...\n";
				close(LOG_FILE);
				
				system("echo '$runName cluster.$chr' >> $config->{'QUEUE'}");				# put job back to job-queue
		#	}
		#}
		
		print LOCK "reportResults released lock.\n";		# just to indicate lock release
		close(LOCK);	
	}
	
	# in case there's an error with nothing to do about it.
	if ($flag eq "2"){							#report back error
		open(INF,"< $config->{'FULL_DIR'}/Submissions/$runName/submissionInformation");		# getting project's dir name
		@inf = <INF>;
		close(INF);
		$dir = chomp($inf[1]);
		
		open(LOG_LOCK, ">>"."$config->{'FULL_DIR'}/Submissions/$runName/SLnotify.log");		# writing to logfile
		flock (LOG_LOCK, EX_LOCK);															# wait until lock is free (blocking)
		if (!($msg)) {$msg = "Unknown";}
		print LOG_LOCK "Error while running $chr on Superlink: $msg\n";
		close(LOG_LOCK);
		
		#$link = "http://$config->{'WEB_PREFIX'}/var/tmp/$projName/formatted_output.html";	# $dir and $projName are defined in setParams - needa find a better way to get projName (time dependant)
		system("echo \"cluster.$chrom Error\" >> $config->{'FULL_DIR'}/$dir/.results");		# show result to user
	}
}

if ($mode eq "finish") {
    finishTask($runName, $tarName);	
	
	# killing sshd proccess to release link06 script   ( uses scp instead on link06 script!)
	#	system("kill -9 `ps aux |grep 'sshd: oren\@notty' |awk '{ print $2 }'`");       # another way instead of writing in and out from a file
	###########################
	
	exit 0;
}

exit 1;


sub reportTaskError( $ $ $ $ ) {
	my $runName = $_[0];
	my $chr = $_[1];
	my $parameter = $_[2];
	my $msg = $_[3];	
	if (!($chr) or !($parameter) or !($runName)) {die "missing chromosme or parameter.";}
	
	&updatePercents($runName, $chr, $parameter, "Error");
	
	my $errorFile = "$config->{'FULL_DIR'}/Submissions/$runName" . "/error";
	system ("touch $errorFile");
	system("echo \"error encountered on chromosome: ". $chr .", during: ". $parameter ."\" >> $errorFile");	
	if ($msg){
		$msg =~ s/~~/ /g;			# $message is sent with ~~ instead of spaces
		system("echo \"message for chromosome: ". $chr .", during: ". $parameter ." - ".$msg."\" >> $errorFile");
	}	
	
	my $dir = getDirOfRunName($runName);
	if (!(-e "$config->{'FULL_DIR'}/$dir/.logs")) {system("touch $config->{'FULL_DIR'}/$dir/.logs");}
	system("echo \"$msg\" >> $config->{'FULL_DIR'}/".$dir."/.".$chr."_".$parameter."_log.txt");
	
    #Omer 1/9/2011 - update experiments that were waiting for this experiment to finish
    my $experimentsWaiting = getWaitingExperiments($runName);    
    my @experimentsWaiting = split(",",$experimentsWaiting);
    my $expDir = "$config->{'FULL_DIR'}\/".getDirOfRunName($runName);    
    foreach $experiment (@experimentsWaiting) {
        my $newExperimentDir = $expDir."\/\.\.\/".$experiment;		
		my @stopFiles = <$newExperimentDir."/.stop*">;
        if (scalar(@stopFiles) > 0) {next;}  #Do not update stopped experiments
        
        open(PROCESS_ID_FILE, $newExperimentDir."\/\.processID.txt");        
        my @lines = <PROCESS_ID_FILE>;        
        close(PROCESS_ID_FILE);
        chomp($lines[0]);        
        my $newExperimentRunName = $lines[0];
		reportTaskError($newExperimentRunName, $chr, $parameter, $msg);
    }	
}



sub updateTask( $ $ $ $ $ ) {	
	my $runName = $_[0];
	my $chr = $_[1];
	my $parameter = $_[2];
	my $percent = $_[3];	
	my $logFile = $_[4];

	#Update the percents file of the run
	&updatePercents($runName, $chr, $parameter, $percent);
	
    #Omer 31/8/2011 - update experiments that were waiting for this experiment to finish
    my $experimentsWaiting = getWaitingExperiments($runName);    
    my @experimentsWaiting = split(",",$experimentsWaiting);
    my $expDir = "$config->{'FULL_DIR'}\/".getDirOfRunName($runName);    
    foreach $experiment (@experimentsWaiting) {
        my $newExperimentDir = $expDir."\/\.\.\/".$experiment;		
		my @stopFiles = <$newExperimentDir."/.stop*">;
        if (scalar(@stopFiles) > 0) {next;}  #Do not update stopped experiments
        
        open(PROCESS_ID_FILE, $newExperimentDir."\/\.processID.txt");        
        my @lines = <PROCESS_ID_FILE>;        
        close(PROCESS_ID_FILE);
        chomp($lines[0]);        
        my $newExperimentRunName = $lines[0];
		updateTask($newExperimentRunName, $chr, $parameter, $percent, $logFile);        
    }
	
	my $dir = &getDirOfRunName($runName);
	unless ($logFile and $chr and $parameter) {return;}	
	@logs = ();
	if (-e "$config->{'FULL_DIR'}/" . $dir . "/.logs"){
		open(LOGS, "< $config->{'FULL_DIR'}/" . $dir . "/.logs");
		@logs = <LOGS>;
		close(LOGS);
	}
	
	$log = "$config->{'FULL_DIR'}/Submissions/$runName/$logFile";
	unless (-e $log) {return;}	
	my $lineFound = 0;
	foreach $logLine (@logs){
		if ($logLine eq $chr." ".$parameter." ".".".$chr."_".$parameter."_log.txt"."\n"){
			$lineFound = 1;
			last;
		}
	}
	if (!($lineFound)){
		$logs[$#logs+1] = $chr." ".$parameter." ".".".$chr."_".$parameter."_log.txt"."\n";
		open(LOGS, "> $config->{'FULL_DIR'}/" . $dir . "/.logs");
		print LOGS @logs;
		close(LOGS);
	}
	system("unix2dos $log");
	copy($log, "$config->{'FULL_DIR'}/".$dir."/.".$chr."_".$parameter."_log.txt") or die "File cannot be copied.";
	system("rm -rf $config->{'FULL_DIR'}/Submissions/$runName/$logFile");	
	
}

sub extractFilesFromTar( $ $ $ $ $ ) {
	my $newDir = $_[0];
	my $tempDir = $_[1];
	my $runDir = $_[2];
	my $tarName = $_[3];
	my $runName = $_[4];

	system ("mkdir $newDir") unless(-e $newDir);
	system ("mkdir $tempDir") unless(-e $tempDir);	
	if (system("tar -C $tempDir -xzf $runDir\/$tarName") != 0) {
		my $errorFile = "$config->{'FULL_DIR'}/Submissions/$runName" . "/error";
		system("touch $errorFile");
		exit(1);
	}
	system("cp $tempDir\/\* $newDir");		# copy the incoming files to a local directory
}

sub wakeTask( $ $ ) {
    my $runName = $_[0];
    my $tarName = $_[1];	
		
	my $runDir = "$config->{'FULL_DIR'}/Submissions/$runName";	    
	my $newDir = $runDir . "/clusteredFiles";
	my $tempDir = $runDir . "/untarTemp_".$tarName;
	&extractFilesFromTar($newDir, $tempDir, $runDir, $tarName, $runName);
	
	#Wake up the experiment
	if (-e "$runDir\/sendToSL.flag") {
		opendir(DIR, $tempDir);					# pushing only the new incoming files!
		
		foreach $pedFile (readdir(DIR)) {
			if ($pedFile !~ /^(.*)\.ped$/) {next;}
			unless (-e $tempDir."/".$1.".map") {system("touch ".$newDir."/".$1.".map");}							
			if (-e $tempDir."/".$1.".dat") {
				$queue = getQueueForTask($runName);
				$script = getScriptForTask($runName);
				if ($script eq "submitTask.pl") {
					# dvir 2011/10/23
					system("export PERLLIB=$cgibinDir; perl $cgibinDir/enqueueTask.pl $queue Submissions/$runName perl $script -task $runName");
					#system("export PERLLIB=$cgibinDir; perl $cgibinDir/enqueueTask.pl $queue perl $script -task $runName");
				}
				else {
					# dvir 2011/10/23
					my $mail = &submissionConfig::getMailOfUserBySubmissionDir($runName);
					my $chromSubDirInitial = &submissionConfig::getChromSubDirInitial_AtSubmissionDir_BySubmissionDir($runName, $1, $mail);
					my $submitErrorDir = "Submissions/$runName/$chromSubDirInitial";
					system("export PERLLIB=$cgibinDir; perl $cgibinDir/enqueueTask.pl $queue $submitErrorDir perl $script $runName Submissions/$runName/clusteredFiles/$1");
					#system("export PERLLIB=$cgibinDir; perl $cgibinDir/enqueueTask.pl $queue perl $script $runName Submissions/$runName/clusteredFiles/$1");
				}
			}			
		}
	}
	
    ## cleaning the area after everything
	system("rm -rf $runDir\/$tarName");	
	system("rm -rf $tempDir");
}


sub finishTask( $ $ ) {
    my $runName = $_[0];
    my $tarName = $_[1];	
		
	my $runDir = "$config->{'FULL_DIR'}/Submissions/$runName";    	
	my $tempDir = $runDir . "/untarTemp_".$tarName;		
	my $newDir = $runDir . "/clusteredFiles";
	&extractFilesFromTar($newDir, $tempDir, $runDir, $tarName, $runName);
	
	if (-e "$runDir\/clustering.flag") {
		open(INF,"< $config->{'FULL_DIR'}/Submissions/$runName/submissionInformation");
		@lines = <INF>;
		close(INF);
		chomp($lines[1]);
		$userClusteredFilesDir = "$config->{'FULL_DIR'}/".$lines[1]."/clustered";
		
		system("cp -f $tempDir\/\* $userClusteredFilesDir");	# copy the clustered files to the user's clustered files directory
	}
	
	if (-e "$runDir\/cleaning.flag") {
		open(INF,"< $config->{'FULL_DIR'}/Submissions/$runName/submissionInformation");
		@lines = <INF>;
		close(INF);
		chomp($lines[1]);
		$userCleanFilesDir = "$config->{'FULL_DIR'}/".$lines[1]."/clean";
		
		system("cp $tempDir\/\* $userCleanFilesDir");		# copy the clean files to the user's clean files directory	
	}
    my %newRuns = ();
	
    #Omer 7/8/2011 - Run experiments that were waiting for this experiment to finish
	my $experimentsWaiting = getWaitingExperiments($runName);
	my @experimentsWaiting = split(",",$experimentsWaiting);
	my $expDir = "$config->{'FULL_DIR'}\/".getDirOfRunName($runName);
	foreach $experiment (@experimentsWaiting) {
		my $newExperimentDir = $expDir."\/\.\.\/".$experiment;
		my @stopFiles = <$newExperimentDir."/.stop*">;
		if (scalar(@stopFiles) > 0) {next;}  #Do not run stopped experiments
		
		open(PROCESS_ID_FILE, $newExperimentDir."\/\.processID.txt");        
		my @lines = <PROCESS_ID_FILE>;        
		close(PROCESS_ID_FILE);
		chomp($lines[0]);        
		my $newExperimentRunName = $lines[0];
		$newRuns{$newExperimentRunName} = 1;
		my $newExperimentRunDir = "$config->{'FULL_DIR'}/Submissions/$newExperimentRunName";
		system("cp $runDir\/$tarName $newExperimentRunDir\/$tarName");        
		&wakeTask($newExperimentRunName, $tarName);
	}


	#####
	# dvir 2011/12/05
	my $TASKS_WAITING_LIST = "TasksWaitingList";
	
	foreach my $newRun (keys %newRuns) {
		system("export PERLLIB=$cgibinDir; perl $cgibinDir/enqueueTask.pl $TASKS_WAITING_LIST None $newRun");
	}
	#####
	
		
    ## cleaning the area after everything
	system("rm -rf $runDir\/$tarName");	
	system("rm -rf $tempDir");    
}

sub getDirOfRunName( $ ){
	my $runName = $_[0];
	open(INF,"< $config->{'FULL_DIR'}/Submissions/$runName/submissionInformation");
	@lines = <INF>;
	close(INF);
	chomp($lines[1]);
	my $dir = $lines[1];
	return $dir;
}

# arg0 - task runName
# arg1 - file to update percents for
# arg2 - parameter (cleaning, clustering, analysis)
# arg3 - new percent
sub updatePercents( $ $ $ $ ){
	my $runName = $_[0];
	my $chr = $_[1];
	my $parameter = $_[2];
	my $percent = $_[3];
	
	#system("echo \"$runName, $chr, $parameter, $percent\" >> /tmp/log.log");
	open(INF,"< $config->{'FULL_DIR'}/Submissions/$runName/submissionInformation");
	@lines = <INF>;
	close(INF);
	chomp($lines[1]);
	$dir = $lines[1];
	if ($percent and $chr and $parameter){
		open(PROGRESS_LOCK, "> $config->{'FULL_DIR'}/" . $dir . "/.progressLock");
		flock (PROGRESS_LOCK, EX_LOCK);
		open(PROGRESS,"< $config->{'FULL_DIR'}/" . $dir . "/.progress");
		@percents = <PROGRESS>;
		close(PROGRESS);
		for $i (0..$#percents) {
			$per = $percents[$i];
			chomp($per);
			@per = split(/ /, $per);
			$percentsFor = $per[0];
			if ( ($chr eq $percentsFor) and ($per[1] eq $parameter) ){
				$per[2] = $percent;
				$percents[$i] = $per[0]." ".$per[1]." ".$per[2]."\n";		#updating the percentage of the right parameter for the given chromosome
				last;
			}
		}
		
		#updating .progress file
		open(PROGRESS, "> $config->{'FULL_DIR'}/" . $dir . "/.progress");
		print PROGRESS @percents;				# clean filehandle before!?
		close(PROGRESS);
		close(PROGRESS_LOCK);
	}
}


sub getWaitingExperiments( $ ){
	my $runName = $_[0];
	my $AnalysisType = "";
	
	open(INF,"$config->{'FULL_DIR'}/Submissions/$runName/submissionInformation");
	@inf = <INF>;
	close(INF);
	
	for $line (@inf) {
		chomp($line);
		
		@line = split(/[ \t]/, $line);
		if ($line[0] eq "ExperimentsWaiting"){
			return $line[1];
		}		
	}
    return "";
}

sub getQueueForTask( $ ) {
	my $runName = $_[0];
	my $AnalysisType = "";
	
	open(INF,"$config->{'FULL_DIR'}/Submissions/$runName/submissionInformation");
	@inf = <INF>;
	close(INF);
	
	for $line (@inf) {
		chomp($line);
		@line = split(/[ \t]/, $line);
		if ($line[0] eq "Analysis") {$AnalysisType = $line[1];}
	}
	
	if (($AnalysisType eq "TwoPoint") || ($AnalysisType eq "MultiPoint")) {return "FrontendJobsQ";}
	return "RemoteJobsQ";
}

sub getScriptForTask( $ ) {
	my $runName = $_[0];
	my $runDir = "$config->{'FULL_DIR'}/Submissions/$runName";
	
	if (-e "$runDir\/clustering.flag" or -e "$runDir\/cleaning.flag") {return "submitTask.pl";}
	return "submitAnalysis.pl"
}