#!/usr/bin/perl -w

use submissionConfig;
use Processing;
use SharedConsts;

# call to this script:
# perl submitTask.pl [-task <task ID>] [-mode <mode number>] 
# -dir is the projDir to arcive and send.
# -mode should be 0 or omitted if the command is called from apache. mode should be 1 if the command is called from any other user.

use FindBin ();
use lib "$FindBin::Bin";
use submissionConfig;
use Processing;
use CGI ':standard';

$config = new submissionConfig;

if ( $#ARGV == -1) {
	print "Script parameters error.";
	exit -1;
}
else {
	$mode = 0;			# mode is 0 if apache calls this script (not a must). use mode 1 if others with ~/.ssh folder call this script.  specify by -mode.
	
	for $i (0..$#ARGV){
		if ($ARGV[$i] eq "-mode"){
			$mode = $ARGV[$i+1];
		}
		
		if ($ARGV[$i] eq "-dir"){
			$projDir = $ARGV[$i+1];
		}
	}
}

chdir("$projDir");

my %variables = %{ &Processing::initVariablesFromPrePoint( $projDir ) };
$projName = $variables{ PROJ };

$analysis = $variables{ program };

$chromName = "chrom_all";
@chromNameData = split /chrom_/, $projName;
if (defined($chromNameData[1])) {
	$chromName = "chrom_".$chromNameData[1];
}

@path = split /\//, $projDir;

system("mv datafile.dat $chromName.dat");
system("mv pedfile.dat $chromName.ped");

$modefileData = `cat modefile.txt`;
$modefileData =~ s/datafile\.dat/$chromName.dat/g;
$modefileData =~ s/pedfile\.dat/$chromName.ped/g;
open MODEFILE, ">modefile.txt";
print MODEFILE "$modefileData";
close MODEFILE;

open DETAILS, ">details.txt";
print DETAILS "$chromName.dat\n";
print DETAILS "$chromName.ped";
close DETAILS;

open RESULT, ">results.html";
$begin = `cat $config->{'FULL_DIR'}\/cgi-bin\/Tmpl\/results.html.begin`;
$begin =~ s/PEDTOOL_PROJECT_NAME/$projName $analysis analysis/g;
print RESULT "$begin";
$now =`date`;
print RESULT "<font size=\"-2\">(Last update at $now)</font><br>";

if ($analysis =~ /HMM/) {
        # start. dvir 2011/08/03 , unused
		#$memReq = "$config->{'SUPERLINK_PARAMETER_HMM_M800'}";
        #$hmmTest = "$config->{'SUPERLINK_PARAMETER_HMM_TEST_ONLY'}";
        #$hmmRun = "$config->{'SUPERLINK_PARAMETER_HMM_RUN'}";
		#$hmmParams = "$config->{'SUPERLINK_PARAMETER_HMM_WINDOWED_PARAMS'}";
		# end. dvir 2011/08/03 


        #system("$config->{'SUPERLINK_EXEC_LOCAL'} $chromName.dat $chromName.ped $hmmRun $memReq $hmmTest $hmmParams start= end= size= ");
	#$ret = $? >> 8;
	#if ($ret == $config->{'SUPERLINK_RETURN_FAILURE'}) {
	#	print RESULT "<br>Task failed.<br>Job too heavy.</br>Your data is not compatible with HMM analysis requirments. The MultiPoint analyses on it will be run without using HMM.";	
	#	close RESULT;
	#	`touch TASK_LOG.txt`;
	#	exit(0);
	#}
}

print RESULT "<br>Pending execution.";
close RESULT;

system("mv $workDir\/results.html.tmp $workDir\/results.html");

#system("tar -z -h -c -f  Files.tar.gz *");
open LIST, ">tarList.txt";
print LIST "$chromName.dat\n";
print LIST "$chromName.ped\n";
print LIST "modefile.txt\n";
print LIST "mapfile.dat";
if (-e ".pedigree_translate_1.txt") {
	print LIST "\n.pedigree_translate_1.txt";
}
if (-e $SharedConsts::MORGAN_MORE_PARAMS_FILENAME) {
	print LIST "\n$SharedConsts::MORGAN_MORE_PARAMS_FILENAME";
}
close LIST;

system("tar -C $projDir -T tarList.txt -z -h -c -f  Files.tar.gz");
system("tar -C $projDir -z -h -c -f  Submission.tar.gz details.txt Files.tar.gz");

if ($mode == 1){
	$sshCmd = "$config->{'SSHCMD'}";
}
else{
	$sshCmd = "$config->{'SSHCMD_NOT_APACHE'}";
}
$ret = system("cat $projDir/Submission.tar.gz | $sshCmd $config->{'REMOTE_USER'}" . "@" . "$config->{'GW'} $config->{'REMOTE_SUBMIT_SCRIPT'} $path[$#path] "); #>> $config->{'ERROR_LOG'}");

$ret = $? >> 8;
if($ret != 0) {
	exit $ret;
}

exit(0);

	
