package submissionConfig;

use WebServerEnvironment;

sub new ( $ ); 
sub Log( $ $ $ );
sub Error( $ $ $ ); 
sub Warn( $ $ $ ); 
sub dieMail( $ $ );
sub new ( $ ) {
	my ($className) = @_;
	my ($self) = {};

	bless($self,$className);
		
	
	$self->{'WEB_FOLDER_NAME'} = $WebServerEnvironment::SRC_DIR;			# release folder: web.    		development folder: webDevelopment
	$self->{'REMOTE_FOLDER_NAME'} = $WebServerEnvironment::BACKEND_SRC_DIR;			# release folder: release.    	development folder: development
	
	$self->{'THIS_USER'} = "oren";
	$self->{'FULL_DIR'} = "/var/www/html/oren/$self->{'WEB_FOLDER_NAME'}";
	$self->{'SL_JOBS_DIR'} = "/var/www/html/oren/$self->{'WEB_FOLDER_NAME'}/var/tmp/";
	$self->{'REMOTE_USER'} = "superlinksnp";
	$self->{'GW'} = "cbl-link01.cs.technion.ac.il";
	$self->{'REMOTE_SUBMIT_SCRIPT'} ="/scratch/superlinksnp/$self->{'REMOTE_FOLDER_NAME'}/perlbin/AcceptSubmission.pl";
	$self->{'SSH_APACHE_DIR'} = "$self->{'FULL_DIR'}/cgi-bin/ssh";
	$self->{'SSH_DIR'} = "~/.ssh";
	$self->{'SSH_OPTIONS'} = "-o IdentityFile=$self->{'SSH_APACHE_DIR'}/apache_id_dsa -o UserKnownHostsFile=$self->{'SSH_DIR'}/known_hosts -o CheckHostIP=no -o ConnectTimeout=60 -o StrictHostKeyChecking=no";
	$self->{'SSH_NOT_APACHE_OPTIONS'} = "-o IdentityFile=$self->{'SSH_DIR'}/id_dsa -o UserKnownHostsFile=$self->{'SSH_DIR'}/known_hosts -o CheckHostIP=no -o ConnectTimeout=60 -o StrictHostKeyChecking=no";
	$self->{'SSHCMD'} = "ssh $self->{'SSH_OPTIONS'} -vvv ";
	$self->{'SSHCMD_NOT_APACHE'} = "ssh $self->{'SSH_NOT_APACHE_OPTIONS'} -vvv ";
	$self->{'SCPCMD'} = "scp $self->{'SSH_OPTIONS'} -v ";
	$self->{'GLOBAL_LOG'} = "$self->{'FULL_DIR'}/Submissions/submissions.log";
	$self->{'ERROR_LOG'} = "$self->{'FULL_DIR'}/log/submissions.log";
	$self->{'WEB_PREFIX'} = "cbl-hap.cs.technion.ac.il/oren/$self->{'WEB_FOLDER_NAME'}";
	$self->{'SMTP_SERVER'} = "localhost";
	$self->{'HTML_ROOT'} = "cbl-hap.cs.technion.ac.il/oren/$self->{'WEB_FOLDER_NAME'}";
	$self->{'PORTAL_EMAIL'} ='Superlink-online <superlink-online@cs.technion.ac.il>';
	$self->{'QUEUE_LOCK'} ="$self->{'FULL_DIR'}/Submissions/QueueHandlerLock";
	$self->{'QUEUE'} ="$self->{'FULL_DIR'}/Submissions/JobQ";
	$self->{'QUEUE_DIR'} ="$self->{'FULL_DIR'}/Submissions";
	$self->{'TASK_FINISH_FLAG'} = "TASK_LOG.txt";
	$self->{'MAX_LODSCORE_FILE'} = "max_lod.txt";
	$self->{'SUPERLINK_EXEC_LOCAL'} ="$self->{'FULL_DIR'}/prog/SuperLink.linux";
	$self->{'SUPERLINK_PARAMETER_HMM_RUN'} ="-gh";
	$self->{'SUPERLINK_PARAMETER_HMM_M800'} ="-m800";
	$self->{'SUPERLINK_PARAMETER_HMM_TEST_ONLY'} ="-exit";
	$self->{'SUPERLINK_RETURN_SUCCESS'} ="0";
	$self->{'SUPERLINK_RETURN_FAILURE'} ="3";
	$self->{'TIME_TO_ARCHIVE'} = 172800; #48 hours
	$self->{'TIME_TO_FREE_LOCK'} = 1800; #30 minutes
	
	return $self;
}

sub Log( $ $ $ ) {
	my $taskId = $_[0];
	my $msg = $_[1];
	my $logFile = $_[2];
	system("echo \"LOG: `date` TASKID=$taskId $msg \" >> $logFile");
}

sub Error( $ $ $ ) {
	my $taskId = $_[0];
	my $msg = $_[1];
	my $logFile = $_[2];
	system("echo \"ERROR: `date` TASKID=$taskId $msg\" >> $logFile");
}

sub Warn( $ $ $ ) {
	my $taskId = $_[0];
	my $msg = $_[1];
	my $logFile = $_[2];	
	system ("echo \"WARNING: `date` TASKID=$taskId $msg\" >> $logFile");
}

sub dieMail( $ $ ){
	my $runName = $_[0];
	my $msg = $_[1];
	my $mailSender = "$self->{'FULL_DIR'}/Submissions/$runName" . "/mail_sender.pl";
        system ("echo \"Failure The system experiences internal failure. The error is reported to the administrator. Please try again later.\" | $mailSender 1"); 
        system ("echo \"Failure: Bug found in submission: $runName.\" | ./admin_mail_sender.pl");
        die 1;
}

# Dvir 2011/08
our $SUBMISSION_INFORMATION_FILENAME = 'submissionInformation';

# Dvir 2011/10/23
sub getMailOfUserBySubmissionDir($) {
	my $submissionDir = $_[0]; # for example : 5v1k7pmb3w
	my $config2 = submissionConfig->new();
	
	open(INF,"$config2->{'FULL_DIR'}/Submissions/$submissionDir/submissionInformation");
	$mail = <INF>;
	close INF;
	chomp ($mail);
	return $mail;
}

# Dvir 2011/10/23
sub getChromSubDirInitial_AtSubmissionDir_BySubmissionDir($ $ $) {
	my $submissionDir = $_[0]; # for example : 5v1k7pmb3w
	my $chromName = $_[1];
	my $userMail = $_[2];
		
	my @mailList = split(/[@]/,$userMail);
	return  $mailList[0] . '.' . $chromName . '.' . $submissionDir . '.';
}

1;

