#!/usr/bin/perl -w

# call to this script:
# perl submitTask.pl [-task <task ID>] [-mode <mode number>] 
# -task is the task id to submit for cleaning / clustering.
# -mode should be 0 or omitted if the command is called from apache. mode should be 1 if the command is called from any other user.

use FindBin ();
use lib "$FindBin::Bin";
use submissionConfig;
use CGI ':standard';

$config = new submissionConfig;

if ( $#ARGV == -1) {
	print "Script parameters error.";
	exit -1;
}
else {
	$mode = 0;			# use mode 1 if apache calls this script (not a must). use mode 0 (or omit) if others with ~/.ssh folder call this script.  specify by -mode.
	
	for $i (0..$#ARGV) {
		if ($ARGV[$i] eq "-mode") {$mode = $ARGV[$i+1];}
		if ($ARGV[$i] eq "-task") {$runName = $ARGV[$i+1];}
	}
}

$dir = &getDirByTask($runName);

system("tar -C $config->{'FULL_DIR'}/$dir -T $config->{'FULL_DIR'}/Submissions/$runName/tarList.txt -z -h -c -f  $config->{'FULL_DIR'}/Submissions/$runName/Files.tar.gz");
system("tar -C $config->{'FULL_DIR'}/Submissions/$runName -z -h -c -f  $config->{'FULL_DIR'}/Submissions/$runName/Submission.tar.gz details.txt Files.tar.gz");

if ($mode == 1) {$sshCmd = "$config->{'SSHCMD'}";}
else {$sshCmd = "$config->{'SSHCMD_NOT_APACHE'}";}

$ret = system("cat $config->{'FULL_DIR'}/Submissions/$runName/Submission.tar.gz | $sshCmd $config->{'REMOTE_USER'}" . "@" . "$config->{'GW'} $config->{'REMOTE_SUBMIT_SCRIPT'} $runName >> $config->{'ERROR_LOG'}");
print "Before: ".$ret." ";
$ret = $? >> 8;
print "After: ".$ret."/n";
if($ret != 0) {
	submissionConfig::Log($runName, "Submission failed. error code: $ret", $config->{'GLOBAL_LOG'});
	exit $ret;
}

#### DEBUG - if needed logging of the send command ###
#open(LOG,">$config->{'FULL_DIR'}/Submissions/$runName/logSubmit");
#print LOG "cat $config->{'FULL_DIR'}/Submissions/$runName/Submission.tar.gz | $config->{'SSHCMD'} $config->{'REMOTE_USER'}" . "@" . "$config->{'GW'} $config->{'REMOTE_SUBMIT_SCRIPT'} $runName";
#close(LOG);
###################################

submissionConfig::Log($runName, "Submission was submitted successfully.", $config->{'GLOBAL_LOG'});

print $runName."\n";

sub getDirByTask( $ ){
	$taskID = $_[0];
	open(INF,"$config->{'FULL_DIR'}/Submissions/$taskID/submissionInformation");
	@inf = <INF>;
	close(INF);
	
	$dir = $inf[1];
	chomp($dir);
	return $dir;
}