<?php
	require("log.php");
	include("fileHandleFunctions.php");
	include_once("snpManipulation.php");
	include("layout.php");
	include("helpSystem.php");

	if (isset($_POST['mapping'])){
		$username = $_SESSION['name'];
		$params['oldProjName'] = $_POST['oldProjName'];
		$params['newProjName'] = $_POST['newProjName'];
		if (isset($_POST['ReSampling'])){
			$params['ReSampling'] = "true";
		}
		
		$params['frequency'] = preg_match("/^[ \t\n]*$/",$_POST['frequency']) ?  "0.01" : $_POST['frequency'];
		$params['penetrance'] = "Recessive";
		$params['penetranceChoice'] = "penetranceChoiceRec";
		if (isset($_POST['penetrance']) && ($_POST['penetrance'] == "Dominant")){
			$params['penetranceChoice'] = "penetranceChoiceDom";
		}
		$params[$params['penetranceChoice']] = isset($_POST[$params['penetranceChoice']]) ? $_POST[$params['penetranceChoice']] : "0 0 0.99";
		
		if (isset($_SESSION['copyProjectParameters'])) { unset($_SESSION['copyProjectParameters']); }
		$_SESSION['copyProjectParameters'] = $params;
		
		if (!preg_match("/^[ \t\n\s\r]*$/", $params['newProjName'])){
			if (is_dir(USER_PROJECTS_DIR."/".$params['newProjName'])){
				//$_SESSION['copyProjectParameters']['exists'] = true;
				rmdir_r(USER_PROJECTS_DIR."/".$params['newProjName']);
			}
		//}
		//else{
			createProjectFolder(USER_PROJECTS_DIR, $params['newProjName']);
			$infoTable = array();
			$map = "";
			if ($_POST['pedigreeInputType'] == "simplifiedFormat"){
				convertSimplifiedToPed($params['newProjName'], $_POST['pedigreeInput']);
				$map = getSimplifiedMappingFromExistingMapping(	USER_PROJECTS_DIR."/".$params['newProjName']."/raw/".SIMPLIFIED_PED_MAP_FILE,
																USER_PROJECTS_DIR."/".$params['oldProjName']."/raw/".SIMPLIFIED_PED_MAP_FILE,
																USER_PROJECTS_DIR."/".$params['oldProjName']."/raw/".MAP_FILE_NAME);
				$infoTable['snp'][KEY_SNP_PEDFILE] = "sl_input.ped";
			}
			else{
				exec("echo \"".$_POST['pedigreeInput']."\" > ".USER_PROJECTS_DIR."/".$params['newProjName']."/raw/pedfile.ped");
				$map = getPedigreeMappingFromExistingMapping(USER_PROJECTS_DIR."/".$params['newProjName']."/raw/pedfile.ped", USER_PROJECTS_DIR."/".$params['oldProjName']."/raw/".MAP_FILE_NAME);
				$infoTable['snp'][KEY_SNP_PEDFILE] = "pedfile.ped";
			}
			exec("echo \"".implode("\n", $map)."\" > ".USER_PROJECTS_DIR."/".$params['newProjName']."/raw/".MAP_FILE_NAME);
			
			$oldProjRawDir = USER_PROJECTS_DIR."/".$params['oldProjName']."/raw";
			$newProjRawDir = USER_PROJECTS_DIR."/".$params['newProjName']."/raw";
			$oldIni = false;
			if (is_file($oldProjRawDir."/".UPLOADED_DATA_INFO)){
				$oldIni = parse_ini_file($oldProjRawDir."/".UPLOADED_DATA_INFO, true);
				if (isset($oldIni['snp'][KEY_SNP_FILE_LIST])){
					foreach ($oldIni['snp'][KEY_SNP_FILE_LIST] as $snpFile){
						link($oldProjRawDir."/".$snpFile, $newProjRawDir."/".$snpFile);
						link($oldProjRawDir."/".SELECTION_FILE_INITIAL.$snpFile, $newProjRawDir."/".SELECTION_FILE_INITIAL.$snpFile);
					}
					$infoTable['snp'][KEY_SNP_FILE_LIST] = $oldIni['snp'][KEY_SNP_FILE_LIST];
				}
			}
			
			$infoTable['general'][KEY_INPUT_TYPE] = 'snp';
			AppendIniWithTable($newProjRawDir, UPLOADED_DATA_INFO, $infoTable);
		}
		header("Location: copyProject.php?step=mapping"); // send back
	}
	
	// if page sent as POST, need to process
	if (isset($_POST['copy'])){
		$username = $_SESSION['name'];
		$oldProject = $_POST['oldProjName'];
		$newProject = $_POST['newProjName'];
		$reSampling = isset($_POST['ReSampling']) ? "-ReSampling" : "";
		
		$frequency = preg_match("/^[ \t\n]*$/",$_POST['frequency']) ?  "0.01" : $_POST['frequency'];
		$penetrance = "0 0 0.99";
		$penetranceChoice = "penetranceChoiceRec";
		if (isset($_POST['penetrance']) && ($_POST['penetrance'] == "Dominant")){
			$penetranceChoice = "penetranceChoiceDom";
		}
		if (isset($_POST[$penetranceChoice])){
			$penetrance = $_POST[$penetranceChoice];
		}
		
		exec("/usr/bin/php ./copyProjectOp.php $oldProject $newProject $reSampling -frequency $frequency -penetrance $penetrance -name $username > /dev/null 2>&1 &");
		header("Location: copyProject.php?done=true&oldProj=$oldProject&newProj=$newProject"); // send back
		
		//echo "/usr/bin/php ./copyProjectOp.php $oldProject $newProject $reSampling -frequency $frequency -penetrance $penetrance -name $username > /dev/null 2>&1 &";
		//exit(0);
	}
	
	function getNamesOfProject($project){
		$dir = USER_PROJECTS_DIR."/".$project."/raw";
		if (!is_file($dir."/".UPLOADED_DATA_INFO)){ return false; }
		$ini = parse_ini_file($dir."/".UPLOADED_DATA_INFO, true);
		if (!isset($ini['snp']) || !isset($ini['snp'][KEY_SNP_FILE_LIST])) { return false; }
		$fileList = $ini['snp'][KEY_SNP_FILE_LIST];
		$names = array();
		foreach ($fileList as $snpFile){
			$names[$snpFile] = getNamesFromSnp($dir, $snpFile);
		}
		
		return $names;
	}
	
	function getSimplifiedToSnpNamesMapping($simplifiedMappingFile, $pedigreeSnpMappingFile){
		$simplifiedMap = file($simplifiedMappingFile, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
		$pedigreeMap = file($pedigreeSnpMappingFile,  FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
		$SfToSnpMapping = array();
		
		foreach ($pedigreeMap as $line){
			$line = preg_split("/[ \t]/", $line);
			$person = $line[0];
			$snpName = $line[1]."\t".$line[2];
			foreach ($simplifiedMap as $mapLine){
				$mapLineArr = preg_split("/[ \t]/", $mapLine);
				$simplifiedNumber = $mapLineArr[0].".".$mapLineArr[1];
				$simplifiedName = $mapLineArr[2];
				if ($simplifiedNumber === $person){
					$finalMapping[$simplifiedName] = $snpName;
				}
			}
		}
		
		return $finalMapping;
	}
	
	function getSimplifiedMappingFromExistingMapping($simplifiedToPedigreeMapFile, $oldSimplifiedMappingFile, $oldPedigreeSnpMappingFile){
		$simplifiedMap = file($simplifiedToPedigreeMapFile, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
		$map = getSimplifiedToSnpNamesMapping($oldSimplifiedMappingFile, $oldPedigreeSnpMappingFile);
		$finalMapping = array();
		
		foreach ($simplifiedMap as $mapLine){
			$mapLine = preg_split("/[ \t]/", $mapLine);
			$simplifiedNumber = $mapLine[0].".".$mapLine[1];
			$simplifiedName = $mapLine[2];
			if (isset($map[$simplifiedName])){
				$finalMapping[] = $simplifiedNumber."\t".$map[$simplifiedName];
			}
		}
		
		return $finalMapping;
	}	
	
	function getPedigreeMappingFromExistingMapping($pedfile, $existingMappingFile){
		$ped = file($pedfile, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
		$map = file($existingMappingFile, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
		$finalMapping = array();
		
		foreach ($ped as $line){
			$line = preg_split("/[ \t]/", $line);
			$person = $line[0].".".$line[1];
			foreach ($map as $mapLine){
				$mapLineArr = preg_split("/[ \t]/", $mapLine);
				$mapPerson = $mapLineArr[0];
				if ($mapPerson === $person){
					$finalMapping[] = $mapLine;
				}
			}
		}
		
		return $finalMapping;
	}
	
	function tagString($str){
		return "'".$str."'";
	}
	
	$allProjects = getUserProjects();
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
            "http://www.w3.org/TR/html4/loose.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<script type="text/javascript">
	var simplifiedInputText = '';
	var pedfileInputText = '';
	
	function changeBGColor(objectID, newColor){
		document.getElementById(objectID).style.backgroundColor = newColor;
	}
	
	function changeText(textAreaId, text){
		//alert(text);
		document.getElementById(textAreaId).value = '';
		document.getElementById(textAreaId).value = text;
	}
	
	function createTableRowElement(collsObjectsArray){
		newrow = document.createElement("tr");
		var i;
		
		for (i = 0 ; i < collsObjectsArray.length ; i++){
			newcol = document.createElement("td");
			newcol.style.paddingRight = "10px";
			newcol.appendChild(collsObjectsArray[i]);
			newrow.appendChild(newcol);			
		}
		
		return newrow;
	}
	
	function updateSimplifiedMapping(simplifiedText, namesArray, targetDiv){
		var lines = simplifiedText.split('\n');
		var line;
		var family = 0;
		var newFamily = true;
			
		var table = document.createElement( 'table' );
		var tableBody = document.createElement('tbody');
		var selectElement;
		var newOption;
		
		var objectsArr;
		
		for (i = 0 ; i < lines.length ; i++){
			if (lines[i].match(/^( |\t|\n|\r|\s)*$/)){
				//newFamily = true;
				continue;
			}
			/*else{
				if (newFamily){
					family++;
					newFamily = false;
				}
			}*/
			
			if ( (lines[i].indexOf("pedigree:") != -1) || (lines[i].indexOf("pedigree :") != -1) ){
				family++;
				continue;
			}
			if (family == 0){ family = 1; }

			line = (lines[i]).split('\t');
					
			selectElement = document.createElement("select");
			selectElement.name = "mapSelections[]";
			for (j = 0 ; j < namesArray.length ; j++){
				name = namesArray[j];
				newOption = document.createElement('option');
				newOption.text = name;
				newOption.value = family+"."+line[0]+"\t"+name+"\tfinalDB";
				selectElement.add(newOption);		// IE only
			}
			objectsArr = new Array(document.createTextNode(family), document.createTextNode(line[0]), selectElement);

			tableBody.appendChild(createTableRowElement(objectsArr));
			table.appendChild(tableBody);
		}
		
		document.getElementById(targetDiv).innerHTML = '';
		document.getElementById(targetDiv).appendChild( table );

	}
	
	function updatePedfileMapping(pedfileText, namesArray, targetDiv){
		var lines = pedfileText.split('\n');
		var line;
		var family = 0;
		
		var table = document.createElement( 'table' );
		var tableBody = document.createElement('tbody');
		var selectElement;
		var newOption;
		
		var objectsArr;
		
		for (i = 0 ; i < lines.length ; i++){
			if (lines[i].match(/^( |\t|\n|\r|\s)*$/)){
				continue;
			}
			
			line = (lines[i]).split(' ');
			if (line.length < 2){
				line = (lines[i]).split('\t');
			}
			family = line[0];
			person = line[1];
					
			selectElement = document.createElement("select");
			selectElement.name = "mapSelections[]";
			for (j = 0 ; j < namesArray.length ; j++){
				name = namesArray[j];
				newOption = document.createElement('option');
				newOption.text = name;
				newOption.value = family+"."+person+"\t"+name+"\tfinalDB";
				selectElement.add(newOption);		// IE only
			}
			
			objectsArr = new Array(document.createTextNode(family), document.createTextNode(person), selectElement);
			
			tableBody.appendChild(createTableRowElement(objectsArr));
			table.appendChild(tableBody);
		}
		
		document.getElementById(targetDiv).innerHTML = '';
		document.getElementById(targetDiv).appendChild( table );

	}
</script>
<script type="text/javascript" src="jsFunctions.js">
</script>
<head>
<title>Superlink Online</title>
<meta http-equiv="Content-Type" content="text/html; charset=windows-1255" />
<link href="style.css" rel="stylesheet" type="text/css" />
</head>
<body onload="
			projects = new Array(<?php	foreach($allProjects as $project){
											echo "'$project',";
										}
										echo "' '";
								?> );
">
<div id="site_layout">
	<div class="site_header">
		<div id="logoImg">
			<a href="main.php"><img src="images/index_01.gif"	height="136" alt="" border="0"/ ></a>
		</div>
		<div id="dnaPic">
			<img src="images/index_02.gif" alt="" border="0" height="136" width="560" />
		</div>
	</div>

	<div id="userBar">
		<table width="100%" style="text-indent: 10px;">
			<tr>
				<td width="75%">
					<?php
						print "Welcome, " . $_SESSION["name"];
					?>
				</td>
				<td width="25%" style="text-align: right; padding-right: 10px">
					<?php print date("F j, Y"); ?>
				</td>
			</tr>
		</table>
	</div>

	<table>
		<tr>
		<td width="130" style="vertical-align: top;">
			<div id="Menu">
				<?php showMainMenu(); ?>
			</div>
		</td>
		<td width="100%" height="550" style="vertical-align: top;">
			<div id="Center">
				<h2>Copy project</h2>
				<br/>
				<?php 
					if (isset($_GET['error'])){
						echo "Failed to copy project, an error has occured";
					}
					elseif (isset($_GET['done']) && ($_GET['done'] == "true") && isset($_GET['oldProj']) && isset($_GET['newProj'])){ ?>
						Project <b><?php echo $_GET['oldProj']; ?></b> is being copied to project <b><?php echo $_GET['newProj']; ?></b>.<br/>
						Click <a href="projects.php?proj=<?php echo $_GET['newProj']; ?>">here</a> to go to project <b><?php echo $_GET['newProj']; ?></b>'s page.
						<br/><br/>
						<div id="copyProgressBar">
							<!--<div class="progressBar">
								<span class="progressBar" style="width:0%;"></span>
							</div>
							<img src="images/waitspinner.gif"/> 0%-->
						</div>
						<script language="JavaScript">
							var parameters = new Array();
							parameters['name'] = '<?php echo $_SESSION['name']; ?>';
							parameters['project'] = '<?php echo $_GET['newProj']; ?>';
							parameters['source'] = '<?php echo $_GET['oldProj']; ?>';
							setTimeout( "PerformAjaxReuqestGeneral('copyProjectProgress.php', parameters, 'copyProgressBar');", 1 );		// one time instant call, just to show the status immediately
							setInterval( "PerformAjaxReuqestGeneral('copyProjectProgress.php', parameters, 'copyProgressBar');", 5000 );  	///////// 5 seconds
						</script>
					<?php }
					elseif (isset($_GET['step']) && ($_GET['step'] = "mapping")){
						$disabled = "";
						$dir = USER_PROJECTS_DIR."/".$_SESSION['copyProjectParameters']['newProjName'];		// get names from the old project's snp files
						/*if (isset($_SESSION['copyProjectParameters']['exists']) && $_SESSION['copyProjectParameters']['exists']){
							$disabled = "disabled";
							echo "<p style=\"color: red;\">A project with the selected name already exists, copying into an existing project is impossible.</p>";
						}*/
						
						// check for errors of simplified format pedigree
						$errors = false;
						if (is_file($dir."/raw/".SIMPLIFIED_CONVERT_ERROR) && (!preg_match("/^[ \t\s\r\n]*$/", file_get_contents($dir."/raw/".SIMPLIFIED_CONVERT_ERROR)))){
							$disabled = "disabled";
							$errors = file($dir."/raw/".SIMPLIFIED_CONVERT_ERROR, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
							echo "<p style=\"color: red;\"><b><u>Errors</u></b>:<br/>".implode("<br/>", $errors)."<br/><br/>Go back to fix the pedigree and retry.</p>";
						}
						?><form name="copyProject" method="POST" action="copyProject.php"><?php
						if (!is_dir($dir)){
							$disabled = "disabled";
							echo "<p style=\"color: red;\">A problem has occurred, selected project cannot be copied.</p>";
						}
						if (is_file($dir."/raw/".UPLOADED_DATA_INFO) && (!$errors)){
							$ini = parse_ini_file($dir."/raw/".UPLOADED_DATA_INFO, true);
							choose_mapping($dir."/raw", $ini['snp']['pedfile'], $ini['snp'][KEY_SNP_FILE_LIST], "one");
						}
						$params = $_SESSION['copyProjectParameters'];
						
						foreach ($params as $key => $val){?>
							<input type="hidden" name="<?php echo $key;?>" value="<?php echo $val;?>"/>
						<?php }	?>
						
						<input <?php echo $disabled;?> type="submit" name="copy" value="Make Copy"/>
						</form>
						<?php
						//unset($_SESSION['copyProjectParameters']);
						/* KILL SESSION AND TELL THE USER THAT THE SESSION EXPIRED */
					}
					elseif (isset($_GET['project'])) {
						$help = new Help();
						$project = $_GET['project'];
						$dir = USER_PROJECTS_DIR."/".$project;
						$projectExists = false;
						
						$data = is_file($dir."/raw/".UPLOADED_DATA_INFO) ? parse_ini_file($dir."/raw/".UPLOADED_DATA_INFO, true) : false;
						
						if (!$data || ($data['general'][KEY_INPUT_TYPE] != "snp")) {
							echo "<p style=\"color: red;\">This project data was not uploaded in SNP format.<br/>
														Unfortunately those type of projects cannot be copied.</p>";
						}
						else {
							$copyBaseName = $project."_Copy";
							$copyName = $copyBaseName;
							$i = 1;
							while (is_dir(USER_PROJECTS_DIR."/".$copyName)) {								
								$copyName = $copyBaseName.$i;
								$i++;
							}
						
							$names = getNamesOfProject($project);
							$allNames = array();
							if ($names){
								foreach ($names as $snp => $namesArray){
									$allNames = array_merge($allNames, $namesArray);
								}
							}
							$namesString = "'none',".implode(",", array_map("tagString", $allNames));
							
							?>	
							
							<!--<form name="copyProject" method="POST" action="copyProjectOp.php">-->
							<form name="copyProject" method="POST" action="copyProject.php">
								<?php
									if (isset($_GET['pe']) && ($_GET['pe'] == "true")){
										$projectExists = true;
										?><input type="hidden" name="pe"/><?php
									}
								?>
								<p>
								You chose to copy project <b><?php echo $project; ?></b>.<br/>
								Your uploaded data will be copied, you may choose to edit the rest of the information.<br/><br/>
								
								Define the following properties:<br/>
								</p>
								
								<p>
								<input type="hidden" name="oldProjName" value="<?php echo $project;?>" />
								New project's name: <input type="text" id="newProjName" name="newProjName" value="<?php echo $copyName;?>" />
								</p>
								
								<p>
								<input type="checkbox" name="ReSampling" /> Resample from the project data
								</p>
								
								<p>
								<a style="text-decoration: none;" href="#" onclick="if (this.innerHTML == '[-]'){
														this.innerHTML = '[+]';
													}
													else{
														this.innerHTML = '[-]';
													}
													switchElement('pedigree'); return false;">[+]</a> Show and edit Pedigree<br/>
								<!-- if there's a simplified format pedigree, show it, otherwise show the pedfile -->
								<?php
									$simplifiedData = "";
									$simplifiedDataJS = "";
									$pedfileData = "";
									$simplified = true;
									if (is_file($dir."/raw/".SIMPLIFIED_DATA_FILE)){
										$simplifiedData = file_get_contents($dir."/raw/".SIMPLIFIED_DATA_FILE);
										$simplifiedDataJS = str_replace("\t", '\t', $simplifiedData);
										$simplifiedDataJS = str_replace("\n", '\n', $simplifiedDataJS);
										$simplifiedDataJS = str_replace("\r", '', $simplifiedDataJS);
									}
									else{
										$simplified = false;
									}
									$pedfileName = $data['snp'][KEY_SNP_PEDFILE];
									$pedfileData = file_get_contents($dir."/raw/".$pedfileName);
									$pedfileDataJS = str_replace("\n", '\n', $pedfileData);
									$pedfileDataJS = str_replace("\t", ' ', $pedfileDataJS);
									$pedfileDataJS = str_replace("\r", '', $pedfileDataJS);
									
									$SLchecked = "checked";
									$pedTextChecked = "";
									$SLbg = "background-color: #00CCFF;";
									$pedbg = "";
									if (!$simplified){
										$SLchecked = "";
										$pedTextChecked = "checked";
										$SLbg = "";
										$pedbg = "background-color: #00CCFF;";
									}
								?>
								<script type="text/javascript">
										pedfileInputText = '<?php echo $pedfileDataJS;?>';
										simplifiedInputText = '<?php echo $simplifiedDataJS;?>';
								</script>
								
								<div id="pedigree" style="display: none;">
									
									<div style="float:left;">
										<div name="simplifiedFormatText" id="simplifiedFormatText" 
											 style="margin-left: 10px; padding-right: 20px; <?php echo $SLbg; ?>">
											<input <?php echo $SLchecked; ?> type="radio" name="pedigreeInputType" value="simplifiedFormat" 
													onclick="changeBGColor('pedfileText', '#f0ffff'); changeBGColor('simplifiedFormatText', '#00CCFF');
															changeText('pedigreeInput', simplifiedInputText);"/> Simplified format</br>
										</div>
										<div name="pedfileText" id="pedfileText" style="margin-left: 10px; padding-right: 20px; <?php echo $pedbg; ?>">
											<input <?php echo $pedTextChecked; ?> type="radio" name="pedigreeInputType" value="pedigree" 
													onclick="changeBGColor('simplifiedFormatText', '#f0ffff'); changeBGColor('pedfileText', '#00CCFF');
															changeText('pedigreeInput', pedfileInputText);"/> Pedfile format</br>
										</div>
										<br/>
										<!--
										&nbsp;&nbsp;<input type="submit" name="updatePedigree" value="Update Pedigree" 
															onclick="if ( (pedigreeInputType[0].value == 'simplifiedFormat') && (pedigreeInputType[0].checked) ){
																		simplifiedInputText = document.getElementById('pedigreeInput').value;
																		updateSimplifiedMapping(simplifiedInputText, new Array('none', 'name1', 'name2'), 'mapping');
																	 }
																	 else{
																		pedfileInputText = document.getElementById('pedigreeInput').value;
																		updatePedfileMapping(pedfileInputText, new Array('none', 'name1', 'name2'), 'mapping');
																	 }
																	 return false;"/>-->
									</div>
									
									<div style="float:left; padding: 10px; background-color: #00CCFF;">
										<textarea name="pedigreeInput" id="pedigreeInput" rows="18" cols="70"><?php echo ($simplified ? $simplifiedData : $pedfileData); ?></textarea>
									</div>
								</div>
								<div style="clear: both;"></div>
								</p>
								
								<!--<p>
								<a style="text-decoration: none;" href="#" onclick="if (this.innerHTML == '[-]'){
														this.innerHTML = '[+]';
													}
													else{
														this.innerHTML = '[-]';
													}
													switchElement('mapping'); return false;">[+]</a> Show and edit Mapping<br/>-->
								<!-- if there's simplified mapping use it, otherwise use the pedfile mapping -->
								<?php
									//if (is_file($dir."/raw/".SIMPLIFIED_PED_MAP_FILE)){
										$mapFile = is_file($dir."/raw/".SIMPLIFIED_PED_MAP_FILE) ? SIMPLIFIED_PED_MAP_FILE : MAP_FILE_NAME;
										$data = file_get_contents($dir."/raw/".$mapFile);
									//}
								?>
								<!--<div id="mapping" style="display: none;">
									<textarea rows="18" cols="70"><?php echo $data; ?></textarea>
									<?php
									if (is_file($dir."/raw/".UPLOADED_DATA_INFO)){
										$ini = parse_ini_file($dir."/raw/".UPLOADED_DATA_INFO, true);
										//choose_mapping($dir."/raw", $ini['snp']['pedfile'], $ini['snp'][KEY_SNP_FILE_LIST] ,$mode = "one");
									}
									?>
								</div>
								</p>-->
								
								<p>
								<a style="text-decoration: none;" href="#" onclick="if (this.innerHTML == '[-]'){
														this.innerHTML = '[+]';
													}
													else{
														this.innerHTML = '[-]';
													}
													switchElement('parameters'); return false;">[+]</a> Disease parameters<br/>
								<!-- disease frequency and Mode of Inheritance -->
								<div id="parameters" style="display: none;">
									<p>
										Disease mutant gene frequency:  <input type="text" size="10" name="frequency" id="frequency" value="0.01"/> (help)<br/>
									</p>

									<p>
										Mode of inheritance (MOI): <?php $help->displayHelpLink("tools", "MOIWarning"); ?><br/>
										&nbsp;&nbsp;&nbsp;
										<input type="radio" checked name="penetrance" value="Recessive"/>Recessive - penetrance choices
										<select id="penetraceChoiceRec" name="penetranceChoiceRec">
											<option value="0 0.99">0.99</option>
											<option value="0 1">1</option>
										<?php
											for ($i = 9; $i > 1; $i -= 1){
												?><option value="0 0.<?php echo $i?>">0.<?php echo $i?></option><?php
											}
										?>
										</select>
										<br/>
										
										&nbsp;&nbsp;&nbsp;
										<input type="radio" name="penetrance" value="Dominant"/>Dominant - penetrance choices
										<select id="penetraceChoiceDom" name="penetranceChoiceDom">
											<option value="0.99 0.99">0.99, 0.99</option>
											<option value="1 1">1, 1</option>
											<?php /*
												for ($i = 9; $i > 0; $i -=1){
													if ( ($i == 6) || ($i == 2) ){
														continue;
													}
													for ($j = 9; $i > 0; $j -=1){
														if ($j = 9){
														}
													}
												}*/
											?>
											<option value="0.9 0.9">0.9, 0.9</option>
											<option value="0.8 0.8">0.8, 0.8</option>
											<option value="0.7 0.7">0.7, 0.7</option>
											<option value="0.5 0.9">0.5, 0.9</option>
											<option value="0.5 0.8">0.5, 0.8</option>
											<option value="0.5 0.7">0.5, 0.7</option>
											<option value="0.5 0.5">0.5, 0.5</option>
											<option value="0.4 0.9">0.4, 0.9</option>
											<option value="0.4 0.7">0.4, 0.7</option>
											<option value="0.5 0.6">0.4, 0.6</option>
											<option value="0.4 0.4">0.4, 0.4</option>
											<option value="0.3 0.9">0.3, 0.9</option>
											<option value="0.3 0.7">0.3, 0.7</option>
											<option value="0.3 0.5">0.3, 0.5</option>
											<option value="0.3 0.3">0.3, 0.3</option>
											<option value="0.3 0.2">0.3, 0.2</option>
											<option value="0.1 0.1">0.1, 0.1</option>

										</select>
									</p>
								</div>
								</p>
								
								<!--<input type="submit" name="copy" value="Make Copy"/>-->
								<input type="submit" name="mapping" value="Next Step" onClick="var projName = document.getElementById('newProjName').value;
																 if (!isProjectNameValid(projName)){ return false; }
																 if (projects.inArray(projName)){
																	return confirm('Project name already exists, clicking ok will DELETE project '+projName+'.\nAre you sure?');
																 }"/>
							</form>
						<?php }
					}
					else{
						echo "No project selected to copy";
					}
				?>
			</div>
		</td>
		</tr>
	</table>
	
	<div id="Bottom">
		<br/>
        <?php webFooter(); ?>
	</div>

 </div>
</body>