<?php
require_once("log.php");
require_once("config.php");
require_once("fileHandleFunctions.php");
require_once("datpedCreator.php");

$oldProject = isset($_POST['oldProjName']) ? $_POST['oldProjName'] : (isset($argv[1]) ? $argv[1] : false);
$newProject = isset($_POST['newProjName']) ? $_POST['newProjName'] : (isset($argv[2]) ? $argv[2] : false);

$i = 3;

// resampling
$reSampling = false;
if (isset($_POST['ReSampling']) || (isset($argv[$i]) && ($argv[$i] == "-ReSampling"))){
	$reSampling = true;
	$i += 1;
}

// pedigree input
$pedigreeInputFile = false;
$pedigreeInputMapFile = false;
$pedigreeInputType = false;
if (isset($argv[$i]) && (($argv[$i] == "-simplifiedFormat") || ($argv[$i] == "-pedfileFormat"))  ){
	$pedigreeInputType = $argv[$i];
	$pedigreeInputFile = $argv[$i+1];
	$pedigreeInputMapFile = $argv[$i+2];
	$i += 3;
}

// frequency
$frequency = "0.01";
if (isset($_POST['frequency'])){
	$frequency = $_POST['frequency'];
}
if (isset($argv[$i]) && ($argv[$i] == "-frequency")){
	$frequency = $argv[$i+1];
	$i += 2;
}
$frequency = preg_match("/^[ \t\n]*$/",$frequency) ?  "0.01" : $frequency;

// penetrance
$penetrance = "0 0.99";
$penetranceChoice = "penetranceChoiceRec";
if (isset($_POST['penetrance']) && ($_POST['penetrance'] == "Dominant")){
	$penetranceChoice = "penetranceChoiceDom";
	$penetrance = "0.99 0.99";
}
if (isset($_POST[$penetranceChoice])){
	$penetrance = str_replace(" ","_",$_POST[$penetranceChoice]);
}
if (isset($argv[$i]) && ($argv[$i] == "-penetrance") && isset($argv[$i+1]) && isset($argv[$i+2])){				// must be of the form: -penetrance x1 x2 x3
	$penetrance = $argv[$i+1]." ".$argv[$i+2];
	$i += 3;
}

// projects directory
$projectsDir = "";
if (isset($_SESSION['name'])){
	$projectsDir = USER_PROJECTS_DIR;
}
else{
	if (isset($argv[$i]) && ($argv[$i] == "-name")){
		$projectsDir = USERS_DIR."/".$argv[$i+1]."/projects";
		$i += 2;
	}
	else{
		exit(1);
	}
}


//if (isset($_POST['oldProjName']) && isset($_POST['newProjName'])){
if ($oldProject && $newProject){
	//$oldProject = $_POST['oldProjName'];
	//$oldDir = USER_PROJECTS_DIR."/".$oldProject;
	$oldDir = $projectsDir."/".$oldProject;
	//$newProject = $_POST['newProjName'];
	//$newDir = USER_PROJECTS_DIR."/".$newProject;
	$newDir = $projectsDir."/".$newProject;
	//$reSampling = isset($_POST['ReSampling']) ? true : false;
	$pedFile = false;
	$infoFile = $newDir."/raw/".UPLOADED_DATA_INFO;
	$ini = false;
	if (is_file($infoFile)){
		$ini = parse_ini_file($infoFile, true);
		$pedFile = $ini['snp'][KEY_SNP_PEDFILE];
	}
	else{
		// error
	}
	
	//if (is_dir($oldDir) && !is_dir($newDir)){
	if (is_dir($oldDir) && is_dir($newDir)){
		//createProjectFolder(USER_PROJECTS_DIR, $newProject);
		//createProjectFolder($projectsDir, $newProject);
		if (fileOfTypeExistsInDir($oldDir."/raw", "snp") == true){		// snp project
			//$DBfile = SORTED_SNP_INITIAL."final_".SORTED_SNP_DB_FILENAME;
			$oldProjInfoFile = $oldDir."/raw/".UPLOADED_DATA_INFO;
			$oldIni = false;
			if (is_file($oldProjInfoFile)){
				$oldIni = parse_ini_file($oldProjInfoFile, true);
				if (isset($oldIni['snp'][KEY_SNP_FILE_LIST])){
					foreach ($oldIni['snp'][KEY_SNP_FILE_LIST] as $snpFile){
						//link($oldDir."/raw/".$snpFile, $newDir."/raw/".$snpFile);
						//link($oldDir."/raw/".SELECTION_FILE_INITIAL.$snpFile, $newDir."/raw/".SELECTION_FILE_INITIAL.$snpFile);
						// add to metadata
					}
				}
			}
			
			$DBfile = createDB($newDir."/raw", $ini['snp'][KEY_SNP_FILE_LIST], $pedFile, MAP_FILE_NAME, false);
			if (!$DBfile) {
				// error
			}
			
			if ($reSampling){								// create re-sampling
				$filteredFinalDB = filterSnp($newDir."/raw", $DBfile, 10);
				if ($filteredFinalDB){
					if ($filteredFinalDB != $DBfile){
						log_error("filterSnp on $dir / raw / $filteredFinalDB completed successfully.");
						$DBfile = $filteredFinalDB;
					}
				}
			}
			else{
				if (is_dir($oldDir."/experiments/.formatted/") && !is_file($oldDir."/experiments/.formatted/".INIT_EXPERIMENT_FLAG)){
					$oldInfo = getExpContentInfo($oldDir."/experiments/.formatted");
					$neededMarkers = array();
					$formatDone = true;
					foreach ($oldInfo as $key => $table){
						$cleanDat = $table['clean_datfile'];
						if (!is_file($cleanDat)) { $formatDone = false; break; }
					}
					if ($formatDone){
						foreach ($oldInfo as $key => $table){
							$cleanDat = $table['clean_datfile'];
							$markerLines = array();
							exec("grep \"3.*#.*#\" $cleanDat", $markerLines);
							foreach ($markerLines as $markerLine){
								$names = explode("#", $markerLine);			// WHAT IF THERE'S NO NAME?
								$names = $names[1];		// names are between the first # <names> #
								$names = explode(" ", $names);
								
								$neededMarkers = array_merge($neededMarkers, $names);
							}
						}
						$conj = makeConjunctionDB($newDir."/raw", $DBfile, $neededMarkers);
						if ($conj){
							$DBfile = $conj;
						}
					}
				}
				//	get contentInfo from oldDir/experiments/.formatted  (only if exists and done creating files)
				//	foreach chrom in contentInfo
				//		keep markers on markersList
				//	make a new DB by conjunction between DBfile and markersList
			}
				
			$varsTable[KEY_PENETRANCE] = str_replace(" ","_",$penetrance);
			$varsTable[KEY_FREQUENCY] = $frequency;
			$varsTable[SNP_SOURCE_EXPERIMENT] = "true";
			
			$parameters[KEY_PENETRANCE] = str_replace("_"," ",$penetrance);
			if (preg_match("/^(0|0\.[0-9]+?)$/", $frequency)){
				$parameters[KEY_FREQUENCY] = (1-$frequency)." ".$frequency;
			}
			$experimentsDir = $newDir."/experiments";
			//createFolder($experimentsDir, ".formatted", true);			// creating the folder for the formatted files
			//createExperimentFolder($experimentsDir, ".formatted", true, false, false, true);
			createFolder($experimentsDir, ".formatted", true);			// creating the folder for the formatted files
			$formattedDir = $experimentsDir."/.formatted";
			createFolder($formattedDir, "clean");
			markConversionFolder($formattedDir);

			createFormattedFiles($newDir, $formattedDir, $DBfile, $pedFile, MAP_FILE_NAME, $parameters, $varsTable);
			
			//foreach file in oldDir/raw{
			//	if filtered_final.sorted and resampling{
			//		continue
			//	}
			//	make hard link to newDir/raw/
			// }
			// if resampling - filter sortedDB
			// else{					// no need to re-sample: need to take only the markers that were chosen on oldProj
			//	get contentInfo from oldDir/experiments/.formatted/clean
			//	foreach chrom in contentInfo
			//		make a new DB by conjunction between fileterd_final.sorted to chrom
			// }

			
		}
		else {													// dat/ped project
		}
	}
	else{
		echo "<br/>error";
		exit;
		header("Location: copyProject.php?error=true&oldProj=1&newProj=2"); // send back
		exit;
	}
	
}

echo "<br/>success";

//header("Location: copyProject.php?done=true&oldProj=1&newProj=2"); // send back
//exit;

// $snpFileList - array, parameters for creating the dat/ped files
function createFormattedFiles($projectDir, $formattedDir ,$DB, $pedFile, $mapFile, $parameters, $varsTable){
	$projDir = $projectDir;
	$dir = $projectDir."/raw";
	$varsTableFormatted = $varsTable;
	
	//$experimentsDir = $projDir."/experiments";
	//createFolder($experimentsDir, ".formatted", true);			// creating the folder for the formatted files
	//$formattedDir = $experimentsDir."/.formatted";
	if (!is_dir($formattedDir)){
		createFolder($formattedDir, "clean");
	}
	markConversionFolder($formattedDir);
	fclose(fopen($formattedDir."/".INIT_EXPERIMENT_FLAG, 'w'));

	$flags = CLEANING_FLAG;
	//$varsTableFormatted[KEY_CLEANING_THRESHOLD] = "Weak";
	$varsTableFormatted[KEY_CLEANING_THRESHOLD] = "MendelianOnly";
	$varsTableFormatted[KEY_RUN_MODE] = VAL_RUN_MODE_CLEAN_ONLY;
	/*if (isset($varsTableFormatted[KEY_RUN_ANALYSIS])){ unset($varsTableFormatted[KEY_RUN_ANALYSIS]); }	// createVariablesTable returns this
	if (isset($varsTableFormatted[KEY_AUTOMATE_MAXVAR])){ unset($varsTableFormatted[KEY_AUTOMATE_MAXVAR]); } // in case Exp1 was automated
	if (isset($varsTableFormatted[KEY_AUTOMATE_MINVAR])){ unset($varsTableFormatted[KEY_AUTOMATE_MINVAR]); }
	if (isset($varsTableFormatted[KEY_AUTOMATE_MINAREASIZE])){ unset($varsTableFormatted[KEY_AUTOMATE_MINAREASIZE]); }	
	if (isset($varsTableFormatted[KEY_AUTOMATE_LOWRATE])){ unset($varsTableFormatted[KEY_AUTOMATE_LOWRATE]); }
	if (isset($varsTableFormatted[KEY_AUTOMATE_MAXLOWAREA])){ unset($varsTableFormatted[KEY_AUTOMATE_MAXLOWAREA]); }
	if (isset($varsTableFormatted[KEY_AUTOMATE_MAXTHRESH])){ unset($varsTableFormatted[KEY_AUTOMATE_MAXTHRESH]); }*/
	
	createVariablesFile($formattedDir, $varsTableFormatted);	
	//$expDir = $expDir."/formatted";
	//$progressFile = $expDir."/".PROGRESS_FILENAME;
	
	//$success = createDB($dir, $snpFileList, $pedFile, $mapFile);
	
	if ($DB != false){  // make peds and dats
		for ($i = 1; $i <= 22 ; $i += 1){
			if (!makePedAndDatForChrom($dir, $DB, $pedFile, $formattedDir, "$i", $parameters)){
				continue;
			}
			$progressOf = array("cleaning");
			$zero = ( ($i / 10) < 1 ) ? "0" : "";
			initProgressForFile($formattedDir, "chrom_$zero"."$i", $progressOf);

			$table['header'] = "chrom_$zero"."$i";
			$table['datfile'] = $formattedDir.'/clean/resultFile.'."chrom_$zero"."$i".".dat";
			$table['pedfile'] = $formattedDir.'/clean/resultFile.'."chrom_$zero"."$i".".ped";
			$table['clean_datfile'] = $formattedDir.'/clean/resultFile.'."chrom_$zero"."$i".".dat";
			$table['clean_pedfile'] = $formattedDir.'/clean/resultFile.'."chrom_$zero"."$i".".ped";
			updateExpContentInfo($formattedDir, $table);
			unset($table);
		}
		
		if (makePedAndDatForChrom($dir, $DB, $pedFile, $formattedDir, "X", $parameters)){
			$progressOf = array("cleaning");
			initProgressForFile($formattedDir, "chrom_X", $progressOf);
			
			$table['header'] = "chrom_X";
			$table['datfile'] = $formattedDir.'/clean/resultFile.'."chrom_X.dat";
			$table['pedfile'] = $formattedDir.'/clean/resultFile.'."chrom_X.ped";
			$table['clean_datfile'] = $formattedDir.'/clean/resultFile.'."chrom_X.dat";
			$table['clean_pedfile'] = $formattedDir.'/clean/resultFile.'."chrom_X.ped";
			updateExpContentInfo($formattedDir, $table);
			unset($table);
		}
	}
	else{
		log_error("Can't create database for: ".$dir);
		exit(1);
	}
	
	unlink($formattedDir."/".INIT_EXPERIMENT_FLAG);
	sendExperiment($formattedDir, $flags);
}

function makeConjunctionDB($dir, $DBfile, $markersArray){
	if (!($DB = fopen($dir."/".$DBfile, "r"))){
			log_error("can't open $dir/$DBfile");
			return false;
	}
	if (sizeof($markersArray) == 0) { return false; }
	if (!($conjDB = fopen($dir."/conj_".$DBfile, "w"))){
			log_error("can't open $dir/conj_$DBfile");
			return false;
	}
	
	/*for ($i = 0 ; $i < sizeof($markersArray) ; $i += 1){
		do {
			$line = fgets($DB);
			if (feof($DB)) { $i = sizeof($markersArray); break; }
			if (preg_match("/^[ \t]*[\n]?$/", $line)) {		// if line empty
				continue;
			}
			$lineArray = explode("\t", rtrim($line));
			if ($markersArray[$i] == $lineArray[DB_MARKERNAME_COL]){
				fwrite($conjDB, $line);
				break;
			}
		} while (($markersArray[$i] != $lineArray[DB_MARKERNAME_COL]) && (!feof($DB)));
	}*/
	$i = 0;
	do {
		$line = fgets($DB);
		if (feof($DB)) { break; }
		if (preg_match("/^[ \t]*[\n]?$/", $line)) {		// if line empty
			continue;
		}
		$lineArray = explode("\t", rtrim($line));
		if (in_array($lineArray[DB_MARKERNAME_COL], $markersArray)){
			fwrite($conjDB, $line);
			$i += 1;
		}
	} while (!feof($DB) || ($i != sizeof($markersArray)));
	
	fclose($conjDB);
	return "conj_".$DBfile;
}

?>