<?php
require_once("log.php");
require_once("config.php");
require_once("fileHandleFunctions.php");

$user = $_GET["name"];
$project = $_GET["project"];
$sourceProject = $_GET["source"];

$projectDir = USERS_DIR."/".$user."/projects/".$project;
$experimentsDir = $projectDir."/experiments";
$contentInfo = getExpContentInfo($experimentsDir."/.formatted");

$spinner = "<img src=\"images/waitspinner.gif\"/>";
$percent = "0%";
$text = array("Project creation" => array(), "Data validation" => array(), "File formatting" => array(), "Sent to cleaning" => array());

if (is_dir($projectDir)) {
	$percent = "1%";
	$item["value"] = "Done";
	$item["valueColor"] = "green";
	$text["Project creation"] = $item;	
}


if (is_file($projectDir."/raw/.unsortedDB.snp")) {			// snp only
	$DB = $projectDir."/raw/.unsortedDB.snp";
	$markersReady = exec("wc -l $DB");
	$ini = $projectDir."/raw/".UPLOADED_DATA_INFO;
	if (is_file($ini)){
		$info = parse_ini_file($ini, true);
		$snpFiles = $info["snp"][KEY_SNP_FILE_LIST];
		$markers = 0;
		foreach ($snpFiles as $snpfile){
			$markers += exec("wc -l $projectDir/raw/$snpfile");
		}
		$percent = ((int)(1 + (23 * ($markersReady / $markers))))."%";
	}	
}


if (is_file($projectDir."/raw/".SORTED_SNP_DB_FILENAME)) {			// snp only
	$DB = $projectDir."/raw/".SORTED_SNP_DB_FILENAME;
	$markersReady = exec("wc -l $DB");
	$ini = $projectDir."/raw/".UPLOADED_DATA_INFO;
	if (is_file($ini)){
		$info = parse_ini_file($ini, true);
		$percent = "24%";
	}
	
}

if (is_file($projectDir."/raw/filtered_".SORTED_SNP_INITIAL."final_".SORTED_SNP_DB_FILENAME)) {			// snp only
	$DB = $projectDir."/raw/filtered_".SORTED_SNP_INITIAL."final_".SORTED_SNP_DB_FILENAME;
	$markersReady = exec("wc -l $DB");
	$percent = ((int)(24 + (22 * ($markersReady / 25500))))."%";
}

if (is_file($projectDir."/raw/conj_filtered_".SORTED_SNP_INITIAL."filtered_final_".SORTED_SNP_DB_FILENAME)) {	// snp only
	$DB = $projectDir."/raw/filtered_".SORTED_SNP_INITIAL."final_".SORTED_SNP_DB_FILENAME;
	$conjDB = $projectDir."/raw/conj_filtered_".SORTED_SNP_INITIAL."final_".SORTED_SNP_DB_FILENAME;
	$chroms = exec("cut -f 2 $DB | uniq | wc -l");
	$conjChroms = exec("cut -f 2 $conjDB | uniq | wc -l");
	
	$percent = ((int)(47 + (22 * $conjChroms / $chroms)))."%";
}

if (is_file($projectDir."/raw/conj_".SORTED_SNP_INITIAL."final_".SORTED_SNP_DB_FILENAME)) {	// snp only
	$DB = $projectDir."/raw/".SORTED_SNP_INITIAL."final_".SORTED_SNP_DB_FILENAME;
	$conjDB = $projectDir."/raw/conj_".SORTED_SNP_INITIAL."final_".SORTED_SNP_DB_FILENAME;
	$chroms = exec("cut -f 2 $DB | uniq | wc -l");
	$conjChroms = exec("cut -f 2 $conjDB | uniq | wc -l");
	
	$percent = ((int)(47 + (22 * $conjChroms / $chroms)))."%";
}

if (is_dir($experimentsDir."/.formatted")) {
	$percent = "70%";
	$item["value"] = "Done";
	$item["valueColor"] = "green";
	$text["Data validation"] = $item;	
}

if (is_file($experimentsDir."/.formatted/".$contentInfo)) {
	$DB = $projectDir."/raw/filtered_".SORTED_SNP_INITIAL."final_".SORTED_SNP_DB_FILENAME;
	$chroms = exec("cut -f 2 $DB | uniq | wc -l");							// snp only
	$readyDatFiles = min(countFilesInDir($experimentsDir."/.formatted", "visible", "dat"), $chroms);
	
	$percent = ((int)(70 + (15 * $readyDatFiles / $chroms)))."%";
}

if ( $contentInfo && (!is_file($experimentsDir."/.formatted/".INIT_EXPERIMENT_FLAG)) ){
	$percent = "90%";
	//$item["title"] = "File formatting";
	$item["value"] = "Done";
	$item["valueColor"] = "green";
	$text["File formatting"] = $item;
}

if ( is_file($experimentsDir."/.formatted/.processID.txt") ){
	$percent = "100%";
	//$item["title"] = "File formatting";
	$item["value"] = "Done";
	$item["valueColor"] = "green";
	$text["Sent to cleaning"] = $item;
}

$bar = "<div class=\"progressBar\">
			<span class=\"progressBar\" style=\"width:$percent;\"></span>
		</div>";

$table = "<table>";
foreach ($text as $key => $item){
	$value = isset($item["value"]) ? $item["value"] : "";
	$color = isset($item["valueColor"]) ? $item["valueColor"] : "black";
	$table = $table."<tr><td>".$key."<td>......</td><td style=\"color: ".$color."\">".$value."</tr>";
}
$table = $table."</table>";
if ($percent != "100%") { $percent = $spinner.$percent; }

echo $bar."$percent<br/>".$table;


/*

//if (isset($_POST['oldProjName']) && isset($_POST['newProjName'])){
if ($oldProject && $newProject){
	//$oldProject = $_POST['oldProjName'];
	//$oldDir = USER_PROJECTS_DIR."/".$oldProject;
	$oldDir = $projectsDir."/".$oldProject;
	//$newProject = $_POST['newProjName'];
	//$newDir = USER_PROJECTS_DIR."/".$newProject;
	$newDir = $projectsDir."/".$newProject;
	//$reSampling = isset($_POST['ReSampling']) ? true : false;
	$pedFile = false;
	
	if (is_dir($oldDir) && !is_dir($newDir)){
		//createProjectFolder(USER_PROJECTS_DIR, $newProject);
		createProjectFolder($projectsDir, $newProject);
		if (fileOfTypeExistsInDir($oldDir."/raw", "snp") == true){		// snp project
			$DBfile = SORTED_SNP_INITIAL."final_".SORTED_SNP_DB_FILENAME;
			$handle = opendir($oldDir."/raw");
			while (($file = readdir($handle)) != false){
				if (($file == ".") || ($file == "..")){  //if file/dir is . or ..
					continue;
				}
				if ($file == "filtered_".$DBfile){
					if ($reSampling){ continue; }			// if the user wanted re-sampling dont take the filetered
					$DBfile = $file;
				}
				link($oldDir."/raw/".$file, $newDir."/raw/".$file);
				if ( (is_file($newDir."/raw/".$file)) && (preg_match("/^[^\.].*\.ped$/", $file)) ){
					$pedFile = $file;
				}
			}
			closedir($handle);
			if ($reSampling){								// create re-sampling
				$filteredFinalDB = filterSnp($newDir, $DBfile, 10);
				if ($filteredFinalDB){
					if ($filteredFinalDB != $DBfile){
						log_error("filterSnp on $dir / raw / $filteredFinalDB completed successfully.");
						$DBfile = $filteredFinalDB;
					}
				}
			}
			else{
				if (is_dir($oldDir."/experiments/.formatted/") && !is_file($oldDir."/experiments/.formatted/".INIT_EXPERIMENT_FLAG)){
					$oldInfo = getExpContentInfo($oldDir."/experiments/.formatted");
					$neededMarkers = array();
					$formatDone = true;
					foreach ($oldInfo as $key => $table){
						$cleanDat = $table['clean_datfile'];
						if (!is_file($cleanDat)) { $formatDone = false; break; }
					}
					if ($formatDone){
						foreach ($oldInfo as $key => $table){
							$cleanDat = $table['clean_datfile'];
							$markerLines = array();
							exec("grep \"3.*#.*#\" $cleanDat", $markerLines);
							foreach ($markerLines as $markerLine){
								$names = explode("#", $markerLine);
								$names = $names[1];		// names are between the first # <names> #
								$names = explode(" ", $names);
								
								$neededMarkers = array_merge($neededMarkers, $names);
							}
						}
						$conj = makeConjunctionDB($newDir."/raw", $DBfile, $neededMarkers);
						if ($conj){
							$DBfile = $conj;
						}
					}
				}
				//	get contentInfo from oldDir/experiments/.formatted  (only if exists and done creating files)
				//	foreach chrom in contentInfo
				//		keep markers on markersList
				//	make a new DB by conjunction between DBfile and markersList
			}
				
			$varsTable[KEY_PENETRANCE] = $penetrance;
			$varsTable[KEY_FREQUENCY] = $frequency;
			$varsTable[SNP_SOURCE_EXPERIMENT] = "true";
			
			$parameters[KEY_PENETRANCE] = str_replace("_"," ",$penetrance);
			if (preg_match("/^(0|0\.[0-9]+?)$/", $frequency)){
				$parameters[KEY_FREQUENCY] = (1-$frequency)." ".$frequency;
			}
			$experimentsDir = $newDir."/experiments";
			createFolder($experimentsDir, ".formatted", true);			// creating the folder for the formatted files
			$formattedDir = $experimentsDir."/.formatted";
			createFormattedFiles($newDir, $formattedDir, $DBfile, $pedFile, MAP_FILE_NAME, $parameters, $varsTable);
			
			//foreach file in oldDir/raw{
			//	if filtered_final.sorted and resampling{
			//		continue
			//	}
			//	make hard link to newDir/raw/
			// }
			// if resampling - filter sortedDB
			// else{					// no need to re-sample: need to take only the markers that were chosen on oldProj
			//	get contentInfo from oldDir/experiments/.formatted/clean
			//	foreach chrom in contentInfo
			//		make a new DB by conjunction between fileterd_final.sorted to chrom
			// }

			
		}
		else {													// dat/ped project
		}
	}
	else{
		echo "<br/>error";
		exit;
		header("Location: copyProject.php?error=true&oldProj=1&newProj=2"); // send back
		exit;
	}
	
}

echo "<br/>success";

//header("Location: copyProject.php?done=true&oldProj=1&newProj=2"); // send back
//exit;

// $snpFileList - array, parameters for creating the dat/ped files
function createFormattedFiles($projectDir, $formattedDir ,$DB, $pedFile, $mapFile, $parameters, $varsTable){
	$projDir = $projectDir;
	$dir = $projectDir."/raw";
	$varsTableFormatted = $varsTable;
	
	//$experimentsDir = $projDir."/experiments";
	//createFolder($experimentsDir, ".formatted", true);			// creating the folder for the formatted files
	//$formattedDir = $experimentsDir."/.formatted";
	if (!is_dir($formattedDir)){
		createFolder($formattedDir, "clean");
	}
	markConversionFolder($formattedDir);
	fclose(fopen($formattedDir."/".INIT_EXPERIMENT_FLAG, 'w'));

	$flags = CLEANING_FLAG;
	//$varsTableFormatted[KEY_CLEANING_THRESHOLD] = "Weak";
	$varsTableFormatted[KEY_CLEANING_THRESHOLD] = "MendelianOnly";
	$varsTableFormatted[KEY_RUN_MODE] = VAL_RUN_MODE_CLEAN_ONLY;

	
	createVariablesFile($formattedDir, $varsTableFormatted);	
	//$expDir = $expDir."/formatted";
	//$progressFile = $expDir."/".PROGRESS_FILENAME;
	
	//$success = createDB($dir, $snpFileList, $pedFile, $mapFile);
	
	if ($DB != false){  // make peds and dats
		for ($i = 1; $i <= 22 ; $i += 1){
			if (!makePedAndDatForChrom($dir, $DB, $pedFile, $formattedDir, "$i", $parameters)){
				continue;
			}
			$progressOf = array("cleaning");
			$zero = ( ($i / 10) < 1 ) ? "0" : "";
			initProgressForFile($formattedDir, "chrom_$zero"."$i", $progressOf);

			$table['header'] = "chrom_$zero"."$i";
			$table['datfile'] = $formattedDir.'/clean/resultFile.'."chrom_$zero"."$i".".dat";
			$table['pedfile'] = $formattedDir.'/clean/resultFile.'."chrom_$zero"."$i".".ped";
			$table['clean_datfile'] = $formattedDir.'/clean/resultFile.'."chrom_$zero"."$i".".dat";
			$table['clean_pedfile'] = $formattedDir.'/clean/resultFile.'."chrom_$zero"."$i".".ped";
			updateExpContentInfo($formattedDir, $table);
			unset($table);
		}
		
		if (makePedAndDatForChrom($dir, $DB, $pedFile, $formattedDir, "X", $parameters)){
			$progressOf = array("cleaning");
			initProgressForFile($formattedDir, "chrom_X", $progressOf);
			
			$table['header'] = "chrom_X";
			$table['datfile'] = $formattedDir.'/clean/resultFile.'."chrom_X.dat";
			$table['pedfile'] = $formattedDir.'/clean/resultFile.'."chrom_X.ped";
			$table['clean_datfile'] = $formattedDir.'/clean/resultFile.'."chrom_X.dat";
			$table['clean_pedfile'] = $formattedDir.'/clean/resultFile.'."chrom_X.ped";
			updateExpContentInfo($formattedDir, $table);
			unset($table);
		}
	}
	else{
		log_error("Can't create database for: ".$dir);
		exit(1);
	}
	
	unlink($formattedDir."/".INIT_EXPERIMENT_FLAG);
	//sendExperiment($formattedDir, $flags);
}

function makeConjunctionDB($dir, $DBfile, $markersArray){
	if (!($DB = fopen($dir."/".$DBfile, "r"))){
			log_error("can't open $dir/$DBfile");
			return false;
	}
	if (sizeof($markersArray) == 0) { return false; }
	if (!($conjDB = fopen($dir."/conj_".$DBfile, "w"))){
			log_error("can't open $dir/conj_$DBfile");
			return false;
	}
	
	/*for ($i = 0 ; $i < sizeof($markersArray) ; $i += 1){
		do {
			$line = fgets($DB);
			if (feof($DB)) { $i = sizeof($markersArray); break; }
			if (preg_match("/^[ \t]*[\n]?$/", $line)) {		// if line empty
				continue;
			}
			$lineArray = explode("\t", rtrim($line));
			if ($markersArray[$i] == $lineArray[DB_MARKERNAME_COL]){
				fwrite($conjDB, $line);
				break;
			}
		} while (($markersArray[$i] != $lineArray[DB_MARKERNAME_COL]) && (!feof($DB)));
	}
	$i = 0;
	do {
		$line = fgets($DB);
		if (feof($DB)) { break; }
		if (preg_match("/^[ \t]*[\n]?$/", $line)) {		// if line empty
			continue;
		}
		$lineArray = explode("\t", rtrim($line));
		if (in_array($lineArray[DB_MARKERNAME_COL], $markersArray)){
			fwrite($conjDB, $line);
			$i += 1;
		}
	} while (!feof($DB) || ($i != sizeof($markersArray)));
	
	fclose($conjDB);
	return "conj_".$DBfile;
}
*/
?>