<?php

require_once("config.php");

/*
 * InputException used to represent an exception caused by incorrect input.
 * it get a message that will be displayed to the user
 */
class InputException extends Exception {
	public function __construct ($msg) {
		$this->msg = $msg;
	}
	
	public function errorMessage() {
		return "Error: ".$this->msg;
	}
	
	private $msg;
}

/*
 * GeneralException used to represent an exception that was not ocured due to an input error.
 * it get a message that will be logged in a file and returned to the calling function.
 */
class GeneralException extends Exception {
	public function __construct ($msg) {
		$this->msg = $msg;
		$logFile = fopen (GENERAL_EXCEPTIONS_LOG_FILE, "a");
		fwrite ($logFile, $this->msg."\n");
		fclose ($logFile);
	}
	
	public function errorMessage() {
		return $this->msg;
	}
	
	private $msg;
}

?>