#=================settings to be changed for every installation==========#
PORTAL_NAME="oren/web"
PREFIX=/var/www/html/${PORTAL_NAME}


# portal path to the results in terms of links to be published on the web site
PORTAL_HTML_ROOT=/${PORTAL_NAME}/var/tmp/

#portal E-mail, as it will appear on all notification messages
PORTAL_EMAIL="Superlink-online <superlink-online@cs.technion.ac.il>"
#SSH -related settings
#path to the .ssh directory with known_hosts and id_dsa
SSH_DIR=${PREFIX}/frontend/ssh

#program which allows to acess to ssh account of the condor-backend
#should be placed in secure place!
ASKPASS_SCRIPTS=${SSH_DIR}

# host where Web portal is running
PORTAL_HOST=cbl-hap.cs.technion.ac.il

#user name of the condor-backend ssh
REMOTE_USER="linkageathome"
#REMOTE_USER="marks"
#REMOTE_USER="dang"
#REMOTE_USER="pedtool"
#REMOTE_USER="skolya"

#remote submission machine 
CONDOR_GW="cbl-link01.cs.technion.ac.il"
#CONDOR_GW="cbl-hap.cs.technion.ac.il"
#CONDOR_GW="ibis.cs.wisc.edu"
#CONDOR_GW="regular.cs.wisc.edu"
#CONDOR_GW="diet.cs.wisc.edu"


ASKPASS="${ASKPASS_SCRIPTS}/${REMOTE_USER}_${CONDOR_GW}"
#ASKPASS="${BIN}/pedtool_regular.cs.wisc.edu"
#ASKPASS="${BIN}/skolya_diet.cs.wisc.edu"

#remote root - used for the remote script
REMOTE_ROOT=/scratch/gridbot/bin/

#remote submission machine settings:
#submission script path
REMOTE_SUBMIT_SCRIPT=${REMOTE_ROOT}/AcceptSubmission.sh
#REMOTE_SUBMIT_SCRIPT=/scratch/pedtool/Pedtool/bin/AcceptSubmission.sh
#REMOTE_SUBMIT_SCRIPT=/scratch/dang/Pedtool/bin/AcceptSubmission.sh
#REMOTE_SUBMIT_SCRIPT=/scratch/pedtool/Pedtool/bin/AcceptSubmission.sh
#REMOTE_SUBMIT_SCRIPT=/scratch/skolya/Pedtool/bin/AcceptSubmission.sh

#remote location of all utilization statistics files
REMOTE_STAT_INCLUDE_FILE=${PREFIX}/includes/RemoteStat.html
REMOTE_UTILIZATION_STATUS_LOCATION=public/html/status
REMOTE_STAT_FILE_PREFIX=runstat
GRAPH_LOCATION=${PREFIX}/usage-stat
GRAPH_TASKS_FILE=${GRAPH_LOCATION}/Tasks.dat
GRAPH_CONDOR_FILE=${GRAPH_LOCATION}/Condor.dat
# number of idle jobs which we consider to be quite large
# for frontfill
NUM_JOBS_OVERLOAD_FF=800
NUM_JOBS_OVERLOAD_BF=500
#number of tasks which we consider to be quite large
# for frontfill
NUM_TASKS_OVERLOAD_FF=6
NUM_TASKS_OVERLOAD_BF=4

#######################################################################
#new settings for statistics
#######################################################################
# gateways to fetch statistics from
STAT_GATEWAYS=( ${REMOTE_USER}_${CONDOR_GW} )
FF_POOLS=( ${REMOTE_USER}_${CONDOR_GW} )
BF_POOLS=
#( skolya_diet.cs.wisc.edu dang_decaf.cs.wisc.edu )
REMOTE_HTML_STAT_LOCATION=${PREFIX}/usage-stat
#========================================================================#

CGI_BIN=${PREFIX}/cgi-bin
FRONTEND=${PREFIX}/frontend
BIN=${FRONTEND}/bin
TMPL=${FRONTEND}/templates
LOG=${FRONTEND}/log
# this a path from /var/www as a root
REMOVE_CGI_SCRIPT=/${PORTAL_NAME}/cgi-bin/HTMLTerminateCondor.pl
CGI_WORKDIR=${PREFIX}/var/tmp
GLOBAL_LOG=$LOG/Log.txt


# Mail server for outgoing mail
SMTP_SERVER=localhost

if [[ $(whoami) == apache ]]
then
	#SSH_DIR=${PREFIX}/cgi-bin/ssh 
	#SSH_FILE=id_rsa.apache
	SSH_FILE=id_dsa.apache
else
	SSH_FILE=id_dsa
fi

ssh_options="-o IdentityFile=${SSH_DIR}/${SSH_FILE} -o UserKnownHostsFile=${SSH_DIR}/known_hosts  -o CheckHostIP=no -o ConnectTimeout=60 -o StrictHostKeyChecking=no"
sshcmd="ssh ${ssh_options} -v"
scpcmd="scp  ${ssh_options} -v" 

# dvir 2011/10/11: not relevat, as long as no one calls admin_mail_sender.sh
ADMIN_MAIL=dvirtub@gmail.com

###################INTERNAL VARS################
NO_CONNECT_LOCKFILE=/tmp/CANNOT_CONNECT_PEDTOOL_${CONDOR_GW}
REMOTE_MACHINE_MARKER_FILE=CONDOR_GW_HOST_FILE.txt

#create SSH-related configs to setup keyword-less operation
# these two are required to get ssh read password NOT from keyboard
export DISPLAY=:0
export SSH_ASKPASS=${ASKPASS}

MULTIPOINT_RUN=1
TWOPOINT_RUN=0

#status update script:
STATUS_UPDATER=${BIN}/status_updater.sh
STATUS_FILE=results.html

#remove html
REMOVE_FILE=remove.html
# mail sending script
MAIL_SENDER=mail_sender.pl
#admin mail sending script
ADMIN_MAIL_SENDER=${BIN}/admin_mail_sender.sh

# final mail sender
FINAL_MAIL_SENDER=${BIN}/final_mail_sender.pl
