#!/bin/bash -x

set -x

base=`dirname $0`
. $base/CONFIG.SH
. $base/Utils.sh

exec 3>> ${GLOBAL_LOG}
exec 1>&3
exec 2>&3 

[ -z "$1" ] && Die "Missing parameter: project running dir"
Log "Attempting to remove project $1"

workdir=${CGI_WORKDIR}/$1
[ -e $workdir ] || Die "Failed to find directory  $workdir"
[ -r $workdir/${REMOTE_MACHINE_MARKER_FILE} ] || Die "Failed to detect the exact running server: $workdir/${REMOTE_MACHINE_MARKER_FILE}"
server_remote_cmd=`cat $workdir/${REMOTE_MACHINE_MARKER_FILE}`
[ -z "$server_remote_cmd" ] && Die "Running server file is empty"

# find the name of the ASKPASS script
#askpass=`echo "$server_remote_cmd" | awk '{ gsub("\@","_",$1); print $1 }'`
unset SSH_ASKPASS
#[ -x $ASKPASS_SCRIPTS/$askpass ] || Die "Cannot find password for the remote server"
#export SSH_ASKPASS=${ASKPASS_SCRIPTS}/${askpass}

echo 1234 | $sshcmd $server_remote_cmd $1 || Die "Failed to remove the project while connecting to server $server_remote_cmd"
Log "Removal successfull"
exit 0 

