#!/usr/bin/env perl

sub parseLine{
  my %output;
  my $line=$_[0];
  $line=~m/DATE=(\w+)/; $output{'date'}=$1;
  $line=~m/BUSY=(\w+)/; $output{'busy'}=$1;
  $line=~m/IDLE=(\w+)/; $output{'idle'}=$1;
  $line=~m/TASKS=(\w+)/; $output{'tasks'}=$1;
  if ($line=~ERROR){
	$output{'busy'}=0;
	$output{'idle'}=0;
	$output{'tasks'}=0;
  }
  return \%output;
}
sub parseFile{
	my $filename=$_[0];
	open FILE, "$filename";
	my %dates;
	while ($line=<FILE>){
		my $res=parseLine("$line");
		my %res=%{$res};
		if ($res{'date'}>$starting_time){
			$dates{$res{'date'}}=$res;
		}
	}
	close FILE;
	return \%dates;
	
}

$FORMAT_TASKS="FORMAT Tasks Short Heavy";
$FORMAT_CONDOR="FORMAT ShortJobs Running Idle HeavyJobs Running Idle";
$starting_time=time()-24*3600*7;
$MAX_DIF=100;

 die "Params: frontfill_stat_file bf_stat_file tasks_out condor_out" if($#ARGV!=3);

my $ff_file=$ARGV[0];
my $bf_file=$ARGV[1];
my $output_stat_condor=$ARGV[3];
my $output_stat_tasks=$ARGV[2];


open TASKS,">$output_stat_tasks" || die "Failed to open $output_stat_tasks";
open CONDOR,">$output_stat_condor" || die "Failed to open $output_stat_condor";

print TASKS "$FORMAT_TASKS\n";
print CONDOR "$FORMAT_CONDOR\n";


my $res=parseFile($ff_file);
my %ff_data=%{$res};
$res=parseFile($bf_file);
my %bf_data=%{$res};

@keys_bf=sort(keys(%bf_data));
@keys_ff=sort(keys(%ff_data));
my $ff_ptr=0;
my $bf_ptr=0;
my $ff_prev_date=$keys_ff[0];
my $bf_prev_date=$keys_bf[0];
while (!(($ff_ptr>$#keys_ff) && ($bf_ptr>$#keys_bf))){
	 undef %ff_entry;
	 undef %bf_entry;
	 my @output_tasks;
	 my @output_condor;
	 my $final_tasks;
	 my $final_condor;

	 if ($ff_ptr<=$#keys_ff){
		if ($ff_ptr!=0){
			 $ff_prev_date=$keys_ff[$ff_ptr-1];
	 	}
		%ff_entry=%{$ff_data{$keys_ff[$ff_ptr]}};
		$output_condor[0]="$ff_entry{'busy'},$ff_entry{'idle'}";
		$output_tasks[0]="$ff_entry{'tasks'}";
	 }else{
		$output_condor[0]="0,0";
		$output_tasks[0]="0";
	 }
	 if ($bf_ptr<=$#keys_bf){
		if ($bf_ptr!=0){
			 $bf_prev_date=$keys_bf[$bf_ptr-1];
	 	}
		%bf_entry=%{$bf_data{$keys_bf[$bf_ptr]}};
		$output_condor[1]="$bf_entry{'busy'},$bf_entry{'idle'}";
		$output_tasks[1]="$bf_entry{'tasks'}";
		# if ff_entry is not defined-> we can create the output here
		if (!defined(%ff_entry) ){
			$final_tasks="$bf_entry{'date'} 0,$output_tasks[1]";
			$final_condor="$bf_entry{'date'} 0,0 $output_tasks[1]";
			$bf_ptr++;
		}

	 }else{
		# we can create the output here - ff is defined, otherwise we would be out
		$final_tasks="$ff_entry{'date'} $output_tasks[0],0";
		$final_condor="$ff_entry{'date'} $output_condor[0] 0,0";
		$ff_ptr++;
	 }
	 if (defined(%ff_entry) && defined(%bf_entry)){
	# if both values are there, we can compare and decide if to combine or not
		if (abs($ff_entry{'date'}-$bf_entry{'date'})<$MAX_DIF){
		# we can merge
			$final_tasks="$ff_entry{'date'} $output_tasks[0],$output_tasks[1]";
			$final_condor="$ff_entry{'date'} $output_condor[0] $output_condor[1]";
	 		$bf_ptr++;
		 	$ff_ptr++;
		}elsif ( $ff_entry{'date'}>$bf_entry{'date'}){
		# now we choose the smallest, and merge it with the previous value
			my %prev_ff=%{$ff_data{$ff_prev_date}};
			$final_tasks="$bf_entry{'date'} $prev_ff{'tasks'},$output_tasks[1]";
			$final_condor="$bf_entry{'date'} $prev_ff{'busy'},$prev_ff{'idle'} $output_condor[1]";
	 		$bf_ptr++;
		}elsif ( $ff_entry{'date'}<$bf_entry{'date'}){
			my %prev_bf=%{$bf_data{$bf_prev_date}};
			$final_tasks="$ff_entry{'date'} $output_tasks[0],$prev_bf{'tasks'}";
			$final_condor="$ff_entry{'date'} $output_condor[0] $prev_bf{'busy'},$prev_bf{'idle'}";
		 	$ff_ptr++;
		}
	 }
	 print TASKS "$final_tasks\n";
	 print CONDOR "$final_condor \n";	
}
close TASKS;
close CONDOR;
