<?php
	require("log.php");
	include("fileHandleFunctions.php");
	include("layout.php");
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
            "http://www.w3.org/TR/html4/loose.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Superlink Online</title>
<meta http-equiv="Content-Type" content="text/html; charset=windows-1255" />
<link href="style.css" rel="stylesheet" type="text/css" />

<style type='text/css'>
li {
margin-bottom: 12px;
}
</style>

</head>
<body>
<div id="site_layout">
	<div class="site_header">
		<div id="logoImg">
			<a href="main.php"><img src="images/index_01.gif"	height="136" alt="" border="0"/ ></a>
		</div>
		<div id="dnaPic">
			<img src="images/index_02.gif" alt="" border="0" height="136" width="580" />
		</div>
	</div>

	<div id="userBar">
		<table width="100%" style="text-indent: 10px;">
			<tr>
				<td width="75%">
					<?php
						print "Welcome, " . $_SESSION["name"];
					?>
				</td>
				<td width="25%" style="text-align: right; padding-right: 10px">
					<?php print date("F j, Y"); ?>
				</td>
			</tr>
		</table>
	</div>

	<table>
		<tr>
		<td width="130" style="vertical-align: top;">
			<div id="Menu">
				<?php showMainMenu(); ?>
			</div>
		</td>
		<td width="100%" style="display:block; line-height:120%; width:95%; max-width:1000px; font-size:100%;>
			<div id="Center">
				<h1>Help</h1>
				<hr/>
				<p>				
				<table>
				<tr><td>
				<h3>Table of Contents</h3>
				</td></tr>
				<tr><td>
				<a href="#overview">Overview</a>
				</td></tr>
				<tr><td>
				<a href="#workflow">Recommended Work Flow</a>
				</td></tr>
				<tr><td>
				<a href="#input_format">Data Input Format</a>
				</td></tr>
				<tr><td>
				<!--
				<a href="#automation">Automation</a>
				</td></tr>
				<tr><td>
				-->
				<a href="#tools">Superlink-Online Tools</a>
				</td></tr>                
				<tr><td>
				<a href="#project_page">The Project Page</a>
				</td></tr>				
				<tr><td>
				<a href="#experiment_page">The Experiment Page</a>
				</td></tr>				
				</table>				
				</p>
				
				<hr/>
				<p>				
				<a name="overview"><h3>Overview</h3></a>
				You start your work with the WIZARD to import your SNP and pedigree data into a PROJECT (see below more details on the supported data formats).<br>
				The system automatically removes non-informative (single allele reading available) or erroneous (Mendelian errors) markers. It then randomly selects at most 25,000 valid markers (genome-wide,or roughly 1000 per chromosome) while keeping the same relative amount of markers per chromosome.<br>
				Aftwrwards, the system automatically creates and invokes three experiments:<br>
				<ul>
				<li><b>Segregation Analysis:</b> This determines the most likely mode of inheritance (MOI) of the data.</li>
				<li><b>Multipoint HMM:</b> This attempts to perform multipoint analysis on the entire genome using GENEHUNTER-like methods. This analysis will fail for large pedigrees due to the algorithm complexity.</li>
				<li><b>Experiment 1:</b> This performs a Two-Point analysis on the entire genome - this is the fastest type of the analysis with low computation demand.</li>
				</ul>
				</p>
				<p>
				Once the data is imported, you will find it in "formatted data" folder in the created PROJECT.  Your input is in the "Uploaded Data files".<br>
				You will be able to create EXPERIMENTS by selecting the input data (either the original input or the input or output of one of the EXPERIMENTS), and employing one of the tools from the tool bar.  You can also create new EXPERIMENTS by using the DATA BROWSER as you view the results.  Some of the EXPERIMENTS will be automatically created and invoked in the end of the import process. Note that the marker readings cannot be changed once imported into the system. To analyze new data, please create a new PROJECT.<br>
				You will be able to view a drawing of your uploaded pedigree via the "Show Pedigree" button. Two drawings are automatically generated with two separate programs: <a href="http://eyegene.ophthy.med.umich.edu/madeline/">Madeline</a> and <a href="http://haplopainter.sourceforge.net/">Haplopainter</a>.
				</p>
				<p>
				The system allows you to:<br>
				<ol>
				<li>Perform equidistant or random sampling from the input markers.</li>
				<li>Select only the subset of the markers of interest.</li>
				<li>Apply clustering, which is a way to group several SNPs into  super-markers, similarly to Merlin. This method often improves the power of the analysis.</li>
				<li>Perform two/multipoint linkage analysis of large pedigrees via parallel version of Superlink running on thousands of CPUs, or via Genehunter-like method if the pedigree size permits. The system automatically  applies multi-point analysis over all the selected markers by generating a sliding window of the selected size.</li>
				<li>Perform approximate multipoint analysis on several computers concurrently via the program <a href="http://www.stat.washington.edu/thompson/Genepi/MORGAN/Morgan.shtml">Morgan lm_linkage</a>.</li>
				<li>Perform haplotyping.</li>
				<li>Perform segregation analysis.</li>
				<li>Draw your pedigree via the programs <a href="http://eyegene.ophthy.med.umich.edu/madeline/">Madeline</a> and <a href="http://haplopainter.sourceforge.net/">Haplopainter</a>.</li>
				<li>View the results and the data in a graphical interactive DATA BROWSER.</li>
				</ol>
				Detailed help is available for each tool by clicking on the help links provided.<br>
				At any stage you will be able to download the respective input used by the system, as well as all your data with the results of all the runs.<br>
				<br>
				</p>
				<hr/>
				<p>
				<a name="workflow"><h3>Recommended Work Flow</h3></a>
				We recommend the following work flow:<br>
				</p>
				<p>
				Start your work by creating a project via the Wizard.<br>
				The wizard will automatically create three initial experiments: Segregation Analysis, HMM Multipoint Analysis and a Two-Point Analysis.
				HMM Multipoint Analysis performs a multipoint analysis using all markers, but it may fail if the pedigree is large.<br>				
				View the results of the Automatically-created Two-Point analysis by clicking on "Experiment 1" and then clicking the "View Results" button.
				This will show an overview of the analysis results for all the chromosomes.<br>
				If you find regions with higher LOD, you can zoom into them and move on to the multipoint analysis with more markers.<br>
				Use clustering to group several markers into one highly-informative marker.<br>
				<!--
				You can also use our AUTOMATION  where the system automatically performs the flow above - see the instructions below.<br>
				-->
				If the window size is too large for Multipoint analysis, you can use approximate multipoint analysis via Morgan lm_linkage to obtain more informative LOD scores.<br>
				Use the Data Browser tool to view the marker contents of suspect regions for testing homozygosity or other patterns of interest.<br>
				Finally, use the haplotyping tool to discern whether there is a haplotype segregating healthy and affected individuals in suspect regions.<br>
				<br>
				</p>
				<hr/>
				<p>
				<a name="input_format"><h3>Data Input Format</h3></a>
				Data is uploaded into the system via the WIZARD, located on the Main Menu at the top-left of the page.<br>
				Data can currently be uploaded in three formats:<br>
				<br>
				<b>SNP format:</b> We support the following SNP format, most conveniently obtained by exporting the data from MS Excel sheets.<br>
				<ul>
				<li>one marker per row.</li>
				<li>each row contains at least the following data:<br>
				<ol>
				<li>marker name of the form "rsXXX..X" where rs is lower-case and XXX.. is any number of digits.</li>
				<li>chromosome the marker resides on marker physical location (either digits or x/X for sex chromosome).</li>
				<li>marker readings - one column (for both alleles) per person, each allele is either a,b,c,g,t,1,2. No call is encoded as one of:<br>
				&nbsp;&nbsp;&nbsp;&nbsp;NoCall , 00 , 0 , -- , -<br></li>
				</ol>
				</ul>
				<br>
				Note, at the moment allele frequencies information cannot be imported, and the frequency for each allele is assumed 0.5. This will be changed in a newer version.<br>
				To use allele frequencies for the analysis now, please use Superlink format.<br>								
				<br>
				<b>Superlink Format:</b> Data can be uploaded in Superlink format - a <a href="http://bioinfo.cs.technion.ac.il/superlink/Locus_File.html">dat file</a> and a <a href="http://bioinfo.cs.technion.ac.il/superlink/Pedigree_File.html">ped file</a> (you may try the <a href="http://www.dynacom.co.jp/u-tokyo.ac.jp/snphitlink">HiTlink tool</a> to convert your data to Superlink format).<br>				
				<br>
				<b>Simplfied Format:</b> Data can be uploaded directly into a web form without uploading files, in a manner similar to that used in previous versions of Superlink-Online.<br>
				<br>
				If you have your data in another format, please contact us and we will help you with importing it.<br>
				You can upload files not exceeding 15MB. If you have larger files, please split them into several smaller parts and upload each separately.<br>				
				<br>
				</p>
				
                
                <hr/>
				<!--
				<p>
				<a name="automation"><h3>Automation</h3></a>
				AUTOMATION allows for easier detection of the potential regions of interest. When used, it will automatically generate and run new EXPERIMENTS by gradually increasing the number of markers in the analysis in the regions having higher LOD score. For example, if the original data is used as the input, AUTOMATION will run two-point analysis, find contiguous regions with higher LOD, run three point analysis in these regions, and keep to four-point and further until either  no further improvement is obtained, or when the analysis becomes too computationally complex to perform.<br>
				<br>
				Automation can also use any EXPERIMENT as a starting point. For example, when applied on the EXPERIMENT containing three point analysis results, AUTOMATION will start from four-point analysis instead of the two-point of the original data.<br>
				<br>
				<b>How to run Automation:</b><br>
				Enter the EXPERIMENT/FORMATTED DATA folder  whose data you want to use as the input. Mark the chromosomes to be analyzed and choose Two Point or Multi Point analysis on the tool bar. Click Go.<br>
				Then mark V in the "Automate" check box . In order to set the automation parameters, click on "Advanced".</br>
				<br>
				</p>
				-->
				
                
                <hr/>
				<p>
				<a name="tools"><h3>Superlink-Online Tools</h3></a>
                Superlink-Online currently provides the following analysis tools:
                <ul>
                <li><b>General Tools:</b>
                <ul>
                <li>
                    <b>Pedigree Drawing:</b> Superlink-Online uses two external tools for pedigree drawings:
                    <a href="http://eyegene.ophthy.med.umich.edu/madeline/">Madeline</a> and <a href="http://haplopainter.sourceforge.net/">Haplopainter</a>.
                    The pedigrees can be shown by clicking on the "Show Pedigree" button on the project page.
                </li>
                </ul>
                </li>
                <li><b>Exact Analysis:</b>
                <ul>
                <li>
                    <b>Segregation Analysis:</b> This tool, which runs automatically upon project creation, computes the likelihood of the pedigree data
                    under several different modes of inheritance (MOIs). This can be used to determine the MOI of the studied trait. Please note that
                    this tool uses only the phenotypic data of the pedigree and does not markers data into account at all.
                </li>
                <li>
                    <b>HMM Multipoint:</b> This tool, which runs automatically upon project creation, computes LOD scores throughout the genome,
                    using all the markers in the chromosome for each computation. The tool uses an HMM algorithm, similar to that used in
                    <a href="http://www.broadinstitute.org/ftp/distribution/software/genehunter/">GENEHUNTER</a>,
                    <a href="http://www.sph.umich.edu/csg/abecasis/Merlin/index.html">Merlin</a>, and <a href="http://www.decode.com/software/">Allegro</a>.
                    This means that the tool will produce accurate results for small pedigrees with an arbitrary number of markers.
                    However, the tool will fail for large pedigrees due to the algorithm complexity.
                    In addition to computing LOD scores, this tool also determines the haplotyping output (see below) of the pedigree.
                    If the pedigree is small enough, each Multipoint computation that is performed in the project will actually use the HMM tool instead of 
                    the regular Multipoint analysis.
                </li>
                <li>
                <b>Two-Point Analysis:</b> For every specified marker individually, <b>Two Point Analysis</b> computes the LOD score of the pedigree data,
                assuming the trait locus is located exactly on this marker and using only this marker for the analysis.
                This tool runs automatically upon project creation, in an experiment called "Experiment1". This experiment uses the MOI specified in the Wizard for the analysis.
                While a <b>Two Point Analysis</b> is very fast, it is often not powerful enough to yield high LOD scores.
                </li>
                <li>
                <b>Multi-Point Analysis:</b> This tool computes LOD scores using a group of markers for each analysis. The tool assumes that the trait locus
                is located exactly on one of the markers in the analysis, and thus computes a LOD scores for each marker locus in the analysis.
                The analysis run time scales exponentially with the number of markers. Thus, only moderately-sized windows can be used for this type of analysis.
                If a computation was requested which will take too long to run on a single CPU, Superlink-Online SNP parallelizes the analysis into thousands of simpler
                tasks and computes these on thousands of CPUs concurrently. This allows Superlink-Online SNP to perform computations that are infeasible elsewhere.
                To compute LOD scores with windows that are too large for exact analysis, you may perform an approximate analysis using Morgan lm_linkage (see below).
                </li>
                <li>
                <b>Haplotyping:</b> Haplotyping Analysis determines the genetic information descending through a pedigree and provides a visualization of the gene flow through it.
                This tool is used to identify patterns of identity by descent (IBD) among members of a pedigree, given markers data. Note that Haplotyping
                does not use trait data for the analysis.
                Please note that like Multi-Point analysis, Haplotyping analysis is also a very time-consuming analysis which scales exponentially with the number
                of markers in the analysis.
                <!--To perform a Haplotyping analysis with windows that are too large for exact analysis, you may perform an approximate analysis using Morgan gl_auto (see below).-->
                </li>
                </ul>
                </li>                
                <li><b>Approximate Analysis:</b>
                <ul>
                <li>
                <b>Morgan lm_linkage:</b> <a href='http://www.stat.washington.edu/thompson/Genepi/MORGAN/Morgan.shtml'>MORGAN</a> is a collection of software, under the PANGAEA (pedigree analysis for genetics and epidemiological attributes) umbrella.
                These programs implement a number of methods for the analysis of data observed on members of a pedigree structure.
                lm_linkage is a program of the <a href='http://www.stat.washington.edu/thompson/Genepi/MORGAN/Morgan.shtml'>Morgan package</a>, which estimates Multi point LOD scores via Monte Carlo sampling of latent autozygosity states conditional on multilocus marker data.
                lm_linkage is the work of <a href='http://www.stat.washington.edu/thompson'>Elizabeth A. Thompson</a> and <a href='http://webpages.math.luc.edu/~ltong/'>Liping Tong</a> (<a href='http://www.ncbi.nlm.nih.gov/pmc/articles/PMC2701716/'>Multilocus LOD scores in large pedigrees: combination of exact and approximate calculations. <i>Human Heredity</i> <b>65</b>: 142-153, 2008</a>).
                <br>
                lm_linkage computes Multi-Point LOD scores, similar to the standard Multi-point computation.
                Unlike the standard analysis, this analysis computes approximate LOD scores via MCMC simulations.
                This analysis may be able to perform computations where the standard computation fails.
                However, the accuracy of the results is not guaranteed.<br>
                In order to use lm_linkage, one must specify the desired computation time for each window in the analysis.
                lm_linkage computes LOD scores only halfway between each pair of adjacent markers, since the LOD score estimation on the actual marker loci is less accurate.
                <br>
                In addition to LOD scores, the output also shows The Gelman-Rubin (GR) score for each computation.
                This score is an estimator for the accuracy of the results. It was developed by Gelman and Rubin (<a href='http://www.jstor.org/stable/2246093'>Inference from iterative simulation using multiple sequences.
                Statistical Science 7(4):457-472, 1992</a>).
                The GR score is a real number greater than 1. The closer this number is to 1, the better the accuracy of the LOD score estimation.
                Generally, a GR score of 1.1 or less is an accurate approximation of the LOD score.
                </li>
                <!--
                <li><b>Morgan gl_auto:</b> Morgan gl_auto is one of the <a href='http://www.stat.washington.edu/thompson/Genepi/MORGAN/Morgan.shtml'>MORGAN</a> "Autozyg" programs, so called because they estimate autozygosity, or identity by descent (ibd).
                The Autozyg programs use MCMC to infer patterns of ibd among members of a
                pedigree conditional on marker data, and possibly also on trait data.
                "gl_auto" is the work of <a href='http://www.stat.washington.edu/thompson'>Elizabeth A. Thompson</a> and Steven Lewis.
                It uses library functions based on work by Simon Heath.
                <br>gl_auto realizes ibd configurations from their conditional distribution given the marker data.
                This tool is used to identify patterns of identity by descent (IBD) among members of a pedigree, given markers data.
                </li>
                -->
                
                </ul>
                </li>
                <li><b>Data Reduction Tools:</b>
                <ul>
                <li><b>Clsutering Tool:</b> The clustering tool groups several SNP markers into one highly-informative marker. An analysis performed on clustered
                markers often has higher power to detect linkage.
                For two SNPs to be in the same cluster they must satisfy the following criteria:
                <ul><li>The most probable haplotype for this cluster lacks recombinations.</li>
                <li>The number of expected recombinations in the cluster for the current pedigree is less than 1.</li></ul>                
                </li>
                <li><b>Remove erroneous markers (Cleaning Tool):</b> This tool removes problematic markers from the analysis. There are two types of cleaning procedures:
                <ul>
                <li><b>Cleaning Mendelian Errors (runs automatically on project creation):</b> This tool removes markers that show inconsistency between parents and offspring, and markers with onle a single allele present (such marker contribute nothing to the LOD score).
                This tool runs automatically upon project creation (its results are shown in the "Formatted output" link in the main project page).
                </li>
                <li><b>Cleaning Unlikely Markers:</b> This tool removes markers that decrease the likelihood of the data.
                Namely, it removes markers which significatly decrease the likelihood of the data under linkage, but do not significantly decrease
                the likelihood of the data under non-linkage.
                Additionally, this tool removes markers that have alleles with extreme frequencies. Such alleles can inflate the LOD score because the disease tends to occur in the typed members of the pedigree,
                most often together with the most frequent allele, simply because that allele is common.
                </li>
                </ul>                
                </li>
                <li><b>Filtering Tool:</b> This tool creates new dat+ped files which contain fewer markers than the original files. The average distance between every pair of chosen markers will be the distance that the user specified.
                The larger the average distance, the less markers will be in the output files.
                </li>
                </ul>
                </li>
                
                <li><b>Zooming Tools</b>
                <ul>
                <li><b>Zoom on Markers:</b> This tool creates new data files that contain only the markers from a specified region in the chromosome.
                If the input files are SNP files, this tool can add more markers from the SNP file, that were removed during the initial filtering process, back into the dat files.
                </li>
                </ul>               
                                
                </ul>
				</p>                
                
                
                <br/>
                <hr/>
				<p>
				<a name="project_page"><h3>The Project Page</h3></a>
				When uploading data to the system, a new PROJECT will be created.<br>
				When clicking on a project, a page with the following information will be displayed:
				<ul>
				<li><b>The project toolbar:</b> This contains general tools for managenement of the project:
				<ul>
				<li><b>Copy:</b> Copy the project data into a new project. You can change the pedigree data for the new project (e.g. to perform affected-only analysis). This option is currently available only for data uploaded in SNP format.</li>
				<li><b>Download:</b> Download the project data and the results of all analyses.</li>				
				<li><b>Edit Comments:</b> View/Edit comments for the project. These comments will be saved for future reference.</li>
				<li><b>Show Pedigree:</b> View a drawing of the pedigree structure. Two drawings are created with two separate programs: <a href="http://eyegene.ophthy.med.umich.edu/madeline/">Madeline</a> and <a href="http://haplopainter.sourceforge.net/">Haplopainter</a>.</li>
				<li><b>Delete Selected:</b> Delete the selected experiments.</li>
				<li><b>Restore Deleted:</b> Restore experiments that may have been accidentally deleted.</li>
				<li><b>Data Browser:</b> Invoke the data browser which shows the marker contents of suspect regions in a graphical interactive environment. This tool is only available for data uploaded in SNP format.</li>
				</ul>
				</li>
				<li><b>Uploaded Data Files:</b> Shows the data files that have been uploaded into the system.</li>
				<li><b>Formatted Data Files:</b> Shows the data files that have been imported into the system after performing filtering and removing erroneous and non-informative markers.</li>
				<li><b>Experiments Table:</b> Here all the experiments are shown. Experiments status can be either "Running", "Finished" or "Stopped" (experiment was manually terminated). Clicking on an experiment will open the experiment page.</li>
				</ul>
				<br>				
				</p>
				
				<hr/>
				<p>
				<a name="experiment_page"><h3>The Experiment Page</h3></a>				
				When clicking on an experiment, a page with the following information will be displayed:
				<ul>
				<li><b>Status:</b> The status of the experiment (either "Running", "Finished" or "Stopped"). An experiment status will be "Finished" only when all the experiment analyses are finished).</li>
				<li><b>The experiment toolbar:</b>
				<ul>
				<li><b>View Results:</b> View the results of all analyses that have already finished.</li>
				<li><b>Download:</b> Download the results of all analyses that have already finished.</li>
				<li><b>Data Browser:</b> Invoke the data browser that will show the marker contents of suspect regions found in the experiment.</li>
				<li><b>Stop:</b> Stop all currently running analyses in the experiment and mark the experiment status as "Stopped".</li>
				</ul>
				</li>
				<li><b>Experiment Details:</b> The type of analysis performed in the experiment and its associated parameters.</li>
				<li><b>Tools Menu:</b> A list of tools that can be invoked on the input of one or more of the experiment analyses. To use a tool on the results, select one or more analyses and then choose a tool from this list and click "Go".</li>
				<li><b>Analyses Table:</b> A table with a row for each analysis in the experiment. A different analysis is performed for each chromosome or for each uploaded markers file. The table columns are the following:
				<ul>
				<li><b>Name:</b> The analysis name.</li>
				<li><b>Source Files:</b> The files on which the analysis was performed.</li>
				<li><b>Clean Files:</b> In case the analysis was a cleaning analysis, the resulting data files after the cleaning.</li>
				<li><b>Clustered Files:</b> In case the analysis was a clustering analysis, the resulting data files after the clustering.</li>
				<li><b>Cleaning Report:</b> In case the analysis was a cleaning analysis, a report of the markers that were removed.</li>
				<li><b>Clustering Report:</b> In case the analysis was a clustering analysis, a report of the markers that were clustered.</li>
				</ul>
				</li>
				</ul>
				
				<hr/>
				<p>
				If you have any questions, please don't hesitate to contact us at <a href="mailto:superlink@cs.technion.ac.il">superlink@cs.technion.ac.il</a>.<br>
				Looking forward to seeing your runs here,<br>
				Superlink Team.<br>
				</p>				


				
			</div>
		</td>
		</tr>
	</table>
	
	<div id="Bottom">
		<br/>
        <?php webFooter(); ?>
	</div>

 </div>
</body>