<?php
class Help
{
    /*********** property declaration ***********/
    // private $var = 'a default value';

    /************ method declaration ***********/
	
	// displays a link to a page containing help for the given input (give helpID if u know the exact ID)
    public function displayHelpLink($primerySubject, $secondarySubject = false) {
        echo Help::getHelpButton($primerySubject, $secondarySubject);
    }
	
    public function displayWhatsNew($version) {
		?>
		<script type="text/javascript" src="jsFunctions.js">
		</script>
		<?php
		
		$newsInfo = Help::getHelpInfo("whatsNew".$version);
		foreach ($newsInfo as $key => $info){
			//if (is_numeric($key)){
			//	echo $key."<br/>";
			//}
			if (Help::getNewsButton("whatsNew".$version, $key)){
				echo "<br/>";
			}
			//$button = Help::getHelpButtonInfo($pSubject, $sSubject);
			//echo "<a href=\"helpUtility.php".$params."\" style=\"".$style."\" target=\"_blank\"\">".$title."</a>";
		}
    }
	
	// displays a help message according to given input
	public function displayHelpMessage($primerySubject, $secondarySubject = false) {
        echo Help::getHelpMessage($primerySubject, $secondarySubject);
    }
	
	private function getHelpButton($pSubject, $sSubject){
		$helpInfo = Help::getHelpButtonInfo($pSubject, $sSubject);
		
		//$params = (!isset($helpInfo['buttonParams']) || ($helpInfo['buttonParams'] == "null") || ($helpInfo['buttonParams'] == null))   ? "" : "?".$helpInfo['buttonParams'];
		//$params = str_replace(",", "&", $params);
		//$params = str_replace("_", "=", $params);
		
		$link = "helpUtility.php?primery=$pSubject".($sSubject ? "&secondary=$sSubject" : "");
		$link = (!isset($helpInfo['buttonDownloadLink']) || ($helpInfo['buttonDownloadLink'] == "null") || ($helpInfo['buttonDownloadLink'] == null)) ? $link : Help::getDownloadLink($helpInfo['buttonDownloadLink']);
		$link = (!isset($helpInfo['buttonLink']) || ($helpInfo['buttonLink'] == "null") || ($helpInfo['buttonLink'] == null)) ? $link : $helpInfo['buttonLink'];
		$style = (!isset($helpInfo['buttonStyle']) || ($helpInfo['buttonStyle'] == "null") || ($helpInfo['buttonStyle'] == null)) ? "" : $helpInfo['buttonStyle'];
		$title = (!isset($helpInfo['buttonTitle']) || ($helpInfo['buttonTitle'] == "null") || ($helpInfo['buttonTitle'] == null)) ? "" : $helpInfo['buttonTitle'];
		
		if ($title == "") { return false; }
		
		return "<a href=\"".$link."\" style=\"".$style."\" target=\"_blank\"\">".$title."</a>";
	}
	
	private function getNewsButton($pSubject, $sSubject){
		$helpInfo = Help::getHelpButtonInfo($pSubject, $sSubject);
		
		$params = "?primery=$pSubject".($sSubject ? "&secondary=$sSubject" : "");
		$style = (!isset($helpInfo['buttonStyle']) || ($helpInfo['buttonStyle'] == "null") || ($helpInfo['buttonStyle'] == null)) ? "" : $helpInfo['buttonStyle'];
		$title = (!isset($helpInfo['buttonTitle']) || ($helpInfo['buttonTitle'] == "null") || ($helpInfo['buttonTitle'] == null)) ? "" : $helpInfo['buttonTitle'];
		
		if ($title == "") { return false; }
		echo "<a href=\"#\" style=\"".$style."\" onclick=\"switchElement('".$pSubject."_".$sSubject."'); return false;\">".$title."</a>";
		
		echo "<span id=\"".$pSubject."_".$sSubject."\" style=\"padding-left: 20px; display: none;\">";
		echo Help::getNewsMessage($pSubject, $sSubject);
		echo "</span>";
		
		return true;
	}

	// returns a table of help info which contains:
	// buttonTitle - text on the link / button
	// buttonStyle - style of the link
	// buttonParams - link GET parameters
	// order - order of contents
	private function getHelpButtonInfo($pSubject, $sSubject){
		$help = Help::getHelpInfo($pSubject, $sSubject);
		$sub = $sSubject ? $sSubject : "button";
		return $help[$sub];
	}	
	
	// returns a table of help info for a given $subject
	// ini file with the info should be names: <$subject>Help.ini
	private function getHelpInfo($subject){
		$iniFile = HELP_DIR."/".$subject."Help.ini";
		if (!is_file($iniFile)){
			$help['buttonTitle'] = "no help available";
		}
		else {
			$help = parse_ini_file($iniFile, true);
		}
		return $help;
	}
	
	private function getHelpMessage($pSubject, $sSubject){
		$help = Help::getHelpInfo($pSubject);
		$helpOn = $sSubject ? $sSubject : 'button';
		$order = explode(",",$help[$helpOn]['order']);
		$message = "";

		/*********  SHOW ONLY EXAMPLES - REMOVE WHEN HELP IS READY ***********
		$example = false;
		foreach ($order as $key){
			if (!isset($help[trim($key)])){
				echo "[".trim($key)."] is undefined.<br/>";
				continue;
			}
			$content = $help[trim($key)];
			$i = 1;
			while (isset($content['line'.$i.'file'])){
				$example = true;
				break;
				$i += 1;
			}
			if ($example) { break; }
			else { return "<br/><br/>Under construction..."; }
		}
		****************************************************************************/

		foreach ($order as $key){
			if (!isset($help[trim($key)])){
				echo "[".trim($key)."] is undefined.<br/>";
				continue;
			}
			$content = $help[trim($key)];
			$i = 1;
			while (isset($content['line'.$i]) || isset($content['line'.$i.'file'])){
				$message = $message."<br/>".(isset($content['line'.$i.'file']) ? "<br/>".Help::getColumnsFileHtml($content['line'.$i.'file']) : $content['line'.$i]);
				$i += 1;
			}
		}
		
		return $message;
	}
	
	private function linkFile($filePath, $title = "example"){
		return "<a href=\"$filePath\" target=\"_blank\">$title</a>";
	}
	
	private function getDownloadLink($filePath){
		return "download.php?file=".base64_encode($filePath);
	}
	
	private function getColumnsFileHtml($filePath){
		$content = file($filePath);
		$Html = "<table>";
		for ($i = 0 ; $i < sizeof($content) ; $i += 1){
			$Html = $Html."<tr>";
			$line = explode("\t", $content[$i]);
			$line = "<td>".implode("</td><td>", $line)."</td>";
			$Html = $Html.$line."</tr>";
		}
		return $Html."</table>";
	}
	
	
	/****************************************************************/
	/* REMOVE WHEN HELP IS READY, USE GetHelpMessage INSTEAD !!!!! */
	/****************************************************************/
	private function getNewsMessage($pSubject, $sSubject){
		$help = Help::getHelpInfo($pSubject);
		$helpOn = $sSubject ? $sSubject : 'button';
		$order = explode(",",$help[$helpOn]['order']);
		$message = "";

		foreach ($order as $key){
			if (!isset($help[trim($key)])){
				echo "[".trim($key)."] is undefined.<br/>";
				continue;
			}
			$content = $help[trim($key)];
			$i = 1;
			$spaces = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
			while (isset($content['line'.$i]) || isset($content['line'.$i.'file'])){
				$message = $message."<br/>$spaces".(isset($content['line'.$i.'file']) ? "<br/>".Help::getColumnsFileHtml($content['line'.$i.'file']) : $content['line'.$i]);
				$i += 1;
			}
		}
		
		return $message;
	}
	
}
?>