Array.prototype.inArray = function (value) {
	// Returns true if the passed value is found in the
	// array. Returns false if it is not.
	var i=0;
	for (i=0; i < this.length; i++) {
		// Matches identical (===), not just similar (==).
		if (this[i] == value) {
			return true;
		}
	}
	return false;
};

// allowdMany is an array of elements allowd more than once.
// mustSet is an array of elements that must be set at least once
function checkMapping(formName, mapName, splitSign, AllowdMany, mustSet, warnOnly) {
	var formObj = document.getElementsByTagName(formName);
	if (formObj == null){
		alert("error on page.");
		return false;
	}
	if (AllowdMany == null){
		AllowdMany = new Array();
	}
	if (mustSet == null){
		mustSet = new Array();
	}

	var selIndex;
	var mapArray = new Array();
	for (var v=0 ; v < document.wizardSteps.elements.length ; v = v+1){
		//if (document.wizardSteps.elements[v].disabled == true) { continue; }
		if (document.wizardSteps.elements[v].name == mapName){
			selIndex = document.wizardSteps.elements[v].selectedIndex;
			//alert(selIndex + " " + document.wizardSteps.elements[v].options[selIndex].text);
			//alert(document.wizardSteps.elements[v].options[selIndex].value);
			mapArray[v] = document.wizardSteps.elements[v].options[selIndex].value;
			
		}
	}
	
	var checkArr = new Array(mapArray.length);
	var ppl = {}; // empty hashMap
	var i=0;
	var num;
	var name;
	var mapItem;
	var warning = false;
	for (i=0 ; i<checkArr.length ; i = i+1){     // init
		checkArr[i] = 0;
	}
	var notNon = 0; //indicate the number of people that has been mapped
	for (i=0 ; i<mapArray.length ; i = i+1){
		mapItem = mapArray[i].split(splitSign);
		num = mapItem[0];
		name = mapItem[1];
		if (name != "none") {
			notNon++;
			if ( (ppl[name] == null) || (ppl[name] == mapItem[0]) || (AllowdMany.inArray(name)) ){
				ppl[name] = mapItem[0];
			}
			else {
				alert("Illegal choice for: "+ name +"\n" + "This cannot be chosen multiple times.");
				return false;
			}
		}
	}
	if (notNon == 0) {
		alert("Please select a mapping for at least one person.");
		return false;
	}
	if ( (warnOnly != null) && warnOnly && warning){
		if (!confirm(warning)) { return false; }
	}
	
	for (i=0 ; i < mustSet.length ; i = i+1){
		if (ppl[mustSet[i]] == null){
			alert("Error: at least one "+ mustSet[i] +" has to be chosen.");
			return false;
		}
	}
	return true;
}

// disables all buttons in buttonsArray, by name.
function disableButtons(buttonsArray){
	var i;
	for (i=0 ; i<buttonsArray.length ; i = i+1){
		document.getElementById(buttonsArray[i]).disabled = true;
	}
}

// switcher between divs
function switchForms(id, div1, div2) {
	if (id=="btn1") {
		document.getElementById(div1).style.display = ""; //shows the form
		document.getElementById(div2).style.display = "none"; //hides form
	}
	else {
		document.getElementById(div1).style.display = "none";
		document.getElementById(div2).style.display = "";
	}
}

// switcher between divs
function switchDivs(div1, div2) {
	div1Elem = document.getElementById(div1);
	div2Elem = document.getElementById(div2);
	if ( (div1Elem == null) || (div2Elem == null) ) { return; }
	if (div1Elem.style.display == "") {
		div1Elem.style.display = "none"; //hides form
		div2Elem.style.display = ""; //shows the form
	}
	else {
		div2Elem.style.display = "none";
		div1Elem.style.display = "";
	}
}

function switchElement(element){
	if (document.getElementById(element) == null){
		return;
	}
	if (document.getElementById(element).style.display == ''){
		document.getElementById(element).style.display = 'none';	// hide
	}
	else{
		document.getElementById(element).style.display = '';		// show
	}
}

function enableElementAccess(element){
	if (document.getElementById(element) == null){
		return;
	}
	document.getElementById(element).disabled = false;		// enable
}

function disableElementAccess(element){
	if (document.getElementById(element) == null){
		return;
	}
	document.getElementById(element).disabled = true;		// disable
}

function switchElementAccess(element) {
	if (document.getElementById(element) == null) { return; }
	if (document.getElementById(element).disabled) { document.getElementById(element).disabled = false; }
	else { document.getElementById(element).disabled = true; }
}

function getElement(id) { return document.getElementById(id); }

function showElement(element) { element.style.display = ''; }

function hideElement(element) { element.style.display = 'none'; }

function validate()
{
	conf = confirm("This action will cancel the whole progress of the wizard!\nAre you sure?");
	return conf;
}

function updateSelections(){//selections){
	alert("hey!!  ");// + selections.selected);
}

function countChecked() {
	var checked = 0;
	for (var v = 0; v < document.form.elements.length; v++) {
		if (document.form.elements[v].checked == true){
			checked++;
		}
	}
	return checked;
}

function getInput(inputElement){
	return document.getElementById(inputElement).value;
}

function setValue(element, newValue){
	document.getElementById(element).value = newValue;
}

function isProjectNameValid(pName){
	if (pName.length == 0){
		alert("An empty project name is illegal, enter a legal name.");
		return false;
	}
	if (pName.charAt(0) == '.'){
		alert("A project name starting with \".\" is illegal, enter a legal name.");
		return false;	
	}
	//if (pName.charAt(0) == ' '){
	if (pName.indexOf(' ') != -1){
		alert("A project name containing spaces is illegal, enter a legal name.");
		return false;	
	}
	var temp = pName.split('$');
	if (temp.length > 1){
		alert("A project name containing \"$\" is illegal, enter a legal name.");
		return false;	
	}
	var temp = pName.split('/');
	if (temp.length > 1){
		alert("A project name containing \"/\" is illegal, enter a legal name.");
		return false;	
	}
	var temp = pName.split('\\');
	if (temp.length > 1){
		alert("A project name containing \"\\\" is illegal, enter a legal name.");
		return false;	
	}
	var temp = pName.split('*');
	if (temp.length > 1){
		alert("A project name containing \"*\" is illegal, enter a legal name.");
		return false;	
	}
	if ( (pName.indexOf('(') != -1) || (pName.indexOf(')') != -1) ){
		alert("A project name containing bracets is illegal, enter a legal name.");
		return false;
	}
	return true;
}

function isAnyoneChecked(array){
	for (i=0 ; i<array.length ; i = i+1){
		if (document.getElementById(array[i]).checked == true){
			return true;
		}
	}
	alert("You must choose at least one option from: " + array +".");
	return false;
}

function countSpaces(str){
	// checking for spaces in filename
	spaces = str.split(' ');
	return spaces.length-1;
}

function TestFileType( fileName, fileTypes, all ) {
	if (all == null){
		all = false;
	}
	if (!fileName && all){
		alert("All file selection fields should be filled.");
		return false;
	}
	
	spaces = fileName.split('\\');
	if (countSpaces(spaces[spaces.length-1]) > 0){
		alert("File names should not contain spaces.");
		return false;
	}
	
	dots = fileName.split(".");
	//get the part AFTER the LAST period.
	fileType = dots[dots.length-1];

	if (fileTypes.join(".").indexOf(fileType) != -1){		// if file type is found
		return true;
	}

	alert("Illegal file extension found!\nInput has ." + dots[dots.length-1] + " extension instead of: ." + (fileTypes.join(" .")) + "\n\nSelect a new file and try again.");
	return false;
}

function sameFileHead( fileName1, fileName2 ) {
	if (!fileName1 || !fileName2) {return false;}
	//get the names of the files.
	fileName1 = (fileName1.split('\\'));
	fileName2 = (fileName2.split('\\'));
	fileName1 = fileName1[fileName1.length-1];
	fileName2 = fileName2[fileName2.length-1];
	// if file names without the extension are similar, its ok.
	if (fileName1.substr(0, fileName1.lastIndexOf('.')) == fileName2.substr(0, fileName2.lastIndexOf('.'))){
		return true;
	}

	alert("Input files must have the same name before their extension.");
	return false;
}

/* give true to check all, and false to uncheck all */
function switchCheckAll(form, checkBoxes, specialString) {
	for (var v = 0; v < form.elements.length; v++) {
		if (form.elements[v].type == 'checkbox'){
			if ( (specialString == null) || (specialString == form.elements[v].value.substr(0, form.elements[v].value.lastIndexOf('@'))) ){
				form.elements[v].checked = checkBoxes;
			}
		}
	}
}

function getCheckedElements(elements) {
	res = new Array();
	if (elements != null) {
		for (var i=0 ; i < elements.length ; i++) {
			if (elements[i].checked) {res[res.length] = elements[i];}
		}
	}
	return res;
}

// matches array elements' value to given regExp. returns an array with the matching elements.
function getRegExpValueMatches(regExp, array) {
	var resArr = new Array();
	if (array != null) {
		for (var i=0 ; i < array.length ; i++) {
			if (regExp.exec(array[i].value)) {resArr[resArr.length] = array[i];}
		}
	}
	return resArr;
}

function selectValuesOf(selectName, values) {
	var selectElement;
	/*for (var v=0 ; v < values.length ; v++){
		alert(values[v]);
	}*/
	for (var v=0 ; v < document.wizardSteps.elements.length ; v++) {
		selectElement = document.wizardSteps.elements[v];
		equal = (selectElement.id.substr(0,selectName.length) == selectName);
		if ( equal && (!selectElement.disabled) ) {
			for (var i = 0 ; i < selectElement.options.length ; i++) {
				if (values.inArray(selectElement.options[i].value)) {selectElement.options[i].selected = true;}
				else{selectElement.options[i].selected = false;}
			}
		}
	}
}

// checks if any of the values of selectName changed (by a given original values array) - returns true if so, and false otherwise
function selectValuesChanged(selectName, values) {
	var selectElement;
	for (var v=0 ; v < document.wizardSteps.elements.length ; v++) {
		selectElement = document.wizardSteps.elements[v];
		equal = (selectElement.id.substr(0,selectName.length) == selectName);
		if ( equal && (!selectElement.disabled) ) {
			if (!values.inArray(selectElement.options[selectElement.selectedIndex].value)) {return true;}
		}
	}
	return false;
}

/*************************/
/*	Tool bar functions   */
/*************************/
function legalToolBarOperation(form, operation) {
	if ((operation == null) || (operation == "")) {
		alert('Choose a tool please');
		return false;
	}
	
	if (form == null) {return false;}
	
	var count = 0;
	//check that there is only one set of files selected.
	if (operation == "filtering" || operation == "haplotyping" || operation == "simpleZoom") {
		for (var v = 0; v < form.elements.length; v++) {
			if (form.elements[v].checked) {count++;}
			if (count > 1) {
				var toolToDisplay = (operation == "simpleZoom") ? "zooming" : operation;
				alert(toolToDisplay+' is allowed for one file only!');
				return false;
			}
		}
	}
	
	if (operation == "simpleZoom") {									// check that
		if (count == 0) {
			alert('Please choose input for zooming!');
			return false;
		}
		return true;
	}
	
	if (operation == "filtering") {									// check that
		if (count == 0) {
			alert('Please choose input for filtering!');
			return false;
		}
		return true;
	}
	
	if ( (operation == "clustering") || (operation == "cleaning") ) {									// check that
		var count = 0;
		var elem;
		for (var v = 0; v < form.elements.length; v++) {
			elem = form.elements[v];
			if (elem.checked) {
				if (elem.value.indexOf('cluster') != -1) {
					alert('You chose a clustered file for '+operation+'. Clustered files cannot be re-clustered');
					return false;
				}
				count++;
			}
		}
		if (count == 0) {
			alert('Please choose input for data reduction!');
			return false;
		}
		return true;
	}
	
	if ( (operation == "multiPoint") || (operation == "twoPoint") || (operation == "haplotyping") ||
			(operation == "segregation")  || (operation == "lm_markers") || (operation == "gl_auto")) {									// check that
		var count = 0;
		var elem;
		var objRegex;
		var matches;
		var checked = getCheckedElements(form.elements);
		//for (var v = 0; v < form.elements.length; v++) {
		for (var v = 0; v < checked.length; v++) {
			elem = checked[v];
			objRegex = new RegExp(elem.value.split('@')[1]);
			matches = getRegExpValueMatches(objRegex, checked);
			if (matches.length > 1) {
				alert('Only one type of files should be chosen for analysis');
				return false;
			}
		}
		if (checked.length == 0) {
			alert('Please choose input for analysis!');
			return false;
		}
		return true;
	}
	return false;
}

function viewSimplifiedExample(textBoxID){
	var textBox = document.getElementById(textBoxID);
	if (textBox == null){
		return false;
	}
	var exampleStr = 
		"Ggdad	0	0	male	h\n"+
		"Ggmom	0	0	female	h\n"+
		"gdad	Ggdad	Ggmom	male	h\n"+
		"gmom	Ggdad	Ggmom	female	h\n"+
		"Outdad	0	0	male	h\n"+
		"Outmom	0	0	female	h\n"+
		"dad	gdad	Outmom	male	h\n"+
		"mom	Outdad	gmom	female	h\n"+
		"son1	dad	mom	male	a\n"+
		"son2	dad	mom	male	a\n"+
		"son3	dad	mom	male	a\n"+
		"son4	dad	mom	male	a";
	textBox.value = exampleStr;
	return true;
}

function changecss(theClass,element,value) {
	//Last Updated on June 23, 2009
	//documentation for this script at
	//http://www.shawnolson.net/a/503/altering-css-class-attributes-with-javascript.html
	var cssRules;
	var added = false;
	for (var S = 0; S < document.styleSheets.length; S++) {

		if (document.styleSheets[S]['rules']) {cssRules = 'rules';}
		else if (document.styleSheets[S]['cssRules']) {cssRules = 'cssRules';}
		//else {//no rules found... browser unknown }

		for (var R = 0; R < document.styleSheets[S][cssRules].length; R++) {
			if (document.styleSheets[S][cssRules][R].selectorText == theClass) {
				if(document.styleSheets[S][cssRules][R].style[element]) {
					document.styleSheets[S][cssRules][R].style[element] = value;
					added=true;
					break;
				}
			}
		}
		if(!added){
			if(document.styleSheets[S].insertRule){
				document.styleSheets[S].insertRule(theClass+' { '+element+': '+value+'; }',document.styleSheets[S][cssRules].length);
			} else if (document.styleSheets[S].addRule) {document.styleSheets[S].addRule(theClass,element+': '+value+';');}
		}
	}
}

function changecss(theClass,element,value) {
	//Last Updated on June 23, 2009
	//documentation for this script at
	//http://www.shawnolson.net/a/503/altering-css-class-attributes-with-javascript.html
	 var cssRules;

	 var added = false;
	 for (var S = 0; S < document.styleSheets.length; S++){

    if (document.styleSheets[S]['rules']) {
	  cssRules = 'rules';
	 } else if (document.styleSheets[S]['cssRules']) {
	  cssRules = 'cssRules';
	 } else {
	  //no rules found... browser unknown
	 }

	  for (var R = 0; R < document.styleSheets[S][cssRules].length; R++) {
	   if (document.styleSheets[S][cssRules][R].selectorText == theClass) {
	    if(document.styleSheets[S][cssRules][R].style[element]){
	    document.styleSheets[S][cssRules][R].style[element] = value;
	    added=true;
		break;
	    }
	   }
	  }
	  if(!added){
	  if(document.styleSheets[S].insertRule){
			  document.styleSheets[S].insertRule(theClass+' { '+element+': '+value+'; }',document.styleSheets[S][cssRules].length);
			} else if (document.styleSheets[S].addRule) {
				document.styleSheets[S].addRule(theClass,element+': '+value+';');
			}
	  }
	 }
}

/*********************** AJAX FTW ***********************/

// Get the HTTP Object
function getHTTPObject(){
	if 		(window.ActiveXObject)  { return new ActiveXObject("Microsoft.XMLHTTP"); }
	else if (window.XMLHttpRequest) { return new XMLHttpRequest(); }
	else {
		alert("Your browser does not support AJAX.");
		return null;
	}
}

// Change the value of the outputText field
function setOutput(){
	if (httpObject.readyState == 4){
		document.getElementById('chrom_01_cleaning').innerHTML = httpObject.responseText;
	}
}

// Implement business logic
// a job should be in the form: <name>*<method>
function doWork(project, experiment, jobsArray) {
	var httpObject = getHTTPObject();
	var allJobs = "";
	for(i=0 ; i < jobsArray.length ; i++) {
		allJobs = allJobs+"&jobs[]="+jobsArray[i];
		if (allJobs.length > 1800) { break; }			// WTF ?!?!?
	}
	if (httpObject == null) { return; }					//error
	httpObject.open("GET", "getProgress.php?proj="+project+"&exp="+experiment+allJobs, true);
	httpObject.send(null);
	httpObject.onreadystatechange = function() {		
		if (httpObject.readyState == 4) {
			//alert(name+'_'+method+":   "+httpObject.responseText);
			//alert(httpObject.responseText);
			updatedArray = (httpObject.responseText).split("#");
			for(i=0 ; i < updatedArray.length ; i++) {
				job = (updatedArray[i]).split("*");
				name 	= job[0];
				newVal 	= job[1];
				//if (i==0) {alert(name+":   "+newVal);}
				//alert(document.getElementById(name).innerHTML + "\n VS \n" + newVal);
				if ( (document.getElementById(name) == null) || (document.getElementById(name).innerHTML.toLowerCase() == newVal.toLowerCase()) ||
					 (/check/.test(document.getElementById(name).innerHTML.toLowerCase())) ) { continue; }
				document.getElementById(name).innerHTML = newVal;
			}
		}
	}
}

function PerformAjaxReuqest(parameters, updateObjectID, ajaxJob){
	if (ajaxJob == 'chroms'){
		var Element = document.getElementById(updateObjectID);
		if (Element == null) { return; }
		Element.innerHTML = "";		// add new node...
	}
	else{
	//if (ajaxJob == 'mapValues'){
		var Element = document.getElementById(updateObjectID);
		if (Element == null) { return; }
		Element.innerHTML = "Please wait, processing...<br/><img src=\"./images/waitspinner.gif\">";		// add new node...
	}

	
	var httpObject = getHTTPObject();
	if (httpObject != null){
		var request = '';
		for (var key in parameters) {
			if (key == 'inArray') { continue; }
			request = request + key + '=' + parameters[key] + '&';
		}
		
		//httpObject.open("GET", "processAjaxRequest.php?proj="+project+"&exp="+experiment+"&"+ajaxJob+"=true", true);
		httpObject.open("GET", "processAjaxRequest.php?"+request+ajaxJob+"=true", true);
		httpObject.send(null);
		httpObject.onreadystatechange = function(){
			if (httpObject.readyState == 4){
				//alert(name+'_'+method+":   "+httpObject.responseText);
				//alert(httpObject.responseText);
				if (ajaxJob == 'chroms'){
					var selectElement = document.getElementById(updateObjectID);
					if (selectElement == null) { return; }
					selectElement.innerHTML = "";		// add new node...
					updatedArray = (httpObject.responseText).split("#");
					for(i=0 ; i < updatedArray.length ; i++) {
						name = updatedArray[i];
						var newOption = document.createElement('option');
						newOption.text = name;
						newOption.value = name;
					    selectElement.add(newOption); // IE only
					}
				}
				else {
					var Element = document.getElementById(updateObjectID);
					if (Element == null) { return; }
					Element.innerHTML = "";
					Element.innerHTML = httpObject.responseText;
				}
			}
		}
	}
}

function PerformAjaxReuqestGeneral(callback, parameters, updateObjectID, spinner){
	if ( (spinner != null) && (spinner == true) ){
		var Element = document.getElementById(updateObjectID);
		if (Element == null) { return; }
		Element.innerHTML = "Please wait, processing...<br/><img src=\"./images/waitspinner.gif\">";		// add new node...
	}

	var httpObject = getHTTPObject();
	if (httpObject != null){
		var request = '';
		for (var key in parameters) {
			if (key == 'inArray') { continue; }
			request = request + key + '=' + parameters[key] + '&';
		}
		
		//httpObject.open("GET", "processAjaxRequest.php?proj="+project+"&exp="+experiment+"&"+ajaxJob+"=true", true);
		httpObject.open("GET", callback+"?"+request, true);
		httpObject.send(null);
		httpObject.onreadystatechange = function(){
			if (httpObject.readyState == 4){
				//alert(name+'_'+method+":   "+httpObject.responseText);
				//alert(httpObject.responseText);
				var Element = document.getElementById(updateObjectID);
				if (Element == null) { return; }
				Element.innerHTML = "";
				Element.innerHTML = httpObject.responseText;
			}
		}
	}
}


/*****************************************************************************/
/*
 * this function used to filter empty elements in an array
 */
function notEmptyData (data) {
	return (data!=null && data!="");
}


/*
 * return: the number of markers in this project
 *			0 if pedigrees data is not valid.
 */
function getNumberOfMarkers (nameOfForm) {
	var pedigrees = document.forms[nameOfForm]["pedigrees"].value;
	if (pedigrees == null || pedigrees == "") {
		alert ("pleas enter the pedigrees data");
		return 0;
	}
	pedLinesArray = (pedigrees.split("\n")).filter(notEmptyData); //split the pedigree data to array of lines, and delete empty lines.
	var numOfMarkers = 0;
	for (i=0; i<pedLinesArray.length; i++) {
		pedLinesArray[i] = trim(pedLinesArray[i]);
		var lineSplits = pedLinesArray[i].split(/\s+/g);
		if (lineSplits[0] != "pedigree:") {
			var merkersInLine = lineSplits.length - 5; //5 for: id father mother sex status
			if (numOfMarkers == 0) {numOfMarkers = merkersInLine;}
			else if (merkersInLine != numOfMarkers) {
				i++; //humen count from 1 and not from 0
				alert ("Error: the pedigree data contains different number of markers\nbetween the line of person 1 and line "+i+".");
				return 0;
			}
		}
	}
	if (numOfMarkers <= 0) {
		alert ("Error: the pedigree data is empty or incorrect");
		return 0;
	} else if (numOfMarkers%2 != 0) {
		alert ("Error: there is a marker whith a single allele");
		return 0;
	}
	return (numOfMarkers/2);
}


/*
 * check the basic correctness on the input in the simplified input form
 */
function wizardMan1DataCheck(nameOfForm) {
	var numberOfMarkers = getNumberOfMarkers(nameOfForm);
	if (numberOfMarkers == 0) {
		return false;
	}
	
	var geneFrequency = document.forms[nameOfForm]["geneFrequency"].value;
	var pedigrees = document.forms[nameOfForm]["pedigrees"].value;
	if (geneFrequency == null || geneFrequency == "") {
		alert ("Please enter the disease mutant gene frequency");
		return false;
	}
	if (isNaN(geneFrequency) || geneFrequency < 0 || geneFrequency > 1) {
		alert ("Error: disease mutant gene frequency should only be a number between 0 and 1");
		return false;
	}

	var markerDistances = document.forms[nameOfForm]["markerDistances"].value;
	if (numberOfMarkers > 1 && (markerDistances == null || markerDistances == "")) {
		alert ("Please enter the distances between the markers");
		return false;
	} else if (numberOfMarkers == 1 && markerDistances != null && markerDistances != "") {
		alert ("Error: there is something in the distance field, but only one marker");
		return false;
	}
	if (numberOfMarkers > 1) { //check the values of the distances - only if there are distances.
		var distancesArr = markerDistances.split(","); //splits to distances
		if (distancesArr.length != numberOfMarkers-1) {
			alert ("Error: the number of distances doesn't match the number of markers");
			return false;
		}
		for (i=0; i<distancesArr.length; i++) {
			distance = trim(distancesArr[i]);
			if (distance == "" || isNaN(distance) || distance < 0) {
				alert ("Error: The value at index "+i+" with the value of "+distancesArr[i]+" is not a distance");
				return false;
			}
		}
		if (distancesArr.length != numberOfMarkers-1) {
			alert ("Error: the number of distances is incorrect");
			return false;
		}
	}

	//check the names only if the text box is checked
	if (document.forms[nameOfForm]["enableMarkerNames"].checked == true) {
		var markerNames = document.forms[nameOfForm]["markerNames"].value;
		var markerNamesArr = markerNames.split(",");
		if (markerNamesArr.length > numberOfMarkers) {
			alert ("Error: the number of marker names is bigger than the number of markers\n(or some of the names contains illigal characters in it)");
			return false;
		}
		for (i=0; i<markerNamesArr.length; i++) {markerNamesArr[i] = trim(markerNamesArr[i]);}
		markerNamesArr.sort();
		for (i=1; i<markerNamesArr.length; i++) {
			if (markerNamesArr[i-1] == markerNamesArr[i] && markerNamesArr[i] != "") {
				alert ("Error: there are two markers with the name "+markerNamesArr[i]);
				return false;
			}
		}
	}
	return true;
}

/*
 * as trim in php - return a new string without white spaces at the begining and the end of the string
 */
function trim(stringToTrim) {
	return stringToTrim.replace(/^\s+|\s+$/g,"");
}

/*
 * return the display name of a tool
 */
function toolDisplayName (tool) {
	switch (tool) {
		case "EliminatingAndCluster":	return "cleaning and clustering"; break;
		case "EliminatingOnly":			return "cleaning"; break;
		case "ClusteringOnly":			return "clustering"; break;
		case "filter":					return "filtering"; break;
		case "zoom":					return "zooming"; break;
		case "MultiPoint":				return "Multipoint"; break;
		case "MultiPointHMM":			return "MultiPointHMM"; break;
		case "TwoPoint":				return "TwoPoint"; break;
		case "lm_markers":				return "Morgan lm_linkage"; break;
		case "gl_auto":					return "Morgan gl_auto"; break;
		case "Haplotyping":				return "Haplotyping"; break;
		case "Segregation":				return "Segregation"; break;
		default:						return "";
	}
}
