<?php
	require_once("log.php");
	require_once("config.php");
	require_once("layout.php");
	require_once("toolsFlowNew.php");
	require_once("fileHandleFunctions.php");
	require_once("datpedCreator.php");
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
            "http://www.w3.org/TR/html4/loose.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Superlink Online</title>
<meta http-equiv="Content-Type" content="text/html; charset=windows-1255" />
<link href="style.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="site_layout">
	<div class="site_header">
		<div id="logoImg">
			<a href="main.php"><img src="images/index_01.gif"	height="136" alt="" border="0"/ ></a>
		</div>
		<div id="dnaPic">
			<img src="images/index_02.gif" alt="" border="0" height="136" width="560" />
		</div>
	</div>

	<div id="userBar">
		<table width="100%" style="text-indent: 10px;">
			<tr>
				<td width="75%">
					<?php
						print "Welcome, " . $_SESSION["name"];
					?>
				</td>
				<td width="25%" style="text-align: right; padding-right: 10px">
					<?php print date("F j, Y"); ?>
				</td>
			</tr>
		</table>
	</div>

	<table>
		<tr>
		<td width="130" style="vertical-align: top;">
			<div id="Menu">
				<?php showMainMenu(); ?>
			</div>
		</td>
		<td width="100%" height="550" style="vertical-align: top;">
			<div id="Center">
	<h1>Tools</h1>
	<hr/>
	<p>
	
	<?php	
	$ReductionTools				= array("Clustering", "Cleaning");
	
	if (!isValidInput()) {reportErrorAndExit();}
	
	$experimentsDir = USER_PROJECTS_DIR."/".$_GET["ProjectChoice"]."/experiments";			
	$subdir = isset($_GET["ExperimentChoice"]) ? "experiments/".$_GET["ExperimentChoice"] : "raw";
	$inputDir = USER_PROJECTS_DIR."/".$_GET["ProjectChoice"]."/".$subdir;
	$expDir = $experimentsDir."/".$_GET["experimentName"];
	
	#check input validity
	if (!is_dir($inputDir)) {
		reportErrorAndExit("Input path is incorrect. Go back to the tools page, and try again.");
	}
	if (is_dir($expDir)) {
		$msgPrefix = "";
		if (is_file($expDir."/".DELETED_FLAG)) {
			$msgPrefix = "A deleted and may be restorable experiment named ".$_GET["experimentName"]." exists.";
		}								
		else {$msgPrefix = "Experiment named ".$_GET["experimentName"]." already exists.";}
		reportErrorAndExit($msgPrefix." Go back to the tools page, and try again.");
	}		
	
	#Initialize a new variables table for this new experiment
	$varsTable = array();
	
	#Check if this project uses SNP data
	if (isset($_GET['parent'])) {
		$parentDir = $experimentsDir."/".$_GET['parent'];
		$parentTable = getVariablesTable($parentDir);
		if (isset($parentTable[SNP_SOURCE_EXPERIMENT]) && ($parentTable[SNP_SOURCE_EXPERIMENT] == "true")) {
			$varsTable[SNP_SOURCE_EXPERIMENT] = "true";
		}
	}
	
	#If a markers list was used for this experiment, add it to the variables table
	if (isset($_GET['MarkersList'])) {
		$list = in_array($_GET['toolsChoice'], $ReductionTools) ? KEY_REDUCTION_MARKERS_LIST : KEY_MARKERS_LIST;
		$markersList = $_GET['MarkersList'];
		$markersList = trim(preg_replace('/\s+/', ',', $markersList));  #Remove extra whitespaces		
		$markersList = trim(preg_replace('/,+/', ',', $markersList));  #Remove consecutive commas		
		$varsTable[$list] = implode(",", array_map("removeInitialLetter", explode(",",$markersList)));		
	}
	
	#If a start and end markers were specified for this experiment, add it to the variables table
	if (isset($_GET['StartMarker']) && isset($_GET['EndMarker'])) {
		if ( isset($_GET['WindowBox']) && isset($_GET['WindowSize']) ) {
			$varsTable[KEY_START_MARKER] 	= removeInitialLetter($_GET['StartMarker']);
			$varsTable[KEY_END_MARKER] 		= removeInitialLetter($_GET['EndMarker']);
			$varsTable[KEY_WINDOW_SIZE] 	= $_GET['WindowSize'];								
		}
		else {
			$start = removeInitialLetter($_GET['StartMarker']);
			$end = ($_GET['EndMarker'] === "xlast") ? getDatMarkersAmount(getDatFromInput($inputDir, $input)) : removeInitialLetter($_GET['EndMarker']);								
			$varsTable[KEY_START_MARKER] = $start;
			$varsTable[KEY_END_MARKER] 	 = $end;			
			if ($start != '' and $end != '') {$varsTable[KEY_WINDOW_SIZE]	 = $end - $start + 1;}
		}
	}
	
	#Create automation options if needed
	if (isset($_GET['automate']) && ($_GET['automate'] == "on")) {
		system("touch $expDir/.automate");		
		$varsTable[KEY_AUTOMATE_MAXVAR] 	= ($_GET[KEY_AUTOMATE_MAXVAR] == "") ? VAL_AUTOMATE_MAXVAR_DEFAULT : $_GET[KEY_AUTOMATE_MAXVAR];
		$varsTable[KEY_AUTOMATE_MINVAR] 	= ($_GET[KEY_AUTOMATE_MINVAR] == "") ? VAL_AUTOMATE_MINVAR_DEFAULT : $_GET[KEY_AUTOMATE_MINVAR];
		$varsTable[KEY_AUTOMATE_MINAREASIZE]= ($_GET[KEY_AUTOMATE_MINAREASIZE] == "") ? VAL_AUTOMATE_MINAREASIZE_DEFAULT : $_GET[KEY_AUTOMATE_MINAREASIZE];
		$varsTable[KEY_AUTOMATE_LOWRATE] 	= ($_GET[KEY_AUTOMATE_LOWRATE] == "") ? VAL_AUTOMATE_LOWRATE_DEFAULT : $_GET[KEY_AUTOMATE_LOWRATE];
		$varsTable[KEY_AUTOMATE_MAXLOWAREA]	= ($_GET[KEY_AUTOMATE_MAXLOWAREA] == "") ? VAL_AUTOMATE_MAXLOWAREA_DEFAULT : $_GET[KEY_AUTOMATE_MAXLOWAREA];
		$varsTable[KEY_AUTOMATE_MAXTHRESH] 	= ($_GET[KEY_AUTOMATE_MAXTHRESH] == "") ? VAL_AUTOMATE_MAXTHRESH_DEFAULT : $_GET[KEY_AUTOMATE_MAXTHRESH];
	}
	
	#Create fields in variables table according to the experiment type and run it
	switch($_GET["toolsChoice"]) {
		case "Clustering":
			$varsTable[KEY_RUN_MODE] = VAL_RUN_MODE_CLUSTER_ONLY;
			$varsTable[KEY_CLUSTERING_DISTANCE] = $_GET['ClusteringMarkersDistance'];		
			createReductionExperiment($varsTable, $experimentsDir, $expDir, $inputDir);
			break;
		case "Cleaning":
			$varsTable[KEY_RUN_MODE] = VAL_RUN_MODE_CLEAN_ONLY;								
			$varsTable[KEY_CLEANING_THRESHOLD] = "Strong";
			createReductionExperiment($varsTable, $experimentsDir, $expDir, $inputDir);
			break;
		case "Zooming":
			createZoomingExperiment($varsTable, $experimentsDir, $expDir, $inputDir);
			break;
		case "Filtering":
			createFilterExperiment($varsTable, $experimentsDir, $expDir, $inputDir);
			break;
		case "MultiPointAnalysis":			
			$varsTable[KEY_RUN_ANALYSIS] 		= VAL_RUN_ANALYSIS_MULTIPOINT;			
			createAnalysisExperiment($varsTable, $experimentsDir, $expDir, $inputDir);
			break;
		case "TwoPointAnalysis":
			unset($varsTable[KEY_RUN_ANALYSIS]);
			$varsTable[KEY_RUN_ANALYSIS] 		= VAL_RUN_ANALYSIS_TWOPOINT;			
			createAnalysisExperiment($varsTable, $experimentsDir, $expDir, $inputDir);
			break;
		case "lm_markers":
			createLmMarkersExperiment($varsTable, $experimentsDir, $expDir, $inputDir);
			break;
		case "gl_auto":
			createGlAutoExperiment($varsTable, $experimentsDir, $expDir, $inputDir);
			break;
		case "Haplotyping":			
			$varsTable[KEY_RUN_ANALYSIS] 		= VAL_RUN_ANALYSIS_HAPLOTYPING;
			if (isset($_GET['lars']) && ($_GET['lars'] == true)) {$varsTable[KEY_RUN_ANALYSIS] = "HaplotypingLars";}					
			createAnalysisExperiment($varsTable, $experimentsDir, $expDir, $inputDir);
			break;
		default: break;
	}
	
	echo "<br><br>A new experiment named <strong>".$_GET["experimentName"]."</strong> has been created under project: ".$_GET["ProjectChoice"].".<br/>";
	echo $_GET["toolsChoice"] . " tool is now running with the chosen input.<br/>";	
	?>
		<br/><br/>
		For the project page, click <a href="projects.php?proj=<?php echo $_GET["ProjectChoice"]; ?>">here</a>.<br/>
		For the experiment details and files, click
		<a href="projects.php?proj=<?php echo $_GET["ProjectChoice"]; ?>&exp=<?php echo $_GET["experimentName"];?>"> here
		</a>.<br/>
	<?php	
	
	#Add this experiment to its parent's derived experiments list
	if (isset($_GET['parent'])) {
		$parentDir = $experimentsDir."/".$_GET['parent'];
		$parentTable = getVariablesTable($parentDir);
		$parentTable[KEY_DERIVED_EXPERIMENTS] = (isset($parentTable[KEY_DERIVED_EXPERIMENTS]) ? $parentTable[KEY_DERIVED_EXPERIMENTS]."," : "").$_GET["experimentName"];
		createVariablesFile($parentDir, $parentTable);
	}
	
	
	createEndOfHTMLPage();
#########################################################################################################

function createLmMarkersExperiment(&$varsTable, $experimentsDir, $expDir, $inputDir) {

	#Verify that the markers range is valid for all inputs
	checkMarkerRange($varsTable, $inputDir);
	
	#Compute the CPU hours required for the computation
	$numWindows = 0;
	foreach ($_GET["FileChoice"] as $input) {
		$numMarkers = 0;

		#Omer - the option "All" is currently not supported by Morgan but
		#I added support for this in case things will change in the future
		if ($_GET["InputRadio"] == "All") {
			$numMarkers = getDatMarkersAmount(getDatFromInput($inputDir, $input))-1;
		}
		elseif ($_GET["InputRadio"] == "Range") {
			#Omer - this is what happens in case both the start and end fields are blank
			$numMarkers = getDatMarkersAmount(getDatFromInput($inputDir, $input))-1;
			if (isset($_GET['StartMarker']) && isset($_GET['EndMarker'])) {											
				$start = $_GET['StartMarker'];
				$end = $_GET['EndMarker'];
				if ($start != "" and $end != "") {$numMarkers = $end - $start + 1;}
				elseif ($start != "") {$numMarkers = $numMarkers - $start + 1;}
				elseif ($end != "") {$numMarkers = $end;}											
			}
		}
		elseif ($_GET["InputRadio"] == "List") {$numMarkers = count(explode(",", $_GET['MarkersList']));}
		else {reportErrorAndExit("Input error. Please try again.");}

		#Find number of windows required for this file
		if (isset($_GET["WindowBox"]) and isset($_GET["WindowSize"]) and $_GET["WindowBox"]) {
			$numWindows += ceil($numMarkers / $_GET["WindowSize"]);
		}
		else {$numWindows += 1;}
	}
	
	#Check if the computation is feasible or not								
	if ($_GET[MORGAN_RUN_TYPE] == MORGAN_RUN_BY_TIME_VAL) {
		$numFamilies = getPedFamiliesAmount(getPedFromInput($inputDir, $input));                                
		$numRequiredTasks = $numWindows * $numFamilies * NUMBER_DUPLICATIONS_PER_JOB;
		$maxPossibleTasks = ceil(MAX_TIME_PER_JOB / $_GET[MORGAN_TIME_PER_WINDOW]) * MAX_JOBS_PER_TASK;                                
		if ($numRequiredTasks > $maxPossibleTasks) {
			error_msg("Too many computations required.");                                    
			error_msg("Required computation time: ".
			round($numRequiredTasks*$_GET[MORGAN_TIME_PER_WINDOW]/3600,1)." hours. (".
			$numWindows. " windows ".(($numFamilies>1) ? ("* ".$numFamilies." families ") : "").
			"* ".NUMBER_DUPLICATIONS_PER_JOB." computations per window * ".
			$_GET[MORGAN_TIME_PER_WINDOW]." seconds per computation)");				
			$error_msg = "Maximum allowed computation time: ".round($maxPossibleTasks*$_GET[MORGAN_TIME_PER_WINDOW]/3600,1)." hours.";
			reportErrorAndExit($error_msg);
		}
	}
	
	$varsTable[KEY_RUN_ANALYSIS] 			 	= VAL_RUN_ANALYSIS_LM_MARKERS;
	$varsTable[KEY_MAX_JOBS_PER_TASK] 		 	= MAX_JOBS_PER_TASK;
	$varsTable[KEY_MAX_TIME_PER_JOB] 		 	= MAX_TIME_PER_JOB;
	$varsTable[KEY_MIN_DESIRED_TIME_PER_JOB] 	= MIN_DESIRED_TIME_PER_JOB;
	$varsTable[KEY_NUMBER_DUPLICATIONS_PER_JOB] = NUMBER_DUPLICATIONS_PER_JOB;
	
	#Omer - the time and iteration parameters are taken from the GUI
	if ($_GET[MORGAN_RUN_TYPE] == MORGAN_RUN_BY_TIME_VAL) {
		$varsTable[KEY_TIME_OF_WINDOW_IN_SECONDS] 	= $_GET['timePerWindow'];
		$varsTable[KEY_MIN_NUM_ITERATIONS] = MIN_NUM_ITERATIONS;
		$varsTable[KEY_MAX_NUM_ITERATIONS] = MAX_NUM_ITERATIONS;
	} else {
		$varsTable[KEY_TIME_OF_WINDOW_IN_SECONDS] 	= MAX_TIME_PER_JOB;
		$varsTable[KEY_MIN_NUM_ITERATIONS] = $_GET[MORGAN_ITERATIONS_PER_WINDOW];
		$varsTable[KEY_MAX_NUM_ITERATIONS] = $_GET[MORGAN_ITERATIONS_PER_WINDOW];			
	}
	
	#Omer - the burn-in percentage and sequential imputations parameters could be taken from the GUI
	if (isset($_GET[MORGAN_ADVANCED_OPTIONS]) and $_GET[MORGAN_ADVANCED_OPTIONS]) {
		if (isset($_GET[MORGAN_BURN_IN_ITERATIONS])) {
			$varsTable[KEY_BURN_IN_ITERATIONS_PERCENTAGE] 	= $_GET[MORGAN_BURN_IN_ITERATIONS];
		}
		if (isset($_GET[MORGAN_IMPUTATION_REALIZATIONS])) {
			$varsTable[KEY_SEQ_IMP_REALIZATIONS_PERCENTAGE] = $_GET[MORGAN_IMPUTATION_REALIZATIONS];
		}
	}
	
	#Create an experiment folder
	if (!createExperimentFolder($experimentsDir, $_GET["experimentName"], false, false, true)) {reportErrorAndExit();}
	if (!createVariablesFile($expDir, $varsTable)) {rmdir_r($expDir); reportErrorAndExit();}
	
	#Omer 31/7/2011 - create parameters file for Morgan
	createLMMarkersParametersFile($expDir);
	
	#Create experiment input files
	foreach ($_GET["FileChoice"] as $input) {
		$fileName = createExpInput($inputDir, $expDir, $input);
		initProgressForFile($expDir, $fileName, array('analysis'));
	}
	
	#Run the experiment
	$runName = sendExperiment($expDir, "");
	if ($runName == "1") {rmdir_r($expDir); reportErrorAndExit();}
	
	#Create GUI parameters file
	createMorganGuiParams ($expDir);
}

/*
 * this function writes all the morgan related parameters that will be displayed to the user
 */
function createMorganGuiParams ($dir) {
	$varTable[MORGAN_RUN_TYPE] = $_GET[MORGAN_RUN_TYPE];
	if ($_GET[MORGAN_RUN_TYPE] == MORGAN_RUN_BY_TIME_VAL) { 
		$varTable[MORGAN_TIME_PER_WINDOW] = $_GET[MORGAN_TIME_PER_WINDOW];
	} else { $varTable[MORGAN_ITERATIONS_PER_WINDOW] = $_GET[MORGAN_ITERATIONS_PER_WINDOW]; }
	
	if (!isSet($_GET[MORGAN_ADVANCED_OPTIONS])) { $varTable[MORGAN_ADVANCED_OPTIONS] = "0"; }
	else {
		$varTable[MORGAN_ADVANCED_OPTIONS] = "1";
		$varTable[MORGAN_BURN_IN_ITERATIONS] = $_GET[MORGAN_BURN_IN_ITERATIONS];
		$varTable[MORGAN_L_SAMPLER_PROBABILITY] = $_GET[MORGAN_L_SAMPLER_PROBABILITY];
		$varTable[MORGAN_MEIOSES_INITIALAZATION] = $_GET[MORGAN_MEIOSES_INITIALAZATION];
		if (isset($_GET[MORGAN_IMPUTATION_REALIZATIONS])) {
			$varTable[MORGAN_IMPUTATION_REALIZATIONS] = $_GET[MORGAN_IMPUTATION_REALIZATIONS];
		}
		$varTable[MORGAN_MEIOSES_SAMPLER] = $_GET[MORGAN_MEIOSES_SAMPLER];
	}
	createGuiVarFile($dir, $varTable);
}

function createGlAutoExperiment(&$varsTable, $experimentsDir, $expDir, $inputDir) {
	#Verify that the markers range is valid for all inputs
	checkMarkerRange($varsTable, $inputDir);
	
	#Compute the CPU hours required for the computation
	$numWindows = 0;
	foreach ($_GET["FileChoice"] as $input) {
		$numMarkers = 0;

		#the option "All" is currently not supported by Morgan but
		#I added support for this in case things will change in the future
		if ($_GET["InputRadio"] == "All") {
			$numMarkers = getDatMarkersAmount(getDatFromInput($inputDir, $input))-1;
		}
		elseif ($_GET["InputRadio"] == "Range") {
			#this is what happens in case both the start and end fields are blank
			$numMarkers = getDatMarkersAmount(getDatFromInput($inputDir, $input))-1;
			if (isset($_GET['StartMarker']) && isset($_GET['EndMarker'])) {											
				$start = $_GET['StartMarker'];
				$end = $_GET['EndMarker'];
				if ($start != "" and $end != "") {$numMarkers = $end - $start + 1;}
				elseif ($start != "") {$numMarkers = $numMarkers - $start + 1;}
				elseif ($end != "") {$numMarkers = $end;}											
			}
		}
		elseif ($_GET["InputRadio"] == "List") {$numMarkers = count(explode(",", $_GET['MarkersList']));}
		else {reportErrorAndExit("Input error. Please try again.");}

		#Find number of windows required for this file
		if (isset($_GET["WindowBox"]) and isset($_GET["WindowSize"]) and $_GET["WindowBox"]) {
			$numWindows += ceil($numMarkers / $_GET["WindowSize"]);
		}
		else {$numWindows += 1;}
	}
	
	#Check if the computation is feasible or not								
	if ($_GET[MORGAN_RUN_TYPE] == MORGAN_RUN_BY_TIME_VAL) {
		$numFamilies = getPedFamiliesAmount(getPedFromInput($inputDir, $input));                                
		$numRequiredTasks = $numWindows * $numFamilies * NUMBER_DUPLICATIONS_PER_JOB;
		$maxPossibleTasks = ceil(MAX_TIME_PER_JOB / $_GET[MORGAN_TIME_PER_WINDOW]) * MAX_JOBS_PER_TASK;                                
		if ($numRequiredTasks > $maxPossibleTasks) {
			error_msg("Too many computations required.");                                    
			error_msg("Required computation time: ".
			round($numRequiredTasks*$_GET[MORGAN_TIME_PER_WINDOW]/3600,1)." hours. (".
			$numWindows. " windows ".(($numFamilies>1) ? ("* ".$numFamilies." families ") : "").
			"* ".NUMBER_DUPLICATIONS_PER_JOB." computations per window * ".
			$_GET[MORGAN_TIME_PER_WINDOW]." seconds per computation)");				
			$error_msg = "Maximum allowed computation time: ".round($maxPossibleTasks*$_GET[MORGAN_TIME_PER_WINDOW]/3600,1)." hours.";
			reportErrorAndExit($error_msg);
		}
	}
	
	$varsTable[KEY_RUN_ANALYSIS] 			 	= VAL_RUN_ANALYSIS_GL_AUTO;
	$varsTable[KEY_MAX_JOBS_PER_TASK] 		 	= MAX_JOBS_PER_TASK;
	$varsTable[KEY_MAX_TIME_PER_JOB] 		 	= MAX_TIME_PER_JOB;
	$varsTable[KEY_MIN_DESIRED_TIME_PER_JOB] 	= MIN_DESIRED_TIME_PER_JOB;
	$varsTable[KEY_NUMBER_DUPLICATIONS_PER_JOB] = 1;
	
	#the time and iteration parameters are taken from the GUI
	if ($_GET[MORGAN_RUN_TYPE] == MORGAN_RUN_BY_TIME_VAL) {
		$varsTable[KEY_TIME_OF_WINDOW_IN_SECONDS] 	= $_GET['timePerWindow'];
		$varsTable[KEY_MIN_NUM_ITERATIONS] = MIN_NUM_ITERATIONS;
		$varsTable[KEY_MAX_NUM_ITERATIONS] = MAX_NUM_ITERATIONS;
	} else {
		$varsTable[KEY_TIME_OF_WINDOW_IN_SECONDS] 	= MAX_TIME_PER_JOB;
		$varsTable[KEY_MIN_NUM_ITERATIONS] = $_GET[MORGAN_ITERATIONS_PER_WINDOW];
		$varsTable[KEY_MAX_NUM_ITERATIONS] = $_GET[MORGAN_ITERATIONS_PER_WINDOW];			
	}
	
	#the burn-in percentage and sequential imputations parameters could be taken from the GUI
	if (isset($_GET[MORGAN_ADVANCED_OPTIONS]) and $_GET[MORGAN_ADVANCED_OPTIONS]) {
		if (isset($_GET[MORGAN_BURN_IN_ITERATIONS])) {
			$varsTable[KEY_BURN_IN_ITERATIONS_PERCENTAGE] 	= $_GET[MORGAN_BURN_IN_ITERATIONS];
		}
		if (isset($_GET[MORGAN_IMPUTATION_REALIZATIONS])) {
			$varsTable[KEY_SEQ_IMP_REALIZATIONS_PERCENTAGE] = $_GET[MORGAN_IMPUTATION_REALIZATIONS];
		}
	}
	
	#Create an experiment folder
	if (!createExperimentFolder($experimentsDir, $_GET["experimentName"], false, false, true)) {reportErrorAndExit();}	
	if (!createVariablesFile($expDir, $varsTable)) {rmdir_r($expDir); reportErrorAndExit();}	
	
	#create parameters file for Morgan
	createLMMarkersParametersFile($expDir);
	
	#Create experiment input files
	foreach ($_GET["FileChoice"] as $input) {
		$fileName = createExpInput($inputDir, $expDir, $input);
		initProgressForFile($expDir, $fileName, array('analysis'));
	}
	
	#Create GUI parameters file
	createMorganGuiParams ($expDir);
	
	#Run the experiment
	$runName = sendExperiment($expDir, "");	
	if ($runName == "1") {rmdir_r($expDir); reportErrorAndExit();}	
}


function createAnalysisExperiment(&$varsTable, $experimentsDir, $expDir, $inputDir) {
	
	#Verify that the markers range is valid for all inputs
	checkMarkerRange($varsTable, $inputDir);

	#Create an experiment folder
	if (!createExperimentFolder($experimentsDir, $_GET["experimentName"], false, false, true)) {reportErrorAndExit();}	
	
	foreach ($_GET["FileChoice"] as $input) {		
		$fileName = createExpInput($inputDir, $expDir, $input);
		initProgressForFile($expDir, $fileName, array('analysis'));
	}
	
	#Check if HMM should be used for Multipoint analysis
	$useHMM = false;
	if ($_GET["toolsChoice"] == "MultiPointAnalysis" && isset($_GET["hmm"]) && ($_GET["hmm"] === "true")) {
		#If a list was chosen, use HMM
		if (isset($varsTable[KEY_MARKERS_LIST]) && sizeof(explode(",", $varsTable[KEY_MARKERS_LIST])) <= $_GET["hmmMax"]) {$useHMM = true;}

		#If a range was chosen
		elseif (isset($varsTable[KEY_START_MARKER]) && isset($varsTable[KEY_END_MARKER])) {
			#If no window was requested, use HMM
			if (!isset($varsTable[KEY_WINDOW_SIZE]) || $varsTable[KEY_WINDOW_SIZE]=="") {$useHMM = true;}			
			#If the window size equals the range size, use HMM
			elseif (isset($varsTable[KEY_WINDOW_SIZE]) && 
				($varsTable[KEY_END_MARKER] - $varsTable[KEY_START_MARKER] + 1) == $varsTable[KEY_WINDOW_SIZE]) {$useHMM = true;}
		}
	}
	if ($useHMM) {$varsTable[KEY_RUN_ANALYSIS] = VAL_RUN_ANALYSIS_MULTIPOINT_HMM;}
	
	if (!createVariablesFile($expDir, $varsTable)) {rmdir_r($expDir); reportErrorAndExit();}			
	if (!preg_match("/^.*\/users\/(.*)/", $expDir, $userDir)) {rmdir_r($expDir); reportErrorAndExit();}
	$runName = sendExperiment($expDir, "");	
	if ($runName == "1") {rmdir_r($expDir); reportErrorAndExit();}
}



function createFilterExperiment(&$varsTable, $experimentsDir, $expDir, $inputDir) {
	if (!isset($_GET['filteringDistance'])) {
		reportErrorAndExit("Input is incorrect. Go back to the tools page, and try again.");
	}
	
	#Create an experiment folder
	if (!createExperimentFolder($experimentsDir, $_GET["experimentName"], false, false, false)) {reportErrorAndExit();}
	
	#Update variables table	
	$varsTable[KEY_RUN_MODE] = VAL_RUN_MODE_FILTERING;
	createVariablesFile($expDir, $varsTable);
	
	#Create experiment input
	$input = $_GET["FileChoice"][0];
	$filename = createExpInput($inputDir, $expDir, $input);

	#Filter the dat and ped files
	$filteredFiles = filterDatPedByCM($expDir, $filename, $_GET['filteringDistance']);
	if (!$filteredFiles) {rmdir_r($expDir); reportErrorAndExit();}
	$table['header'] = "filter_".$_GET['filteringDistance']."cM_".$filename;
	$table['datfile'] = $filteredFiles['filter_dat'];
	$table['pedfile'] = $filteredFiles['filter_ped'];
	updateExpContentInfo($expDir, $table, false);
	$guiVarTable[FILTERING_DISTANCE] = $_GET['filteringDistance'];
	createGuiVarFile($expDir, $guiVarTable);
}
	

#Operation in case of cleaning and clustering	
function createReductionExperiment(&$varsTable, $experimentsDir, $expDir, $inputDir) {

	#Verify that the markers range is valid for all inputs
	checkMarkerRange($varsTable, $inputDir);

	$cleanFolder = false;
	$cluster = false;
	$flag = "";
	if ($_GET["toolsChoice"] == "Cleaning") {$flag = CLEANING_FLAG; $cleanFolder = true;}	
	elseif ($_GET["toolsChoice"] == "Clustering") {$flag = CLUSTERING_FLAG; $cluster = true;}
	
	#Create an experiment folder
	if (!createExperimentFolder($experimentsDir, $_GET["experimentName"], $cleanFolder, $cluster, false)) {reportErrorAndExit();}		
	if (!createVariablesFile($expDir, $varsTable)) {rmdir_r($expDir); reportErrorAndExit();}
	$progressFile = $expDir."/".PROGRESS_FILENAME;
	
	foreach ($_GET["FileChoice"] as $input) {
		$fileName = createExpInput($inputDir, $expDir, $input);
		initProgressForFile($expDir, $fileName, array('cleaning', 'clustering', 'analysis'));			
	}		
	
	if (!preg_match("/^.*\/users\/(.*)/", $expDir, $userDir)) {rmdir_r($expDir); ReportErrorAndExit();}
	$runName = sendExperiment($expDir, $flag);
	if ($runName == "1") {rmdir_r($expDir); reportErrorAndExit();}
}


function adjustPositionBySnpFile($position, $datFile) {	
	$projDir = USER_PROJECTS_DIR."/".$_GET["ProjectChoice"];		
	$uploadedData = is_file($projDir."/raw/".UPLOADED_DATA_INFO) ? parse_ini_file($projDir."/raw/".UPLOADED_DATA_INFO, true) : false;
	if ($uploadedData and ($uploadedData['general'][KEY_INPUT_TYPE] === "snp")) {
		$OriginalSnp = ".final_".SORTED_SNP_DB_FILENAME;
		$rawDir = $projDir."/raw";					
		//If the marker name contains spaces, this means it's a clustered marker.
		//We'll take the name of the first marker in the cluster
		$markerName = $markerName = getMarkerNameByNumber($datFile, 1);
		$markerNameList = explode(' ',trim($markerName));										
		$markerName = $markerNameList[0];						
		$markerName = preg_replace('/\(\d+\)/', '', $markerName);					
		getSnpLineNumbersOf($rawDir, $OriginalSnp, $markerName, $markerName, $from, $to);
		if ($from) {
			$snpLine = exec("head -".$from." ".$rawDir."/".$OriginalSnp." | tail -1");
			$LineArray = explode("\t", rtrim($snpLine));
			$markerPos = $LineArray[DB_POS_COL] / 1000000;
			$position = max(0, $position-$markerPos);
		}
	}
	
	return $position;
}

	
function createZoomingExperiment(&$varsTable, $experimentsDir, $expDir, $inputDir) {
	#Create an experiment folder
	$cleanFolder = false;
	if (isset($_GET['expandZoomedRegion']) && $_GET['expandZoomedRegion']) {$cleanFolder = true;}
	if (!createExperimentFolder($experimentsDir, $_GET["experimentName"], $cleanFolder, false, false)) {reportErrorAndExit();}	
	
	#Add fields to the variables table
	$varsTable[KEY_RUN_MODE] = "zoom";
	createVariablesFile($expDir, $varsTable);	
	markZoomingFolder($expDir);
	
	//Omer - in case no enlargement of the region was requested, do a simple zoom
	//(focus only on some of the markers that were in the original dat file)	
	$rangeType = $_GET['zoomBy'];
	$input = $_GET["FileChoice"][0];
	if (!isset($_GET['expandZoomedRegion']) or !$_GET['expandZoomedRegion']) {
		$filename = createExpInput($inputDir, $expDir, $input);
		$start = $_GET['zoomingStart'];
		$end = $_GET['zoomingEnd'];
		
		#Adjust positions by SNP file
		if ($rangeType == "positions") {
			$datFile = $expDir."/".$filename.".dat";
			$start = adjustPositionBySnpFile($start, $datFile);
			$end = adjustPositionBySnpFile($end, $datFile);
		}
		
		$zoomedFiles = zoomDatAndPed($expDir, $filename, $start, $end, $rangeType);
		if (!$zoomedFiles) {
			$errorMessage = "An error has occurred, system administrators have been informed.";
			if ($rangeType == "strings") {$errorMessage = $errorMessage ." Please verify that you have entered valid marker names.";}
			rmdir_r($expDir);
			reportErrorAndExit($errorMessage);
		}
		$table['header'] = "zoom_".$_GET['zoomingStart']."_".$_GET['zoomingEnd']."_".$filename;
		$table['datfile'] = $zoomedFiles['zoom_dat'];
		$table['pedfile'] = $zoomedFiles['zoom_ped'];
		updateExpContentInfo($expDir, $table, false);
		$guiVars[ZOOMING_START] = $_GET['zoomingStart'];
		$guiVars[ZOOMING_END] = $_GET['zoomingEnd'];
		$guiVars[ZOOMING_RANGE_TYPE] = $_GET['zoomBy'];
		createGuiVarFile($expDir, $guiVars);
		return;
	}	
	
	
	//Omer 8/8/2011 - We are here in case the user requested to enlarge the region	
	$input = explode("@", $input);
	if (sizeof($input) != 2) {$input[1] = $input; $input[0] = "";}		// in case there's no '@'
	$file	= $input[1];
	$method	= $input[0];
	$space	= ($method == "") ? "" : " ";
	$us		= ($method == "") ? "" : "_";	
	
	$startMarker = $_GET['zoomingStart'];
	$endMarker = $_GET['zoomingEnd'];
	$info = getExpContentInfo($inputDir, $file);
	
	//If the rangetype is numeric, find the names of the appropriate numbers
	if ($rangeType == "numbers") {
		$rangeType = "strings";
		$startMarker = getMarkerNameByNumber($info[$method.$us."datfile"], $startMarker);
		$endMarker = getMarkerNameByNumber($info[$method.$us."datfile"], $endMarker);
		if ($startMarker === -1 or $endMarker === -1) {
			rmdir_r($expDir);			
			reportErrorAndExit("The markers range specified is invalid. Please choose a valid markers range");
		}
	}	
	
	
	//If the rangetype is by position, find the names of the appropriate numbers		
	if ($rangeType == "positions") {		
		#Adjust positions by SNP file
		$datFile = $info[$method.$us."datfile"];		
		$startMarker = adjustPositionBySnpFile($startMarker, $datFile);
		$endMarker = adjustPositionBySnpFile($endMarker, $datFile);
	
		#Find the names of the markers at the start and end positions
		$rangeType = "strings";		
		$startMarker = getMarkerNameByPosition($datFile, $startMarker, true);
		$endMarker = getMarkerNameByPosition($datFile, $endMarker, false);		
		if ($startMarker === -1 or $endMarker === -1) {
			rmdir_r($expDir);
			reportErrorAndExit();
		}
	}
	
	
	//If the marker name contains spaces, this means it's a clustered marker.
	//We'll take the names of the first and last markers in the first and last clusters
	$startMarkerArr = explode(' ',trim($startMarker));
	if (count($startMarkerArr)>1) {
		$startMarker = $startMarkerArr[0];											
		$startMarker = preg_replace('/\(\d+\)/', '', $startMarker);
	}
	$endMarkerArr = explode(' ',trim($endMarker));
	if (count($endMarkerArr)>1) {
		$endMarker = $endMarkerArr[count($endMarkerArr)-1];
		$endMarker = preg_replace('/\(\d+\)/', '', $endMarker);											
	}
	
	
	//Find chromosome number
	$chromNum = explode("_",$file);
	$chromNum = $chromNum[1];
	if ($chromNum != "x" and $chromNum != "X") {$chromNum = strval(intval($chromNum));}                                        
	
	//Create the zoomed SNP file
	$projDir = USER_PROJECTS_DIR."/".$_GET["ProjectChoice"];
	$OriginalSnp = ".final_".SORTED_SNP_DB_FILENAME;
	$newSnp = ".final_".SORTED_SNP_DB_FILENAME."_$startMarker"."_$endMarker.snp";
	$rawDir = $projDir."/raw";
	if (!getSnpPart($rawDir, $OriginalSnp, $chromNum, $startMarker, $endMarker, $rangeType, $expDir, $newSnp)) {										
		rmdir_r($expDir);
		reportErrorAndExit();
	}		
	
	#Find the size of the SNP file
	$linesCount = exec("cat $expDir/$newSnp | wc -l");
	if ($linesCount > MAX_MARKERS_ALLOWED) {
		rmdir_r($expDir);
		reportErrorAndExit("The zoomed region contains too many markers (".$linesCount.
		"). The maximum allowed number of markers is ".MAX_MARKERS_ALLOWED);					
	}
	
	//Create .dat and .ped files from the zoomed .SNP file
	$datFile = $info[$method.$us."datfile"];
	$pedFile = "orig_ped.ped";
	copy($info[$method.$us."pedfile"], $expDir."/".$pedFile);                                            
	$frequency = getFrequencyFromDat($datFile);
	$MOI = getMOIFromDat($datFile);
	$parameters[KEY_PENETRANCE] = $MOI[1]." ".$MOI[2];
	$parameters[KEY_FREQUENCY] = (1-$frequency)." ".$frequency;                                                 
	if (!makePedAndDatForChrom($expDir, $newSnp, $pedFile, $expDir, $chromNum, $parameters)) {rmdir_r($expDir); reportErrorAndExit();}
	
	#Rename the dat and ped files
	$zero = ( ($chromNum != "X") && (($chromNum / 10) < 1)) ? "0" : "";
	$datName = "chrom_".$zero.$chromNum.".dat";
	$pedName = "chrom_".$zero.$chromNum.".ped";
	$newName = "zoom_".$_GET['zoomingStart']."_".$_GET['zoomingEnd']."_".$method.$us.$file;
	$newDatName = $newName.".dat";
	$newPedName = $newName.".ped";
	rename("$expDir"."/".$datName, $expDir."/".$newDatName);
	rename("$expDir"."/".$pedName, $expDir."/".$newPedName);
	
	#Perform cleaning
	$table['header'] = $newName;
	$table['datfile'] = $expDir."/clean/resultFile.".$newDatName;
	$table['pedfile'] = $expDir."/clean/resultFile.".$newPedName;
	$table['cluster_datfile'] 	= $expDir."/clustered/resultFile.".$newDatName;
	$table['cluster_pedfile'] 	= $expDir."/clustered/resultFile.".$newPedName;
	$table['cluster_mapfile'] 	= $expDir."/clustered/resultFile.".$newName.".map";                                                        
	$table['clean_datfile'] 	= $expDir."/clean/resultFile.".$newDatName;
	$table['clean_pedfile'] 	= $expDir."/clean/resultFile.".$newPedName;
	updateExpContentInfo($expDir, $table);

	$varsTable[KEY_RUN_MODE] = VAL_RUN_MODE_CLEAN_ONLY;
	$varsTable[KEY_CLEANING_THRESHOLD] = "Weak";
	$progressFile = $expDir."/".PROGRESS_FILENAME;                                                        
	if (!createVariablesFile($expDir, $varsTable)) {rmdir_r($expDir); reportErrorAndExit();}
	$guiVars[ZOOMING_START] = $_GET['zoomingStart'];
	$guiVars[ZOOMING_END] = $_GET['zoomingEnd'];
	$guiVars[ZOOMING_RANGE_TYPE] = $_GET['zoomBy'];
	$guiVars[ZOOMING_EXPAND_REGION] = "true";
	createGuiVarFile($expDir, $guiVars);
	initProgressForFile($expDir, $newName, array('cleaning'));			
	$flag = CLEANING_FLAG;
	$runName = sendExperiment($expDir, $flag);
	if ($runName == "1") {rmdir_r($expDir); reportErrorAndExit();}
	unlink($expDir."/".$pedFile);						                                    
}



function checkMarkerRange(&$varsTable, $inputDir) {

	#Define which tools are reduction tools
	$ReductionTools	= array("Clustering", "Cleaning");

	#Find if all the dat markers will be used in a single window
	$useAllDatMarkersInOneWindow = false;
	if ($_GET["InputRadio"] == "All") {$useAllDatMarkersInOneWindow = true;}
	elseif ($_GET["InputRadio"] == "Range" && !isset($_GET["WindowSize"])
		&& trim($_GET['StartMarker']) == "" && trim($_GET['EndMarker']) == "") {$useAllDatMarkersInOneWindow = true;}
	
	#Check that the markers range is valid for all inputs	
	$maxMarkers = 100;
	if ($_GET["toolsChoice"] == "TwoPointAnalysis") {$maxMarkers = MAX_MARKERS_ALLOWED;}
	elseif ($_GET["toolsChoice"] == "lm_markers") {$maxMarkers = MAX_MARKERS_ALLOWED;}
	foreach ($_GET["FileChoice"] as $input) {
		#Check that all markers to analyze exist in the dat file
		$in = str_replace("@", " ", $input);
		$numMarkersInDatFile = getDatMarkersAmount(getDatFromInput($inputDir, $input));		
		if ((isSet($varsTable[KEY_START_MARKER]) && $varsTable[KEY_START_MARKER] > $numMarkersInDatFile)
			|| (isSet($varsTable[KEY_END_MARKER]) && $varsTable[KEY_END_MARKER] > $numMarkersInDatFile)) {
			reportErrorAndExit("The markers range specified for input ".$in." is illegal. The maximum marker number should be ".$numMarkersInDatFile.".");
		}		
		elseif (isset($_GET['MarkersList'])) {
			$list = in_array($_GET['toolsChoice'], $ReductionTools) ? KEY_REDUCTION_MARKERS_LIST : KEY_MARKERS_LIST;
			$list = explode(',', $varsTable[$list]);
			foreach ($list as &$ind) {
				if ($ind > $numMarkersInDatFile) {
					reportErrorAndExit("The markers range specified for input ".$in." is illegal. The maximum marker number should be ".$numMarkersInDatFile.".");
				}
			}
		}
		
		#Reduction tools do not have a maximum number of markers
		if (in_array($_GET['toolsChoice'], $ReductionTools)) {continue;}
		
		#Count the number of markers in the analysis		
		$numMarkersToAnalyze = 0;		
		if ($useAllDatMarkersInOneWindow) {$numMarkersToAnalyze = $numMarkersInDatFile;}
		elseif ($_GET["InputRadio"] == "Range" && !isset($_GET["WindowSize"])
			&& isSet($varsTable[KEY_START_MARKER]) && isSet($varsTable[KEY_END_MARKER])) {
				$start = trim($varsTable[KEY_START_MARKER]);
				$end = trim($varsTable[KEY_END_MARKER]);
				if ($start != "" && $end != "") {$numMarkersToAnalyze = $end - $start + 1;}									
				elseif ($start != "") {$numMarkersToAnalyze = $numMarkersInDatFile - $start + 1;}
				elseif ($end != "") {$numMarkersToAnalyze = $end;}
		}
		if ($numMarkersToAnalyze > $maxMarkers) {
			reportErrorAndExit("Input ".$in." is too large (".$numMarkersToAnalyze." markers when maximum is defined to ".$maxMarkers." markers).<br/>
				Please reduce the data with Filtering or Clustering and try again.");
		}
	}
}



function reportErrorAndExit($errorMessage = "An error has occurred, system administrators have been informed.") {
	error_msg($errorMessage);
	createEndOfHTMLPage();
	exit(0);
}

function createEndOfHTMLPage() {
	?>
	</p>

	</div>
	</td>
	</tr>
	</table>

	<div id="Bottom">
		<br/>
		<?php webFooter(); ?>
		</div>
	 </div>
	</body>	
	<?php
}

function isValidInput() {
	if (!isset($_GET["toolsChoice"])) {
		error_msg("No tool was chosen, please go back to the tools page.");
		return false;
	}
	if (!isset($_GET["ProjectChoice"]) || !isset($_GET["FileChoice"]) || !isset($_GET["experimentName"])) {
		error_msg("Input is incorrect, please go back to the tools page.");
		return false;
	}
	
	if (!hasDiskSpace()){
		error_msg("You are low on disk space - please delete some of your files and try again.");
		return false;
	}	
	
	return true;
}





// creates input for $expDir from $inputDir. input is create for $input that should be in the form of: <method>@<name>   (example: cluster@chrom_01)  or just the name: <name>
// <method> should be empty if the file is not clustered or clean (unlikely only)
// files can be marked with initial $mark, if not given, there won't be a change.
// writes the input name.
// returns the input name made from $input.   <method>_<name> if <method> is not empty and <name> if empty.
function createExpInput($inputDir, $expDir, $input) {
	$input = explode("@", $input);
	if (sizeof($input) != 2){ $input[1] = $input; $input[0] = ""; }		// in case there's no '@'
	$file	= $input[1];
	$method	= $input[0];
	$us		= ($method == "") ? "" : "_";
	$dat = $method.$us.$file.".dat";
	$ped = $method.$us.$file.".ped";
	$map = $method.$us.$file.".map";	
	$info = getExpContentInfo($inputDir, $file);

	if ($inputDir != $expDir) {
		copy($info[$method.$us."datfile"], $expDir."/".$dat);
		copy($info[$method.$us."pedfile"], $expDir."/".$ped);
		if (isset($info[$method.$us."mapfile"])) { copy($info[$method.$us."mapfile"], $expDir."/".$map); }
		if (is_file($inputDir."/.".$file.".raw")){
			system("touch $expDir/.$file.raw");
		}
	}
	
	$table['header'] 	= $method.$us.$info['header'];
	$table['datfile'] 	= $expDir."/".$dat;
	$table['pedfile'] 	= $expDir."/".$ped;
	if (isset($info[$method.$us."mapfile"])) { $table['mapfile'] = $expDir."/".$map; }
	$table['cluster_datfile'] 	= $expDir."/clustered/resultFile.".$dat;
	$table['cluster_pedfile'] 	= $expDir."/clustered/resultFile.".$ped;
	$table['cluster_mapfile'] 	= $expDir."/clustered/resultFile.".$map;
	$table['clean_datfile'] 	= $expDir."/clean/resultFile.".$dat;
	$table['clean_pedfile'] 	= $expDir."/clean/resultFile.".$ped;
	updateExpContentInfo($expDir, $table);

	$MOI = getPenetranceFromInput();
	$freq = getFrequencyFromInput();

	if ($MOI && $freq) {updateMOIandFrequency($expDir."/".$dat, $MOI, $freq);}        
	return $method.$us.$file;
}


function removeInitialLetter($val) {			
	preg_match("/^[a-zA-Z]?(.*)$/", $val, $res);
	return $res[1];
}

function getDatFromInput($dir, $input) {
	$input = explode("@", $input);
	if (sizeof($input) != 2){ $input[1] = $input; $input[0] = ""; }		// in case there's no '@'
	$file	= $input[1];
	$method	= $input[0];
	$us		= ($method == "") ? "" : "_";
	$dat = $method.$us.$file.".dat";

	$info = getExpContentInfo($dir, $file);

	return $info[$method.$us."datfile"];
}
?>