<?php
require("log.php");
include ("config.php");
include_once ("fileHandleFunctions.php");
include_once ("snpManipulation.php");
include("debug.php");
include_once("DataBrowser.php");
require_once ("exceptions.php");
require_once("config.php");

$updates = "";
$dataBrowser = new DataBrowser();

if (isset($_GET[$dataBrowser->getJobTypeTotal()])) {
	$parameters['proj'] = $_GET['proj'];
	$parameters['exp'] = $_GET['exp'];
	$updates = "#".($dataBrowser->ajaxJobExecute($dataBrowser->getJobTypeTotal(), $parameters));	
}

if (isset($_GET[$dataBrowser->getJobTypePart()])) {
	$parameters['proj'] = $_GET['proj'];
	$parameters['exp'] = $_GET['exp'];
	$parameters['chrom'] = $_GET['chrom'];
	$updates = "#".($dataBrowser->ajaxJobExecute($dataBrowser->getJobTypePart(), $parameters));	
}

if (isset($_GET['chroms'])) {
	$directory 	= USER_PROJECTS_DIR."/".$_GET['proj']."/experiments/".$_GET['exp'];
	$chroms = getExpContentInfo($directory);
	foreach ($chroms as $key => $table) {$updates = $updates."#".$key;}
}

if (isset($_GET['mapValues'])) {
	ini_set('memory_limit','128M');
	
	$directory 	= USER_PROJECTS_DIR."/".$_GET['proj']."/experiments/".$_GET['exp'];
	$varsTable = getVariablesTable($directory);
	if (isArchived($directory)) {
		$updates = "#<b>Notice</b>: Experiment is archived, in order to see its data, please unarchive it and try again";
	}
	else {
		$chrom = ($_GET['chrom'] < 10) ? "0".$_GET['chrom'] : $_GET['chrom'];
		if ($chrom == 23) { $chrom = "X"; }
		$from = $_GET['from'];
		$to = $_GET['to'];

        #Make sure that no more than  DATABROWSER_MAX_MARKERS markers were chosen
        $numMarkers = $to - $from + 1;
        if ($numMarkers > DATABROWSER_MAX_MARKERS) {
            error_msg("The chosen range contains ".$numMarkers." markers. The maximum allowed number of markers is ".DATABROWSER_MAX_MARKERS);        
            exit;
        }
        
        
		$chromTable = getExpContentInfo($directory, $chrom);
		// getting ped file
		$pedfile = (isset($chromTable['cluster_pedfile']) && is_file($chromTable['cluster_pedfile'])) ? $chromTable['cluster_pedfile'] : $chromTable['pedfile'];
		$fileContent = file($pedfile, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);

		// getting marker names from dat file
		$datfile = (isset($chromTable['cluster_pedfile']) && is_file($chromTable['cluster_datfile'])) ? $chromTable['cluster_datfile'] : $chromTable['datfile'];
		$allMarkers = array();
		exec("grep \"3.*#.*#\" $datfile", $allMarkers);
		if ( ($from > $to) || ($to < 1) || ($from < 1) ){
			$updates = "#<b>Error</b>: Illegal markers range selected.";
		}
		elseif ( ($to > sizeof($allMarkers)) || ($from > sizeof($allMarkers)) ||
				 (isset($varsTable[KEY_START_MARKER]) && is_numeric($varsTable[KEY_START_MARKER]) && ($from < $varsTable[KEY_START_MARKER])) ||
				 (isset($varsTable[KEY_END_MARKER]) && is_numeric($varsTable[KEY_END_MARKER])   && ($to > $varsTable[KEY_END_MARKER])) ){
			$updates = "#<b>Error</b>: Specified markers range exceeds the markers amount on the selected chromosome.";
		}
		else {
			preg_match("/#([^ ]*)[ ]?.*#/", $allMarkers[$from-1], $fromMarker);
			$fromMarker = $fromMarker[1];
			if (preg_match("/(.*)\(.*\)/", $fromMarker, $withoutBracets)){
				$fromMarker = $withoutBracets[1];
			}
			preg_match("/#([ ]*|[^ ]+[ ])+([^ ]+)[ ]*#/", $allMarkers[$to-1], $toMarker);
			$toMarker = $toMarker[2];
			if (preg_match("/(.*)\(.*\)/", $toMarker, $withoutBracets)){
				$toMarker = $withoutBracets[1];
			}
			$markers = getAllMarkerNamesInRange($allMarkers, $from, $to);
			
			$script = "";
			$tableSwitcher = "";
			$dataTable = "";
			$snpTable = "";
			$tableLines = "";
			$hideSwitch = "";
			$matrix = false;
			
			$updates .= "<div class=\"data\" style=\"text-align: left ;\"><br/>Data from marker: $from to: $to<br/>";
			$file = explode("/", $pedfile);
			$file = $file[sizeof($file)-1];
			if (preg_match("/^resultFile.(.*).ped/", $file, $fileHead)){
				$file = $fileHead[1];
			}
			else{
				if (preg_match("/^(.*).ped/", $file, $fileHead)){
					$file = $fileHead[1];
				}
				else{
					$file = "chrom_".$chrom;
				}
			}
			$file = (isset($chromTable['cluster_pedfile']) && is_file($chromTable['cluster_pedfile']) ? "cluster" : "")."@".$file;
			$initial = (isset($chromTable['cluster_pedfile']) && is_file($chromTable['cluster_pedfile'])) ? "c" : "";
			$updates = $updates."To run MultiPoint Analysis on this markers range click <a href=\"tools.php?showTool=MultiPointAnalysis&proj=".$_GET['proj']."&exp=".$_GET['exp']."&checkboxes[]=".$file."&from=$initial$from&to=$initial$to\">here</a><br/><br/>";
			
			if (snpExists($_GET['proj'])) {
				//$matrix = getSnpDataBetween(USER_PROJECTS_DIR."/".$_GET['proj']."/raw", SORTED_SNP_DB_FILENAME, $markers[$from], $markers[$to]);
				
				//$tableLines = "<tr>".implode("</tr><tr>", $markers)."</tr>";
				/*$tableLines = "<tr>".implode("</tr><tr>", getDataTableLinesFromSnp($_GET['proj'], $fromMarker, $toMarker, $markers))."</tr>";
				$dataTable = "<table id=\"dataTable\" class=\"medium\" style=\"text-align: center; border-collapse: collapse; color: #2F2F4F;\">".$tableLines."</table>";
				$legend = createSnpLegend();*/
				$hideSwitch = "<a href=\"\" onclick=\"changecss('.unused', 'display', 'none'); return false;\">Hide unused markers</a> / 
								<a href=\"\" onclick=\"changecss('.unused', 'display', ''); return false;\">Show unused markers</a><br/>";
				$snpTable = "<div id=\"snpTable\" style=\"display: none;\">".createSnpTable($_GET['proj'], $fromMarker, $toMarker, $markers)."<br/>".$hideSwitch."</div>";
				
				$tableSwitcher = "Data: <a href=\"\" onclick=\"document.getElementById('pedigreeTable').style.display = 'none';
															document.getElementById('snpTable').style.display = ''; return false;
															\">RawData view</a> 
									 <a href=\"\" onclick=\"document.getElementById('snpTable').style.display = 'none';
															document.getElementById('pedigreeTable').style.display = ''; return false;
															\">Pedigree view</a><br/>";
			}
			else {
				$snpTable = "<div id=\"snpTable\" style=\"display: none;\">".createPedTable($pedfile, $from, $to, $markers)."</div>";
				
				$tableSwitcher = "Data: <a href=\"\" onclick=\"document.getElementById('pedigreeTable').style.display = 'none';
															document.getElementById('snpTable').style.display = ''; return false;
															\">RawData view</a> 
									 <a href=\"\" onclick=\"document.getElementById('snpTable').style.display = 'none';
															document.getElementById('pedigreeTable').style.display = ''; return false;
															\">Pedigree view</a><br/>";
			
				//$tableSwitcher = "<br/>No Snp data on this project";
			}
			//else{
				$tableLinesOriginalOrder = "";
				$affectedArr = array();
				$healthyArr = array();
				$unknownArr = array();
				$noDataArr = array();
				$colors = array("1" => "#0000FF", "2" => "#00BBFF", "3" => "#00CCAF", "4" => "#FFCC00", "5" => "#00FFBB");
				$usedColors = array();
				
				$names = getNames($_GET['proj']);
				$lineNum = 0;
				
				foreach ($fileContent as $line){
					$line = str_replace("\t", " ", $line);
					$splitted = explode(" ", $line);
					$affected = false;
					$healthy = false;
					$affStyle = "";
					if (!isset($names[$splitted[1]])){
						$names[$splitted[1]] = $splitted[1];
					}
					switch ($splitted[9]) {
						case 0:	// unknown
							$affStyle = "color: blue;";
							break;
						case 1:	// healthy
							$healthy = true;
							$affStyle = "color: black;";
							break;
						case 2:	// affected
							$affected = true;
							$affStyle = "color: red;";
							break;
						default: 
							$affStyle = "color: black;";
							break;
					}
					/*if ($splitted[9] == 2){
						$affected = true;
						$affStyle = "color: red;";
					}
					elseif ($splitted[9] == 0){
						$affStyle = "color: blue;";
					}*/
					
					$pedmarkers = array_slice($splitted, 10);
					
					$tableLines = "<tr>";
					$tableLines = $tableLines."<td style=\"font-size: 80%; $affStyle\">".$names[$splitted[1]]."</td>";
					$tableLinesOriginalOrder = $tableLinesOriginalOrder.$tableLines;
					
					$noData = true;
					for ($i = 0 ; $i < sizeof($pedmarkers) ; $i += 2) {
						if ($i < 2*($from - 1)) { continue; }
						if ($i > 2*($to - 1)  ) { break; }
						$color;
						if ($pedmarkers[$i] == 0) { $color = "white"; }
						//elseif ($pedmarkers[$i] == $pedmarkers[$i+1]) { $color = "black"; $noData = false;}
						elseif ($pedmarkers[$i] == $pedmarkers[$i+1]) {
							if (isset($colors[$pedmarkers[$i]])) {
								$color = $colors[$pedmarkers[$i]];
								$usedColors[$pedmarkers[$i]] = $colors[$pedmarkers[$i]];
							}
							else {$color = "black";}							
							//$colors[$marker[$i]] = 
							$noData = false;
						}
						else { $color = "gray"; $noData = false;}
						
						$tableLines = $tableLines."<td class=\"tableCell\" style=\"height: 3px; background-color: ".$color.";\"></td>";
						$tableLinesOriginalOrder = $tableLinesOriginalOrder."<td class=\"tableCell\" style=\"height: 3px; background-color: ".$color.";\"></td>";
						/*if (snpExists($_GET['proj']) && isset($pedmarkers[$i+2])){
							//$markers[$i/2]
							echo $markers[$i/2]." ".$markers[($i/2)+1];
							$matrix = getSnpDataBetween(USER_PROJECTS_DIR."/".$_GET['proj']."/raw", SORTED_SNP_DB_FILENAME, $markers[$i/2], $markers[($i/2)+1]);
							for ($j = 1 ; $j < sizeof($matrix[$lineNum]) ; $j += 1){
								if (preg_match(MATCHES_FOR_11, $matrix[$lineNum][$j])) { $color = $colors["1"]; }
								if (preg_match(MATCHES_FOR_12, $matrix[$lineNum][$j]) || preg_match(MATCHES_FOR_21, $matrix[$lineNum][$j])) { $color = "gray"; }
								if (preg_match(MATCHES_FOR_22, $matrix[$lineNum][$j])) { $color = $colors["2"]; }
								$tableLines = $tableLines."<td class=\"tableCell\" style=\"border-bottom: 1px solid red; height: 3px; background-color: ".$color.";\"></td>";
								$tableLinesOriginalOrder = $tableLinesOriginalOrder."<td class=\"tableCell\" style=\"border-bottom: 1px solid red; height: 3px; background-color: ".$color.";\"></td>";
							}
						}*/
					}
					
					$tableLinesOriginalOrder = $tableLinesOriginalOrder."</tr>";
					//$tableLines = $tableLines."</tr>";
					if ($noData) {$noDataArr[] = $tableLines."</tr>";}					
					elseif ($affected) {$affectedArr[] = $tableLines."</tr>";}					
					elseif ($healthy) {$healthyArr[] = $tableLines."</tr>";}					
					else {$unknownArr[] = $tableLines."</tr>";}					
					//$lineNum += 1;
				}
				$tableLines = implode("", $affectedArr).implode("", $healthyArr).implode("", $unknownArr).implode("", $noDataArr);
				
				$dataTable = "<div id=\"affectedFirst\" style=\"display: none;\"><table id=\"dataTable\" class=\"medium\" cellspacing=\"1\" style=\"\">".$tableLines."</table></div>";
				$dataTable = $dataTable."<div id=\"original\"><table id=\"dataTableOriginal\" class=\"medium\" cellspacing=\"1\" style=\"\">".$tableLinesOriginalOrder."</table></div>";
				
				$switch = "Order by: <a href=\"\" onclick=\"document.getElementById('affectedFirst').style.display = 'none';
															document.getElementById('original').style.display = ''; return false;
															\">original order</a> 
									 <a href=\"\" onclick=\"document.getElementById('original').style.display = 'none';
															document.getElementById('affectedFirst').style.display = ''; return false;
															\">affected first</a><br/>";
				$script = "Density: <a href=\"\" onclick=\"document.getElementById('dataTable').className = 'dense';
														   document.getElementById('dataTableOriginal').className = 'dense'; return false;\">dense</a> 
									<a href=\"\" onclick=\"document.getElementById('dataTable').className = 'medium';
														   document.getElementById('dataTableOriginal').className = 'medium'; return false;\">medium</a> 
									<a href=\"\" onclick=\"document.getElementById('dataTable').className = 'spacious';
														   document.getElementById('dataTableOriginal').className = 'spacious'; return false;\">spacious</a>";
				
				$script = $switch.$script;
				$legend = createPedLegend($usedColors);
				$pedTable = "<div id=\"pedigreeTable\">".$dataTable."<br/>".$legend."<br/>".$script."</div>";
			//}
			
			//$updates = "#<br/><br/>".$updates.$legend.$dataTable."<br/>$script</div>";
			$updates = "#$updates<br/><br/>".$pedTable.$snpTable."<br/><br/>$tableSwitcher</div>";
		}
	}
}

echo substr($updates, 1);

function snpExists($project) {
	$dir = USER_PROJECTS_DIR."/".$project."/raw";
	if (!is_file($dir."/".SORTED_SNP_DB_FILENAME)) {return false;}	
	return true;
}

function getDataTableLinesFromSnp($project, $fromMarker, $toMarker, $specialMarkers) {
	$dir = USER_PROJECTS_DIR."/".$project."/raw";
	if (!is_file($dir."/".SORTED_SNP_DB_FILENAME)) {return false;}		
    
	$tableLines = array();
	$firstFound = false;
	$lastFound = false;
	$lineSize;
	$normalStyle= "style=\"background-color: #E8EEF7; border-bottom: 1px solid #f0ffff; padding-left: 2px; padding-right: 2px\"";
	
	$DB = fopen($dir."/".SORTED_SNP_DB_FILENAME,"r");
	while ((!feof($DB))) {
		$Line = fgets($DB);
		if (preg_match("/^[ \t]*$/", $Line)){ continue; }
		$Line = explode("\t", rtrim($Line));
		if (!$firstFound && ($Line[DB_MARKERNAME_COL] != $fromMarker)) {continue;}		
		else {$firstFound = true;}
		$style= $normalStyle;
		$class = "class=\"unused\"";
		if (in_array($Line[DB_MARKERNAME_COL], $specialMarkers)) {
			$style = "style=\"background-color: #FFC0CB; border-bottom: 1px solid #f0ffff; padding-left: 4px; padding-right: 4px;\"";
			$class = ""; 
		}
		//$tableLines[] = "<td class=\"snpTableCell\">".implode("</td><td class=\"snpTableCell\">", array_slice($Line, DB_POS_COL+1))."</td>";
		$colored = array_map("colorizeCall", array_slice($Line, DB_POS_COL+1));
		$tableLines[] = "<tr $class><td $style>".$Line[DB_MARKERNAME_COL]."</td><td $style>".implode("</td><td $style>", $colored)."</td></tr>";
		if ($Line[DB_MARKERNAME_COL] == $toMarker) { break; }
	}
	
	$lineSize = sizeof(array_slice($Line, DB_POS_COL+1));
	$names = getNames($project);
	//$namesColors = getNamesColors($project, $names);
	$namesLine = "<td>marker</td>";
	for ($i = 1; $i <= $lineSize; $i++) {
		$name = isset($names[$i]) ? $names[$i] : $i;
		//$namesLine = $namesLine."<td $normalStyle>".$name."</td>";
		$namesLine = $namesLine."<td $normalStyle><span title=\"$name\">".$i."</span></td>";
		
	}
	$namesLine = array("<tr>".$namesLine."</tr>");
	
	return array_merge($namesLine,$tableLines);
}

function createSnpTable($project, $from, $to, $usedMarkers) {
    
	$tableLines = implode("", getDataTableLinesFromSnp($project, $from, $to, $usedMarkers));
	$dataTable = "<table id=\"dataTable\" class=\"medium\" style=\"text-align: center; border-collapse: collapse; color: #2F2F4F;\">".$tableLines."</table>";
	$legend = createSnpLegend();
	return $dataTable."<br/>".$legend;
}

function getAllMarkerNamesInRange($markersLines, $from, $to) {
	$lines = array_slice($markersLines, $from-1, $to);
	$markers = array();
	foreach ($lines as $line){
		//preg_match_all("/(rs[0-9]+)/", $line, $names);
		$names = explode("#", $line);
		$names = $names[1];		// names are between the first # <names> #
		$names = explode(" ", $names);
		for($i = 0 ; $i < sizeof($names) ; $i += 1){
			if (preg_match("/(.+)\(.*\)/", $names[$i], $noBracets)) {$names[$i] = $noBracets[1];}			
		}
		
		//$markers = array_merge($markers, $names[0]);
		$markers = array_merge($markers, $names);
	}
	return $markers;
}

function getSnpDataBetween($dir, $snpFile, $fromMarker, $toMarker) {
	if (!is_file($dir."/".$snpFile)) { return -1; }
	$snpData = array();
	$matrix = array();
	getSnpLineNumbersOf($dir, $snpFile, $fromMarker, $toMarker, $from, $to);
	$markersAmount = $to - $from + 1;
	exec("head -$to $dir/$snpFile | tail -$markersAmount", $snpData);
	for ($i = 0 ; $i < sizeof($snpData) ; $i += 1) {
		$line = $snpData[$i];
		$line = explode("\t", $line);
		for ($j = DB_POS_COL+1 ; $j < sizeof($line) ; $j += 1) {$matrix[$j-DB_POS_COL-1][$i] = $line[$j];}		
	}
	
	return $matrix;
}

function createSnpLegend() {
	$legend = "<table>";
	$legend = $legend."<tr><td style=\"width:20px ;background-color: #E8EEF7;\"></td><td> - marker not used on analysis</td></tr>";
	$legend = $legend."<tr><td style=\"width:20px ;background-color: #FFC0CB;\"></td><td> - marker used on analysis</td></tr>";
	$legend = $legend."</table>";
	return $legend;
}

function createPedTable($pedfile, $from, $to, $markers) {
	$tableLinesOrder = array();
	$tableLines = array();
	$affectedArr = array();
	$healthyArr = array();
	$unknownArr = array();
	$noDataArr = array();
	$affectedNames = array();
	$healthyNames = array();
	$unknownNames = array();
	$noDataNames = array();	
	$colors = array("1" => "#0000FF", "2" => "#00BBFF", "3" => "#00CCAF", "4" => "#FFCC00", "5" => "#00FFBB");
	$usedColors = array();
	$color;
	
	$names = getNames($_GET['proj']);
	$matrix = array();
	
	$fileContent = file($pedfile, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
	$lineNum = 0;
	$noData = true;
	foreach ($fileContent as $line) {
		$line = str_replace("\t", " ", $line);
		$splitted = explode(" ", $line);
		$affected = false;
		$healthy = false;
		$affStyle = "";
		$noData = true;
		$newLine = array();
		
		if (!isset($names[$splitted[1]])) {$names[$splitted[1]] = $splitted[1];}		
		switch ($splitted[9]) {
			case 0:	// unknown
				$affStyle = "color: blue;";
				break;
			case 1:	// healthy
				$healthy = true;
				$affStyle = "color: black;";
				break;
			case 2:	// affected
				$affected = true;
				$affStyle = "color: red;";
				break;
			default: 
				$affStyle = "color: black;";
				break;
		}		
		/*if ($splitted[9] == 2){
			$affected = true;
			$affStyle = "color: red;";
			$names[$splitted[1]] = "<span style=\"$affStyle\">".$names[$splitted[1]]."</span>";
		}
		if ($splitted[9] == 0){
			$names[$splitted[1]] = "<span style=\"color: blue;\">".$names[$splitted[1]]."</span>";
		}		*/
		$names[$splitted[1]] = "<span style=\"$affStyle\">".$names[$splitted[1]]."</span>";
		$pedmarkers = array_slice($splitted, 10+2*($from - 1), 2*($to - $from + 1));
		
		for ($i = 0 ; $i < sizeof($pedmarkers) ; $i += 2) {
			if ($pedmarkers[$i] == 0) { $color = "white"; }
			elseif ($pedmarkers[$i] == $pedmarkers[$i+1]) {
				if (isset($colors[$pedmarkers[$i]])) {
					$color = $colors[$pedmarkers[$i]];
					$usedColors[$pedmarkers[$i]] = $colors[$pedmarkers[$i]];
				}
				else {$color = "black";}				
				$noData = false;
			}
			else { $color = "gray"; $noData = false; }
			$matrix[$i/2][$lineNum] = "<span style=\"color: $color\">".$pedmarkers[$i]." ".$pedmarkers[$i+1]."</span>";

			$newLine[] = "<span style=\"color: $color\">".$pedmarkers[$i]." ".$pedmarkers[$i+1]."</span>";
		}
		$lineNum += 1;
		
		if ($noData) {
			$noDataArr[] = $newLine;
			$noDataNames[] = $names[$splitted[1]];
		}
		elseif ($affected) {
			$affectedArr[] = $newLine;
			$affectedNames[] = $names[$splitted[1]];
		}
		elseif ($healthy) {
			$healthyArr[] = $newLine;
			$healthyNames[] = $names[$splitted[1]];
		}		
		else {
			$unknownArr[] = $newLine;
			$unknownNames[] = $names[$splitted[1]];
		}
	}
	
	$arrangedMatrix = array_merge(array_merge(array_merge($affectedArr,$healthyArr), $unknownArr), $noDataArr);
	$arrangedNames  = array_merge(array_merge(array_merge($affectedNames,$healthyNames), $unknownNames), $noDataNames);
	
	$tableLines[] = "<td>".implode("</td><td>", $names)."</td>";
	$tableLinesOrder[] = "<td>".implode("</td><td>", $arrangedNames)."</td>";
	for ($i = 0 ; $i < sizeof($matrix) ; $i += 1) {
		$line = "";
		for ($j = 0 ; $j < sizeof($matrix[$i]) ; $j += 1){
			$line = $line."<td style=\"border-bottom: 1px solid #f0ffff; padding-left: 4px; padding-right: 4px;\">".$matrix[$i][$j]."</td>";
		}
		$tableLines[] = $line;
	}
	$table = "<div id=\"tableOriginal\"><table style=\"border-collapse: collapse; color: #2F2F4F; text-align: center;\"><tr>".implode("</tr><tr style=\"width:20px ;background-color: #FFC0CB;\">",$tableLines)."</tr></table></div>";
	
	for ($i = 0 ; $i < sizeof($arrangedMatrix[$i]) ; $i += 1) {
		$line = "";
		for ($j = 0 ; $j < sizeof($arrangedMatrix) ; $j += 1) {
			$line = $line."<td style=\"border-bottom: 1px solid #f0ffff; padding-left: 4px; padding-right: 4px;\">".$arrangedMatrix[$j][$i]."</td>";
		}
		$tableLinesOrder[] = $line;
	}
	$orderedTable = "<div id=\"tableAffectedFirst\" style=\"display: none;\"><table style=\"border-collapse: collapse; color: #2F2F4F; text-align: center;\"><tr>".implode("</tr><tr style=\"width:20px ;background-color: #FFC0CB;\">",$tableLinesOrder)."</tr></table></div>";

	$switch = "Order by: <a href=\"\" onclick=\"document.getElementById('tableAffectedFirst').style.display = 'none';
												document.getElementById('tableOriginal').style.display = ''; return false;
												\">original order</a> 
						 <a href=\"\" onclick=\"document.getElementById('tableOriginal').style.display = 'none';
												document.getElementById('tableAffectedFirst').style.display = ''; return false;
												\">affected first</a><br/>";
	
	return $table.$orderedTable.$switch;
}

function createPedLegend($colorsMap) {
	$legend = "<table>";
	//$legend = $legend."<tr><td style=\"width:20px ;background-color: black;\"></td><td> - homozygous marker</td></tr>";
	foreach ($colorsMap as $val => $color) {
		$legend = $legend."<tr><td style=\"width:20px ;background-color: $color;\"></td><td> - homozygous marker $val$val</td></tr>";
	}
	$legend = $legend."<tr><td style=\"width:20px ;background-color: gray;\"></td><td> - hertrozygous marker</td></tr>";
	$legend = $legend."<tr><td style=\"width:20px ;background-color: white;\"></td><td> - no data</td></tr>";
	$legend = $legend."<tr><td style=\"width:20px; color: red;\">red</td><td> - affected person</td></tr>";
	$legend = $legend."<tr><td style=\"width:20px; color: black;\">black</td><td> - healthy person</td></tr>";	
	$legend = $legend."<tr><td style=\"width:20px; color: blue;\">blue</td><td> - unknown person</td></tr>";
	$legend = $legend."</table>";
	return $legend;
}

function colorizeCall($call) {
	if (preg_match(MATCHES_FOR_11, $call)) { return "<span style=\"color: black\">$call</span>"; }
	if (preg_match(MATCHES_FOR_12, $call) || preg_match(MATCHES_FOR_21, $call)) { return "<span style=\"color: gray\">$call</span>"; }
	if (preg_match(MATCHES_FOR_22, $call)) { return "<span style=\"color: blue\">$call</span>"; }
	return "<span style=\"color: green\">$call</span>";
}

function getNames($project) {
	$dir = USER_PROJECTS_DIR."/".$project."/raw";
	if (!is_file($dir."/".MAP_FILE_NAME)) {return false;}		
	
	$names = array();
	$map = file($dir."/".MAP_FILE_NAME, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
	if (is_file($dir."/".SIMPLIFIED_PED_MAP_FILE)) {
		$simpMap = file($dir."/".SIMPLIFIED_PED_MAP_FILE, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
		foreach ($simpMap as $line) {
			$simpArr = explode("\t", $line);
			$number = $simpArr[1];
			$name = $simpArr[2];
			$names[$number] = $name;
		}
	}
	foreach ($map as $line) {
		$arr = explode("\t", $line);
		$person = explode(".", $arr[0]);
		$names[$person[1]] = $arr[1];
	}	
	return $names;
}

?>