<?php
require("log.php");
include ("config.php");
include_once ("fileHandleFunctions.php");
include("debug.php");
include("formulas.php");
include_once("snpManipulation.php");
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
            "http://www.w3.org/TR/html4/loose.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Superlink Online</title>
<meta http-equiv="Content-Type" content="text/html; charset=windows-1255" />
<link href="style.css" rel="stylesheet" type="text/css" />
</head>
<body>
	<div style="background-color: ffffff; padding-top: 20px; text-align: center;">
	<?php 
		$file  = (isset($_GET['file'])) ? base64_decode($_GET['file']) : false; 
		$clustered = false;
		if (preg_match("/cluster/", $file)) {$clustered = true;}
		
	?>
	<table border="1" cellpadding="0" cellspacing="0" id="markersTable" ALIGN="center">
		<tr>
		<td align="center"><b><?php echo ($clustered ? "Cluster " : "Marker ");?>id</b></td>
		<td align="center"><b>Marker(s) names</b></td>
		<td align="center"><b>Distance (cM)</b></td>
		</tr>

	<?php
		ini_set("precision", 5);
		if ($file) {
			$distances = exec("tail -3 $file | head -1 | cut -d\< -f1");			
			$distances = explode(" ", $distances);
			$distance = 0;
			$projDir = USER_PROJECTS_DIR."/".$_GET['proj'];
			$uploadedData = is_file($projDir."/raw/".UPLOADED_DATA_INFO) ? parse_ini_file($projDir."/raw/".UPLOADED_DATA_INFO, true) : false;
		
			$file = fopen($file,"r");
			$markersCount = 1;
			
			$printedFirstMarker = false;
			while (!feof($file)) {				
				$line = trim(fgets($file));				
				if (!preg_match("/#(.*)#/", $line)) {continue;}								
				if (preg_match("/^1/", $line)) {continue;}	#Don't show the disease marker
				$name = explode("#", $line);
				$name = $name[1];
				
				//If the project uses SNP data, find the distance of the first marker from the beginning of the chromosome				
				if (!$printedFirstMarker and $uploadedData and ($uploadedData['general'][KEY_INPUT_TYPE] === "snp")) {
					$OriginalSnp = ".final_".SORTED_SNP_DB_FILENAME;
					$rawDir = $projDir."/raw";					
					//If the marker name contains spaces, this means it's a clustered marker.
					//We'll take the name of the first marker in the cluster
					$markerName = $name;
					$markerNameList = explode(' ',trim($markerName));										
					$markerName = $markerNameList[0];						
					$markerName = preg_replace('/\(\d+\)/', '', $markerName);					
					getSnpLineNumbersOf($rawDir, $OriginalSnp, $markerName, $markerName, $from, $to);					
					if ($from) {
						$snpLine = exec("head -".$from." ".$rawDir."/".$OriginalSnp." | tail -1");
						$LineArray = explode("\t", rtrim($snpLine));
						$markerPos = $LineArray[DB_POS_COL] / 1000000;
						$distance += $markerPos;
					}
				}				
				
				?>
				<tr>
				<td align="center" style="padding: 0px 5px 0px 5px;"><b><?php echo ($clustered ? "c" : "").$markersCount;?></b></td>
				<td align="center" style="padding: 0px 5px 0px 5px;"><b><?php echo $name; ?></b></td>
				<td align="center" style="padding: 0px 5px 0px 5px;"><b><?php echo $distance; ?></b></td>
				</tr>
				<?php				
				if (isset($distances[$markersCount])) {$distance += convertThetaToCM($distances[$markersCount]);}				
				$printedFirstMarker = true;				
				$markersCount++;
			}
		}
	?>
	</table>
	</div>	
</body>
</html>