<?php
require_once("log.php");
require_once ("config.php");
include_once ("fileHandleFunctions.php");
require_once("debug.php");
require_once("datpedCreator.php");

if (isset($_GET['stop'])) { stopExperiment(); }
elseif (isset($_GET['archive'])) { archiveProject(); }
elseif (isset($_GET['copy'])){ copyProject(); }
elseif (isset($_GET['delete'])) { deleteExperiment(); }
elseif (isset($_GET['restore'])){ restoreDeleted(); }
elseif (isset($_GET['unarchive'])) { unArchive(); }
elseif (isset($_GET['pedigree'])) { displayPedigree(); }
elseif (isset($_GET['dataBrowser'])) { dataBrowser(); }
elseif (isset($_POST['saveComments'])) { saveComment(); } // have to be POST in order to be able to handle more than 2000 chars in the comments
elseif (isset($_GET['wizardReturn']) && isset($_GET['project'])) { wizardReturnTool(); }
elseif (isset($_GET['expAction']) && ($_GET['expAction'] == "simpleZoom") ) { simpleZoomTool(); }
elseif (isset($_GET['expAction']) && ($_GET['expAction'] == "filtering") ) { filteringTool(); }
elseif (isset($_GET['expAction']) && ($_GET['expAction'] == "multiPoint") ) { multiPointTool(); }
elseif (isset($_GET['expAction']) && ($_GET['expAction'] == "twoPoint") ){ twoPointTool(); }
elseif (isset($_GET['expAction']) && ($_GET['expAction'] == "lm_markers") ) { lm_markersTool(); }
elseif (isset($_GET['expAction']) && ($_GET['expAction'] == "gl_auto") ) { gl_autoTool(); }
elseif (isset($_GET['expAction']) && ($_GET['expAction'] == "haplotyping") ) { haplotypingTool(); }
elseif (isset($_GET['expAction']) && ($_GET['expAction'] == "segregation") ) { segregationTool(); }
elseif (isset($_GET['expAction']) && ($_GET['expAction'] == "clustering") ) { clusteringTool(); }
elseif (isset($_GET['expAction']) && ($_GET['expAction'] == "cleaning") ) { cleaningTool(); }
elseif (isset($_GET['mapping'])) { mappingTool(); }
else {
	header("Location: projects.php?proj=".$_GET['project']."&exp=".$_GET['experiment']); // send back
	exit;
}


/*
 * stop running experiment and kills all it tasks in all the servers.
 */
function stopExperiment() {
	$process = file(USER_PROJECTS_DIR."/".$_GET['project']."/experiments/".$_GET['experiment']."/".PROCESS_ID_FILE, FILE_IGNORE_NEW_LINES);
	$process = $process[0];
	
	if (getExperimentStatus($_GET['project'],$_GET['experiment']) == EXP_STATUS_RUNNING){
		$remoteUser = "superlinksnp";
		$GW = "cbl-link01.cs.technion.ac.il";
		$remoteScript ="/scratch/superlinksnp/release/perlbin/killProjByName.pl";
		$sshDir = WEBDIR."/cgi-bin/ssh";
		$sshOptions = "-o IdentityFile=$sshDir/apache_id_dsa -o UserKnownHostsFile=$sshDir/known_hosts -o CheckHostIP=no -o ConnectTimeout=60 -o StrictHostKeyChecking=no";
		$sshCmd = "ssh $sshOptions -vvv ";
		
		// removing the job from both JobQs
		exec("export PERLLIB=".CGI_BIN_DIR ."; perl ".CGI_BIN_DIR ."/dequeueTask.pl $process ".FRONTEND_JOBSQ); // export so apache can read the pm files needed
		exec("export PERLLIB=".CGI_BIN_DIR ."; perl ".CGI_BIN_DIR ."/dequeueTask.pl $process ".REMOTE_JOBSQ);   // export so apache can read the pm files needed
		exec("export PERLLIB=".CGI_BIN_DIR ."; perl ".CGI_BIN_DIR ."/dequeueTask.pl $process ".WAIT_FINISH_TASKS_LIST);   // export so apache can read the pm files needed
		
		// killing the job on link-01
		exec("$sshCmd $remoteUser@$GW '$remoteScript $process' 2>> ".USER_PROJECTS_DIR."/".$_GET['project']."/experiments/".$_GET['experiment']."/".EXP_STOPPED_FILE."\.detailed\.log");
		exec("echo \"killed\" > ".USER_PROJECTS_DIR."/".$_GET['project']."/experiments/".$_GET['experiment']."/".EXP_STOPPED_FILE);
		$str = "$sshCmd $remoteUser@$GW $remoteScript $process";
		
		// removing job from superlink
		exec("export PERLLIB=".CGI_BIN_DIR ."; perl ".CGI_BIN_DIR ."/killTaskExecution.pl $process"); // export so apache can read the pm files needed
	}
	header("Location: projects.php?proj=".$_GET['project']."&exp=".$_GET['experiment']); // send back
	exit;
}

function archiveProject() {
	if (!isset($_GET['project'])) {return;}	// only works if there's at least a project to archive
	$dir = USER_PROJECTS_DIR."/".$_GET['project'];
	$zipMe = ".";
	if ($_GET['experiment'] != "") {
		$zipMe = $zipMe."/".$_GET['experiment'];
		$dir = $dir."/experiments";
	}
	$zipName = ".".$_GET['project'].(($zipMe != ".") ? "_".$_GET['experiment'] : "").".zip";
	$zipFile = $dir."/".$zipName;
	
	collectResults($_GET['project'], ($_GET['experiment'] == "") ? null : $_GET['experiment']);
	
	exec("cd $dir; zip -r $zipName $zipMe/* -i \*.dat \*.ped \*.html \*.png \*.css \*.js; cd -");

	// get the file size and send the http headers
	$size = filesize($zipFile);
	header('Content-Type: application/octet-stream');
	header('Content-Length: '.$size);
	header('Content-Disposition: attachment; filename=superlink'.$zipName);
	header('Content-Transfer-Encoding: binary');

	// open the file in binary read-only mode
	// display the error messages if the file cant be opened
	$file = @ fopen($zipFile, 'rb');

	// stream the file and exit the script when complete
	if ($file) {fpassthru($file);}
	fclose($file);
	exit;
}

function copyProject() {
	if (isset($_GET['project'])) {
		header("Location: copyProject.php?project=".$_GET['project']);
		exit;
	}
}

function deleteExperiment() {
	$backLink = $_SESSION['backFromDeletion'];
	unset($_SESSION['backFromDeletion']);
	
	$directory = false;
	
	//build path
	if ( isset($_GET['project'])){
		$directory = USER_PROJECTS_DIR;
	}
	
	if ( isset($_GET['project']) && (!preg_match("/^[ \t\r\n]*$/",$_GET['project'])) ){
		$directory = USER_PROJECTS_DIR."/".$_GET['project'];
		if (readOnlyProject($_GET['project'])){ header("Location: ".$backLink); exit; }

		if ( isset($_GET['input']) && (!preg_match("/^[ \t\r\n]*$/",$_GET['input'])) ){
			$directory = $directory."/raw";
		}
		else {
				$directory = $directory."/experiments";
				if ( isset($_GET['experiment']) && (!preg_match("/^[ \t\r\n]*$/",$_GET['experiment'])) ){
					$directory = $directory."/".$_GET['experiment'];
					if ( isset($_GET['subexp']) && (!preg_match("/^[ \t\r\n]*$/",$_GET['subexp'])) ){
						$directory = $directory."/".$_GET['subexp'];
					}
				}
		}
	}
	
	// don't allow hidden, or ../ or ./
	$arr = explode("/", $directory);
	for ($i = 1; $i < sizeof($arr); $i += 1){
		if (strpos($arr[$i],".") === 0){			// just in case
			$directory = false;
			break;
		}
	}
	
	// finally...delete selections (again, skip ./ ../ and hidden)
	if ( ($directory != false) && isset($_GET['checkboxes'])) {
		foreach ($_GET['checkboxes'] as $name) {
			if (strpos($name,".") === 0) {continue;}			// just in case
			$new_name = str_replace("$", " ", $name);
			if (readOnlyProject($new_name)){ continue; }
			$toRemove = $directory."/".$new_name;
			if (is_dir($toRemove)){
				if (isExperimentFolder($toRemove)) {system("echo 'deleted' > $toRemove/.deletedFlag");}
				else{ rmdir_r($toRemove); }
			}
			elseif (is_file($toRemove)){
				unlink($toRemove);
				log_error("User attempts to remove file: ".$toRemove);
			}
		}
	}
	
	header("Location: ".$backLink); // send back
	exit;
}

function restoreDeleted() {
	$directory = false;
	//build path
	if ( isset($_GET['project']) && (!preg_match("/^[ \t\r\n]*$/",$_GET['project'])) ) {
		$directory = USER_PROJECTS_DIR."/".$_GET['project']."/experiments";
	}
	else { header("Location: main.php"); } // send to main on error
	// don't allow hidden, or ../ or ./
	$arr = explode("/", $directory);
	for ($i = 1; $i < sizeof($arr); $i += 1) {
		if (strpos($arr[$i],".") === 0) {			// just in case
			$directory = false;
			break;
		}
	}
	
	// finally...restore all deleted experiments
	if ($directory != false) {
		if ( (!($items = @opendir($directory))) ) { break; }
		while ( false !== ($obj=readdir($items)) )	{
			if (!is_dir($directory."/".$obj) || (strpos($obj,".") === 0)) { continue; }
			if (is_file($directory."/$obj/".DELETED_FLAG)) { unlink($directory."/$obj/".DELETED_FLAG); }
		}
		closedir($items);
	}
	
	header("Location: projects.php?proj=".$_GET['project']); // send back
	exit;
}

function unArchive() {
	if (!isset($_GET['project']) || !isset($_GET['experiment'])){ exit; }		// must have project and experiment set

	$project = $_GET['project'];
	$experiment = $_GET['experiment'];
	
	//unarchiveExperiment($_GET['project'], $_GET['experiment']);
	$dir = USER_PROJECTS_DIR."/$project/experiments";
	$archive = file(USER_PROJECTS_DIR."/$project/experiments/$experiment/.archive", FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
	$archive = $archive[0];
	
	exec("cd $dir; unzip -n $archive; cd -");
	// if unzip succeeded:
	//unlink($archive);
	unlink(USER_PROJECTS_DIR."/$project/experiments/$experiment/.archive");
	unlink(USER_PROJECTS_DIR."/$project/experiments/$experiment/.readOnly");
	
	/******************* unarchive .formatted as well ************************/
	$experiment = ".formatted";
	
	//unarchiveExperiment($_GET['project'], $_GET['experiment']);
	$dir = USER_PROJECTS_DIR."/$project/experiments";
	$archive = file(USER_PROJECTS_DIR."/$project/experiments/$experiment/.archive", FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
	$archive = $archive[0];
	
	exec("cd $dir; unzip -n $archive; cd -");
	// if unzip succeeded:
	//unlink($archive);
	unlink(USER_PROJECTS_DIR."/$project/experiments/$experiment/.archive");
	unlink(USER_PROJECTS_DIR."/$project/experiments/$experiment/.readOnly");
	/********************************************************************/
	
	header("Location: projects.php?proj=".$_GET['project']."&exp=".$_GET['experiment']); // send back
	exit;
}

function displayPedigree() {
		$files = "";
		header("Location: projects.php?proj=".$_GET['project']."&pedigree=true"); // send back
		exit;
}

function dataBrowser() {
	if (!isset($_GET['project'])) { return; }
	$params = "proj=".$_GET['project'];
	if (isset($_GET['experiment'])){ $params = $params."&exp=".$_GET['experiment']; }
	header("Location: projects.php?".$params."&dataBrowser=true"); // send back
	exit;
}

function saveComment() {
	$directory = false;
	//build path
	if ( isset($_POST['project']) && (!preg_match("/^[ \t\r\n]*$/",$_POST['project'])) && isset($_POST['comments'])) {
		$directory = USER_PROJECTS_DIR."/".$_POST['project'];
	}
	else { header("Location: main.php"); } // send to main on error
	// don't allow hidden, or ../ or ./
	$arr = explode("/", $directory);
	for ($i = 1; $i < sizeof($arr); $i += 1)  {
		if (strpos($arr[$i],".") === 0) {			// just in case
			$directory = false;
			break;
		}
	}
	// save comments into file	
	if ($directory != false) {
		$commentsFile = $directory."/".COMMENTS_FILE;
		$fh = fopen($commentsFile, 'w');
		fwrite($fh, $_POST['comments']);
		fclose($fh);
	}
	header("Location: projects.php?proj=".$_POST['project']); // send back
	exit;
}

function wizardReturnTool() {
	$_SESSION["newProjectName"] = $_GET['project'];
	$projName = $_GET['project'];
	if (is_file(USER_PROJECTS_DIR."/".$projName."/.inWizard")) { header("Location: wizard.php?action=snp1"); } // send back to wizard
	elseif (is_file(USER_PROJECTS_DIR."/".$projName."/.inWizardDat")) {	header("Location: wizard.php?action=dat1"); } // send back to wizard
	exit;
}

function simpleZoomTool() {
	$file = "";
	if (isset($_GET['checkboxes'])) {
		$file = $_GET['checkboxes'][0];
		preg_match("/(.*)\.[^\.]+$/", $file, $fileHead);
		$fileHead = $fileHead[1];
	}
	else {
		header("Location: projects.php?proj=".$_GET['project']."&exp=".$_GET['experiment']); // send back
		exit;
	}
	header("Location: tools.php?showTool=Zooming&proj=".$_GET['project']."&exp=".$_GET['experiment']."&checkboxes[]=".$file);
	exit;
}

function filteringTool() {
	$file = "";
	if (isset($_GET['checkboxes'])){
		$file = $_GET['checkboxes'][0];
		preg_match("/(.*)\.[^\.]+$/", $file, $fileHead);
		$fileHead = $fileHead[1];
	}
	else {
		header("Location: projects.php?proj=".$_GET['project']."&exp=".$_GET['experiment']); // send back
		exit;
	}
	header("Location: tools.php?showTool=Filtering&proj=".$_GET['project']."&exp=".$_GET['experiment']."&checkboxes[]=".$file);
	exit;
}

function multiPointTool() {
	$files = "";
	if (isset($_GET['checkboxes'])){
		foreach ($_GET['checkboxes'] as $input){ $files = $files."&checkboxes[]=".$input; }
	}
	else {
		header("Location: projects.php?proj=".$_GET['project']."&exp=".$_GET['experiment']); // send back
		exit;
	}
	header("Location: tools.php?showTool=MultiPointAnalysis&proj=".$_GET['project']."&exp=".$_GET['experiment'].$files);
	exit;
}

function twoPointTool() {
	$files = "";
	if (isset($_GET['checkboxes'])){
		foreach ($_GET['checkboxes'] as $input){ $files = $files."&checkboxes[]=".$input; }
	}
	else {
		header("Location: projects.php?proj=".$_GET['project']."&exp=".$_GET['experiment']); // send back
		exit;
	}
	header("Location: tools.php?showTool=TwoPointAnalysis&proj=".$_GET['project']."&exp=".$_GET['experiment'].$files);
	exit;
}

function lm_markersTool() {
	$files = "";
	if (isset($_GET['checkboxes'])) {
		foreach ($_GET['checkboxes'] as $input){ $files = $files."&checkboxes[]=".$input; }
	}
	else {
		header("Location: projects.php?proj=".$_GET['project']."&exp=".$_GET['experiment']); // send back
		exit;
	}
	header("Location: tools.php?showTool=lm_markers&proj=".$_GET['project']."&exp=".$_GET['experiment'].$files);
	exit;
}

function haplotypingTool() {
	$files = "";
	if (isset($_GET['checkboxes'])) {
		foreach ($_GET['checkboxes'] as $input) { $files = $files."&checkboxes[]=".$input; }
	}
	else {
		header("Location: projects.php?proj=".$_GET['project']."&exp=".$_GET['experiment']); // send back
		exit;
	}
	header("Location: tools.php?showTool=Haplotyping&proj=".$_GET['project']."&exp=".$_GET['experiment'].$files);
	exit;
}

function segregationTool() {
	$files = "";
	if (isset($_GET['checkboxes'])) {
		foreach ($_GET['checkboxes'] as $input) { $files = $files."&checkboxes[]=".$input; }
	}
	else {
		header("Location: projects.php?proj=".$_GET['project']."&exp=".$_GET['experiment']); // send back
		exit;
	}
	header("Location: tools.php?showTool=Segregation&proj=".$_GET['project']."&exp=".$_GET['experiment'].$files);
	exit;
}

function clusteringTool() {
	$files = "";
	if (isset($_GET['checkboxes'])) {
		foreach ($_GET['checkboxes'] as $input){ $files = $files."&checkboxes[]=".$input; }
	}
	else {
		header("Location: projects.php?proj=".$_GET['project']."&exp=".$_GET['experiment']); // send back
		exit;
	}
	header("Location: tools.php?showTool=Clustering&proj=".$_GET['project']."&exp=".$_GET['experiment'].$files);
	exit;
}

function cleaningTool() {
	$files = "";
	if (isset($_GET['checkboxes'])){
		foreach ($_GET['checkboxes'] as $input){ $files = $files."&checkboxes[]=".$input; }
	}
	else {
		header("Location: projects.php?proj=".$_GET['project']."&exp=".$_GET['experiment']); // send back
		exit;
	}
	header("Location: tools.php?showTool=Cleaning&proj=".$_GET['project']."&exp=".$_GET['experiment'].$files);
	exit;
}

function mappingTool() {
	header("Location: projects.php?proj=".$_GET['project']."&mapping=true"); // send to mapping
	exit;
}

function gl_autoTool() {
	$files = "";
	if (isset($_GET['checkboxes'])) {
		foreach ($_GET['checkboxes'] as $input){ $files = $files."&checkboxes[]=".$input; }
	}
	else {
		header("Location: projects.php?proj=".$_GET['project']."&exp=".$_GET['experiment']); // send back
		exit;
	}
	header("Location: tools.php?showTool=gl_auto&proj=".$_GET['project']."&exp=".$_GET['experiment'].$files);
	exit;
}
