<script type="text/javascript">
projects = new Array();
experiments = new Array();
expFiles = new Array();
rawFiles = new Array();

// put all input fields in this array (in order to disable when switching between tools)
parametersFields = new Array(
	'ClusteringMarkersDistance', 'ClusteringAndClean',
	'CleanThreshold',
	'Convertparam',
	//'TwoPointAnalysisParam1',
	'zoomingStart', 'zoomingEnd',
	'filteringDistance',
	'multiStart','multiEnd','multiJump');

// put all tools by their ID in this array (for switching between tools)
//Tools = new Array('Convert','Clustering','ClusterNoFilter','Filtering','TwoPointAnalysis','MultiPointAnalysis');
Tools = new Array('Convert','Clustering','TwoPointAnalysis', 'Zooming', 'Filtering', 'MultiPointAnalysis','Haplotyping','Segregation','lm_markers');
var chosenTool = 'none';

//Omer - these values are apparently not in use...
var MultiPointMaxMarkers 	= 20;	// change in order to allow more markers for analysis
var HaplotypingMaxMarkers 	= 15;	// change in order to allow more markers for analysis

// used for the hyplotyping analisys
var MaxMarkersPerWindows	=	120;	// the max mrakers allowd per window
var MaxWindowsAllowd		=	8; //the max number of windows allowd for analysis

var InputInitial = null;
var ClustersInitial = 'c';

// hides a group of elements
function hideElementsById(array){
	for (var i=0 ; i < array.length ; i++){
		hideElement(getElement(array[i]));
	}
}

function disableElement(element){
	if (document.getElementById(element) == null){
		return;
	}
	document.getElementById(element).disabled = true;
}

function enableElement(element){
	if (document.getElementById(element) == null){
		return;
	}
	document.getElementById(element).disabled = false;
}

function toggleElement(element) {
	if (element.style.display == '') {element.style.display = 'none';}
	else {element.style.display = '';}
}

function checkDistance(value) {
	if ( (value <= 10) && (value >= 0.1) ){
		return true;
	}
	alert('Illegal distance.');
	return false;
}

function isLegalValue(value, location) {
	if (/[ \&\t\s\$\\\/\(\)]+/.test(value) || (value == '') || (/^\./.test(value)) ){
		alert('Illegal input in ' + location + '.');
		return false;
	}
	return true;
}

function getExperimentsForProject(project) {
	var elem;
	var exps = new Array();
	exps[0] = '-- Experiments --';
	for (var i=0 ; i < experiments.length ; i++){
		elem = experiments[i].split("*");
		if (elem[0] == project){
			exps[exps.length] = elem[1];
		}
	}
	return exps;
}

function getChromsForProjectExperiment(project, experiment) {
	var elem;
	var returnFiles = new Array();
	returnFiles[0] = '-- Files --';
	for (var i=0 ; i < expFiles.length ; i++){
		elem = expFiles[i].split("*");
		if ( (elem[0] == project) && (elem[1] == experiment) ){
			returnFiles[returnFiles.length] = elem[2];
		}
	}
	return returnFiles;
}

function getRawFilesForProject(project) {
	var elem;
	var returnFiles = new Array();
	returnFiles[0] = '-- Files --';
	for (var i=0 ; i < rawFiles.length ; i++){
		elem = rawFiles[i].split("*");
		if (elem[0] == project){
			returnFiles[returnFiles.length] = elem[1];
		}
	}
	return returnFiles;
}

function updateRawFiles(newArray) {
	temp = newArray.join('$');
	rawFiles = temp.split('$');
}

function updateExperiments(newArray) {
	temp = newArray.join('$');
	experiments = temp.split('$');
}

function setSelections(selectElement, selectionsArray, doc) {
	if (doc == null) {doc = document;}		
	
	selectElement.options.length = 0;
	
	for (var i=0 ; i < selectionsArray.length ; i++) {
		var selection = selectionsArray[i];
		var newOption = doc.createElement('option');
		selectElement.options[i] = newOption;
		newOption.text = selection;
		newOption.value = selection;
	}
}

function resetSelections(elementsArray) {
	var first;
	for (var i=0 ; i < elementsArray.length ; i++) {
		select = document.getElementById(elementsArray[i]);
		first = select.options[0];
		if (select.length != 0){
			select.length = 0;
			select.options.add(first);
		}
	}
}

function setTool(choice) {
	chosenTool = choice;
}

function check(element) {
	document.getElementById(element).checked = true;
}

function unCheck(element) {
	document.getElementById(element).checked = false;
}

function restartToolsPage() {
	resetSelections(new Array('ProjectChoice','ExperimentChoice','FileChoice'));		// reseting selection menues
	for (var i = 0 ; i < Tools.length ; i++){											// hide parameters elements and reset buttons
		hideElement(getElement(Tools[i] + 'Parameters'));
		hideElement(getElement(Tools[i] + 'Reset'));
	}
	hideElement(getElement('FileUpload'));												// hide file upload menu
	check('existingBtn'); /*unCheck('uploadBtn');*/											// reset input selection buttons
	hideElement(getElement('InputSelection')); hideElement(getElement('FileSelection'));// disable experiment and file choosing
	hideElement(getElement('ParametersInput'));											// hide step 3
	disableElement('ExperimentChoice'); disableElement('FileChoice');					// disable experiment and file choosing
	disableConfirm();																	// disable confirm buttons
	for (var i = 0 ; i < parametersFields.length ; i++){								// disable all parameters
		disableElement(parametersFields[i]);
	}
}

// enables all parameters of a given tool (parameters must include the tool name)
function enableParametersOf(toolName) {
	for (var i = 0 ; i < parametersFields.length ; i++){							// uncheck all parameters' checkboxes
		if (parametersFields[i].match(toolName) != null){
			enableElement(parametersFields[i]);
		}
	}
}

// disables all confirm buttons
function disableConfirm() {
	for (var i = 0 ; i < Tools.length ; i++){
		if ( (Tools[i] + 'ToolConfirm') != null ) {
			disableElement(Tools[i] + 'ToolConfirm');
		}
	}
/*	disableElement('ConvertToolConfirm');
	disableElement('FilteringToolConfirm');
	disableElement('ClusteringToolConfirm');	
	disableElement('TwoPointAnalysisToolConfirm'); */
}

// enables all confirm buttons
function enableConfirm() {
	for (var i = 0 ; i < Tools.length ; i++){
		enableElement(Tools[i] + 'ToolConfirm');
	}
}

function legalRange (start, end, jumps, max, initial) {
	if (end == 'xlast') {end = start;}
	// here start and end doesn't have the initial any more.
	// if the anaylsis isn't on a clusterd file, than no initial will be removed. (becasue than initial = null)

	// 1. making sure that the right errors will be shown always.
	// 2. change of message text, according to dan's request.
			
	if (max == null || !isInteger(max)) {        
		alert('max error, please inform us with this error. max: '+max);
		return false;
	}
	
	// checking start & end fields
	var error;
	if ((start !== "" && (!isInteger(start))) || (end !== "" && !isInteger(end))) {
		/* TODO: check if the following test is relevant. for now it works just fine when we dont add c 
					befor the start of the marker name.
		if (initial == ClustersInitial) {
			error = 'Input files have clusters. Thus, use the format: '+initial+'<integer> (rather than just an integer)\n'+
					'to fill in the "From Marker" and "To Marker" fields.';
		 }
		else {
		*/
		error = 'Illegal input, the number should be in valid range.';
		alert(error);
		return false;
	}
	
	if (jumps != null && !isInteger(jumps)) {
		alert('Illegal input, you must enter integer numbers.');
		return false;
	}

	start 	= parseInt(start);
	end 	= parseInt(end);
	if (jumps != null) {jumps 	= parseInt(jumps);}	
	if (start > end){
		alert('Illegal range.');
		return false;
	}
	if ((jumps != null) && (jumps <= 0)) {
		alert('Illegal jumps.');
		return false;
	}
	//if ( ((end - start + 1) / jumps) > max ){
	if ( (jumps == null) && ((end - start + 1)  > max) ){
		alert('Entered range is too large, try a smaller range or try using windows.');
		return false;
	}	
	if ( jumps > max ) {
		//alert('Entered range is too large, try a smaller range or try using a larger window.');
		alert('Window is too large.');
		return false;
	}
	return true;
}


function legalZoomingMarkersRange(start, end, isPositionsChecked, isNumbersChecked, isNamesChecked) {
    
    if (isNumbersChecked) {
        if (!isInteger(start) || !isInteger(end)) {
            alert('start and end markers must be integers');
            return false;
        }
        start 	= parseInt(start);
        end 	= parseInt(end);
        if (start < 1 || end < 1 || start>end) {
            alert('Invalid range.');
            return false;
        }
    }
    
    if (isPositionsChecked) {
        if (!isFinite(start) || !isFinite(end)) {
            alert('Invalid range. Position fields must be positive numbers.');
            return false;
        }
        start = parseFloat(start);
        end 	= parseFloat(end);
        if (start < 0 || end < 0 || start>end) {
            alert('Invalid range.');
            return false;
        }        
    }
    
    return true;
}

// checks if a given string is in the type of a integers list separated by ',' and under the size of maxSize
// if initial is given, every number must have the initial.
function legalList(list, maxSize, initial){
	li = list.split(',');
	if (li.length > maxSize){
		alert('Input has too many markers.');
		return false;
	}
	var item;
	var error;
	for (var i = 0 ; i < li.length ; i++){
		item = hasInitial(li[i], initial);
		//if (!item) { return false; }
		if ( isNaN(item) || (item <= 0) || !isInteger(item)){
			error = 'Input contains an illegal value, please enter integer numbers only, separated by ",".';
			if (initial == ClustersInitial){		
				// 13/04/2011 Dvir: change of message text, according to dan's request
				//error = 'Input files have clusters. Clustered markers must be in the form of '+initial+'<integer>';
				error = 'Input files have clusters. Thus, use the format: '+initial+'<integer> (rather than just an integer)\n'+
						'to fill in the "From Marker" and "To Marker" fields.';
			}
			alert(error);
			return false;
		}
	}
	
	return true;
}

function legalWindow(windowSize, maxSize, sizeName){
	if (sizeName == null) {  sizeName = 'max range'; }
	if ( isNaN(windowSize) || !isInteger(windowSize) ){
		alert('Illegal window size.');
		return false;
	}
	if ( windowSize <= 0 ){
		alert('Window size must be 1 or higher.');
		return false;
	}	
	if (windowSize > maxSize){
		alert('Window size cannot be larger than ' + sizeName);
		return false;
	}
	return true;
}

function isInteger(num) {
	if ( num == null || num == "" || isNaN(num) ) { return false; }
	return Math.floor(num) == num ? true : false;
}

function isLegalNumber(num){
	if (!isLegalValue(num) || !isInteger(num)){
		alert(num +' is an illegal value. Only integers are allowed.');
		return false;
	}
	return true;
}

function isLegalReal(num, min, max) {
	if ((min == null) || isNaN(min)) { min = null; }
	if ((max == null) || isNaN(max)) { max = null; }
	if (!isLegalValue(num) || isNaN(num)) {
		alert(num +' is an illegal value.');
		return false;
	}
	if ((min != null) && (num < min)) {
		alert(num +' must be higher than ' + min);
		return false;
	}
	if ((max != null) && (num > max)) {
		alert(num +' must be smaller than ' + max);
		return false;
	}
	return true;
}

// returns false if a give str doesnt have the given initial.
// if it has, it will return the rest of the str.
// if initial was null or "" returns the str with no change.
function hasInitial(str, initial){
	if ((initial == null) || (initial == "")) {
		return str;
	}

	str = str.split(initial);
	if ( (str[0] != "") || (str.length != 2) ){
		return false;
	}
	return str[1];
}

function getSelectedRadio(buttonGroup) {
   // returns the array number of the selected radio button or -1 if no button is selected
   if (buttonGroup[0]) { // if the button group is an array (one button is not an array)
      for (var i=0; i<buttonGroup.length; i++) {
         if (buttonGroup[i].checked) {
            return i
         }
      }
   } else {
      if (buttonGroup.checked) { return 0; } // if the one button is checked, return zero
   }
   // if we get to this point, no radio button is selected
   return -1;
} // Ends the "getSelectedRadio" function

function getSelectedRadioValue(buttonGroup) {
   // returns the value of the selected radio button or "" if no button is selected
   var i = getSelectedRadio(buttonGroup);
   if (i == -1) {
      return "";
   } else {
      if (buttonGroup[i]) { // Make sure the button group is an array (not just one button)
         return buttonGroup[i].value;
      } else { // The button group is just the one button, and it is checked
         return buttonGroup.value;
      }
   }
} // Ends the "getSelectedRadioValue" function

/*
 * this finction check the number of tasks will be created (each task for each window
 * and check that the windows are not too big
 */
function checkTasksLimit (tool, start, end, lastMarkerNum, windowSize) {
	//this test is needed only for Haplotyping
	if (tool != 'Haplotyping') {return true;}
	
	start = (start=="") ? 1 : start;
	end = (end=="") ? lastMarkerNum : end;

	var numberOfMarkers = end - start + 1;
	var numOfWindows = numberOfMarkers / windowSize;
	if (numOfWindows > MaxWindowsAllowd) {
		alert ("There are too many windows selected (maximum #windows allowed is "+MaxWindowsAllowd+")");
		return false;
	}
	// if there are less markers that the window size selected  than the number of the markers is tha actual window size
	var actualWindowSize = (windowSize > numberOfMarkers) ? numberOfMarkers : windowSize;
	if (actualWindowSize > MaxMarkersPerWindows) {
		alert ("Computation has too many markers (maximum #markers allowed per computation is "+MaxMarkersPerWindows+")");
		return false;
	}

	return true;
}
</script>
<script type="text/javascript" src="jsFunctions.js">
</script>

<?php
	function ToolsFlow() {
		$chosenTool = false;
		$dir = USER_PROJECTS_DIR;
		$projects = array();
		$experiments = array();
		$exprFiles = array();
		$rawFiles = array();        
		createUserDB($projects, $experiments, $exprFiles, $rawFiles);
		$inputInitial = null;
		$TWOPOINT_MAX_MARKERS = 1000000;
		$MULTIPOINT_MAX_MARKERS = 20;
		$LM_MARKERS_MAX_MARKERS = 100;
		$HAPLOTYPING_MAX_MARKERS = 100;
		
		// set Tool
		$tools = array('Clustering','Cleaning','Convert','TwoPointAnalysis','MultiPointAnalysis','Haplotyping','Segregation','Filtering','Zooming','lm_markers','gl_auto');
		if ( isset($_GET['showTool']) && (in_array($_GET['showTool'],$tools))) {
			$chosenTool = $_GET['showTool'];
		}
		
		$fixedInput = false;
		if (($chosenTool != false) && isset($_GET['checkboxes']) && isset($_GET['proj']) && isset($_GET['exp'])) { $fixedInput = true; }			
		?>
			
			<form method="get" action="opTool.php">
				<!-- Main Div Selection Beginning -->
				<?php if ($fixedInput == false) { ?>			<!-- if we came from an experiment using the toolBar do not show this selection -->
				<div id="ToolChoice" name="ToolChoice">
					<p>
					<strong>Step 1 - Tool choice</strong><br/>
					Choose a Tool:
					<select id="toolsChoice" name="toolsChoice"
						onChange="
							if(this.options[this.selectedIndex].value != ''){
								window.top.location.href = 'tools.php?showTool=' + this.options[this.selectedIndex].value;
							}
							">
						<option value="none">-- Select a Tool --</option>
						<optgroup label="Conversion Tools">
							<option value="Convert" <?php echo ($chosenTool == "Convert") ? "selected" : "" ;?> >
							Convert to Superlink format Tool</option>
						</optgroup>
						<optgroup label="Data Reduction Tools">
							<option value="Filtering" <?php echo ($chosenTool == "Filtering") ? "selected" : "" ;?> >
							Filtering Tool</option>							
							<option value="Zooming" <?php echo ($chosenTool == "Zooming") ? "selected" : "" ;?> >
							Zooming Tool</option>					
							<option value="Cleaning" <?php echo ($chosenTool == "Cleaning") ? "selected" : "" ;?> >
							Cleaning Tool</option>
							<option value="Clustering" <?php echo ($chosenTool == "Clustering") ? "selected" : "" ;?> >
							Clustering Tool</option>
						</optgroup>
						<optgroup label="Analysis Tools">
							<option value="TwoPointAnalysis" <?php echo ($chosenTool == "TwoPointAnalysis") ? "selected" : "" ;?> >
							Two Point Analysis Tool</option>
							<option value="MultiPointAnalysis" <?php echo ($chosenTool == "MultiPointAnalysis") ? "selected" : "" ;?> >
							Multi Point Analysis Tool</option>
							<option value="lm_markers" <?php echo ($chosenTool == "lm_markers") ? "selected" : "" ;?> >
							Morgan lm_linkage (Approximate Multi Point Analysis Tool)</option>
							<option value="Haplotyping" <?php echo ($chosenTool == "Haplotyping") ? "selected" : "" ;?> >
							Haplotyping Tool</option>
							<option value="Segregation" <?php echo ($chosenTool == "Segregation") ? "selected" : "" ;?> >
							Segregation Tool</option>
						</optgroup>
						<optgroup label="Other Tools">
							<option value="DrawAPedigree" <?php echo ($chosenTool == "DrawAPedigree") ? "selected" : "" ;?> >
							Draw a pedigree Tool</option>
						</optgroup>
					</select>

						
					</p>
				</div>
				<?php } 
				else { /* $fixedInput==true */ ?>
					<input type="hidden" name="toolsChoice" id="toolsChoice" value="<?php echo $chosenTool;?>"/>
				<?php } ?>
				<!-- Main Div Selection  End-->
				
				<!-- title -->
				<?php
					$lars = "";
					if ( ($chosenTool == "Haplotyping") && isset($_GET['lars']) && ($_GET['lars'] == "true")) {
						$lars = "(Lars)";
					}
					if ( $chosenTool && ($chosenTool != 'none') ) {
						$toolToPrint = $chosenTool;
						if ($chosenTool == "lm_markers") {$toolToPrint = "Morgan lm_linkage";}
						if ($chosenTool == "gl_auto") {$toolToPrint = "Morgan gl_auto";}
						echo "<h2>" . $toolToPrint . $lars ." Tool</h2>";
						echo getToolExplanation($chosenTool) . "<br/>";
					}
				?>

				<!-- Cleaning / Clustering / Zooming / Filtering File Choosing Beginning -->
				<?php
				if (!$fixedInput) {
					if ( in_array($chosenTool, array("Cleaning","Clustering","Zooming","Filtering")) ){ ?>
						<div id="InputSelection">
						<strong>Step 2 - Choose input</strong><br/>
						<p>
							Use files from existing projects&nbsp;&nbsp;&nbsp;&nbsp;
							(or <a href="javascript:void window.open('toolsUpload.php','myWin','width=700, height=420, top=150, left=250, menubar=0, location=1, status=1, scrollbars=1, resizable=0')"
								style="font-size :80%">Upload files</a>)
						</p>
						</div>
						
						<div id="FileSelection">
						<p>
							Select Data:<br/><br/>
							<div id="ProjectChoice1" style="float: left;">
							<p>Select a project<br/>
							<select id="ProjectChoice" name="ProjectChoice" size="10" onChange="
								var element = document.getElementById('ProjectChoice');
								var selIndex = element.selectedIndex;
								resetSelections(new Array('FileChoice'));
								disableElement('FileChoice');
								disableConfirm();
								if (selIndex == 0) {
									disableElement('ExperimentChoice');
									disableElement('Rawrsrc');
									disableElement('Exprsrc');
								} else {
									enableElement('Rawrsrc');
									enableElement('Exprsrc');
									if (document.getElementById('Rawrsrc').checked == true){
										setSelections(getElement('FileChoice'), getRawFilesForProject(element.options[selIndex].text));
										enableElement('FileChoice');
									}
									else{
										enableElement('ExperimentChoice');
									}
								}
								
								var element = document.getElementById('ProjectChoice');
								var selIndex = element.selectedIndex;
								setSelections(getElement('ExperimentChoice'), getExperimentsForProject(element.options[selIndex].text));" >
							</select>
							</p>
							</div>
							<div id="ProjectChoice2" style="float: left; padding-left: 20px;">
							<p>Select a source<br/>
							<input type="radio" id="Rawrsrc" onClick="
								check(this.id); unCheck('Exprsrc');
								disableElement('ExperimentChoice');
								disableConfirm();
								enableElement('FileChoice');
								var proj = document.getElementById('ProjectChoice');
								if (proj.selectedIndex != -1){
									proj = proj.options[proj.selectedIndex].text;
									setSelections(getElement('FileChoice'), getRawFilesForProject(proj));
								}	"/>
							Uploaded Files<br/><br/>
							
							<input type="radio" id="Exprsrc" checked onClick="
								check(this.id); unCheck('Rawrsrc');
								enableElement('ExperimentChoice');
								resetSelections(new Array('FileChoice'));
								var exp = document.getElementById('ExperimentChoice');
								var selIndex = exp.selectedIndex;
								disableConfirm();
								if (selIndex == 0) {
									disableElement('FileChoice');
								} else {
									enableElement('FileChoice');
								}
								
								if (exp.selectedIndex != -1){
									exp = exp.options[exp.selectedIndex].text;
									var proj = document.getElementById('ProjectChoice');
									if (proj.selectedIndex != -1){
										proj = proj.options[proj.selectedIndex].text;
										setSelections(getElement('FileChoice'), getChromsForProjectExperiment(proj,exp));
									}
								}
								"/>
							Experiments<br/>
							<select name="ExperimentChoice" id="ExperimentChoice" disabled size="6" onChange="
								var exp = document.getElementById('ExperimentChoice');
								var selIndex = exp.selectedIndex;
								disableConfirm();
								if (selIndex == 0) {
									disableElement('FileChoice');
								} else {enableElement('FileChoice');}
								exp = exp.options[exp.selectedIndex].text;
								var proj = document.getElementById('ProjectChoice');
								proj = proj.options[proj.selectedIndex].text;
								setSelections(getElement('FileChoice'), getChromsForProjectExperiment(proj,exp));" >
								<option value="" selected>-- Experiments --</option>
							</select>
							</p>
							</div>
							<div id="ProjectChoice3" style="float: left; padding-left: 20px;">
							<p>Select file(s)<br/>
							<select id="FileChoice" name="FileChoice[]" size="10" multiple="yes" style="width: 250px" disabled onChange="
								var files = document.getElementById('FileChoice');
								var selIndex = files.selectedIndex;
								if (selIndex == 0) {
									disableConfirm();
								} else {enableConfirm();} ">
								<option value="" selected>-- File(s) --</option>
							</select><br/>
							(hold the CTRL button to select multiple files)<br/>
							</p>
							</div>
							
							<div style="clear: both"></div>
						</p>
						</div>
				<?php } 
					else{ /* Temporary!!!! */
						echo "<div style=\"display: none\"><select id=\"ProjectChoice\" name=\"ProjectChoice\"></select></div>";
					}
				}
				else {
					$inputTable = array();
					$maxMarkers["dat"] = false;
					$maxMarkers["ped"] = false;
					$maxMarkers["markers"] = 0;
					$i = 0;
					foreach ($_GET['checkboxes'] as $input){
						$input = explode("@", $input);
						if (sizeof($input) != 2){ continue; }
						$table['name']		= $input[1];
						$table['method']	= $input[0];
						$table['space']		= ($table['method'] == "") ? "" : " ";
						
						if ( preg_match("/cluster/", $table['method']) || preg_match("/cluster/", $table['name']) ){
							$inputInitial = "ClustersInitial";
						}
						$dir = USER_PROJECTS_DIR."/".$_GET['proj']."/experiments/".$_GET['exp'];
						$info = getExpContentInfo($dir, $table['name']);
						$header = (($table['method'] == "") ? "" : $table['method']."_")."datfile";
						$see_markers = (isset($info[$header]) && (is_file($info[$header]))) ? "(<a href=\"showMarkers.php?proj=".$_GET['proj']."&file=".base64_encode($info[$header])."\" target=\"_blank\">see markers</a>)" : "";
						$table['seeMarkersLink'] = $see_markers;
						$inputTable[$i]		= $table;
						$i += 1;
						
						$pedHeader = (($table['method'] == "") ? "" : $table['method']."_")."pedfile";
						unset($line);
						exec("head -1 ".$info[$header], $line);
						$line = explode(" ", $line[0]);
						if (!$maxMarkers["dat"]) {
							$maxMarkers["dat"] = $info[$header];
							$maxMarkers["ped"] = $info[$pedHeader];
							$maxMarkers["markers"] = $line[0] - 1;
						}
						else{
							if ($maxMarkers["markers"] < ($line[0] - 1)){
								$maxMarkers["dat"] = $info[$header];
								$maxMarkers["ped"] = $info[$pedHeader];
								$maxMarkers["markers"] = $line[0] - 1;
							}
						}
					}
					
					$HMMsize = HmmSizeSearch($maxMarkers["dat"], $maxMarkers["ped"]);
					$MULTIPOINT_MAX_MARKERS = ($maxMarkers["markers"] > $MULTIPOINT_MAX_MARKERS) ? $MULTIPOINT_MAX_MARKERS : $maxMarkers["markers"];
					$toolToPrint = $chosenTool;
					if ($chosenTool == "lm_markers") {$toolToPrint = "Morgan lm_linkage";}
					?>
					<p>
					<strong>Step 2 - Choose input</strong><br/>
					<strong><?php echo $toolToPrint;?></strong> chosen input:<br/><br/>
					<div style="padding-left: 5px; padding-top: 5px;">
						<div style="background: gray; float: left; z-index: 1;">
							<div style="background: #f0ffff; border: 1px solid black; padding: 15px; float: left; z-index: 2; position: relative; left: -5px; top: -5px;">
								<table>
								<tr><td><strong>Project: 	</strong></td><td>&nbsp;&nbsp;<?php echo $_GET['proj'];?></td></tr>
								<?php $expName = ($_GET['exp'] == ".formatted") ? "Formatted Data" : $_GET['exp']; ?>
								<input type="hidden" name="parent" id="parent" value="<?php echo $_GET['exp']; ?>"/>
								<tr><td><strong>Experiment: </strong></td><td>&nbsp;&nbsp;<?php echo $expName;?></td></tr>								
								<?php
									$first = true;
									//foreach ($_GET['checkboxes'] as $input){
									for ($i = 0 ; $i < sizeof($inputTable) ; $i += 1){
										echo ($first == true) ? "<tr><td><strong>Input: </strong></td>" : "<tr><td></td>";
										$first = false;
										$table = $inputTable[$i];
										?>  <td>&nbsp;&nbsp;<?php echo $table['method'].$table['space'].$table['name']; ?></td>
											<td>&nbsp;&nbsp;<?php echo $table['seeMarkersLink']; ?></td></tr> <?php
									}
								?>
								</table>
							</div>
						</div>
					</div>
					<div style="clear: both;"></div>
					<!-- <p>Note that you may choose to operate the tool in the input's experiment, or create a new experiment in this project.</br></p> -->
					<br/>
					</p>
					<input type="hidden" name="ProjectChoice" 	 id="ProjectChoice"    value="<?php echo $_GET['proj']; ?>"/>
					<input type="hidden" name="ExperimentChoice" id="ExperimentChoice" value="<?php echo $_GET['exp'];  ?>"/>
					<?php foreach ($_GET['checkboxes'] as $input){ ?>
							<input type="hidden" name="FileChoice[]" id="FileChoice[]" value="<?php echo $input;		?>"/>
					<?php }
				}
				?>
				<!-- Cleaning / Clustering / Zooming / Filtering file choosing end -->
				
				<!-- Convert tool file choosing beginning -->
				<?php if ( $chosenTool == "Convert"){ ?>
						Convert tool is not available yet.<br/>
						You may use our <a href="wizard.php">wizard</a> instead.<br/>
				<?php } ?>
				<!-- Convert tool file Choosing End -->
				
				<!-- Two Point Analysis Tool file choosing beginning -->
				<?php if ( ($chosenTool == "TwoPointAnalysis") || ($chosenTool == "MultiPointAnalysis") ){ ?>
						<!-- TODO file choosing or use exiting one -->						
				<?php } ?>	
				<!-- Two Point Analysis Tool file choosing end -->
								
				<!-- Parameters Step Beginning -->
				<?php //if ( $chosenTool == "Cleaning" || $chosenTool == "Clustering" ){ ?>
				<?php if ( in_array($chosenTool, $tools) ){ ?>
						<strong>Step 3 - Set parameters</strong><br/>
						<?php
						//$expName = (isset($_GET['exp']) && in_array($chosenTool, array("Zooming","Filtering"))) ? $_GET['exp'] : "";
						$i = 1;
						$toolToPrint = $chosenTool;
						if ($toolToPrint == "lm_markers") {$toolToPrint = "lm_linkage";}
						$expName = $toolToPrint."_1";
						if (isset($_GET['proj'])){
							$project = $_GET['proj'];
							$matches = preg_grep("/$project.*$expName/", $experiments);
							while (sizeof($matches) > 0){
								$i += 1;
								$expName = $toolToPrint."_".$i;
								$matches = preg_grep("/$project.*$expName/", $experiments);
							}
						}
						?>
						Name your experiment: <input type="text" name="experimentName" id="experimentName" value="<?php echo $expName;?>" style="width: 350px"><br/><br/>
				<?php }	?>				
				
				<div id="ParametersInput">					
					
					<!-- Convert Tool Parameters Beginning -->
					<!--<div id="ConvertParameters" style="display: none;">					
						Convert parameters:<br/>
						Column labeling:<br/>
						Mapping:<br/>
						<input type="text" name="Convertparam" id="Convertparam" style="width: 100px"/><br/><br/>
						
						<input type="submit" value="Confirm" id="ConvertToolConfirm"
						 onClick="if(checkDistance(document.getElementById('Convertparam').value)){
									return confirm('Are you ready for running the filtering tool?');} return false;" />
						<!-- TODO: check if files selected or uploaded -->
					<!--</div>
					<!-- Convert Tool Parameters End -->				
					
					<!-- Filtering Tool Parameters Beginning -->
					<?php if ( $chosenTool == "Filtering" ){ ?>
							<p>
								Filtering distance:
								<select name="filteringDistance" id="filteringDistance">
									<option value="0.1">0.1 cM</option>
									<option value="0.25">0.25 cM</option>
									<option value="0.5">0.5 cM</option>
									<option value="0.75">0.75 cM</option>
									<option value="1" selected>1 cM</option>
									<option value="2" selected>2 cM</option>
									<option value="5">5 cM</option>
									<option value="10">10 cM</option>
								</select>
								<?php 
									$help = new Help();
									$help->displayHelpLink("tools", "FilteringDistChoose");
								?>
								<br/>
							</p>
							
							<input type="submit" value="Confirm" id="FilteringToolConfirm"
								 onClick="return (isLegalValue(document.getElementById('experimentName').value, 'experiment name') &&
												  confirm('Are you ready for running the <?php echo (toolDisplayName($chosenTool)); ?> tool?'));" />
					<?php } ?>
					<!-- Filtering Tool Parameters End -->
					
					<!-- Zooming Tool Parameters Beginning -->					<!-- CANCELLED -->                    
					<?php if ( $chosenTool == "Zooming" ) {
                        ?>
							<p>
								please note that zooming my be done in the input experiment.<br/><br/>                                
								
								Range Type:<br/>
   								&nbsp;&nbsp;&nbsp;<input type="radio" id="zoomNumbers" name="zoomBy" value="numbers" checked /> Marker numbers<br/>
                                &nbsp;&nbsp;&nbsp;<input type="radio" id="zoomPositions" name="zoomBy" value="positions"/> Positions on chromosome (cM)<br/>
								&nbsp;&nbsp;&nbsp;<input type="radio" id="zoomNames" name="zoomBy" value="strings"/> Marker names<br/>
                                <br/>
								Zooming range:<br/>
								&nbsp;&nbsp;&nbsp;start: <input type="text" name="zoomingStart" id="zoomingStart"/>
								&nbsp;&nbsp;&nbsp;&nbsp;
								end: <input type="text" name="zoomingEnd" id="zoomingEnd"/>
								<br/>
                                
                                <?php
                                // Omer 8/8/2011 - Add an expansion checkbutton if the data originated in a .SNP file                                
                                $projDir = USER_PROJECTS_DIR."/".$_GET['proj'];
                                $uploadedData = is_file($projDir."/raw/".UPLOADED_DATA_INFO) ? parse_ini_file($projDir."/raw/".UPLOADED_DATA_INFO, true) : false;
                                if ($uploadedData and ($uploadedData['general'][KEY_INPUT_TYPE] === "snp")) {
                                    ?>
                                    <br><br><strong>Data Expansion</strong><br/>
                                    <br><input type="checkbox" name="expandZoomedRegion" id="expandZoomedRegion" checked/>Add more markers in this region<br/>
                                    <?php
                                }
                                ?>                                    
                                
							</p>

							<input type="submit" value="Confirm" id="ZoomingToolConfirm"
								 onClick="return (isLegalValue(document.getElementById('experimentName').value, 'experiment name') &&
                                                  isLegalValue(document.getElementById('zoomingStart').value, 'start field') &&
                                                  isLegalValue(document.getElementById('zoomingEnd').value, 'end field') &&
                                                  legalZoomingMarkersRange(
                                                  document.getElementById('zoomingStart').value,
                                                  document.getElementById('zoomingEnd').value,
                                                  document.getElementById('zoomPositions').checked,
                                                  document.getElementById('zoomNumbers').checked,
                                                  document.getElementById('zoomNames').checked                                                  
                                                  ) &&
												  confirm('Are you ready for running the <?php echo (toolDisplayName($chosenTool)); ?> tool?'));" />
											
					<?php } ?>
					<!-- Zooming Tool Parameters End -->
					
					<!-- Cleaning and Clustering Tools Parameters Beginning -->
					<?php if ( $chosenTool == "Cleaning" || $chosenTool == "Clustering" ){ ?>
								<?php
									$additionalConfirmationChecks = "";
									if ( $chosenTool == "Clustering" ){
										$additionalConfirmationChecks = "&& isLegalValue(document.getElementById('ClusteringMarkersDistance').value, 'markers distance') &&
																		checkDistance(document.getElementById('ClusteringMarkersDistance').value)";
									?>
								<?php }
									else {?>
									<!-- Cleaning Parameters Beginning -->
									<span id="CleaningParameters"  <?php echo ( $chosenTool == "Clustering" ) ? "style=\"display: none;\"" : ""; ?>>										
									</span>
									<br/>
								<?php } ?>
								
								<!-- Clustering Parameters Beginning -->
								<?php if ( $chosenTool == "Clustering" ){ ?>
								<br/>
								Window size for clustering in cM (0.1 - 10):
								<input type="text" name="ClusteringMarkersDistance" id="ClusteringMarkersDistance" value="10" style="width: 100px"/>
								<?php
									$help = new Help();
									$help->displayHelpLink("tools", "ClusteringDistChoose");
								?>
								<br />
								<?php }
								CreateMarkersRangeParameters($chosenTool, $TWOPOINT_MAX_MARKERS, $inputInitial, false, true, $additionalConfirmationChecks);
								?>
					<?php } ?>
					<!-- Cleaning and Clustering Tool Parameters End -->
					
					<!-- Two Point Analysis Tool Parameters Beginning -->					
					<?php if ( $chosenTool == "TwoPointAnalysis" ){
							showAutomateOption();
							?><br/><br/><?php
							showMOIandFrequencySelection();
							$moreChecks = "&& isLegalReal(document.getElementById('frequency').value, 0 , 1)";
							?><br/><?php
							CreateMarkersRangeParameters($chosenTool, $TWOPOINT_MAX_MARKERS, $inputInitial, false, true, $moreChecks);
							?>
							<!--<input type="submit" value="Confirm" id="TwoPointAnalysisToolConfirm"
							 onClick="return (isLegalValue(document.getElementById('experimentName').value, 'experiment name') 	&&
											  confirm('Are you ready for running the <?php echo (toolDisplayName($chosenTool)); ?> tool?'));" />-->
							<!-- TODO: check if files selected or uploaded -->
					<?php } ?>
					<!-- Two Point Analysis Tool Parameters Beginning -->					
					
					<!-- Multi Point Analysis Tool Parameters Beginning -->
					<?php if ( $chosenTool == "MultiPointAnalysis" ){
							showAutomateOption();
							?><br/><br/><?php
							showMOIandFrequencySelection();
							$moreChecks = "&& isLegalReal(document.getElementById('frequency').value, 0 , 1)";
							?><br/><?php
							$maximumMarkers["multipleWindow"] = $MULTIPOINT_MAX_MARKERS;
							if ($HMMsize) {
								$maximumMarkers["singleWindow"] = $HMMsize;
							}
							CreateMarkersRangeParameters($chosenTool, $maximumMarkers, $inputInitial, true, false, $moreChecks);
							?>
							
								 
								 
								 <!--return (isLegalValue(document.getElementById('experimentName').value, 'experiment name') 	&&
												  isLegalValue(document.getElementById('multiStart').value, 	'start marker')		&&
												  isLegalValue(document.getElementById('multiEnd').value, 		'end marker')		&&
												  isLegalValue(document.getElementById('multiJump').value, 		'marker window size') &&
												  confirm('Are you ready for running the <?php echo (toolDisplayName($chosenTool)); ?> tool?')); -->
												  
							
					<?php } ?>					
					<!-- Multi Point Analysis Tool Parameters End -->
					
					<!-- lm_markers Analysis Tool Parameters Beginning -->
					<?php if ( $chosenTool == "lm_markers" ) {
							?><br/><br/><?php                            
							showMOIandFrequencySelection();
							$moreChecks = "&& isLegalReal(document.getElementById('frequency').value, 0 , 1)";
							?><br/><?php
							$maximumMarkers["multipleWindow"] = $LM_MARKERS_MAX_MARKERS;
							CreateMarkersRangeParameters($chosenTool, $maximumMarkers, $inputInitial, true, false, $moreChecks, false);
                            ?><br/><br/><?php
                            showMorganOptions("lm_linkage");                            
                            showConfirmButton($chosenTool, $maximumMarkers, $inputInitial, $moreChecks);
							?>
							
								 
								 
								 <!--return (isLegalValue(document.getElementById('experimentName').value, 'experiment name') 	&&
												  isLegalValue(document.getElementById('multiStart').value, 	'start marker')		&&
												  isLegalValue(document.getElementById('multiEnd').value, 		'end marker')		&&
												  isLegalValue(document.getElementById('multiJump').value, 		'marker window size') &&
												  confirm('Are you ready for running the <?php echo (toolDisplayName($chosenTool)); ?> tool?')); -->
												  
							
					<?php } ?>					
					<!-- lm_markers Analysis Tool Parameters End -->
					
					<!-- gl_auto Analysis Tool Parameters Beginning -->
					<?php if ( $chosenTool == "gl_auto" ) {?>
						<br/><br/><?php
							$maximumMarkers["multipleWindow"] = $LM_MARKERS_MAX_MARKERS;
							CreateMarkersRangeParameters($chosenTool, $maximumMarkers, $inputInitial, true, false, "", false);?>
						<br/><br/><?php
							showMorganOptions("gl_auto");                            
							showConfirmButton($chosenTool, $maximumMarkers, $inputInitial, "");
					} ?>
					<!-- gl_auto Analysis Tool Parameters End -->

					<!-- Haplotyping Analysis Tool Parameters Beginning -->
					<?php if ( $chosenTool == "Haplotyping" ) {
							$moreChecks = "";
							CreateMarkersRangeParameters($chosenTool, $HAPLOTYPING_MAX_MARKERS, $inputInitial, true, false, $moreChecks);
							if (isset($_GET['lars']) && ($_GET['lars'] == "true")){?>
								<input type="hidden" name="lars"  id="lars"  value="true"/>
							<?php 
							}
						} ?>					
					<!-- Haplotyping Analysis Tool Parameters End -->
					
					<!-- Segregation Analysis Tool Parameters Beginning -->
					<?php if ( $chosenTool == "Segregation" ) {
							?>
							<p>
								Choose analysis type:<br/>
								<table border="0">
								<tr>
								<td><input type="radio" checked name="segType"  id="segType"  value="Freq"/> By mutant gene frequency</td>
								<td><input type="radio" checked name="segSpeed" id="segSpeed" value="Quick"/> Quick(4 likelihood evaluations)</td>
								</tr>
								<tr>
								<td><input type="radio" name="segType"  id="segType"  value="Prev"/> By population prevalence</td>
								<td><input type="radio" name="segSpeed" id="segSpeed" value="Medium"/> Medium(50 likelihood evaluations)</td>
								</tr>
								<tr>
								<td></td>
								<td><input type="radio" name="segSpeed" id="segSpeed" value="Long"/> Long(120 likelihood evaluations)</td>
								</tr>
								</table>
							</p>
							
							<input type="submit" value="Confirm" id="SegregationAnalysisToolConfirm"
								 onClick=" 	return (isLegalValue(document.getElementById('experimentName').value, 'experiment name') &&
											confirm('Are you ready for running the <?php echo (toolDisplayName($chosenTool)); ?> tool?'));" />
							
					<?php } ?>					
					<!-- Segregation Analysis Tool Parameters End -->
				</div>
				<!-- End of parameters step -->
				
			</form>
			
			
			<!-- Reset Button (have to be out side of the form)-->
			<!--
			<?php if ( $chosenTool && ($chosenTool != 'none') ){ ?>
					<p>
					<input type="submit" value="Reset" id="Reset" onClick="window.top.location.href = 'tools.php';" />		
					</p>
			<?php } ?>
			-->
			<!-- End of reset button -->
			
		<?php
			if (!hasDiskSpace()){
				error_msg("You are low on disk space - please delete some of your files and try again. (Confirm will fail)");
			}
	}
    
    /*
	 * Omer 31/7/2011 - Show special options for morgan programs
	 * input:
	 *	$morganTool - the name of the morgan program - "lm_linkage" or "gl_auto"
	 */
	
    function showMorganOptions($morganTool) {		
        $help = new Help();
		$helpSecoundarySubject = ($morganTool == "lm_linkage") ? "lm_markersOptions" : "gl_autoOptions";
		?>
        <p>
        <b>Morgan Related Options:&nbsp;&nbsp;&nbsp;&nbsp;<?php $help->displayHelpLink("tools",$helpSecoundarySubject)?></b>
        <p>		
		
		<table style="border: 0px;">
		<tr>
		<td>
		<input type="radio" name="lmMarkersRunType" id="lmMarkersRunType" value="runLmMarkersByTime" checked onClick="
			disableElement('iterationsPerWindow');	enableElement('timePerWindow');
		" />
		Analysis time for each window:&nbsp&nbsp&nbsp
		</td>
		<td>
        <select id="timePerWindow" name="timePerWindow"> 
			<option value="30">30 seconds</option>
            <option value="60">1 minute</option>
            <option value="600">10 minutes</option>
            <option value="1800">30 minutes</option>
            <option value="3600">1 hour</option>
			<option value="18000">5 hours</option>
			<option value="36000">10 hours</option>
			<option value="86400">24 hours</option>
			<option value="172800">48 hours</option>
        </select><br/>
		</td>
		
		</tr>
		<tr>
		<td>
		<input type="radio" name="lmMarkersRunType" id="lmMarkersRunType" value="runLmMarkersByIterations" onClick="
			disableElement('timePerWindow');	enableElement('iterationsPerWindow');
		" />		
		Number of MCMC iterations for each window:&nbsp&nbsp&nbsp
		
		</td>
		<td>
        <select id="iterationsPerWindow" name="iterationsPerWindow" disabled="true">			
            <option value="1000">1000</option>
            <option value="10000">10,000</option>
            <option value="50000">50,000</option>
            <option value="100000">100,000</option>
			<option value="200000">200,000</option>
			<option value="500000">500,000</option>
			<option value="1000000">1,000,000</option>
			<option value="5000000">5,000,000</option>
        </select><br/>		
		</td>
		</tr>
		</table>
		</p>
        
        <p>
        <input type="checkbox" name="MorganAdvancedOptions" id="MorganAdvancedOptions" onClick="            
                toggleElement(getElementById('MorganParameters'));
            "/>Show Advanced Morgan Options
        </p>
        
        
        <span id="MorganParameters"  style="display: none">
        
        <div style="padding-left: 22px;">
            <table style="border: 0px;">
            <tr>
            <td>Percentage of burn-in iterations:</td>
			<td><select id="burnInIterations" name="burnInIterations">				
			<?php
				for ($i = 1; $i <= 10; $i += 1) {
					$val = 0.1 * $i;
					if ($i == 5) {print "<option selected value=$val>$val</option>";}
					else {print "<option value=$val>$val</option>";}
				}
			?>
            </select>
            </td></tr>
            
            <tr>
            <td>L-sampler probability:</td>            
			<td><select id="LSamplerProbability" name="LSamplerProbability">
            <option value="0">0</option>
			<?php
				for ($i = 0; $i <= 10; $i += 1) {
					$val = 0.1 * $i;
					if ($i == 5) {print "<option selected value=$val>$val</option>";}
					else {print "<option value=$val>$val</option>";}
				}
			?>            
            </select>
            </td></tr>            

            <tr>
            <td>Meioses indicators initialization mode:</td>
			<td><select id="MeiosesInitialization" name="MeiosesInitialization" onChange="
                    if(this.options[this.selectedIndex].value == 'sequential imputation') {
                        enableElement('ImputationRealizations');                        
                    }
                    else {disableElement('ImputationRealizations');}                    
                    ">            
				<option value="locus-by-locus sampling">locus-by-locus sampling</option>
				<option value="sequential imputation">sequential imputation</option>                
            </select>
            </td></tr>
			
            <tr>
            <td>Percentage of sequential imputation realizations for setup:</td>
			<td><select id="ImputationRealizations" name="ImputationRealizations" disabled="true">            
			<?php
				for ($i = 1; $i <= 10; $i += 1) {
					$val = 0.1 * $i;
					if ($i == 1) {print "<option selected value=$val>$val</option>";}
					else {print "<option value=$val>$val</option>";}
				}				
			?>            
            </select>
            </td></tr>
			
            
            <tr>
            <td>Meiosis sampler mode:</td>
			<td><select id="MeiosesSampler" name="MeiosesSampler">							
				<option value="multiple">multiple</option>
                <option value="single">single</option>
            </select>
            </td></tr>
            
            </table>
			<br/>
			</div>
        </span>    
        <?php
    }
	
	function createUserDB(&$projects, &$experiments, &$files, &$rawFiles) {
		$dir = USER_PROJECTS_DIR;
		$handle = opendir($dir);
		$i = 0;
		//finds all the projects of the user and saves it in $projects array
		while ( false !== ($obj = readdir($handle)) ) { // while there are files to read
			if (is_dir($dir."/".$obj) && (strpos($obj,".") !== 0) ) { // obj is a real folder
				$projects[$i] = $obj;
				$i += 1;
			}
		}
		closedir($handle);
		sort($projects);
		
		// find all the dat and ped files in all the project\raw directories and saves in $rawFiles array
		foreach ($projects as $project){
			$dir = USER_PROJECTS_DIR."/".$project."/raw/";
			$handle = opendir($dir);
			while ( false !== ($obj = readdir($handle)) ) { // while there are files to read
				if (is_file($dir."/".$obj) && (preg_match("/^(.+)\.dat$/",$obj, $fname)) && (strpos($obj,".") !== 0) ) { //find dat files
					if (is_file($dir."/".$fname[1].".ped")) { //verify there is a ped file with the same name
						$rawFiles[] = $project."*".$fname[1].".dat";
						$rawFiles[] = $project."*".$fname[1].".ped";
					}
				}
			}
			closedir($handle);
		}
		sort($rawFiles);
		
		// find all the experiments in each project
		foreach ($projects as $project) {
			$dir = USER_PROJECTS_DIR."/".$project."/experiments/";
			$handle = opendir($dir);
			while ( false !== ($obj = readdir($handle)) ) {
				if (is_dir($dir."/".$obj) && (strpos($obj,".") !== 0) ) { $experiments[] = $project."*".$obj; }
			}
			closedir($handle);
		}
		sort($experiments);
		
		//finds all the dat and ped files for each experiment in each project
		foreach ($experiments as $exp) {
			$exp = explode("*", $exp);
			$project = $exp[0];
			$exp = $exp[1];
			$dir = USER_PROJECTS_DIR."/".$project."/experiments/".$exp;
			$handle = opendir($dir);
			while ( false !== ($obj = readdir($handle)) ) {
				if (is_file($dir."/".$obj) && (strpos($obj,".") !== 0) && preg_match("/^(.+)\.dat$/",$obj,$file) ) {
					$files[] = $project."*".$exp."*".$file[1].".dat";
					$files[] = $project."*".$exp."*".$file[1].".ped";
				}
			}
			closedir($handle);
		}
		sort($files);
	}
	
	function getToolExplanation($toolName) {
		$explanation = array ("Filtering" => "Leave markers at specified distances");		
		if (isset($explanation[$toolName])) {return $explanation[$toolName];}
		return "";
	}

	/*
	* shows MOI and frequency selection areas.
	* defines inputs named: "frequency" with a number and "penetrance" - with the type of MOI (recessive or dominant).
	* the inputs: penetranceChoiceRec / penetranceChoiceDom - holds the selected values for the MOI
	*/
	function showMOIandFrequencySelection() {
		$freq = "";
		$MOI = false;
		$checkRec = true;
		if ( isset($_GET['checkboxes']) && isset($_GET['proj']) && isset($_GET['exp']) ){
			$input = explode("@", $_GET['checkboxes'][0]);
			$inputInitial = ($input[0] == "") ? "" : $input[0]."_";			
			$dir = USER_PROJECTS_DIR."/".$_GET['proj']."/experiments/".$_GET['exp'];
			$info = getExpContentInfo($dir, $input[1]);
			$firstChoice = $info[$inputInitial.'datfile'];
			$freq = getFrequencyFromDat($firstChoice);
			$MOI  = getMOIFromDat($firstChoice);
			if ($MOI) {$checkRec = ($MOI[0] == "Recessive") ? true : false;}				
			
			if ($MOI && $freq){
				echo "<b>Note</b>: MOI and frequency adopted from the input and can be changed.<br/><br/>";
			}
		}
		?>
		<p>
			Disease mutant gene frequency:  <input type="text" size="30" name="frequency" id="frequency" value="<?php echo $freq;?>"/><br/>
		</p>
		<p>
			Mode of inheritance (MOI): &nbsp;&nbsp;<!--<a href="" target="_blank" style="color: red;">WARNING</a>-->
			<?php 
				$help = new Help();
				$help->displayHelpLink("tools", "MOIWarning");
			?>
			<br/>
			&nbsp;&nbsp;&nbsp;&nbsp;<input type="radio" <?php echo ($checkRec) ? "checked" : "";?> name="penetrance" value="Recessive" onClick="	
				disableElement('penetraceChoiceDom');
				enableElement('penetraceChoiceRec');
			" />Recessive - penetrance choices
			<select id="penetraceChoiceRec" name="penetranceChoiceRec" <?php echo ($checkRec) ? "" : "disabled";?> >
				<option selected value="0 0.99">0.99</option>
				<option value="0 1">1</option>
			<?php
				for ($i = 9; $i > 1; $i -= 1) {
					?><option value="0 0.<?php echo $i ?>" >0.<?php echo $i ?></option><?php
				}
			?>
			</select>
			<br/>
			
			&nbsp;&nbsp;&nbsp;&nbsp;<input type="radio" <?php echo (!$checkRec) ? "checked" : "";?> name="penetrance" value="Dominant" onClick="
				enableElement('penetraceChoiceDom');
				disableElement('penetraceChoiceRec');
			"/>Dominant - penetrance choices
			<select id="penetraceChoiceDom" name="penetranceChoiceDom" <?php echo (!$checkRec) ? "" : "disabled";?> >
				<option value="0.99 0.99">0.99, 0.99</option>
				<option value="1 1">1, 1</option>
				<?php /*
					for ($i = 9; $i > 0; $i -=1){
						if ( ($i == 6) || ($i == 2) ){
							continue;
						}
						for ($j = 9; $i > 0; $j -=1){
							if ($j = 9){
							}
						}
					}*/
				?>
				<?php
				if ($MOI && ($MOI[0] == "Dominant")){
					?><option selected value="<?php echo $MOI[1]." ".$MOI[2];?>"><?php echo $MOI[1].", ".$MOI[2];?></option><?php
				}
				?>
				<option value="0.9 0.9">0.9, 0.9</option>
				<option value="0.8 0.8">0.8, 0.8</option>
				<option value="0.7 0.7">0.7, 0.7</option>
				<option value="0.5 0.9">0.5, 0.9</option>
				<option value="0.5 0.8">0.5, 0.8</option>
				<option value="0.5 0.7">0.5, 0.7</option>
				<option value="0.5 0.5">0.5, 0.5</option>
				<option value="0.4 0.9">0.4, 0.9</option>
				<option value="0.4 0.7">0.4, 0.7</option>
				<option value="0.5 0.6">0.4, 0.6</option>
				<option value="0.4 0.4">0.4, 0.4</option>
				<option value="0.3 0.9">0.3, 0.9</option>
				<option value="0.3 0.7">0.3, 0.7</option>
				<option value="0.3 0.5">0.3, 0.5</option>
				<option value="0.3 0.3">0.3, 0.3</option>
				<option value="0.3 0.2">0.3, 0.2</option>
				<option value="0.1 0.1">0.1, 0.1</option>
			</select>
		</p>
		<?php
	}
	
	function CreateMarkersRangeParameters($tool, $maxMarkers, $inputInitial = null, $showJump = true, $showAll = false, $moreChecks = "", $showConfirmButton = true) {
		$help = new Help();
		$maxSingleWindowSize = $maxMarkers;
		$toolToPrint = $tool;
		if ($toolToPrint == "lm_markers") {$toolToPrint = "Morgan lm_linkage";}
		elseif ($toolToPrint == "gl_auto") {$toolToPrint = "Morgan gl_auto";}
		?>
		<p>
			<b>Perform <?php echo $toolToPrint;?> on:</b>&nbsp;&nbsp;&nbsp;&nbsp;<?php $help->displayHelpLink("tools",$tool."PerformOn")?><br/><br/>
			<?php if ($showAll){ ?>
				<input type="radio" <?php echo ($showAll ? "checked" : "");?> name="InputRadio" id="InputRadio" value="All" onClick="
					disableElement('StartMarker'); disableElement('EndMarker'); disableElement('WindowBox'); disableElement('WindowSize');
					disableElement('MarkersList');
				" />
				All markers<br/>
			<?php } ?>
			<br/>
			<input type="radio" <?php echo ($showAll ? "" : "checked");?> name="InputRadio" id="InputRadio" value="Range" onClick="
				disableElement('MarkersList');
				enableElement('StartMarker'); enableElement('EndMarker'); enableElement('WindowBox');
				if ( (document.getElementById('WindowBox') != null) && (document.getElementById('WindowBox').checked == true) ){
					enableElement('WindowSize');
				}
			" />
			Range of markers:<br/>
			<div style="padding-left: 22px;">
				<table style="border: 0px;">
				<tr>
				<td>From marker:</td><td><input type="text" <?php echo ($showAll ? "disabled" : "");?> name="StartMarker" id="StartMarker" <?php if (isset($_GET['from'])){ echo "value=\"".$_GET['from']."\"";}?> /></td>
				</tr><tr>
				<td>To marker:</td><td><input type="text" <?php echo ($showAll ? "disabled" : "");?> name="EndMarker" id="EndMarker" <?php if (isset($_GET['to'])){ echo "value=\"".$_GET['to']."\"";}?> /></td>
				</tr><tr><td>&nbsp;</td></tr>
				<?php if ($showJump) { ?>
					<tr>
						<td><input type="checkbox" <?php echo ($showAll ? "disabled" : "");?> name="WindowBox" id="WindowBox" onClick="
							if (this.checked == true) {
								enableElement('WindowSize');
							}
							else{
								disableElement('WindowSize');
							}
						"/>Use a sliding window
						</td><td></td>
					</tr>
					<tr>
						<td style="padding-left: 20px;">
						Sliding window size:</td><td><input type="text" disabled name="WindowSize" id="WindowSize" value="3"/>(default: 3)</td>
					</tr>
					<?php if (isset($maxMarkers["multipleWindow"])) {
							$windowType = " the"; ?>
							<tr>
							<td></td><td><?php
							$maxSingleWindowSize = $maxMarkers["multipleWindow"];
							if (isset($maxMarkers["singleWindow"])) { ?>
								maximum size for single window: <?php echo $maxMarkers["singleWindow"]."<br/>";
								$_GET["numberOfMarkers"] = $maxMarkers["singleWindow"];
								$maxSingleWindowSize = max($maxMarkers["multipleWindow"], $maxMarkers["singleWindow"]);
								$hmmMark = ($maxMarkers["singleWindow"] >= $maxMarkers["multipleWindow"]) ? true : false;
								if ($hmmMark){
									?><input type="hidden" name="hmm" value="true"/>
									<input type="hidden" name="hmmMax" value="<?php echo $maxMarkers["singleWindow"];?>"/><?php
								}
								$windowType = " multiple";
							}
							echo "maximum size for$windowType windows: ".$maxMarkers["multipleWindow"];
							$maxMarkers = $maxMarkers["multipleWindow"];
							?>
							</td>
							</tr>
					<?php } ?>
				<?php } ?>
				</table>
				<br/>
			</div>
			<input type="radio" name="InputRadio" id="InputRadio" value="List" onClick="
				disableElement('StartMarker'); disableElement('EndMarker'); disableElement('WindowBox'); disableElement('WindowSize');
				enableElement('MarkersList');
			" />
			List of markers:<br/>
			<span style="padding-left: 25px;">Markers: <input disabled type="text" name="MarkersList" id="MarkersList"/></span>
			<br/>
		</p>		
        
        <?php if (!$showConfirmButton) {return;} ?>
        
		<input type="submit" value="Confirm" id="<?php echo $tool;?>ToolConfirm"
			 onClick=" 	var legalInput = true;
						var maxWindowSize = <?php echo $maxMarkers; ?>;
						var maxSingleWindowSize = <?php echo $maxSingleWindowSize; ?>;
						var max = maxWindowSize;
						var tool = <?php echo ("'".$tool."'");?>;
						var numOfMarkers =  <?php 
								$dir = USER_PROJECTS_DIR."/".$_GET['proj']."/experiments/".$_GET['exp'];
								$input = $_GET['checkboxes'][0]; //only one set of files is allowed to sugregation
								$input = explode("@", $input);
								$table['name']		= $input[1];
								$table['method']	= $input[0];
								$info = getExpContentInfo($dir, $table['name']);
								$header = (($table['method'] == "") ? "" : $table['method']."_")."datfile";
								exec("head -1 ".$info[$header], $line);
								$line = explode(" ", $line[0]);
								$numberOfMarkers = $line[0] - 1;
								echo ($numberOfMarkers); 
							?>;
						<?php if ($inputInitial != null) { echo "InputInitial = $inputInitial;"; } ?>
						if (getSelectedRadioValue(document.forms[0].InputRadio) == 'Range') { //if range selected
							var start = document.getElementById('StartMarker').value;
							var end = document.getElementById('EndMarker').value;
							var window = null;
							if ( (document.getElementById('WindowBox') != null) && (document.getElementById('WindowBox').checked == true) ) {
								window = document.getElementById('WindowSize').value;								
								startInt = parseInt(hasInitial(start, InputInitial));
								endInt = parseInt(hasInitial(end, InputInitial));
								if (window == (endInt - startInt + 1 )) {
									max = maxSingleWindowSize;
									if (window > maxSingleWindowSize) {
										alert('Single window chosen - chosen window cannot be larger than max single window size.');
										legalInput = false;
									}
								}
								legalInput = legalInput && legalWindow(window, endInt-startInt+1, 'total range');
							}
							var windowSize = (window==null) ? numOfMarkers : window;
							legalInput = legalInput && checkTasksLimit(tool, start, end, numOfMarkers, windowSize);
							if (window == null){ max = maxSingleWindowSize; }
							legalInput = legalInput && legalRange(start, end, window, max, InputInitial);
						}
						else if (getSelectedRadioValue(document.forms[0].InputRadio) == 'List') {
							var list = document.getElementById('MarkersList').value;
							legalInput = legalList(list, tool, InputInitial);
							listArr = list.split(',');
							legalInput = legalInput && checkTasksLimit(tool, 1, listArr.length, numOfMarkers, numOfMarkers);
						}
						else if (getSelectedRadioValue(document.forms[0].InputRadio) == 'All') {
							legalInput = true;
							legalInput = legalInput && checkTasksLimit(tool, 1, numOfMarkers, numOfMarkers, numOfMarkers);
						}
						else { legalInput = false; }
						return (isLegalValue(document.getElementById('experimentName').value, 'experiment name') &&
								legalInput <?php echo $moreChecks;?> && 
								confirm('Are you ready for running the '+toolDisplayName(tool)+' tool?'));" />
		<?php
	}
    
    #Omer 31/7/2011 - this function contains code that was at the end of the function CreateMarkersRangeParameters()
    #In order to separate the confirm button from the markers range GUI
    function showConfirmButton($tool, $maxMarkers, $inputInitial = null, $moreChecks = "") {
        $maxSingleWindowSize = $maxMarkers;
        ?>
        <?php if (isset($maxMarkers["multipleWindow"])) {
            $maxSingleWindowSize = $maxMarkers["multipleWindow"];
            if (isset($maxMarkers["singleWindow"])){				
                $maxSingleWindowSize = max($maxMarkers["multipleWindow"], $maxMarkers["singleWindow"]);
            }
            $maxMarkers = $maxMarkers["multipleWindow"];
        }
        
        ?>
		<input type="submit" value="Confirm" id="<?php echo $tool;?>ToolConfirm"
			 onClick=" 	var legalInput = true;
						var maxWindowSize = <?php echo $maxMarkers; ?>;
						var maxSingleWindowSize = <?php echo $maxSingleWindowSize; ?>;
						var max = maxWindowSize;
						var tool = <?php echo ("'".$tool."'"); ?>;
						<?php if ($inputInitial != null){ echo "InputInitial = $inputInitial;"; } ?>
						if (getSelectedRadioValue(document.forms[0].InputRadio) == 'Range') {
							var start = document.getElementById('StartMarker').value;
							var end = document.getElementById('EndMarker').value;
							if (end - start == 1) {
								alert('Window size for lm_markers must contain more than one marker');
								return false;								
							}
							if (end - start + 1 > <?php echo MAX_MARKERS_ALLOWED ?>) {
								alert('Selected range is too large. Please choose a smaller range.');
								return false;								
							}							
							
							var window = null;
							if ( (document.getElementById('WindowBox') != null) && (document.getElementById('WindowBox').checked == true) ) {
								window = document.getElementById('WindowSize').value;								
								if (window <= 1) {
									alert('Window size for lm_markers must contain more than one marker');
									return false;
								}							
								startInt = parseInt(hasInitial(start, InputInitial));
								endInt = parseInt(hasInitial(end, InputInitial));
								if (window == (endInt - startInt + 1 )) {
									max = maxSingleWindowSize;
									if (window > maxSingleWindowSize ) {
										alert('Single window chosen - chosen window cannot be larger than max single window size.');
										return false;
									}
								}
								legalInput = legalWindow(window, endInt-startInt+1, 'total range');
							}
							if (window == null) {max = maxSingleWindowSize;}
							legalInput = legalInput && legalRange(start, end, window, max, InputInitial);
							var windowSize = (window==null) ? 1 : window;
						}
						else if (getSelectedRadioValue(document.forms[0].InputRadio) == 'List') {								
							var list = document.getElementById('MarkersList').value;
							if (list.length <= 1) {
								alert('lm_markers must use more than one marker');
								return false;
							}
							legalInput = legalList(list, <?php echo $maxMarkers;?>, InputInitial);
						}
						else if (getSelectedRadioValue(document.forms[0].InputRadio) == 'All') {
							legalInput = true;
						}
						else {legalInput = false;}
						return (isLegalValue(document.getElementById('experimentName').value, 'experiment name') &&
								legalInput <?php echo $moreChecks;?> && 
								confirm('Are you ready for running the '+toolDisplayName(tool)+' tool?'));" />
		<?php    
    }
	
	function HmmSizeSearch($dat, $ped) {
		if (!is_file($dat) || !is_file($ped)) { return false; }
		if (!($datFile = fopen($dat,"r"))) {return false;}	//error...

		$line = fgets($datFile);
		fclose($datFile);
		$line = explode(" ", $line);
		$markers = $line[0] - 1;		// getting the number of markers (hmm test starts from 0 to amount -1 )
		
		$families = array();
		exec("cut -d \" \" -f 1 $ped | uniq", $families);
		foreach ($families as $fam) {
			$family = intval($fam);
			if (is_int($family) && ($family > 0)) {
				while (($markers > 1) && !runSuperlinkLocally($dat, $ped, SUPERLINK_PARAMETER_HMM." ".SUPERLINK_PARAMETER_M800." ".SUPERLINK_PARAMETER_HMM_TEST_ONLY." -hmm_windowed_params start=0 end=".($markers-1)." size=$markers family=$family")) {
					$markers = (int)(($markers / 2) + 0.5);
				}
				//echo "family: $family, markers: $markers<br/>";
			}
		}
		
		/*
		while (($markers > 1) && !runSuperlinkLocally($dat, $ped, SUPERLINK_PARAMETER_HMM." ".SUPERLINK_PARAMETER_M800." ".SUPERLINK_PARAMETER_HMM_TEST_ONLY." -hmm_windowed_params start=0 end=".($markers-1)." size=$markers family=$family")){
			$markers = (int)(($markers / 2) + 0.5);
		}*/
		
		if ($markers <= 1) { return false; }
		return $markers;
	}
	
?>