<?php
require_once("log.php");
require_once("config.php");
require_once("fileHandleFunctions.php");

require_once("debug.php");

/* this script gets 2-3 hidden parameters:
	- folder/project name    $_POST["pName"]
	- raw(snp/ped) or sltype(dat/ped) file type     $_POST["fileType"]
	- if sltype file sent, needs to get experiment name    $_POST["expName"]
	- $_SESSION["backFromUpload"] is which script to go back to. 
*/
	$snpUploaded = false;
	$datUploaded = false;
	$onlyOnePed = true;
	$dataFile = false;
	
	if (isset($_FILES["snpfile"]["name"])) { //snp file is used
		$dataFile = "snpfile";
		$snpUploaded = true;
	}
	
	if (isset($_FILES["datfile"]["name"])) { //dat file is used
		$dataFile = "datfile";
		$datUploaded = true;
	}
	
	if (isset($_POST["pairs"]) && ($_POST["pairs"] == "true")) {
		$onlyOnePed = false;
	}

	if (!hasDiskSpace()){
		error_msg("You are low on disk space - please delete some of your files and try again.");
		exit(0);
	}
	
	if ( (!isset($_POST["pName"])) || (!isset($_POST["fileType"])) || ( (!isset($_POST["textArea"]) || ($_POST["textArea"] == "")) &&		// no simplified input
																		(!isset($_FILES["pedfile"]["name"]) || ($_FILES["pedfile"]["name"] == "")) &&		// no pedfile
																		((!$snpUploaded && !$datUploaded) || ($_FILES[$dataFile]["name"] == "")) ) ){		// no data (snp or dat) file
		error_msg("Empty input (no files selected or empty simplified data). please go back and try again.");
		exit(0);
	}
	else {
		if ( ($_POST["fileType"] == "sltype") && (!isset($_POST["expName"])) ){
			//error...
			exit(0);
		}
		
		if ( isset($_FILES["pedfile"]["name"]) && ($_FILES["pedfile"]["name"] != "") && (!(preg_match("/^[^.].*\.ped$/", $_FILES["pedfile"]["name"])))){
			error_msg("Wrong file type for PED file. Expected a .ped file");
			exit(0);
		}
		if ($snpUploaded){
			if ( ($_FILES["snpfile"]["name"] != "") && (!(preg_match("/^[^.].*\.snp$/", $_FILES["snpfile"]["name"])))){
				error_msg("Wrong file type for SNP file. Expected a .snp file");
				exit(0);
			}
		}
		if ($datUploaded){
			if ( ($_FILES["datfile"]["name"] != "") && (!(preg_match("/^[^.].*\.dat$/", $_FILES["datfile"]["name"])))){
				error_msg("Wrong file type for DAT file. Expected a .dat file");
				exit(0);
			}
		}
		
		if ($onlyOnePed){
			if (isset($_FILES["pedfile"]["name"]) && ($_POST["fileType"] == "raw") && (preg_match("/^[^.].*\.ped$/", $_FILES["pedfile"]["name"]))){
				if (is_dir(USER_PROJECTS_DIR."/".$_POST["pName"]."/raw")){
					$open = opendir(USER_PROJECTS_DIR."/".$_POST["pName"]."/raw");
					while( ($file = readdir($open)) !== false ) {
						if ( preg_match("/^[^.].*\.ped$/", $file) ) {
							unlink(USER_PROJECTS_DIR."/".$_POST["pName"]."/raw/".$file);
						}
					}
				}
			}
			elseif (isset($_POST["textArea"]) && ($_POST["textArea"] != "")){
				convertSimplifiedToPed($_POST["pName"], $_POST["textArea"]);
				$subTable[KEY_SNP_PEDFILE] = "sl_input.ped";
				$folder = USER_PROJECTS_DIR."/".$_POST["pName"]."/raw";
				$ini = is_file($folder."/".UPLOADED_DATA_INFO) ? parse_ini_file($folder."/".UPLOADED_DATA_INFO, true) : array();
				if (isset($ini['snp'][KEY_SNP_FILE_LIST])){ $subTable[KEY_SNP_FILE_LIST] = $ini['snp'][KEY_SNP_FILE_LIST]; 	}
				$SFTable['snp'] = $subTable;
				AppendIniWithTable($folder, UPLOADED_DATA_INFO, $SFTable);
				unset($subTable);
			}
		}
	}
	
	/*$types = array("text/plain","application/msaccess"); 
	$file_type = $_FILES["userfile"]["type"];  */
	$types = array(".ped",".snp",".dat"); 
	if (isset($_FILES["pedfile"]["name"]) && preg_match("/[^\.\/$]+[^\/$]*(\.[a-zA-Z0-9]*)$/",$_FILES["pedfile"]["name"], $pedMatch)){
		$ped_file_type = $pedMatch[1];
	}
	else {
		$ped_file_type = false;
	}
	
	if (isset($_FILES[$dataFile]["name"]) && preg_match("/[^\.\/$]+[^\/$]*(\.[a-zA-Z0-9]*)$/",$_FILES[$dataFile]["name"], $dataMatch)){
		$data_file_type = $dataMatch[1];
	}
	else {
		$data_file_type = false;
	}
	
	if ( ($ped_file_type == ".ped") && (in_array($ped_file_type,$types)) && ($_FILES["pedfile"]["size"] < 20000000)) {
		if ($_FILES["pedfile"]["error"] > 0) {
			echo "Return Code: " . $_FILES["pedfile"]["error"] . "<br />";
			error_msg("Please go back and check that your input is legal");
		}
		else {
			if (!is_dir(USER_PROJECTS_DIR."/".$_POST["pName"])) {
				if (!createProjectFolder(USER_PROJECTS_DIR, $_POST["pName"])){
					echo "create Project failed";
					error_msg("Please contact system administrator");
					exit(0);
				}
			}
			
			$upFolder = USER_PROJECTS_DIR."/".$_POST["pName"];
			switch ($_POST["fileType"]) {
				case "raw": $upFolder = $upFolder."/raw"; break;
				case "sltype": $upFolder = $upFolder."/experiments/".$_POST["expName"]; break;
			}
			
			if (file_exists($upFolder."/".$_FILES["pedfile"]["name"])){
				error_msg("The file: ".$_FILES["pedfile"]["name"]." already exists.");
				error_msg("Please upload a different file or continue with the analysis");
				exit(0);
		    }
			else{
				move_uploaded_file($_FILES["pedfile"]["tmp_name"],$upFolder."/".$_FILES["pedfile"]["name"]);
				//echo "Stored in: " . "upload/" . $_FILES["userfile"]["name"];
				log_error("User uploaded file: ".$upFolder."/".$_FILES["pedfile"]["name"]);
		    }
	    }
	}
	else {
		if (isset($_FILES["pedfile"]["name"]) && ($_FILES["pedfile"]["name"] != "")) { error_msg("Invalid ped file"); }
		if ($data_file_type == "") { header("location:".$_SESSION["backFromUpload"]); }
	}
	
	
	if ( ( ($data_file_type == ".snp") || ($data_file_type == ".dat") ) && (in_array($data_file_type,$types))
			&& ($_FILES[$dataFile]["size"] < 20000000)) {
		if ($_FILES[$dataFile]["error"] > 0) {
			echo "Return Code: " . $_FILES[$dataFile]["error"] . "<br />";
			error_msg("This page will be updated soon");
		}
		else {
			if (!is_dir(USER_PROJECTS_DIR."/".$_POST["pName"])) {
				if (!createProjectFolder(USER_PROJECTS_DIR, $_POST["pName"])) {
					echo "create Project failed";
					error_msg("Please contact system administrator");
					exit(0);
				}
			}
			
			$upFolder = USER_PROJECTS_DIR."/".$_POST["pName"];
			switch ($_POST["fileType"]) {
				case "raw": $upFolder = $upFolder."/raw"; break;
				case "sltype": $upFolder = $upFolder."/experiments/".$_POST["expName"]; break;
			}
			
			if (file_exists($upFolder."/".$_FILES[$dataFile]["name"])){
				error_msg("the file: ".$_FILES[$dataFile]["name"]." already exists.");
				error_msg("Please upload a different file or continue with the analysis");
				exit(0);
		    }
			else{
				move_uploaded_file($_FILES[$dataFile]["tmp_name"],$upFolder."/".$_FILES[$dataFile]["name"]);
				if ($data_file_type == ".dat"){
					$fileName = $_FILES[$dataFile]["name"];
					system("touch \"$upFolder/.$fileName.raw\"");
				}
				log_error("User uploaded file: ".$upFolder."/".$_FILES[$dataFile]["name"]);
		    }
	    }
	}
	else{
		if ($_FILES[$dataFile]["name"] != "") { error_msg("Invalid data file"); }
		if ( ($ped_file_type == "") || ($ped_file_type == false)) { header("location:".$_SESSION["backFromUpload"]); }
	}
	
	if (isset($_POST['toolsUpload']) && ($_POST['toolsUpload'] == "true")) {
		$_SESSION["Project"] = $_POST['pName'];
		if (!isset($_SESSION["Uploaded"])){
			$_SESSION["Uploaded"] = "";
		}
		if (isset($_FILES[$dataFile]["name"])){
			$_SESSION["Uploaded"] = $_SESSION["Uploaded"]."*".$_FILES[$dataFile]["name"];
		}
		if (isset($_FILES["pedfile"]["name"])){
			$_SESSION["Uploaded"] = $_SESSION["Uploaded"]."*".$_FILES["pedfile"]["name"];
		}
	}
	
	$table = array();
	$ini = is_file($upFolder."/".UPLOADED_DATA_INFO) ? parse_ini_file($upFolder."/".UPLOADED_DATA_INFO, true) : array();
	if (!isset($ini['general'])){
		$subTable[KEY_INPUT_TYPE] = $datUploaded ? "dat" : "snp";
		$table['general'] = $subTable;
		unset($subTable);
	}
	$sectionName = $datUploaded ? "dat" : "snp";
	$subTable = array();
	if ($sectionName == "snp"){						// snp and/or ped uploaded
		if (isset($ini['snp'])){
			if (isset($ini['snp'][KEY_SNP_FILE_LIST])){ $subTable[KEY_SNP_FILE_LIST]	= $ini['snp'][KEY_SNP_FILE_LIST]; 	}
			if (isset($ini['snp'][KEY_SNP_PEDFILE])) { 	$subTable[KEY_SNP_PEDFILE] 		= $ini['snp'][KEY_SNP_PEDFILE]; 	}
		}
		
		if (isset($_FILES[$dataFile]["name"]) && !preg_match("/^[ \t]*$/", $_FILES[$dataFile]["name"])){
			$snpList = array($_FILES[$dataFile]["name"]);
			if (isset($subTable[KEY_SNP_FILE_LIST])){
				$currentList = $subTable[KEY_SNP_FILE_LIST];
				if (is_array($currentList)) {
					$snpList = $currentList;
					if (!in_array($_FILES[$dataFile]["name"], $currentList)){
						$snpList[] = $_FILES[$dataFile]["name"];
					}
				}
			}
			$subTable[KEY_SNP_FILE_LIST] = $snpList;
		}
		
		if ($onlyOnePed && isset($_FILES["pedfile"]["name"]) && !preg_match("/^[ \t]*$/", $_FILES["pedfile"]["name"])){
			$subTable[KEY_SNP_PEDFILE] = $_FILES["pedfile"]["name"];
		}
	}
	else{											// dat and ped pair uploaded
		if (isset($ini['dat'])){
			$subTable = $ini['dat'];
		}
		$subTable[$_FILES[$dataFile]["name"]] = $_FILES["pedfile"]["name"];
	}
	$table[$sectionName] = $subTable;
	AppendIniWithTable($upFolder, UPLOADED_DATA_INFO, $table);
	header("location:".$_SESSION["backFromUpload"]);
?> 
