<?php
require("log.php");
include("config.php");
include("debug.php");
include("fileHandleFunctions.php");
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
            "http://www.w3.org/TR/html4/loose.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Superlink Online</title>
<meta http-equiv="Content-Type" content="text/html; charset=windows-1255" />
<link href="style.css" rel="stylesheet" type="text/css" />
</head>
<body>
	<div style="background-color: f0ffff;">
		<?php
			$project	= $_GET['project'];
			$experiment	= $_GET['experiment'];
			$family		= isset($_GET['fam']) ? $_GET['fam'] : -1;
			$dir = USER_PROJECTS_DIR."/$project/experiments/$experiment";
			$fullServerAddr = "http://".$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'];
			$fullServerAddr = substr($fullServerAddr, 0, strrpos($fullServerAddr, "/"));
			$goodData = false;
		
			$results = false;
			if (is_file($dir."/".RESULTS_FILENAME)){
				$results = file($dir."/".RESULTS_FILENAME);
			}
			
			$info = getExpContentInfo($dir);
			if (!$info) { $info = array(); }
			ksort($info,SORT_STRING);
			$countReady = 0;						
			foreach ($info as $key => $subTable){
				for ($i = 1 ; $i < sizeof($results) ; $i += 1){
					$line = explode(" ", $results[$i]);
					$resultForHeader = trim($line[0]);
					$resultFolder = trim($line[1]);
					if (preg_match("/$key$/", $resultForHeader)){
						$fileDir = $resultFolder;
						if (preg_match("/^.*\/(var\/tmp\/.*)$/",$resultFolder, $folder)){
							$fileDir = $folder[1];
						}
						$chromDrawData[ $key ] = $fileDir;
						$graph  = $chromDrawData[ $key ]."/LODgraph.pedfile_0_preview.png";
						
						$statusPage  = WEBDIR."/".$fileDir."/".SL_STATUS_PAGE;
						$content = file_get_contents($statusPage);
						if (is_file($statusPage)){
							$content = file_get_contents($statusPage);
							if (preg_match("/.*failed.*/",strtolower($content)) || preg_match("/.*removed.*/",strtolower($content)) || is_file($graph)){
								$countReady += 1;
							}
							if (is_file($graph)){
								$goodData = $chromDrawData[ $key ];
							}
						}				
					}
				}
			}
			
			$update = "";	
			if ( ($countReady == count($info)) && is_file($dir."/".PROCESS_ID_FILE) ) {
				//Add max line to all the graphs
				$procID = file($dir."/".PROCESS_ID_FILE, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
				$procID = $procID[0];
				$postScript = CGI_BIN_DIR."/GlobalPost.pl";
				$projectsDir = WEBDIR."/var/tmp";
				//exec("perl ".$postScript." ".$procID." ".$projectsDir);
				$update = "_update";
			}
			
			$numFamilies = 0;
			if ($goodData){
				while (is_file($goodData."/LODgraph.pedfile_".($numFamilies)."_preview".$update.".png") || is_file($goodData."/LODgraph.pedfile_".($numFamilies)."_preview.png")){
					$numFamilies += 1;
				}
			}
			if ($numFamilies == 1)	{ $family = 0; }
		?>
		<br/><br/>
		<h2>
			Results page for project: <?php echo $project;?>, Experiment: <?php echo $experiment;?><br/>
		</h2>
		<div style="padding-left: 5px; padding-top: 5px;">
			<div style="background: gray; float: left; z-index: 1;">
				<div style="background: #f0ffff; border: 1px solid black; padding: 15px; float: left; z-index: 2; position: relative; left: -5px; top: -5px;">
					<table>
					<tr><td>The <font color="#0033FF">blue lines</font> define the customary LOD score range.</td></tr>
					<?php if ($countReady == count($info)) { ?>
						<tr><td>The <font color="#00CC33">green line</font> demonstrates the maximum LOD score measured genome-wide in this experiment. It appears after all computations are completed.</td></tr>
					<?php } ?>
					</table>
				</div>
			</div>
		</div>
		<div style="clear: both;"></div>
		<br/>
		<?php
			if ($numFamilies > 1){
				$graphsLink = "http://".$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF']."?project=$project&experiment=$experiment";
				?>Results for: <?php if ($family == -1) { echo "<b>"; } ?><a href="<?php echo $graphsLink;?>">All</a><?php if ($family == -1) { echo "</b>"; }
				for ($i = 1 ; $i <= $numFamilies ; $i += 1){
					?> | <?php if ($family == $i-1) { echo "<b>"; } ?>
						<a href="<?php echo $graphsLink."&fam=".($i-1);?>">Family <?php echo $i;?></a><?php
						if ($family == $i-1) { echo "</b>"; }
				}
			}
		?>
		<br/><br/><br/>
		
		<?php
			if ($family == -1) { $family = "main"; }
			foreach ($info as $key => $subTable){
				if (! isset($chromDrawData[ $key ]) ) {
					continue;
				}
				$graph  = WEBDIR."/".$chromDrawData[ $key ]."/LODgraph.pedfile_".$family."_preview".$update.".png";
				if (!is_file($graph)) {
					$graph  = WEBDIR."/".$chromDrawData[ $key ]."/LODgraph.pedfile_".$family."_preview.png";
				}
				/*
				$mainGraph  = WEBDIR."/".$chromDrawData[ $key ]."/LODgraph.pedfile_main_preview".$update.".png";
				if (is_file($mainGraph)) {
					$graph = $mainGraph;
				}
				else {
					$mainGraph  = WEBDIR."/".$chromDrawData[ $key ]."/LODgraph.pedfile_main_preview.png";
					if (is_file($mainGraph)) {
						$graph = $mainGraph;
					}
				}*/
				
				//$statusPage  = $dir."/".SL_STATUS_PAGE;
				if (!is_file($graph)){ continue; }		// no graph for this key
				$customTracksFile = WEBDIR."/".$chromDrawData[ $key ]."/custom_tracks.txt";
				$customTracksLink = $fullServerAddr."/".$chromDrawData[ $key ]."/custom_tracks.txt";
				// if there is a graph
				?>	
					<div style="float: left; padding: 5px; text-align: center;">
						<img height="250" src="<?php echo $graph;?>"/><br/>
						view <?php echo $key; ?>: <a href="<?php echo WEBDIR."/".$chromDrawData[ $key ]."/formatted_output.html"; ?>" target="_blank">details</a>
						<?php if (is_file($customTracksFile)){?>
							 | <a href="http://genome.ucsc.edu/cgi-bin/hgTracks?clade=mammal&org=Human&db=hg18&pix=800&hgt.customText=<?php echo $customTracksLink;?>" target="_blank">genome browser</a>
						<?php } ?>
					</div>
				<?php
			}		
		?>
	</div>
</body>
</html>